#include "captureimage.h"

CaptureImage::CaptureImage(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);
}

void CaptureImage::on_pushButton_clicked()
{
   QString robotName = ui.lineEdit->text();
   QSettings settings("Aibo Ball Tracking", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg;");
          urbiImage.robotI->send("stop recupx;");
          urbiImage.robotI->send("stop recupy;");
          urbiImage.robotI->send("noop;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0;
          urbiImage.capture=0;
          urbiImage.visible = 0;
    }


    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

    urbiImage.robotI->send("motors on;");

    urbiImage.robotI->send("noop;");
    urbiImage.robotI->send("stop uimg;");
    urbiImage.robotI->send("stop recupx;");
    urbiImage.robotI->send("stop recupy;");

    //ball tracking head example
    urbiImage.robotI->send("ball.a = 0.95;"); // absorption coef
    urbiImage.robotI->send("balltrackinghead: whenever (ball.visible)"); 
    urbiImage.robotI->send("{"); 
    urbiImage.robotI->send("headPan  = headPan  + ball.a * camera.xfov * ball.x &"); 
    urbiImage.robotI->send("headTilt = headTilt + ball.a * camera.yfov * ball.y &"); 
    urbiImage.robotI->send("ledF14=1"); 
    urbiImage.robotI->send("}"); 
    urbiImage.robotI->send("else ledF14=0,"); 

    QString videoName = ui.lineEdit_2->text();
    QString delayName = ui.lineEdit_3->text();
    QString recupimage = "uimg:every(" + delayName + "){ uimg:" + videoName + " },";
    QString recupx = "recupx:every(" + delayName + "){ recupx:ball.x },";
    QString recupy = "recupy:every(" + delayName + "){ recupy:ball.y },";

    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");
    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::recupx), "recupx");
    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::recupy), "recupy");
    urbiImage.robotI->send("%s", (const char *) recupimage.toLatin1());
    urbiImage.robotI->send("%s", (const char *) recupx.toLatin1());
    urbiImage.robotI->send("%s", (const char *) recupy.toLatin1());

    }

    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }


}

void CaptureImage::on_lineEdit_returnPressed()
{
   QString robotName = ui.lineEdit->text();
   QSettings settings("Aibo Ball Tracking", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg;");
          urbiImage.robotI->send("stop recupx;");
          urbiImage.robotI->send("stop recupy;");
          urbiImage.robotI->send("noop;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0;
          urbiImage.capture=0;
          urbiImage.visible = 0;
    }


    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

    urbiImage.robotI->send("motors on;");

    urbiImage.robotI->send("noop;");
    urbiImage.robotI->send("stop uimg;");
    urbiImage.robotI->send("stop recupx;");
    urbiImage.robotI->send("stop recupy;");

    //ball tracking head example
    urbiImage.robotI->send("ball.a = 0.95;"); // absorption coef
    urbiImage.robotI->send("balltrackinghead: whenever (ball.visible)"); 
    urbiImage.robotI->send("{"); 
    urbiImage.robotI->send("headPan  = headPan  + ball.a * camera.xfov * ball.x &"); 
    urbiImage.robotI->send("headTilt = headTilt + ball.a * camera.yfov * ball.y &"); 
    urbiImage.robotI->send("ledF14=1"); 
    urbiImage.robotI->send("}"); 
    urbiImage.robotI->send("else ledF14=0,"); 

    QString videoName = ui.lineEdit_2->text();
    QString delayName = ui.lineEdit_3->text();
    QString recupimage = "uimg:every(" + delayName + "){ uimg:" + videoName + " },";
    QString recupx = "recupx:every(" + delayName + "){ recupx:ball.x },";
    QString recupy = "recupy:every(" + delayName + "){ recupy:ball.y },";

    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");
    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::recupx), "recupx");
    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::recupy), "recupy");
    urbiImage.robotI->send("%s", (const char *) recupimage.toLatin1());
    urbiImage.robotI->send("%s", (const char *) recupx.toLatin1());
    urbiImage.robotI->send("%s", (const char *) recupy.toLatin1());

    }

    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }

}
