#include <cv.h>
#include <highgui.h>
#include <urbi/uclient.hh>

class BallTrackingHead
{
 public:
  BallTrackingHead(const char * robotName);

  //callback functions
  urbi::UCallbackAction getImage(const urbi::UMessage &msg);

  IplImage * imgcv;

 private:
  urbi::UClient robotC;
  unsigned char *image;  //uncompressed image
};

urbi::UCallbackAction BallTrackingHead::getImage(const urbi::UMessage &msg)
{

  if (msg.type != urbi::MESSAGE_DATA
      || msg.value->type != urbi::DATA_BINARY
      || msg.value->binary->type != urbi::BINARY_IMAGE)
    return urbi::URBI_CONTINUE;

  urbi::UImage& img = msg.value->binary->image;

  int imgsize = img.width * img.height * 3;

   if (image == NULL)
        image = new unsigned char[img.width * img.height * 3]; // 24 bits

        int sizejpegimage;

      // conversion de l'image en JPG
      if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
      {
            memcpy(  image, img.data, img.size );
            sizejpegimage = img.size;
      }
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
      {
          urbi::convertYCrCbtoJPEG( (const byte *) img.data, img.width, img.height, (byte*) image, sizejpegimage, 100 );
      }
      else if ( img.imageFormat == urbi::IMAGE_RGB)
      {
          urbi::convertRGBtoJPEG( (const byte *) img.data, img.width, img.height, (byte*) image, sizejpegimage , 100 );
      }
      else
      {
            memcpy(  image, img.data, img.size );
            sizejpegimage = img.size;
      }

        std::string File = "image.jpg";
        FILE *f;
        f = fopen(File.c_str(),"wb");
        if (!f)
           return urbi::URBI_CONTINUE;
        fwrite (image, 1 , sizejpegimage, f);
        fclose(f);

    cvNamedWindow( "image", CV_WINDOW_AUTOSIZE );
    const char* filename = "image.jpg";
	imgcv = cvLoadImage( filename, CV_LOAD_IMAGE_COLOR );
    if( !imgcv )
        printf("error\n");
    cvShowImage( "image", imgcv );

    if (cvWaitKey(10)>=0) cvDestroyWindow("image");

  return urbi::URBI_CONTINUE;
}


BallTrackingHead::BallTrackingHead(const char * robotname) :  robotC (robotname)
{
  robotC.start();
  if (robotC.error())
    urbi::exit(1);

  image = NULL;
  imgcv=NULL;

  robotC.setCallback(*this, &BallTrackingHead::getImage,"cam");
  robotC.send("loop cam: camera.val, ");
}



/*
	int width = image->width;
	int height = image->height;

    CvMemStorage * storage = 0;
    storage = cvCreateMemStorage(0);

	IplImage * picture = cvCreateImage(cvSize(208, 160), 8, 1);

    if( !picture )
        return -1;	

	for(int h = 0; h < height; h++)
	{
		for(int w = 0; w < width/2; w++)
		{
			int pos = (image->width*h + w);
			picture->imageData[picture->widthStep*h +w] = 0; //noir
		}
	} 
	for(int h = 0; h < height; h++)
	{
		for(int w = width/2; w < width; w++)
		{
			int pos = (image->width*h + w);
			picture->imageData[picture->widthStep*h +w] = 255; //blanc
		}
	} 

	cvNamedWindow( "image 3", CV_WINDOW_AUTOSIZE );
    cvShowImage( "image 3", picture );
    cvReleaseImage( &picture );

*/
