#include "captureimage.h"

CaptureImage::CaptureImage(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);
}

void CaptureImage::on_pushButton_clicked()
{
   QString robotName = ui.lineEdit->text();
   QSettings settings("Aibo Capture Images", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg2;");
          urbiImage.robotI->send("stop uimg;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0; 
          urbiImage.captureImage=0;
    }

    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

    QString device_video = ui.lineEdit_2->text();

    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");
    QString phrase_send = "uimg2:every(50ms){ uimg:" + device_video + "},";
    urbiImage.robotI->send("%s", (const char *) phrase_send.toLatin1());
    }

    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }


}

void CaptureImage::on_lineEdit_returnPressed()
{
   QString robotName = ui.lineEdit->text();
   QSettings settings("Aibo Capture Images", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg2;");
          urbiImage.robotI->send("stop uimg;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0; 
          urbiImage.captureImage=0;
    }

    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

    QString device_video = ui.lineEdit_2->text();

    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");
    QString phrase_send = "uimg2:every(50ms){ uimg:" + device_video + "},";
    urbiImage.robotI->send("%s", (const char *) phrase_send.toLatin1());
    }

    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }

}


void CaptureImage::on_pushButton_2_clicked()
{
    urbiImage.captureImage=1;
}


void CaptureImage::on_pushButton_3_clicked()
{
   QString robotName = ui.lineEdit->text();
   QSettings settings("Aibo Capture Images", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg2;");
          urbiImage.robotI->send("stop uimg;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0; 
          urbiImage.captureImage=0;
    }
    
    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_3->setPalette(couleur);

    urbiImage.robotI->send("motors on;");

    QString device_video = ui.lineEdit_2->text();
    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command2), "uimg2");

    headPan_init = ui.spinBox->value();
    headPan_final = ui.spinBox_2->value();
    headPan_delta = ui.spinBox_3->value();
    headTilt_init =  ui.spinBox_4->value();
    headTilt_final =  ui.spinBox_5->value();
    headTilt_delta = ui.spinBox_6->value();

    ui.lcdNumber->display(headPan_init);                     
    ui.lcdNumber_2->display(headTilt_init);  

    QString position_headPan;
    QString position_headTilt;
    QString value_headPan;
    QString value_headTilt;

    lieu = ui.lineEdit_3->text();
    QString phrase_send;


    urbiImage.compteur = 0;

    urbiImage.robotI->send(" {");

    int i=0,j=0;
    for(i=headPan_init ; i<=headPan_final ; i=i+headPan_delta)
    {
        value_headPan = QString::number(i);
        position_headPan = "headPan=" +value_headPan + ";";
        urbiImage.robotI->send("%s", (const char *) position_headPan.toLatin1());

        for(j=headTilt_init ; j<=headTilt_final ; j=j+headTilt_delta)
        {
            urbiImage.robotI->send("wait(1s);");
            value_headTilt = QString::number(j);
            position_headTilt = "headTilt=" +value_headTilt + ";";
            urbiImage.robotI->send("%s", (const char *) position_headTilt.toLatin1());
            urbiImage.robotI->send("wait(2s);");
            QString phrase_send = "uimg2:" + device_video + ";";
            urbiImage.robotI->send("%s", (const char *) phrase_send.toLatin1());
        }
    }

    urbiImage.robotI->send(" },");

    }

    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_3->setPalette(couleur);         
    }




}



