#include "urbi.h"
#include "captureimage.h"


ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotI = NULL;  
     buffer = NULL;
     bufferRGB = NULL;   

     traitementEnCours=0; 
     visible = 0;
     capture=0;
     captureImage=0;

     compteur=0;

// code opencv
storage = 0;
cascade = 0;

    char *cascade_name = "haarcascade_frontalface_alt2.xml";
    cascade = (CvHaarClassifierCascade*)cvLoad( cascade_name, 0, 0, 0 );
    //if( !cascade )
    //    return URBI_CONTINUE; // on sort car il y a une erreur
    storage = cvCreateMemStorage(0);
// code opencv

}

UCallbackAction ConnectAibo::command(const UMessage &msg) 
{

  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
       return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;
	urbi::UImage& img = msg.value->binary->image;

    		    int width = img.width;
    		    int height = img.height;

      if (buffer == NULL && bufferRGB == NULL)
      {
    		       buffer = new unsigned char[img.width * img.height * 3 * 8]; // 24 bits
     		       bufferRGB = new unsigned char[img.width * img.height * 4 * 8];  // 32 bits
      }


    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		        imageQT.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
     		   else 
               {
                   if ( img.imageFormat == urbi::IMAGE_YCbCr)
         		           convertYCrCbtoRGB( (const unsigned char *) img.data, img.size, (unsigned char*) buffer );
      		       else if ( img.imageFormat == urbi::IMAGE_RGB)
       		          memcpy(  buffer, img.data, img.size );
       		       else
        		       memcpy( buffer, img.data, img.size );
            
                      // conversion de l'image RGB 24 en RGB 32
                       for(int i=0; i<=width; i++)
                       {
                             for(int j=0; j<=height; j++)
                             {
                                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                             }
                       }    
                
                       // copie de l'image dans QImage
                      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image

                }

// code opencv

     // on enregistre l'image sur le disque dur
     imageQT.save("image_clean.jpg","JPG",100);

        const char* filename = (char*)"image_clean.jpg";
        IplImage* image = cvLoadImage( filename, 1 );

        if( image )
        {
            detect_and_draw( image );
            cvReleaseImage( &image );
        }

     // on charge le nouveau fichier image
     imageQT.load("image_cv.jpg");
// code opencv






      // on recupere la largeur et la hauteur
      int widthLabel = pere->ui.label_2->width();
      int heightLabel  = pere->ui.label_2->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT2 = imageQT;
  
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);
      
      if(capture == 1)
      {
                 QString nameFile="image_000.jpg";
                 QFile test;
                 QString number;
                 int j=1000;
                 for(int i=1 ; i<j ; i++)
                 {    
                                  number.setNum(i);
                                  if(i < 10)
                                       nameFile = "image_00" + number + ".jpg"; 
                                  else if(i < 100)
                                       nameFile = "image_0" + number + ".jpg"; 
                                  else if(i < 1000)
                                       nameFile = "image_" + number + ".jpg";                                        
                                  test.setFileName(nameFile);
                                  if( !test.exists() )
                                      break;
                 }

                 imageQT.save(nameFile,"JPG",100);
                 capture=0;           
      }


      traitementEnCours=0;
  }

  return URBI_CONTINUE;
  
  
}

///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001))
 {

      pere->ui.label_2->setPixmap(QPixmap::fromImage(imageQT2));     // on affiche
 }

 return 1;
}


///////////////////////////////////////////
// detection des visages
void ConnectAibo::detect_and_draw( IplImage* img )
{
    static CvScalar colors[] = 
    {
        {{0,0,255}},
        {{0,128,255}},
        {{0,255,255}},
        {{0,255,0}},
        {{255,128,0}},
        {{255,255,0}},
        {{255,0,0}},
        {{255,0,255}}
    };

    double scale = 1.3;
    IplImage* gray = cvCreateImage( cvSize(img->width,img->height), 8, 1 );
    IplImage* small_img = cvCreateImage( cvSize( cvRound (img->width/scale),
                         cvRound (img->height/scale)),
                     8, 1 );
    int i;

    cvCvtColor( img, gray, CV_BGR2GRAY );
    cvResize( gray, small_img, CV_INTER_LINEAR );
    cvEqualizeHist( small_img, small_img );
    cvClearMemStorage( storage );

    if( cascade )
    {
        double t = (double)cvGetTickCount();
        CvSeq* faces = cvHaarDetectObjects( small_img, cascade, storage,
                                            1.1, 2, 0/*CV_HAAR_DO_CANNY_PRUNING*/,
                                            cvSize(30, 30) );

  double surface_aire=0;

        t = (double)cvGetTickCount() - t;
        for( i = 0; i < (faces ? faces->total : 0); i++ )
        {
            CvRect* r = (CvRect*)cvGetSeqElem( faces, i );
            CvPoint center;
            int radius;
            center.x = cvRound((r->x + r->width*0.5)*scale);
            center.y = cvRound((r->y + r->height*0.5)*scale);
            radius = cvRound((r->width + r->height)*0.25*scale);
            cvCircle( img, center, radius, colors[i%8], 3, 8, 0 );

            if(r->width * r->height > surface_aire)
            {
               surface_aire = r->width * r->height;

               // calcul du centre
               // r->x est le bord gauche du cercle (cela va de 0 a 110)
               // r->with est la largeur du cercle
               // position au centre = x + largeur/x
               // la largeur totale de l'image = largeur initiale de l'image divisee par scale (1.3)
               // on prend la position en x du centre de l'image et on la divise par la largeur totale, ce qui nous donne une valeur comprise entre 0 et 1
               // on retranche ensuite 0.5 pour avoir une valeur comprise entre -0.5 et 0.5

               posx = ( ( ( r->x + r->width * 0.5 ) / (img->width/scale) ) -0.5 ) * -1;
               posy = ( ( ( r->y + r->height * 0.5 ) / (img->height/scale) ) - 0.5 ) * -1;
            }

        }


      // on regarde le nombre de faces
      visible = 0; // aucun visage detecte
      if( faces->total > 0) // il y a au moins un visage de detecte
      {
        visible = 1; // visible passe a 1 pour dire qu'il voit un visage
        QString value1 = QString::number(posx);
        QString value2 = QString::number(posy);
        QString phrase_send = "headPan = headPan + camera.xfov * " + value1 + " & headTilt = headTilt + camera.yfov * " + value2 + " & ledF14 = 1,";
//        QString phrase_send = "ledF14 = 1;";
        robotI->send("%s", (const char *) phrase_send.toLatin1());
//        phrase_send = "headPan = headPan + camera.xfov * " + value1 + ";";
//        robotI->send(phrase_send.toLatin1());
//        phrase_send = "headTilt = headTilt + camera.yfov * " + value2 + ";";
//        robotI->send(phrase_send.toLatin1());
      }
      else
      {
        QString phrase_send = "ledF14 = 0,";
        robotI->send("%s", (const char *) phrase_send.toLatin1());
      }



    }







    cvSaveImage("image_cv.jpg", img);

    cvReleaseImage( &gray );
    cvReleaseImage( &small_img );
}
