#include "urbi.h"
#include "tele.h"

#include "urbi_page3.cpp"
#include "urbi_page4.cpp"


ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotC = NULL;                           
     robotM = NULL;             

     lignes = NULL;

     // page 3
     devCount=18;
     devices=devices2;
     compteurvalue=0;
     value1  = 0;
     value2  = 0;  
     value3  = 0;
     value4  = 0;    
     value5  = 0;
     value6  = 0;    
     value7  = 0;
     value8  = 0;  
     value9  = 0;
     value10 = 0;  
     value11 = 0;
     value12 = 0;    
     value13 = 0;
     value14 = 0;    
     value15 = 0;
     value16 = 0;    
     value17 = 0;
     value18 = 0;   


     // page 4
     devCountLed=25;
     devicesLeds=devicesLeds2;
     compteurvalueled=0;

     // page 6
     robotI = NULL; 
     traitementEnCours=0;
     buffer = NULL;
     bufferRGB=NULL;
     captureImage=0;
     widthImage = 208;
     HeightImage = 160;

     // page 7
     compteurligne=0;

     musiqueEnCours=0;

     imageEnCours=0;
     buffer2 = NULL;
     buffer2RGB=NULL;

}



/////////////////////////////////////////////////
// Tout Recuperer
//////////////////////////////////////////////////
UCallbackAction ConnectAibo::allrecup(const UMessage &msg) 
{ 

  QString texteServeur2;
  QString tag;

	  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_BINARY) 
	  {

		  if (msg.value->binary->type == urbi::BINARY_IMAGE)
		  {
		      urbi::UImage& img = msg.value->binary->image;

     		    if( img.imageFormat == urbi::IMAGE_JPEG )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image JPEG " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
    		    else if ( img.imageFormat == urbi::IMAGE_YCbCr )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image YCbCr " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
    		    else if ( img.imageFormat == urbi::IMAGE_RGB )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image RGB " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
      		    else if ( img.imageFormat == urbi::IMAGE_PPM )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image PPM " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
      		    else
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image UNKNOWN " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }

    		    if (buffer2 == NULL && buffer2RGB == NULL)
    		    {
                     widthImage = img.width;
                     HeightImage = img.height;

    		       buffer2 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
     		       buffer2RGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
     		   }

    		    int width = widthImage;
    		    int height = HeightImage;

          if (widthImage == (int) img.width && HeightImage == (int) img.height)
          {
    		    QImage image;
    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		    {
    		        image.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
    		    }
     		   else // autres cas
     		   {
     		       if ( img.imageFormat == urbi::IMAGE_YCbCr)
     		           convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer2 );
      		      else if ( img.imageFormat == urbi::IMAGE_RGB)
       		         memcpy(  buffer2, img.data, img.size );
       		     else
        		 memcpy( buffer2, img.data, img.size );
    
        		  // conversion de l'image RGB 24 en RGB 32
           		for(int i=0; i<=width; i++)
           		{
                 		for(int j=0; j<=height; j++)
                 		{
                      			buffer2RGB[(4*i) + (j*width*4) + 0] = buffer2[(3*i) + (j*width*3) + 2];  // bleu
                      			buffer2RGB[(4*i) + (j*width*4) + 1] = buffer2[(3*i) + (j*width*3) + 1];  //vert
                      			buffer2RGB[(4*i) + (j*width*4) + 2] = buffer2[(3*i) + (j*width*3) + 0];  // rouge
                      			buffer2RGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                 		}
           		}    
    
          		// constructs image and fills with data 
          		image=QImage( buffer2RGB, img.width, img.height, QImage::Format_RGB32); // on stocke l'image
        	}

      		// enregistrement de l'image
      		imageEnCours++;
      		image_textbrowser = image.copy();

      		// envoi du signal pour dire que c'est une image
      		e3 = new QEvent((QEvent::Type)(1600));
      		QCoreApplication::postEvent(this,e3);

        }

        
	  } // fin de BINARY_IMAGE

  else if (msg.value->binary->type == urbi::BINARY_SOUND)
  {
       urbi::USound& snd = msg.value->binary->sound;

        if( snd.soundFormat == urbi::SOUND_WAV )
        {
            texteServeur2 = "[" + QString::number(msg.timestamp) ;
            if(QString::fromLatin1(msg.tag.c_str()) != "")
              texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
            texteServeur2 = texteServeur2 + "] " + "Binary Sound " + QString::number(snd.size) + " wav" + "\n" ;
        }
        else if ( snd.soundFormat == urbi::SOUND_RAW)       
        {
            texteServeur2 = "[" + QString::number(msg.timestamp) ;
            if(QString::fromLatin1(msg.tag.c_str()) != "")
              texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
             texteServeur2 = texteServeur2 + "] " + "Binary Sound " + QString::number(snd.size) + " raw" + " " + QString::number(snd.channels) + " " + QString::number(snd.rate)  + " "  + QString::number(snd.sampleSize) + " " + QString::number(snd.sampleFormat) + "\n" ;
        }


  } // fin de BINARY_SOUND


  else if (msg.value->binary->type == urbi::BINARY_NONE)
  {
        texteServeur2 = "[" + QString::number(msg.timestamp) + ":" + QString::fromLatin1(msg.tag.c_str()) + "] " + "Binary None" + "\n" ;
  }
  else if (msg.value->binary->type == urbi::BINARY_UNKNOWN)
  {
        texteServeur2 = "[" + QString::number(msg.timestamp) + ":" + QString::fromLatin1(msg.tag.c_str()) + "] " + "Binary Unknown" + "\n" ;
  }

	} // fin du DATA_BINARY

  tag = QString::fromLatin1(msg.tag.c_str() );

    if(lignes == NULL)
              lignes = new QString [500];

// Message non parse
	if(texteServeur2 == "")
	{
     texteServeur2 = "[" + QString::number(msg.timestamp) ;
     if(QString::fromLatin1(msg.tag.c_str()) != "")
       texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
     texteServeur2 = texteServeur2 + "] " + QString::fromLatin1(msg.rawMessage.c_str()) + "\n";
	}


    if (compteurligne >= 0 && compteurligne <= 498)
    {
       lignes[compteurligne] = texteServeur2;
       int valueEvent= 1100 + compteurligne;
       e3 = new QEvent((QEvent::Type)(valueEvent));
       QCoreApplication::postEvent(this,e3);
       compteurligne++;
    }
    else if (compteurligne >= 499 )
    {
       lignes[compteurligne] = texteServeur2;
       int valueEvent= 1100 + compteurligne;
       e3 = new QEvent((QEvent::Type)(valueEvent));
       QCoreApplication::postEvent(this,e3);
       compteurligne=0;
    }


  return URBI_CONTINUE;    

}


/////////////////////////////////////////////////
// Recuperer les images
//////////////////////////////////////////////////
UCallbackAction ConnectAibo::allrecupimg(const UMessage &msg) 
{ 

  if (msg.type != MESSAGE_DATA && msg.value->type != urbi::DATA_BINARY) 
    return URBI_CONTINUE;

  if (msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;


 if(traitementEnCours == 0)
 {
    traitementEnCours=1;

	urbi::UImage& img = msg.value->binary->image;

     int width = img.width;
     int height = img.height;


      if (buffer == NULL && bufferRGB == NULL)
      {
    		       buffer = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
     		       bufferRGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
      }


    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
               {
    		        imageQT.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
              }

     		   else if ( img.imageFormat == urbi::IMAGE_YCbCr)
     		   {
     		           convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );
        
              // conversion de l'image RGB 24 en RGB 32
               for(int i=0; i<=width; i++)
               {
                     for(int j=0; j<=height; j++)
                     {
                          bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                          bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                          bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                          bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                     }
               }    
        
               // copie de l'image dans QImage
              imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image
        }

     imageQT2 = imageQT.scaledToHeight ( 320 );          // on double la taille

      e4 = new QEvent((QEvent::Type)(1003));
      QCoreApplication::postEvent(this,e4);  // on affiche l'image

      
      traitementEnCours=0;

  }


  return URBI_CONTINUE;

}







///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{
 
 if( ev->type() == (QEvent::Type)(1001))
 {
      if(valueled1 == 1)
         pere->ui.label_24->setText("<font color=\"green\">ledF1</font>");
      else
         pere->ui.label_24->setText("<font color=\"red\">ledF1</font>");
      if(valueled2 == 1)
         pere->ui.label_25->setText("<font color=\"green\">ledF2</font>");
      else
         pere->ui.label_25->setText("<font color=\"red\">ledF2</font>");
      if(valueled3 == 1)
         pere->ui.label_26->setText("<font color=\"green\">ledF3</font>");
      else
         pere->ui.label_26->setText("<font color=\"red\">ledF3</font>");
      if(valueled4 == 1)
         pere->ui.label_27->setText("<font color=\"green\">ledF4</font>");
      else
         pere->ui.label_27->setText("<font color=\"red\">ledF4</font>");
      if(valueled5 == 1)
         pere->ui.label_28->setText("<font color=\"green\">ledF5</font>");
      else
         pere->ui.label_28->setText("<font color=\"red\">ledF5</font>");
      if(valueled6 == 1)
         pere->ui.label_29->setText("<font color=\"green\">ledF6</font>");
      else
         pere->ui.label_29->setText("<font color=\"red\">ledF6</font>");
      if(valueled7 == 1)
         pere->ui.label_30->setText("<font color=\"green\">ledF7</font>");
      else
         pere->ui.label_30->setText("<font color=\"red\">ledF7</font>");
      if(valueled8 == 1)
         pere->ui.label_31->setText("<font color=\"green\">ledF8</font>");
      else
         pere->ui.label_31->setText("<font color=\"red\">ledF8</font>");
      if(valueled9 == 1)
         pere->ui.label_32->setText("<font color=\"green\">ledF9</font>");
      else
         pere->ui.label_32->setText("<font color=\"red\">ledF9</font>");
      if(valueled10 == 1)
         pere->ui.label_33->setText("<font color=\"green\">ledF10</font>");
      else
         pere->ui.label_33->setText("<font color=\"red\">ledF10</font>");
      if(valueled11 == 1)
         pere->ui.label_34->setText("<font color=\"green\">ledF11</font>");
      else
         pere->ui.label_34->setText("<font color=\"red\">ledF11</font>");
      if(valueled12 == 1)
         pere->ui.label_35->setText("<font color=\"green\">ledF12</font>");
      else
         pere->ui.label_35->setText("<font color=\"red\">ledF12</font>");
      if(valueled13 == 1)
         pere->ui.label_36->setText("<font color=\"green\">ledF13</font>");
      else
         pere->ui.label_36->setText("<font color=\"red\">ledF13</font>");
      if(valueled14 == 1)
         pere->ui.label_37->setText("<font color=\"green\">ledF14</font>");
      else
         pere->ui.label_37->setText("<font color=\"red\">ledF14</font>");
      if(valueled15 == 1)
         pere->ui.label_38->setText("<font color=\"green\">ledBFC</font>");
      else
         pere->ui.label_38->setText("<font color=\"red\">ledBFC</font>");
      if(valueled16 == 1)
         pere->ui.label_39->setText("<font color=\"green\">ledBFW</font>");
      else
         pere->ui.label_39->setText("<font color=\"red\">ledBFW</font>");
      if(valueled17 == 1)
         pere->ui.label_40->setText("<font color=\"green\">ledBMC</font>");
      else
         pere->ui.label_40->setText("<font color=\"red\">ledBMC</font>");
      if(valueled18 == 1)
         pere->ui.label_41->setText("<font color=\"green\">ledBMW</font>");
      else
         pere->ui.label_41->setText("<font color=\"red\">ledBMW</font>");
      if(valueled19 == 1)
         pere->ui.label_42->setText("<font color=\"green\">ledBRC</font>");
      else
         pere->ui.label_42->setText("<font color=\"red\">ledBRC</font>");
      if(valueled20 == 1)
         pere->ui.label_43->setText("<font color=\"green\">ledBRW</font>");
      else
         pere->ui.label_43->setText("<font color=\"red\">ledBRW</font>");
      if(valueled21 == 1)
         pere->ui.label_44->setText("<font color=\"green\">ledHC</font>");
      else
         pere->ui.label_44->setText("<font color=\"red\">ledHC</font>");
      if(valueled22 == 1)
         pere->ui.label_45->setText("<font color=\"green\">ledWIFI</font>");
      else
         pere->ui.label_45->setText("<font color=\"red\">ledWIFI</font>");
      if(valueled23 == 1)
         pere->ui.label_46->setText("<font color=\"green\">modeR</font>");
      else
         pere->ui.label_46->setText("<font color=\"red\">modeR</font>");
      if(valueled24 == 1)
         pere->ui.label_47->setText("<font color=\"green\">modeG</font>");
      else
         pere->ui.label_47->setText("<font color=\"red\">modeG</font>");
      if(valueled25 == 1)
         pere->ui.label_48->setText("<font color=\"green\">modeB</font>");
      else
         pere->ui.label_48->setText("<font color=\"red\">modeB</font>");
 }

 else if( ev->type() == (QEvent::Type)(1002))
 {
       pere->neRienFaireAvecLesMoteurs = 1;

       pere->ui.spinBox_4->setValue(value13); 
       pere->ui.spinBox_3->setValue(value14); 
       pere->ui.spinBox_2->setValue(value15); 
       pere->ui.spinBox_7->setValue(value16); 
       pere->ui.spinBox_8->setValue(value17); 
       pere->ui.spinBox_5->setValue(value18); 

       pere->ui.horizontalSlider->setValue(value15);
       pere->ui.horizontalSlider_2->setValue(value14);
       pere->ui.horizontalSlider_3->setValue(value13);
       pere->ui.horizontalSlider_4->setValue(value18);
       pere->ui.horizontalSlider_6->setValue(value16);
       pere->ui.horizontalSlider_7->setValue(value17);

       pere->neRienFaireAvecLesMoteurs = 0;

 }


 else if( ev->type() == (QEvent::Type)(1003))
 {
        pere->ui.label_7->setPixmap(QPixmap::fromImage(imageQT2));     // on affiche   
 }



 else if( ev->type() >= (QEvent::Type)(1100) && ev->type() <= (QEvent::Type)(1599))
 {
       // on positionne le curseur a la fin
       QTextCursor cursorEnd(pere->ui.textBrowser->textCursor());
       cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
       pere->ui.textBrowser->setTextCursor ( cursorEnd );

       // on definit la couleur rouge
       pere->ui.textBrowser->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 

       // on ajoute le texte
       int num = (int)ev->type();
       pere->ui.textBrowser->insertPlainText( lignes[num-1100] ) ; 

       // on positionne le scrolling a la fin
       int positionMax = pere->ui.textBrowser->verticalScrollBar()->maximum();
       pere->ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
 }



// affichage image
 else if( ev->type() == (QEvent::Type)(1600))
 {
       QTextCursor cursorEnd(pere->ui.textBrowser->textCursor());
       cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
       pere->ui.textBrowser->setTextCursor ( cursorEnd );
       pere->ui.textBrowser->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 
       QTextDocument *textdocument_image = pere->ui.textBrowser->document();
       int numeroimage = imageEnCours;
       textdocument_image->addResource(QTextDocument::ImageResource, QUrl("image"+QString::number(numeroimage)), image_textbrowser); 
       cursorEnd.insertImage("image"+QString::number(numeroimage));
       QString phrase = "<br>";
       pere->ui.textBrowser->insertHtml( phrase ) ; 
       int positionMax = pere->ui.textBrowser->verticalScrollBar()->maximum();
       pere->ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
 }


 return 1;
}
