#include "couleur.h"
#include "captureimage.h"

/////////////////////////////////////
// Creation de l'objet
Couleur::Couleur(QWidget *parent)
        : QDialog(parent)
{
        ui.setupUi(this);

        Ymin=0;
        Ymax=0;
        Ymoy=0;
        Cbmin=0;
        Cbmax=0;
        Cbmoy=0;
        Crmin=0;
        Crmax=0;
        Crmoy=0;
        R=0;
        G=135;
        B=0;


}


/////////////////////////////////////
// Configuration de l'objet
void Couleur::configure(int Y_min, int Y_max, int Cb_min, int Cb_max, int Cr_min, int Cr_max, QString colorName)
{

    // on entre les valeurs
    Ymin=Y_min;
    Ymax=Y_max;
    Cbmin=Cb_min;
    Cbmax=Cb_max;
    Crmin=Cr_min;
    Crmax=Cr_max;
    nameColor=colorName;


    this->setWindowTitle ( "Color " + nameColor ) ; // on donne le nom de la fenetre

     // on calcule la valeur moyenne
     Ymoy = (int) ( (Ymin + Ymax) / 2 );
     Cbmoy = (int) ( (Cbmin + Cbmax) / 2 );
     Crmoy = (int) ( (Crmin + Crmax) / 2 );


     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on remplit buffer
     buffer[0]=Ymoy;
     buffer[1]=Cbmoy;
     buffer[2]=Crmoy;

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const unsigned char *) buffer, 3, (unsigned char*) buffer2 );

     R= buffer2[0] ; 
     G= buffer2[1] ; 
     B= buffer2[2] ; 

     ui.spinBox->setValue(Ymin);
     ui.spinBox_2->setValue(Ymax);
     ui.spinBox_3->setValue(Cbmin);
     ui.spinBox_4->setValue(Cbmax);
     ui.spinBox_5->setValue(Crmin);
     ui.spinBox_6->setValue(Crmax);

}

/////////////////////////////////////
// Changement de la valeur
void Couleur::on_spinBox_valueChanged ( int i )
{
     Ymin=i;

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on calcule la valeur moyenne
     Ymoy = (int) ( (Ymin + Ymax) / 2 );
     Cbmoy = (int) ( (Cbmin + Cbmax) / 2 );
     Crmoy = (int) ( (Crmin + Crmax) / 2 );

     // on remplit buffer
     buffer[0]=Ymoy;
     buffer[1]=Cbmoy;
     buffer[2]=Crmoy;

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const unsigned char *) buffer, 3, (unsigned char*) buffer2 );

     R= buffer2[0] ; 
     G= buffer2[1] ; 
     B= buffer2[2] ; 
     

    if( pere != NULL)
    {
        if( pere->urbiImage.robotI != NULL)
        {
              QString phrasePink = "ball.ymin = "  + QString::number(i) + ";";
              QString phraseGreen = "greenmarker.ymin = " + QString::number(i) + ";";
    
             if(nameColor.contains("Pink"))
             {
                  pere->urbiImage.robotI->send("%s", (const char *) phrasePink.toLatin1());
                  pere->urbiImage.robotI2->send("%s", (const char *) phrasePink.toLatin1());
             }
             else if(nameColor.contains("Green"))
             {
                  pere->urbiImage.robotI->send("%s", (const char *) phraseGreen.toLatin1());
                  pere->urbiImage.robotI2->send("%s", (const char *) phraseGreen.toLatin1());
             }
         }
     }

}

/////////////////////////////////////
// Changement de la valeur
void Couleur::on_spinBox_2_valueChanged ( int i )
{
    Ymax=i;

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on calcule la valeur moyenne
     Ymoy = (int) ( (Ymin + Ymax) / 2 );
     Cbmoy = (int) ( (Cbmin + Cbmax) / 2 );
     Crmoy = (int) ( (Crmin + Crmax) / 2 );

     // on remplit buffer
     buffer[0]=Ymoy;
     buffer[1]=Cbmoy;
     buffer[2]=Crmoy;

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const unsigned char *) buffer, 3, (unsigned char*) buffer2 );

     R= buffer2[0] ; 
     G= buffer2[1] ; 
     B= buffer2[2] ; 


    if( pere != NULL)
    {
    if( pere->urbiImage.robotI != NULL)
    {

      QString phrasePink = "ball.ymax = "  + QString::number(i) + ";";
      QString phraseGreen = "greenmarker.ymax = " + QString::number(i) + ";";

     if(nameColor == "Pink")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phrasePink.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phrasePink.toLatin1());
     }
     else if(nameColor == "Green")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phraseGreen.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phraseGreen.toLatin1());
     }
     }
     }



}

/////////////////////////////////////
// Changement de la valeur
void Couleur::on_spinBox_3_valueChanged ( int i )
{
    Cbmin=i;

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on calcule la valeur moyenne
     Ymoy = (int) ( (Ymin + Ymax) / 2 );
     Cbmoy = (int) ( (Cbmin + Cbmax) / 2 );
     Crmoy = (int) ( (Crmin + Crmax) / 2 );

     // on remplit buffer
     buffer[0]=Ymoy;
     buffer[1]=Cbmoy;
     buffer[2]=Crmoy;

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const unsigned char *) buffer, 3, (unsigned char*) buffer2 );

     R= buffer2[0] ; 
     G= buffer2[1] ; 
     B= buffer2[2] ; 


    if( pere != NULL)
    {
    if( pere->urbiImage.robotI != NULL)
    {

      QString phrasePink = "ball.cbmin = "  + QString::number(i) + ";";
      QString phraseGreen = "greenmarker.cbmin = " + QString::number(i) + ";";

     if(nameColor.compare("Pink"))
     {
          pere->urbiImage.robotI->send("%s", (const char *) phrasePink.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phrasePink.toLatin1());
     }
     else if(nameColor == "Green")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phraseGreen.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phraseGreen.toLatin1());
     }
     }
     }


}

/////////////////////////////////////
// Changement de la valeur
void Couleur::on_spinBox_4_valueChanged ( int i )
{
    Cbmax=i;

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on calcule la valeur moyenne
     Ymoy = (int) ( (Ymin + Ymax) / 2 );
     Cbmoy = (int) ( (Cbmin + Cbmax) / 2 );
     Crmoy = (int) ( (Crmin + Crmax) / 2 );

     // on remplit buffer
     buffer[0]=Ymoy;
     buffer[1]=Cbmoy;
     buffer[2]=Crmoy;

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const unsigned char *) buffer, 3, (unsigned char*) buffer2 );

     R= buffer2[0] ; 
     G= buffer2[1] ; 
     B= buffer2[2] ; 


    if( pere != NULL)
    {
    if( pere->urbiImage.robotI != NULL)
    {

      QString phrasePink = "ball.cbmax = "  + QString::number(i) + ";";
      QString phraseGreen = "greenmarker.cbmax = " + QString::number(i) + ";";

     if(nameColor == "Pink")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phrasePink.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phrasePink.toLatin1());
     }
     else if(nameColor == "Green")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phraseGreen.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phraseGreen.toLatin1());
     }
     }
    }


}

/////////////////////////////////////
// Changement de la valeur
void Couleur::on_spinBox_5_valueChanged ( int i )
{
    Crmin=i;

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on calcule la valeur moyenne
     Ymoy = (int) ( (Ymin + Ymax) / 2 );
     Cbmoy = (int) ( (Cbmin + Cbmax) / 2 );
     Crmoy = (int) ( (Crmin + Crmax) / 2 );

     // on remplit buffer
     buffer[0]=Ymoy;
     buffer[1]=Cbmoy;
     buffer[2]=Crmoy;

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const unsigned char *) buffer, 3, (unsigned char*) buffer2 );

     R= buffer2[0] ; 
     G= buffer2[1] ; 
     B= buffer2[2] ; 


    if( pere != NULL)
    {
    if( pere->urbiImage.robotI != NULL)
    {

      QString phrasePink = "ball.crmin = "  + QString::number(i) + ";";
      QString phraseGreen = "greenmarker.crmin = " + QString::number(i) + ";";

     if(nameColor == "Pink")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phrasePink.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phrasePink.toLatin1());
     }
     else if(nameColor == "Green")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phraseGreen.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phraseGreen.toLatin1());
     }
     }
     }


}

/////////////////////////////////////
// Changement de la valeur
void Couleur::on_spinBox_6_valueChanged ( int i )
{
    Crmax=i;

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on calcule la valeur moyenne
     Ymoy = (int) ( (Ymin + Ymax) / 2 );
     Cbmoy = (int) ( (Cbmin + Cbmax) / 2 );
     Crmoy = (int) ( (Crmin + Crmax) / 2 );

     // on remplit buffer
     buffer[0]=Ymoy;
     buffer[1]=Cbmoy;
     buffer[2]=Crmoy;

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const unsigned char *) buffer, 3, (unsigned char*) buffer2 );

     R= buffer2[0] ; 
     G= buffer2[1] ; 
     B= buffer2[2] ; 

    if( pere != NULL)
    {
    if( pere->urbiImage.robotI != NULL)
    {

      QString phrasePink = "ball.crmax = "  + QString::number(i) + ";";
      QString phraseGreen = "greenmarker.crmax = " + QString::number(i) + ";";

     if(nameColor == "Pink")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phrasePink.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phrasePink.toLatin1());
     }
     else if(nameColor == "Green")
     {
          pere->urbiImage.robotI->send("%s", (const char *) phraseGreen.toLatin1());
          pere->urbiImage.robotI2->send("%s", (const char *) phraseGreen.toLatin1());
     }
     }
     }
}
