#include "urbi.h"
#include "captureimage.h"


//////////////////////////////////////////
// Creation de l'objet
ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotI = NULL;  
     robotI2 = NULL;  
     buffer = NULL;

     bufferRGB = NULL;   
     bufferRGBCouleur1=NULL; 
     bufferRGBCouleur3=NULL; 
     bufferRGBFinal=NULL; 

     bufferYCbCr = NULL;   
     bufferYCbCrCouleur1 = NULL;
     bufferYCbCrCouleur3 = NULL;
     bufferYCbCrFinal = NULL;

     traitementEnCours=0; 


      value1=0;
      value2=0;
      value3=0;
      value4=0;
      value5=0;
      value6=0;
      value7=0;
      value8=0;
      value9=0;
      value10=0;
      value11=0;
      value12=0;
      value13=0;
      value14=0;
      value15=0;
      compteur=0;

      reception = 0;

}

UCallbackAction ConnectAibo::command(const UMessage &msg) 
{
  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;

	  urbi::UImage& img = msg.value->binary->image;

      int width = img.width;
      int height = img.height;
      int size3b = width*height*3;

      if (buffer == NULL && bufferYCbCr == NULL && bufferRGB == NULL)
      {
 	       buffer = new unsigned char[width * height * 3 * 10]; // 24 bits
           bufferRGB = new unsigned char[width * height * 4 * 10];  // 32 bits

            bufferRGBCouleur1 = new unsigned char[width * height * 4 * 10];  // 32 bits
            bufferRGBCouleur3 = new unsigned char[width * height * 4 * 10];  // 32 bits
            bufferRGBFinal = new unsigned char[width * height * 4 * 10];  // 32 bits

            bufferYCbCr = new unsigned char[width * height * 3 * 10]; // 24 bits
            bufferYCbCrCouleur1 = new unsigned char[width * height * 3 * 10]; // 24 bits
            bufferYCbCrCouleur3 = new unsigned char[width * height * 3 * 10]; // 24 bits
            bufferYCbCrFinal = new unsigned char[width * height * 3 * 10]; // 24 bits
      }


//////////////////////////////////////////////////////////////////////////////
// Realisation de imageQT et imageQT2
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image en RGB
      if( img.imageFormat == urbi::IMAGE_JPEG )
          convertJPEGtoRGB( (const byte *) img.data, img.size, (byte *) buffer, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
          convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );

      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    

       // copie de l'image dans QImage
      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image

      // on recupere la largeur et la hauteur
      int widthLabel = pere->ui.label_3->width();
      int heightLabel  = pere->ui.label_3->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT2 = imageQT;
  
  
//////////////////////////////////////////////////////////////////////////////
// Realisation de imageCouleur1
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image en YCbCr
      if( img.imageFormat == urbi::IMAGE_JPEG )
           convertJPEGtoYCrCb( (const byte *) img.data, img.size, (byte*) bufferYCbCr, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
           memcpy(bufferYCbCr, img.data, size3b);


      int nbDePixels=0;
      double centerX=0;
      double centerY=0;


       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCr[(3*i) + (j*width*3) + 0] <= pere->color1.Ymax && bufferYCbCr[(3*i) + (j*width*3) + 0] >= pere->color1.Ymin )
                     {
                         if( bufferYCbCr[(3*i) + (j*width*3) + 1] <=pere->color1.Cbmax && bufferYCbCr[(3*i) + (j*width*3) + 1] >= pere->color1.Cbmin )
                         {
                             if( bufferYCbCr[(3*i) + (j*width*3) + 2] <= pere->color1.Crmax && bufferYCbCr[(3*i) + (j*width*3) + 2] >= pere->color1.Crmin )
                             {
                                  nbDePixels++;
                                  centerX = centerX + i;
                                  centerY = centerY + j;
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = pere->color1.Ymoy;  // Y
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = pere->color1.Cbmoy;  //Cb
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = pere->color1.Crmoy;  // Cr
                             }
                             else
                             {
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = 16;  // Y
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = 128;  //Cb
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                             }
                         }
                         else
                         {
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = 16;  // Y
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = 128;  //Cb
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                         }
                     }
                     else
                     {
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = 16;  // Y
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = 128;  //Cb
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                     }
             }
       }    

       // on indique le nb de pixels et la position du centre
       pere->color1.nbTotal= nbDePixels ;
       if( nbDePixels != 0)
       {
           pere->color1.posX = (int) (centerX / nbDePixels) ;
           pere->color1.posY = (int) (centerY / nbDePixels) ;
       }
       else
       {
           pere->color1.posX = 0;
           pere->color1.posY = 0;           
       }

       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrCouleur1, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    


       // copie de l'image dans imageCouleur1
      imageCouleur1=QImage( bufferRGBCouleur1, width, height, QImage::Format_RGB32 ); // on stocke l'image



//////////////////////////////////////////////////////////////////////////////
// Realisation de imageCouleur3
/////////////////////////////////////////////////////////////////////////////

      nbDePixels=0;
      centerX=0;
      centerY=0;

       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCr[(3*i) + (j*width*3) + 0] <= pere->color3.Ymax && bufferYCbCr[(3*i) + (j*width*3) + 0] >= pere->color3.Ymin )
                     {
                         if( bufferYCbCr[(3*i) + (j*width*3) + 1] <=pere->color3.Cbmax && bufferYCbCr[(3*i) + (j*width*3) + 1] >= pere->color3.Cbmin )
                         {
                             if( bufferYCbCr[(3*i) + (j*width*3) + 2] <= pere->color3.Crmax && bufferYCbCr[(3*i) + (j*width*3) + 2] >= pere->color3.Crmin )
                             {
                                  nbDePixels++;
                                  centerX = centerX + i;
                                  centerY = centerY + j;
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = pere->color3.Ymoy;  // Y
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = pere->color3.Cbmoy;  //Cb
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = pere->color3.Crmoy;  // Cr
                             }
                             else
                             {
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = 16;  // Y
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = 128;  //Cb
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                             }
                         }
                         else
                         {
                             bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = 16;  // Y
                             bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = 128;  //Cb
                             bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                         }
                     }
                     else
                     {
                         bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = 16;  // Y
                         bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = 128;  //Cb
                         bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                     }
             }
       }    

       // on indique le nb de pixels et la position du centre
       pere->color3.nbTotal= nbDePixels ;
       if( nbDePixels != 0)
       {
           pere->color3.posX = (int) (centerX / nbDePixels) ;
           pere->color3.posY = (int) (centerY / nbDePixels) ;
       }
       else
       {
           pere->color3.posX = 0;
           pere->color3.posY = 0;           
       }

       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrCouleur3, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    
       

       // copie de l'image dans imageCouleur3
      imageCouleur3=QImage( bufferRGBCouleur3, width, height, QImage::Format_RGB32 ); // on stocke l'image


//////////////////////////////////////////////////////////////////////////////
// Realisation de l'image finale
/////////////////////////////////////////////////////////////////////////////


       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] == pere->color1.Ymoy && bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] <=pere->color1.Cbmoy &&  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] <= pere->color1.Crmoy)
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->color1.Ymoy;  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->color1.Cbmoy;  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->color1.Crmoy;  // Cr
                     }
                     else if( bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] == pere->color3.Ymoy && bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] <=pere->color3.Cbmoy &&  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] <= pere->color3.Crmoy)
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->color3.Ymoy;  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->color3.Cbmoy;  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->color3.Crmoy;  // Cr
                     }
                     else
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = bufferYCbCr[(3*i) + (j*width*3) + 0];  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = bufferYCbCr[(3*i) + (j*width*3) + 1];  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = bufferYCbCr[(3*i) + (j*width*3) + 2];  // Cr
                     }

             }
       }    

       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrFinal, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBFinal[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBFinal[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBFinal[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBFinal[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    


       // copie de l'image dans imageCouleur6
      imageFinal=QImage( bufferRGBFinal, width, height, QImage::Format_RGB32 ); // on stocke l'image

      imageFinal2 = imageFinal.scaledToHeight ( imageQT2.height() );          // on donne la meme taille que imageQT2



//////////////////////////////////////////////////////////////////////////////
// Affichage du resultat
/////////////////////////////////////////////////////////////////////////////
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);

      traitementEnCours=0;
 }

  return URBI_CONTINUE;
}






UCallbackAction ConnectAibo::command2(const UMessage &msg) 
{
  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;

	  urbi::UImage& img = msg.value->binary->image;

      int width = img.width;
      int height = img.height;
      int size3b = width*height*3;

      if (buffer == NULL && bufferYCbCr == NULL && bufferRGB == NULL)
      {
 	       buffer = new unsigned char[width * height * 3 * 10]; // 24 bits
           bufferRGB = new unsigned char[width * height * 4 * 10];  // 32 bits

            bufferRGBCouleur1 = new unsigned char[width * height * 4 * 10];  // 32 bits
            bufferRGBCouleur3 = new unsigned char[width * height * 4 * 10];  // 32 bits
            bufferRGBFinal = new unsigned char[width * height * 4 * 10];  // 32 bits

            bufferYCbCr = new unsigned char[width * height * 3 * 10]; // 24 bits
            bufferYCbCrCouleur1 = new unsigned char[width * height * 3 * 10]; // 24 bits
            bufferYCbCrCouleur3 = new unsigned char[width * height * 3 * 10]; // 24 bits
            bufferYCbCrFinal = new unsigned char[width * height * 3 * 10]; // 24 bits
      }


//////////////////////////////////////////////////////////////////////////////
// Realisation de imageQT et imageQT2
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image en RGB
      if( img.imageFormat == urbi::IMAGE_JPEG )
          convertJPEGtoRGB( (const byte *) img.data, img.size, (byte *) buffer, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
          convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );

      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    

       // copie de l'image dans QImage
      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image

      // on recupere la largeur et la hauteur
      int widthLabel = pere->ui.label_3->width();
      int heightLabel  = pere->ui.label_3->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT2 = imageQT;
  
  
//////////////////////////////////////////////////////////////////////////////
// Realisation de l'image finale
/////////////////////////////////////////////////////////////////////////////

      imageFinal2 = imageQT2; 

//////////////////////////////////////////////////////////////////////////////
// Affichage du resultat
/////////////////////////////////////////////////////////////////////////////
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);

      traitementEnCours=0;
 }

  return URBI_CONTINUE;
}



UCallbackAction ConnectAibo::values(const UMessage &msg) 
{


  if ( msg.value->type != urbi::DATA_DOUBLE)
    return URBI_CONTINUE;

        e1 = new QEvent((QEvent::Type)(1002));
        QCoreApplication::postEvent(this,e1);

  QString tag = QString::fromLatin1(msg.tag.c_str());
  int value = (int) msg.value->val;

    if( tag == "gain")
        value1=value;
    else if( tag == "shutter")
        value2=value;
    else if( tag == "wb")
        value3=value;


    else if( tag == "rymin")
        value4=value;
    else if( tag == "rymax")
        value5=value;
    else if( tag == "rcbmin")
        value6=value;
    else if( tag == "rcbmax")
        value7=value;
    else if( tag == "rcrmin")
        value8=value;
    else if( tag == "rcrmax")
        value9=value;


    else if( tag == "vymin")
        value10=value;
    else if( tag == "vymax")
        value11=value;
    else if( tag == "vcbmin")
        value12=value; 
    else if( tag == "vcbmax")
        value13=value;
    else if( tag == "vcrmin")
        value14=value;
    else if( tag == "vcrmax")
        value15=value;

  compteur++;
        if(compteur >= 15)
        {
               e1 = new QEvent((QEvent::Type)(1002));
               QCoreApplication::postEvent(this,e1);
               compteur = 0;
               return URBI_REMOVE;
        }

  return URBI_CONTINUE;
}








///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001))
 {
      pere->ui.label_3->setPixmap(QPixmap::fromImage(imageFinal2));     // on affiche l'image finale

      pere->color1.ui.lcdNumber->display(pere->color1.nbTotal);
      pere->color1.ui.lcdNumber_2->display(pere->color1.posX);
      pere->color1.ui.lcdNumber_3->display(pere->color1.posY);

      pere->color3.ui.lcdNumber->display(pere->color3.nbTotal);
      pere->color3.ui.lcdNumber_2->display(pere->color3.posX);
      pere->color3.ui.lcdNumber_3->display(pere->color3.posY);


       // creation de la couleur rouge
       QColor couleurR ( 127, 127, 127 ); 
       // creation de la couleur verte
       QColor couleurV ( 0, 255, 0 ); 

      if( reception == 0)
      {
            pere->ui.pushButton_3->setPalette(couleurV);               
            reception = 1;
      }
      else
      {
            pere->ui.pushButton_3->setPalette(couleurR);  
            reception = 0;
      }
 }

 else if( ev->type() == (QEvent::Type)(1002))
 {
       // creation de la couleur rouge
       QColor couleurR ( 127, 127, 127 ); 
       // creation de la couleur verte
       QColor couleurV ( 0, 255, 0 ); 


      if (value1 == 1)
      {
            pere->ui.pushButton_8->setPalette(couleurV);               
            pere->ui.pushButton_9->setPalette(couleurR);  
            pere->ui.pushButton_10->setPalette(couleurR);  
      }
      else if (value1 == 2)
      {
            pere->ui.pushButton_8->setPalette(couleurR);               
            pere->ui.pushButton_9->setPalette(couleurV);  
            pere->ui.pushButton_10->setPalette(couleurR);  
      }
      else if (value1 == 3)
      {
            pere->ui.pushButton_8->setPalette(couleurR);               
            pere->ui.pushButton_9->setPalette(couleurR);  
            pere->ui.pushButton_10->setPalette(couleurV);  
      }

      if (value2 == 1)
      {
            pere->ui.pushButton_11->setPalette(couleurV);               
            pere->ui.pushButton_12->setPalette(couleurR);  
            pere->ui.pushButton_13->setPalette(couleurR);  
      }
      else if (value2 == 2)
      {
            pere->ui.pushButton_11->setPalette(couleurR);               
            pere->ui.pushButton_12->setPalette(couleurV);  
            pere->ui.pushButton_13->setPalette(couleurR);  
      }
      else if (value2 == 3)
      {
            pere->ui.pushButton_11->setPalette(couleurR);               
            pere->ui.pushButton_12->setPalette(couleurR);  
            pere->ui.pushButton_13->setPalette(couleurV);  
      }

      if (value3 == 1)
      {
            pere->ui.pushButton_14->setPalette(couleurV);               
            pere->ui.pushButton_15->setPalette(couleurR);  
            pere->ui.pushButton_16->setPalette(couleurR);  
      }
      else if (value3 == 2)
      {
            pere->ui.pushButton_14->setPalette(couleurR);               
            pere->ui.pushButton_15->setPalette(couleurV);  
            pere->ui.pushButton_16->setPalette(couleurR);  
      }
      else if (value3 == 3)
      {
            pere->ui.pushButton_14->setPalette(couleurR);               
            pere->ui.pushButton_15->setPalette(couleurR);  
            pere->ui.pushButton_16->setPalette(couleurV);  
      }

      pere->color1.Ymin = value4;
      pere->color1.Ymax = value5;
      pere->color1.Cbmin = value6;
      pere->color1.Cbmax = value7;
      pere->color1.Crmin = value8;
      pere->color1.Crmax = value9;

      pere->color3.Ymin = value10;
      pere->color3.Ymax = value11;
      pere->color3.Cbmin = value12;
      pere->color3.Cbmax = value13;
      pere->color3.Crmin = value14;
      pere->color3.Crmax = value15;

      pere->color1.ui.spinBox->setValue(value4);
      pere->color1.ui.spinBox_2->setValue(value5);
      pere->color1.ui.spinBox_3->setValue(value6);
      pere->color1.ui.spinBox_4->setValue(value7);
      pere->color1.ui.spinBox_5->setValue(value8);
      pere->color1.ui.spinBox_6->setValue(value9);  
      
      pere->color3.ui.spinBox->setValue(value10);
      pere->color3.ui.spinBox_2->setValue(value11);
      pere->color3.ui.spinBox_3->setValue(value12);
      pere->color3.ui.spinBox_4->setValue(value13);
      pere->color3.ui.spinBox_5->setValue(value14);
      pere->color3.ui.spinBox_6->setValue(value15);  

      if( reception == 0)
      {
            pere->ui.pushButton_3->setPalette(couleurV);               
            reception = 1;
      }
      else
      {
            pere->ui.pushButton_3->setPalette(couleurR);  
            reception = 0;
      }

 }

 return 1;
}
