#include "mirror.h"

Mirror::Mirror(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);
}

void Mirror::on_pushButton_clicked()
{
    QString robotNameSource = ui.lineEdit->text();
    QString robotNameDestination = ui.lineEdit_2->text();

   QSettings settings("AiboMirror", "GOSTAI");
   settings.setValue("robotname1", robotNameSource);
   settings.setValue("robotname2", robotNameDestination);
   settings.sync ();

    if( urbiImage.robotS != NULL)
    {
        // fermeture de la session
          urbiImage.robotS->send(";;;; quit;");
          urbiImage.robotS->send("noop;");
          urbiImage.robotS->send("noop;");
          delete urbiImage.robotS;
    }
    urbiImage.robotS = NULL;


    if( urbiImage.robotD != NULL)
    {
        // fermeture de la session
          urbiImage.robotD->send(";;;; quit;");
          urbiImage.robotD->send("noop;");
          urbiImage.robotD->send("noop;");
          delete urbiImage.robotD;
    }
    urbiImage.robotD = NULL;


    urbiImage.robotS =new UClient(robotNameSource.toLatin1());
    urbiImage.robotD =new UClient(robotNameDestination.toLatin1());

    urbiImage.pere=pointeur;

    if (!urbiImage.robotS->error() && !urbiImage.robotD->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

    	urbiImage.robotS->send("motors off;");
        urbiImage.robotD->send("motors on;");
        
        // creation des callback
        for (int i=0;i<urbiImage.devCount-1;i++) 
            urbiImage.robotS->setCallback(callback(urbiImage,&ConnectAibo::command),urbiImage.devices[i]);
        urbiImage.robotS->setCallback(callback(urbiImage,&ConnectAibo::command),urbiImage.devices[urbiImage.devCount-1]);
    
        // envoi du code urbi
        urbiImage.robotS->send("looptag: loop {");
        for (int i=0;i<urbiImage.devCount-1;i++) 
    	    urbiImage.robotS->send("%s: %s&",urbiImage.devices[i], urbiImage.devices[i]);
        urbiImage.robotS->send("%s: %s},",urbiImage.devices[urbiImage.devCount-1], urbiImage.devices[urbiImage.devCount-1]);

    }
    else // pas de connexion
    {
         urbiImage.robotS = NULL;
         urbiImage.robotD = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }


}
