#include <QtGui>
#include <math.h>

#include "couleur.h"

//////////////////////////////////////////////////////
// Creation de l'objet
Couleur::Couleur(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);


         // on affiche la fenetre de graph
         visionGraph.initWindows1();
         visionGraph.resize(600,600);
         visionGraph.setTitle( "Aibo Members (axys Y and Z)" );   
         visionGraph.show();

         visionGraph2.initWindows2();
         visionGraph2.resize(600,600);
         visionGraph2.setTitle( "Aibo Members (axys X and Z)" );   
         visionGraph2.show();

}


///////////////////////////////////////////////
///////////////////////////////////////////////
// modification de posX
///////////////////////////////////////////////
///////////////////////////////////////////////

void Couleur::on_spinBox_valueChanged ( int i )
{
     calcul();
}

///////////////////////////////////////////////
///////////////////////////////////////////////
// modification de posY
///////////////////////////////////////////////
///////////////////////////////////////////////

void Couleur::on_spinBox_2_valueChanged ( int i )
{
     calcul();
}

///////////////////////////////////////////////
///////////////////////////////////////////////
// modification de distance
///////////////////////////////////////////////
///////////////////////////////////////////////
void Couleur::on_spinBox_3_valueChanged ( int i )
{
     calcul();
}

///////////////////////////////////////////////
///////////////////////////////////////////////
// modification de headPan
///////////////////////////////////////////////
///////////////////////////////////////////////
void Couleur::on_spinBox_4_valueChanged ( int i )
{
     calcul();
}

///////////////////////////////////////////////
///////////////////////////////////////////////
// modification de headTilt
///////////////////////////////////////////////
///////////////////////////////////////////////
void Couleur::on_spinBox_5_valueChanged ( int i )
{
     calcul();
}

///////////////////////////////////////////////
///////////////////////////////////////////////
// modification de neck
///////////////////////////////////////////////
///////////////////////////////////////////////
void Couleur::on_spinBox_6_valueChanged ( int i )
{
     calcul();
}


///////////////////////////////////////////////
///////////////////////////////////////////////
// calcul des coordonnes
///////////////////////////////////////////////
///////////////////////////////////////////////

void Couleur::calcul ( void )
{
    // on recupere toutes les valeurs donnees par l'utilisateur
    int posObjetX = ui.spinBox->value();
    int posObjetY = ui.spinBox_2->value();
    int distanceObjet = ui.spinBox_3->value();
    int headPan = ui.spinBox_4->value();
    int headTilt = ui.spinBox_5->value();
    int neck = ui.spinBox_6->value();    




/////////////////////////////////////////////////
// Referentiel camera
/////////////////////////////////////////////////    

    int widthCamera=208;    // la resolution de la camera est de 208 en horizontal
    int heightCamera=160;  // la resolution de la camera est de 160 en vertical

    double angleWidthCamera=56.9;  // l'angle de vision est de 56,9 degres
    double angleHeightCamera=45.2; // l'angle de vision est de 45.2 degres

    double angleWidhtObjet = ( (posObjetX * angleWidthCamera) / (widthCamera - 1) - angleWidthCamera / 2) * PI / 180;
    double angleHeightObjet = ( (posObjetY * angleHeightCamera) / (heightCamera - 1) - angleHeightCamera / 2) * PI / 180;

    double teta = angleWidhtObjet; // valeur de l'angle en radian

    double X1, Y1, Z1; // cela correspond aux coordonnees de l'objet
    double Xtemp, Ytemp, Ztemp; // cela correspond aux valeurs temporaires    

    Xtemp=0;
    Ytemp=0;
    Ztemp=distanceObjet;
    
    X1 = cos(teta) * Xtemp + sin(teta) * Ztemp;
    Y1 = Ytemp;
    Z1 = -sin(teta) * Xtemp + cos(teta) * Ztemp;
    
    teta = angleHeightObjet;
    Xtemp=X1;
    Ytemp=Y1;
    Ztemp=Z1;

    X1 = Xtemp;
    Y1 = cos(teta) * Ytemp - sin(teta)*Ztemp;
    Z1 = sin(teta) * Ytemp + cos(teta)*Ztemp;


/////////////////////////////////////////////////
// Referentiel axe rotation tete
/////////////////////////////////////////////////    

    int distanceAxeTeteCamera=9;

    int headPan2 = - headPan;   // on inverse la valeur
    int headTilt2 = - headTilt;   // on inverse la valeur

    double X2, Y2, Z2; // cela correspond aux coordonnees de la camera

    X2=0;
    Y2=0;
    Z2=distanceAxeTeteCamera;

    // on met a jour la position de l'objet
    X1=X1;
    Y1=Y1;
    Z1=Z1+9;

    teta = headPan2 * PI / 180;

    Xtemp=X2;
    Ytemp=Y2;
    Ztemp=Z2;
    
    X2 = cos(teta) * Xtemp + sin(teta) * Ztemp;
    Y2 = Ytemp;
    Z2 = -sin(teta) * Xtemp + cos(teta) * Ztemp;
    
    teta = headTilt2 * PI / 180;

    Xtemp=X2;
    Ytemp=Y2;
    Ztemp=Z2;

    X2 = Xtemp;
    Y2 = cos(teta) * Ytemp - sin(teta)*Ztemp;
    Z2 = sin(teta) * Ytemp + cos(teta)*Ztemp;

    teta = headPan2 * PI / 180;

    Xtemp=X1;
    Ytemp=Y1;
    Ztemp=Z1;
    
    X1 = cos(teta) * Xtemp + sin(teta) * Ztemp;
    Y1 = Ytemp;
    Z1 = -sin(teta) * Xtemp + cos(teta) * Ztemp;
    
    teta = headTilt2 * PI / 180;

    Xtemp=X1;
    Ytemp=Y1;
    Ztemp=Z1;

    X1 = Xtemp;
    Y1 = cos(teta) * Ytemp - sin(teta)*Ztemp;
    Z1 = sin(teta) * Ytemp + cos(teta)*Ztemp;


/////////////////////////////////////////////////
// Referentiel bas du cou
/////////////////////////////////////////////////    

    int distanceBasCouAxeTete=7;

    double X3, Y3, Z3; // cela correspond aux coordonnees de l'axe de rotation de la ete

    X3=0;
    Y3=distanceBasCouAxeTete;
    Z3=0;

    // on met a jour la position de la camera
    X2=X2;
    Y2=Y2+7;
    Z2=Z2;

    // on met a jour la position de l'objet
    X1=X1;
    Y1=Y1+7;
    Z1=Z1;

    int neck2=-neck;
    teta = neck2 * PI / 180;

    Xtemp=X3;
    Ytemp=Y3;
    Ztemp=Z3;

    X3 = Xtemp;
    Y3 = cos(teta) * Ytemp - sin(teta)*Ztemp;
    Z3 = sin(teta) * Ytemp + cos(teta)*Ztemp;


    teta = neck2 * PI / 180;

    Xtemp=X2;
    Ytemp=Y2;
    Ztemp=Z2;

    X2 = Xtemp;
    Y2 = cos(teta) * Ytemp - sin(teta)*Ztemp;
    Z2 = sin(teta) * Ytemp + cos(teta)*Ztemp;


    teta = neck2 * PI / 180;

    Xtemp=X1;
    Ytemp=Y1;
    Ztemp=Z1;

    X1 = Xtemp;
    Y1 = cos(teta) * Ytemp - sin(teta)*Ztemp;
    Z1 = sin(teta) * Ytemp + cos(teta)*Ztemp;


/////////////////////////////////////////////////
// Referentiel centre du robot
/////////////////////////////////////////////////    

    // position du centre du robot
    ui.lcdNumber_28->display(0);
    ui.lcdNumber_29->display(0);
    ui.lcdNumber_30->display(0);

    int distanceCentreRobotBasCou=9;

    double X4, Y4, Z4; // cela correspond aux coordonnees de l'axe de rotation de la ete

    X4=0;
    Y4=0;
    Z4=distanceCentreRobotBasCou;

    // on met a jour la position de l'axe de rotation de la tete
    X3=X3;
    Y3=Y3;
    Z3=Z3+9;

    // on met a jour la position de la camera
    X2=X2;
    Y2=Y2;
    Z2=Z2+9;

    // on met a jour la position de l'objet
    X1=X1;
    Y1=Y1;
    Z1=Z1+9;

    // position du bas du cou
    ui.lcdNumber_31->display( (int)X4 );
    ui.lcdNumber_32->display( (int)Y4 );
    ui.lcdNumber_33->display( (int)Z4 );

    // position de l'axe de rotation de la tete
    ui.lcdNumber_34->display( (int)X3 );
    ui.lcdNumber_35->display( (int)Y3 );
    ui.lcdNumber_36->display( (int)Z3 );

    // position de la camera
    ui.lcdNumber_37->display( (int)X2 );
    ui.lcdNumber_38->display( (int)Y2 );
    ui.lcdNumber_39->display( (int)Z2 );

    // position de l'objet
    ui.lcdNumber_40->display( (int)X1 );
    ui.lcdNumber_41->display( (int)Y1 );
    ui.lcdNumber_42->display( (int)Z1 );

    // camera
    urbiImage.posx=posObjetX;
    urbiImage.posy=posObjetY;

    // on envoie les donnees pour l'affichage
    visionGraph.onPlot(X1,X2,X3,X4,Y1,Y2,Y3,Y4,Z1,Z2,Z3,Z4);   
    visionGraph2.onPlot2(X1,X2,X3,X4,Y1,Y2,Y3,Y4,Z1,Z2,Z3,Z4);   
}


///////////////////////////////////////////
// se connecter au robot
void Couleur::on_pushButton_clicked()
{
    urbiImage.pere=pointeur;

    // recuperation des donnes du nom et du port
    QString robotName = ui.lineEdit->text();
    QSettings settings("Object Position", "GOSTAI");
    settings.setValue("robotname", robotName);

    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg;");
          urbiImage.robotI->send("noop;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0;
          urbiImage.compteurvalue=0;

    }
    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient( robotName.toLatin1() );

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);  

    urbiImage.robotI->send("stop uimg;");
    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");
    urbiImage.robotI->send("uimg:every(50ms){ uimg:camera.val},");

       // recuperation de la position des moteurs
       urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::returnvaluemotor),"totoheadPan");
       urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::returnvaluemotor),"totoheadTilt");
       urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::returnvaluemotor),"totoneck");
    }
    else // pas de connexion
    {
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);   
         urbiImage.robotI = NULL;
    }

}

///////////////////////////////////////////
// se connecter au robot
void Couleur::on_pushButton_2_clicked()
{

    if( urbiImage.robotI != NULL)
    {
        urbiImage.robotI->send("totoheadPan: headPan,");
        urbiImage.robotI->send("totoheadTilt: headTilt,");
        urbiImage.robotI->send("totoneck: neck,");
    }

}
