#include "plot.h"

Plot::Plot()
{

}


/////////////////////////////////////////////////////////////////////////
// vue de profil
/////////////////////////////////////////////////////////////////////////

void Plot::initWindows1()
{
    setTitle("Aibo Members ( Y and Z)");
    insertLegend(new QwtLegend(), QwtPlot::RightLegend);

    // Set axis titles
    setAxisTitle(xBottom, "Z (cm)"); // titre de l'axe des X
    setAxisTitle(yLeft, "Y (cm)"); // permet de mettre un titre a l'axe des Y

    // on decide de la valeur min et de la valeur max des axes
    setAxisScale  (  xBottom, -20, 20);
    setAxisScale  (  yLeft, -20, 20);

    // on decide de mettre 5 indications de position
    setAxisMaxMajor  (  xBottom, 4); 
    setAxisMaxMajor  (  yLeft, 4);


    
    // tableau contenant les valeurs
    dataCourbe1Y = NULL;
    dataCourbe2Y = NULL;
    dataCourbe3Y = NULL;
    dataCourbe1Z = NULL;
    dataCourbe2Z = NULL;
    dataCourbe3Z = NULL;

     // configuration de toutes les droites
     courbe1 = new QwtPlotCurve("Static Body");
     courbe1->setRenderHint(QwtPlotItem::RenderAntialiased);
     courbe1->setPen(QPen(Qt::black));
     courbe2 = new QwtPlotCurve("Mobile Body");
     courbe2->setRenderHint(QwtPlotItem::RenderAntialiased);
     courbe2->setPen(QPen(Qt::red));
     courbe3 = new QwtPlotCurve("Object");
     courbe3->setRenderHint(QwtPlotItem::RenderAntialiased);
     courbe3->setPen(QPen(Qt::blue));

     // on attache les courbes au graph
     courbe1->attach(this);
     courbe2->attach(this);
     courbe3->attach(this);


    // Creation des tableaux qui vont stocker les valeurs
    dataCourbe1Y = (double* ) malloc(21 * sizeof(double));
    dataCourbe2Y = (double* ) malloc(4 * sizeof(double));
    dataCourbe3Y = (double* ) malloc(2 * sizeof(double));
    dataCourbe1Z = (double* ) malloc(21 * sizeof(double));
    dataCourbe2Z = (double* ) malloc(4 * sizeof(double));
    dataCourbe3Z = (double* ) malloc(2 * sizeof(double));

    // on donne les valeurs de la partie du corps immobile
    dataCourbe1Z[0]=-6; // extremite de la queue
    dataCourbe1Y[0]=5;
    dataCourbe1Z[1]=-11; // extremite gauche du robot
    dataCourbe1Y[1]=0;
    dataCourbe1Z[2]=-7; // debut des jambes
    dataCourbe1Y[2]=0;
    dataCourbe1Z[3]=-12; // jambe1
    dataCourbe1Y[3]=-5;
    dataCourbe1Z[4]=-19; // pied jambe1
    dataCourbe1Y[4]=-5;
    dataCourbe1Z[5]=-12; // jambe1
    dataCourbe1Y[5]=-5;
    dataCourbe1Z[6]=-7; // debut des jambes
    dataCourbe1Y[6]=0;
    dataCourbe1Z[7]=-2; // jambe2
    dataCourbe1Y[7]=-5;
    dataCourbe1Z[8]=-9; // pied jambe2
    dataCourbe1Y[8]=-5;
    dataCourbe1Z[9]=-2; // jambe2
    dataCourbe1Y[9]=-5;
    dataCourbe1Z[10]=-7; // debut des jambes
    dataCourbe1Y[10]=0;
    dataCourbe1Z[11]=7; // debut des jambes
    dataCourbe1Y[11]=0;
    dataCourbe1Z[12]=12; // jambe3
    dataCourbe1Y[12]=-5;
    dataCourbe1Z[13]=5; // pied jambe3
    dataCourbe1Y[13]=-5;
    dataCourbe1Z[14]=12; // jambe3
    dataCourbe1Y[14]=-5;
    dataCourbe1Z[15]=7; // debut des jambes
    dataCourbe1Y[15]=0;
    dataCourbe1Z[16]=2.5; // jambe4
    dataCourbe1Y[16]=-5.2;
    dataCourbe1Z[17]=-4.2; // pied jambe4
    dataCourbe1Y[17]=-5.2;
    dataCourbe1Z[18]=2.5; // jambe4
    dataCourbe1Y[18]=-5.2;
    dataCourbe1Z[19]=7; // debut des jambes
    dataCourbe1Y[19]=0;
    dataCourbe1Z[20]=-11; // extremite droite du robot
    dataCourbe1Y[20]=0;

    // on donne les valeurs de la partie du corps mobile
    dataCourbe2Z[0]=0; // centre du robot
    dataCourbe2Y[0]=0;
    dataCourbe2Z[1]=9; // bas du cou
    dataCourbe2Y[1]=0;
    dataCourbe2Z[2]=9; // axe de rotation de la tete
    dataCourbe2Y[2]=7;
    dataCourbe2Z[3]=18; // camera
    dataCourbe2Y[3]=7;

    // on donne les valeurs de l'objet
    dataCourbe3Z[0]=18; // camera
    dataCourbe3Y[0]=7;
    dataCourbe3Z[1]=18; // objet
    dataCourbe3Y[1]=7;


    courbe1->setData(dataCourbe1Z, dataCourbe1Y, 21 );
    courbe2->setData(dataCourbe2Z, dataCourbe2Y, 4 );
    courbe3->setData(dataCourbe3Z, dataCourbe3Y, 2 );
}

///////////////////////////////////////////////
// Mise a jour du graph
void Plot::onPlot(double X1, double X2, double X3, double X4,double Y1, double Y2, double Y3, double Y4,double Z1, double Z2, double Z3, double Z4)
{
    // on recherche les positions min et max
    int Zmin = -19;

    int Zmax = (int) Z1;
    if (Z2 > Zmax)
       Zmax = (int) Z2;
    if (Z3 > Zmax)
       Zmax = (int) Z3;
    if (Z4 > Zmax)
       Zmax = (int) Z4;

    int Zmoy = (int) (Zmax + Zmin)/2;
    int Zdist= Zmax - Zmoy;

    int Ymin = -5;
    if (Y1 < Ymin)
       Ymin = (int) Y1;
    if (Y2 < Ymin)
       Ymin = (int) Y2;
    if (Y3 < Ymin)
       Ymin = (int) Y3;
    if (Y4 < Ymin)
       Ymin = (int) Y4;

    int Ymax = (int) Y1;
    if (Y2 > Ymax)
       Ymax = (int) Y2;
    if (Y3 > Ymax)
       Ymax = (int) Y3;
    if (Y4 > Ymax)
       Ymax = (int) Y4;

    int Ymoy = (int) (Ymax + Ymin)/2;
    int Ydist= Ymax - Ymoy;

    if(Ydist > Zdist)
        Zdist = Ydist;
    else
        Ydist = Zdist;


    // on decide de la valeur min et de la valeur max des axes
    setAxisScale  (  xBottom, Zmoy - Zdist - 1, Zmoy + Zdist + 1);
    setAxisScale  (  yLeft, Ymoy - Ydist - 1, Ymoy + Ydist + 1);

    // dessin de la partie mobile 
    dataCourbe2Z[1]=Z4; // bas du cou
    dataCourbe2Y[1]=Y4;
    dataCourbe2Z[2]=Z3; // axe rotation
    dataCourbe2Y[2]=Y3;
    dataCourbe2Z[3]=Z2; // camera
    dataCourbe2Y[3]=Y2;

    
    // dessin de l'objet 
    dataCourbe3Z[0]=Z2; // objet
    dataCourbe3Y[0]=Y2;
    dataCourbe3Z[1]=Z1; // objet
    dataCourbe3Y[1]=Y1;



    courbe2->setData(dataCourbe2Z, dataCourbe2Y, 4 );
    courbe3->setData(dataCourbe3Z, dataCourbe3Y, 2 );


    this->replot();  
}


/////////////////////////////////////////////////////////////////////////
// vue de dessus
/////////////////////////////////////////////////////////////////////////

void Plot::initWindows2()
{
    setTitle("Aibo Members ( X and Z)");
    insertLegend(new QwtLegend(), QwtPlot::RightLegend);

    // Set axis titles
    setAxisTitle(xBottom, "Z (cm)"); // titre de l'axe des X
    setAxisTitle(yLeft, "X (cm)"); // permet de mettre un titre a l'axe des Y

    // on decide de la valeur min et de la valeur max des axes
    setAxisScale  (  xBottom, -20, 20);
    setAxisScale  (  yLeft, -20, 20);

    // on decide de mettre 5 indications de position
    setAxisMaxMajor  (  xBottom, 4); 
    setAxisMaxMajor  (  yLeft, 4);


    
    // tableau contenant les valeurs
    dataCourbe12X = NULL;
    dataCourbe22X = NULL;
    dataCourbe32X = NULL;
    dataCourbe12Z = NULL;
    dataCourbe22Z = NULL;
    dataCourbe32Z = NULL;

     // configuration de toutes les droites
     courbe12 = new QwtPlotCurve("Static Body");
     courbe12->setRenderHint(QwtPlotItem::RenderAntialiased);
     courbe12->setPen(QPen(Qt::black));
     courbe22 = new QwtPlotCurve("Mobile Body");
     courbe22->setRenderHint(QwtPlotItem::RenderAntialiased);
     courbe22->setPen(QPen(Qt::red));
     courbe32 = new QwtPlotCurve("Object");
     courbe32->setRenderHint(QwtPlotItem::RenderAntialiased);
     courbe32->setPen(QPen(Qt::blue));

     // on attache les courbes au graph
     courbe12->attach(this);
     courbe22->attach(this);
     courbe32->attach(this);


    // Creation des tableaux qui vont stocker les valeurs
    dataCourbe12X = (double* ) malloc(21 * sizeof(double));
    dataCourbe22X = (double* ) malloc(4 * sizeof(double));
    dataCourbe32X = (double* ) malloc(2 * sizeof(double));
    dataCourbe12Z = (double* ) malloc(21 * sizeof(double));
    dataCourbe22Z = (double* ) malloc(4 * sizeof(double));
    dataCourbe32Z = (double* ) malloc(2 * sizeof(double));

    // on donne les valeurs de la partie du corps immobile
    dataCourbe12Z[0]=-6; // extremite de la queue
    dataCourbe12X[0]=0;
    dataCourbe12Z[1]=-11; // extremite gauche du robot
    dataCourbe12X[1]=0;

    // rectangle
    dataCourbe12Z[2]=-11; 
    dataCourbe12X[2]=5; 
    dataCourbe12Z[3]=-11; 
    dataCourbe12X[3]=-5; 
    dataCourbe12Z[4]=9; 
    dataCourbe12X[4]=-5; 
    dataCourbe12Z[5]=9; 
    dataCourbe12X[5]=5;
    dataCourbe12Z[6]=-11; 
    dataCourbe12X[6]=5; 

/*
    dataCourbe12Z[2]=-7; // debut des jambes
    dataCourbe12X[2]=0;
    dataCourbe12Z[3]=-12; // jambe1
    dataCourbe12X[3]=-5;
    dataCourbe12Z[4]=-19; // pied jambe1
    dataCourbe12X[4]=-5;
    dataCourbe12Z[5]=-12; // jambe1
    dataCourbe12X[5]=-5;
    dataCourbe12Z[6]=-7; // debut des jambes
    dataCourbe12X[6]=0;
    dataCourbe12Z[7]=-2; // jambe2
    dataCourbe12X[7]=-5;
    dataCourbe12Z[8]=-9; // pied jambe2
    dataCourbe12X[8]=-5;
    dataCourbe12Z[9]=-2; // jambe2
    dataCourbe12X[9]=-5;
    dataCourbe12Z[10]=-7; // debut des jambes
    dataCourbe12X[10]=0;
    dataCourbe12Z[11]=7; // debut des jambes
    dataCourbe12X[11]=0;
    dataCourbe12Z[12]=12; // jambe3
    dataCourbe12X[12]=-5;
    dataCourbe12Z[13]=5; // pied jambe3
    dataCourbe12X[13]=-5;
    dataCourbe12Z[14]=12; // jambe3
    dataCourbe12X[14]=-5;
    dataCourbe12Z[15]=7; // debut des jambes
    dataCourbe12X[15]=0;
    dataCourbe12Z[16]=2.5; // jambe4
    dataCourbe12X[16]=-5.2;
    dataCourbe12Z[17]=-4.2; // pied jambe4
    dataCourbe12X[17]=-5.2;
    dataCourbe12Z[18]=2.5; // jambe4
    dataCourbe12X[18]=-5.2;
    dataCourbe12Z[19]=7; // debut des jambes
    dataCourbe12X[19]=0;
    dataCourbe12Z[20]=-11; // extremite droite du robot
    dataCourbe12X[20]=0;
*/

    // on donne les valeurs de la partie du corps mobile
    dataCourbe22Z[0]=0; // centre du robot
    dataCourbe22X[0]=0;
    dataCourbe22Z[1]=9; // bas du cou
    dataCourbe22X[1]=0;
    dataCourbe22Z[2]=9; // axe de rotation de la tete
    dataCourbe22X[2]=0;
    dataCourbe22Z[3]=18; // camera
    dataCourbe22X[3]=0;

    // on donne les valeurs de l'objet
    dataCourbe32Z[0]=18; // camera
    dataCourbe32X[0]=0;
    dataCourbe32Z[1]=18; // objet
    dataCourbe32X[1]=0;


    courbe12->setData(dataCourbe12Z, dataCourbe12X, 7 );
    courbe22->setData(dataCourbe22Z, dataCourbe22X, 4 );
    courbe32->setData(dataCourbe32Z, dataCourbe32X, 2 );
}

///////////////////////////////////////////////
// Mise a jour du graph
void Plot::onPlot2(double X1, double X2, double X3, double X4,double Y1, double Y2, double Y3, double Y4,double Z1, double Z2, double Z3, double Z4)
{
    // on recherche les positions min et max
    int Zmin = -19;

    int Zmax = (int) Z1;
    if (Z2 > Zmax)
       Zmax = (int) Z2;
    if (Z3 > Zmax)
       Zmax = (int) Z3;
    if (Z4 > Zmax)
       Zmax = (int) Z4;

    int Zmoy = (int) (Zmax + Zmin)/2;
    int Zdist= Zmax - Zmoy;

    int Xmin = -5;
    if (X1 < Xmin)
       Xmin = (int) X1;
    if (X2 < Xmin)
       Xmin = (int) X2;
    if (X3 < Xmin)
       Xmin = (int) X3;
    if (X4 < Xmin)
       Xmin = (int) X4;

    int Xmax = (int) X1;
    if (X2 > Xmax)
       Xmax = (int) X2;
    if (X3 > Xmax)
       Xmax = (int) X3;
    if (X4 > Xmax)
       Xmax = (int) X4;

    int Xmoy = (int) (Xmax + Xmin)/2;
    int Xdist= Xmax - Xmoy;

    if(Xdist > Zdist)
        Zdist = Xdist;
    else
        Xdist = Zdist;


    // on decide de la valeur min et de la valeur max des axes
    setAxisScale  (  xBottom, Zmoy - Zdist - 1, Zmoy + Zdist + 1);
    setAxisScale  (  yLeft, Xmoy - Xdist - 1, Xmoy + Xdist + 1);

    // dessin de la partie mobile 
    dataCourbe22Z[1]=Z4; // bas du cou
    dataCourbe22X[1]=X4;
    dataCourbe22Z[2]=Z3; // axe rotation
    dataCourbe22X[2]=X3;
    dataCourbe22Z[3]=Z2; // camera
    dataCourbe22X[3]=X2;

    
    // dessin de l'objet 
    dataCourbe32Z[0]=Z2; // objet
    dataCourbe32X[0]=X2;
    dataCourbe32Z[1]=Z1; // objet
    dataCourbe32X[1]=X1;



    courbe22->setData(dataCourbe22Z, dataCourbe22X, 4 );
    courbe32->setData(dataCourbe32Z, dataCourbe32X, 2 );


    this->replot();  
}
