#include "urbi.h"
#include "couleur.h"


ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotI = NULL;  
     buffer = NULL;
     bufferRGB = NULL;   

     traitementEnCours=0; 
      visible = 1;

      posx=103;
      posy=79;

      compteurvalue=0;
}

UCallbackAction ConnectAibo::command(const UMessage &msg) 
{
  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;


 if(traitementEnCours == 0)
 {
      traitementEnCours=1;

	  urbi::UImage& img = msg.value->binary->image;

      int width = img.width;
	  int height = img.height;
      int size3b = width*height*3;


      if (buffer == NULL && bufferRGB == NULL)
      {
    		       buffer = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
     		       bufferRGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
      }



      // conversion de l'image en RGB
      if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
          convertJPEGtoRGB( (const byte *) img.data, img.size, (byte *) buffer, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
          convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );
      else if ( img.imageFormat == urbi::IMAGE_RGB)
            memcpy(  buffer, img.data, img.size );
      else
            memcpy(  buffer, img.data, img.size );



      if (visible == 1)
      {

         int positionx =  posx;
         int positiony =  posy;

           for(int i=0; i<=width; i++)
           {
                      buffer[(3*i) + (positiony*width*3) + 2] = 255;  // bleu
                      buffer[(3*i) + (positiony*width*3) + 1] = 255;  //vert
                      buffer[(3*i) + (positiony*width*3) + 0] = 255;  // rouge
           }                      
                      
           for(int j=0; j<=height; j++)
           {
                      buffer[(3*positionx) + (j*width*3) + 2] = 255;  // bleu
                      buffer[(3*positionx) + (j*width*3) + 1] = 255;  //vert
                      buffer[(3*positionx) + (j*width*3) + 0] = 255;  // rouge
           }                      
      }


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    

       // copie de l'image dans QImage
      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image
 
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);
    
      traitementEnCours=0;

 }



  return URBI_CONTINUE;
}


UCallbackAction ConnectAibo::returnvaluemotor(const UMessage &msg) 
{

  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_DOUBLE)
    return URBI_CONTINUE;

  QString tag = QString::fromLatin1(msg.tag.c_str());
  int value = (int) msg.value->val;

    if( tag == "totoheadPan")
        value1=value;
    else if( tag == "totoheadTilt")
        value2=value;
    else if( tag == "totoneck")
        value3=value;

    compteurvalue++;


  if( compteurvalue >= 3)
  {

      e1 = new QEvent((QEvent::Type)(1002));
      QCoreApplication::postEvent(this,e1);

       compteurvalue=0;
  }



  return URBI_CONTINUE;
}



///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001))
 {
      pere->ui.label_7->setPixmap(QPixmap::fromImage(imageQT));     // on affiche
 }

 else if( ev->type() == (QEvent::Type)(1002))
 {
      pere->ui.spinBox_4->setValue(value1);     // headPan
      pere->ui.spinBox_5->setValue(value2);     // headTilt
      pere->ui.spinBox_6->setValue(value3);     // neck

      pere->calcul();

 }

 return 1;
}
