#ifndef URBI_H
#define URBI_H

#include "urbi/uclient.hh"
#include <QWidget>
#include <QtGui>

#include <fmod.h>
#include <fmod_errors.h>

class Telecommande;
using namespace urbi;

class ConnectAibo : public QWidget
{
    Q_OBJECT

public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotC; // communication des commandes
      UClient *robotI; // transfert des images
      UClient *robotS; // transfert des sons

      // lien pour acceder aux objets de telecommande
      Telecommande *pere;

      // les evenements servent pour l'affichage a l'ecran
      virtual bool event(QEvent *ev);
      QEvent *e4;

      // sert pour la page 6
      UCallbackAction allrecupimg(const UMessage &); 
      unsigned char* buffer;
      unsigned char* bufferRGB; 
      int traitementEnCours;
      QImage imageQT;
      QImage imageQT2;

      int reception; // indique quand on recoit quelque chose

      // energie
      UCallbackAction allrecupenergie(const UMessage &); 
      int power;

      // sert pour le son
      UCallbackAction getSoundQT(const UMessage &);
      UCallbackAction getSoundFMOD(const UMessage &);
      int ERRCHECK(FMOD_RESULT result);
      QFile fileQT;
      QFile fileFMOD;
      QDataStream *outfile;
      bool initialized;
      bool errorfmod;
      // FMOD variables
	FMOD_SYSTEM      *system;
	FMOD_SOUND       *sound1;
	FMOD_CHANNEL     *channel;
	FMOD_RESULT       result;
	int               key;
	unsigned int      version;

};

#endif

