#include "urbi.h"
#include "tele.h"

ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotC = NULL;                           
}



UCallbackAction ConnectAibo::getSound(const UMessage &msg) 
{

  // si ce n'est pas du son, alors on quitte
  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_SOUND)
    return URBI_CONTINUE;


   urbi::USound& snd = msg.value->binary->sound;


  if ( initialized == false ) 
  {
    initialized = true;
    totallength = 0;

// on dfinit les paramtres de USound out
// char                  *data;            // pointer to sound data
// int                   size;             // total size in byte
// int                   channels;         // number of audio channels
// int                   rate;             // rate in Hertz
// int                   sampleSize;       // sample size in bit
// USoundFormat          soundFormat;      // format of the sound data (SOUND_RAW, SOUND_WAV, SOUDN_MP3...)
// USoundSampleFormat    sampleFormat;     // sample format

    out.data = 0;
    out.size = 0;
    out.channels = 2; // stereo
    out.sampleSize = 16; // 16 bits
    out.rate = 16000; // 16.000 Hz
    out.sampleFormat = SAMPLE_SIGNED;   // 8 bits non signe, 16 bits = signe
    out.soundFormat = SOUND_WAV; // pour avoir le header
  }
  else
      out.soundFormat = SOUND_RAW; // pour ne plus avoir de header
 

  // conversion de msg.sound vers le USound out
  convert(snd, out);
// convert converti le son dans le bon format du Usound de destination


  // taille totale = taille totale + taille du son en cours
  totallength = totallength + out.size;

  // on enregistre out dans un fichier
  outfile->writeRawData ( out.data, out.size );

  return URBI_CONTINUE;

}







/*
struct wavheader {
	char riff[4];
	int length; == valeur totale du fichier en octets - 8
	char wave[4];
	char fmt[4];
	int lnginfo;
	short one;
	short channels;
	int freqechant;
	int bytespersec;
	short bytesperechant;
	short bitperchannel;
	char data[4]; = valeur totale du fichier en octets - 44
	int datalength;
  };
*/

UCallbackAction ConnectAibo::endProgram(const UMessage &msg) 
{
      file.close();  // on ferme le fichier

      int len = totallength  - 8; // calcul de la taille totale ==> variable length dans le header
      int datalen = totallength - 44; // calcul de la taille data ==> variable datalength dans le header

      file.setFileName(pere->fileNameWav);  // Selection du fichier
      file.open(QIODevice::ReadWrite ); // le fichier est ouvert en lecture/ecriture
      file.seek ( 4 ); // on se place a l'endroit qui nous interesse
      file.write ( (char *)&len, 4 ); // on copie le contenu de texte dans le fichier
      file.seek ( 40 ); // on se place a l'endroit qui nous interesse
      file.write ( (char *)&datalen, 4 ); // on copie le contenu de texte dans le fichier
      file.close();  // on ferme le fichier

       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);

  return URBI_CONTINUE;
}




///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{
     
 if( ev->type() == (QEvent::Type)(1001))
 {
               // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      pere->ui.pushButton->setPalette(couleur);    
 }

 return 1;
}





