#include "urbi.h"
#include "tele.h"

ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotC = NULL;                           

     valuemax = 0;
     valuemin = 25000;
     state = 0;

}


UCallbackAction ConnectAibo::returnvaluevolume(const UMessage &msg) 
{
  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_DOUBLE)
    return URBI_CONTINUE;

  value1 = (int) msg.value->val;

  if ( value1 > valuemax)
     valuemax = value1;
  if ( value1 < valuemin)
     valuemin = value1;

  if ( value1 <= valuemin * 10)
     state = 1;
  else if ( value1 >= valuemin * 100)
     state = 2;
  else
      state = 0;

  e1 = new QEvent((QEvent::Type)(1002));
  QCoreApplication::postEvent(this,e1);

  return URBI_CONTINUE;
}



///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1002))
 {

       pere->ui.lcdNumber_1->display(value1); 
       pere->ui.progressBar_1->setValue(value1); 

       pere->ui.lcdNumber_2->display(valuemin); 
       pere->ui.lcdNumber_3->display(valuemax); 

       if(state == 0) // en attente
       {
                pere->ui.pushButton->setText("State");
                QColor couleur ( 128, 128, 128 ); 
                pere->ui.pushButton->setPalette(couleur);   
       }
       if(state == 1) // silencieux
       {
                pere->ui.pushButton->setText("Silent");
                QColor couleur ( 0, 255, 0 ); 
                pere->ui.pushButton->setPalette(couleur);        
       }
       else if(state == 2) // bruit
       {
                pere->ui.pushButton->setText("Noise");
                QColor couleur ( 255, 0, 0 ); 
                pere->ui.pushButton->setPalette(couleur);     
       }



 }
     

 return 1;
}
