#ifndef TELE_H
#define TELE_H

#include "ui_telecommande.h"
#include "urbi.h"
#include "camera.h"
#include "plot.h"
#include <QWidget>
#include <QtGui>

#include <QMainWindow>

class Telecommande : public QMainWindow
{
    Q_OBJECT

public:
    ConnectAibo urbiTele; // connexion URBI
    Camera visionCamera; // fenetre pour afficher la camera
    Plot visionGraph; // fenetre pour afficher les graphs des moteurs
    Plot visionGraph2; // fenetre pour afficher les graphs d'une variable

    Telecommande(QWidget *parent = 0);
    Telecommande *pointeur;

    Ui::Telecommande ui;

    int neRienFaireAvecLesMoteurs; // sert pour la page 3
    int neRienFaireAvecLaCamera; // sert pour la page 6

    void arretDeLaCamera(); // sert pour la page 6
    void arretDuGraph(); // sert pour la page 8
    void arretDuGraphVariable(); // sert pour la page 8

private slots:

    // sert pour la page 1
    void on_lineEdit_returnPressed(); 
    void on_pushButton_clicked();
    void on_pushButton_2_clicked();
    void on_pushButton_3_clicked();
    void on_pushButton_4_clicked();
    void on_pushButton_5_clicked();
    void on_pushButton_6_clicked();
    void on_pushButton_12_clicked();
    void on_pushButton_13_clicked();
    void on_pushButton_20_clicked();
    void on_pushButton_21_clicked();
    void on_pushButton_22_clicked();
    void on_pushButton_23_clicked();
    void on_pushButton_24_clicked();
    void on_pushButton_25_clicked();
    void on_pushButton_26_clicked();
    void on_pushButton_27_clicked();    
    void on_pushButton_28_clicked();    
    void on_pushButton_94_clicked();   
    void on_pushButton_98_clicked();   //group
    void on_pushButton_99_clicked();   //strict
    void on_pushButton_100_clicked();   //unstrict

    // sert pour la page 2 // fonctions
    void on_pushButton_7_clicked(); // unfreeze ball tracking
    void on_pushButton_8_clicked(); // freeze ball tracking
    void on_pushButton_9_clicked(); // execute motion
    void on_pushButton_10_clicked();  // load script
    void on_pushButton_11_clicked(); // play sound
    void on_pushButton_77_clicked(); // avancer
    void on_pushButton_78_clicked(); // gauche
    void on_pushButton_79_clicked(); // droite
    void on_pushButton_80_clicked(); // reculer
    void on_pushButton_81_clicked(); // stop
    void on_pushButton_84_clicked(); // robot.walk
    void on_pushButton_85_clicked(); // robot.turn
    void on_pushButton_101_clicked(); // walk.go
    void on_pushButton_102_clicked(); // walk.turn


 // sert pour la page 3 // moteurs 
    void on_spinBox_2_valueChanged ( int i ); 
    void on_spinBox_3_valueChanged ( int i ); 
    void on_spinBox_4_valueChanged ( int i );
    void on_spinBox_5_valueChanged ( int i );
    void on_spinBox_6_valueChanged ( int i );
    void on_spinBox_7_valueChanged ( int i );
    void on_spinBox_8_valueChanged ( int i );
    void on_spinBox_9_valueChanged ( int i );
    void on_spinBox_10_valueChanged ( int i );
    void on_spinBox_11_valueChanged ( int i );
    void on_spinBox_12_valueChanged ( int i );
    void on_spinBox_13_valueChanged ( int i );
    void on_spinBox_14_valueChanged ( int i );
    void on_spinBox_15_valueChanged ( int i );
    void on_spinBox_16_valueChanged ( int i );
    void on_spinBox_17_valueChanged ( int i );
    void on_spinBox_18_valueChanged ( int i );
    void on_spinBox_19_valueChanged ( int i );
    void on_spinBox_20_valueChanged ( int i );
    void on_spinBox_21_valueChanged ( int i );

    // sert pour la page 3 // moteurs
    void on_horizontalSlider_valueChanged();
    void on_horizontalSlider_2_valueChanged();
    void on_horizontalSlider_3_valueChanged();
    void on_horizontalSlider_4_valueChanged();
    void on_horizontalSlider_5_valueChanged();
    void on_horizontalSlider_6_valueChanged();
    void on_horizontalSlider_7_valueChanged();
    void on_horizontalSlider_8_valueChanged();
    void on_horizontalSlider_9_valueChanged();
    void on_horizontalSlider_10_valueChanged();
    void on_horizontalSlider_11_valueChanged();
    void on_horizontalSlider_12_valueChanged();
    void on_horizontalSlider_13_valueChanged();
    void on_horizontalSlider_14_valueChanged();
    void on_horizontalSlider_15_valueChanged();
    void on_horizontalSlider_16_valueChanged();
    void on_horizontalSlider_17_valueChanged();
    void on_horizontalSlider_18_valueChanged();
    void on_horizontalSlider_19_valueChanged();
    void on_horizontalSlider_20_valueChanged();


    // sert pour la page 4 // leds
    void on_pushButton_14_clicked();
    void on_pushButton_15_clicked();
    void on_pushButton_16_clicked();
    void on_pushButton_17_clicked();
    void on_pushButton_18_clicked();
    void on_pushButton_19_clicked();
    void on_pushButton_29_clicked();    
    void on_pushButton_30_clicked();    
    void on_pushButton_31_clicked();    
    void on_pushButton_32_clicked();    
    void on_pushButton_33_clicked();    
    void on_pushButton_34_clicked();    
    void on_pushButton_35_clicked();    
    void on_pushButton_36_clicked();    
    void on_pushButton_37_clicked();    
    void on_pushButton_38_clicked();
    void on_pushButton_39_clicked();
    void on_pushButton_40_clicked();    
    void on_pushButton_41_clicked();    
    void on_pushButton_42_clicked();    
    void on_pushButton_43_clicked();
    void on_pushButton_44_clicked();
    void on_pushButton_45_clicked();
    void on_pushButton_46_clicked();
    void on_pushButton_47_clicked();
    void on_pushButton_48_clicked();
    void on_pushButton_49_clicked();
    void on_pushButton_50_clicked();
    void on_pushButton_51_clicked();
    void on_pushButton_52_clicked();
    void on_pushButton_53_clicked();
    void on_pushButton_54_clicked();
    void on_pushButton_55_clicked();
    void on_pushButton_56_clicked();
    void on_pushButton_57_clicked();
    void on_pushButton_58_clicked();
    void on_pushButton_59_clicked();
    void on_pushButton_60_clicked();
    void on_pushButton_61_clicked();
    void on_pushButton_62_clicked();
    void on_pushButton_63_clicked();
    void on_pushButton_64_clicked();
    void on_pushButton_65_clicked();
    void on_pushButton_66_clicked();
    void on_pushButton_67_clicked();
    void on_pushButton_68_clicked();
    void on_pushButton_69_clicked();
    void on_pushButton_70_clicked();
    void on_pushButton_71_clicked();
    void on_pushButton_72_clicked();
    void on_pushButton_73_clicked();
    void on_pushButton_74_clicked();
    void on_pushButton_75_clicked();
    void on_pushButton_76_clicked();



    // sert pour la page 5 // envois de fichiers
    void on_pushButton_86_clicked();
    void on_pushButton_87_clicked();
    void on_pushButton_88_clicked();
    void on_pushButton_89_clicked();
    void on_pushButton_90_clicked();
    void on_pushButton_91_clicked();


    // sert pour la page 6 // camera
    void on_pushButton_83_clicked();
    void on_spinBox_24_valueChanged ( int i ); 
    void on_horizontalSlider_21_valueChanged();
    void on_comboBox_6_currentIndexChanged ( int index );
    void on_comboBox_7_currentIndexChanged ( int index );
    void on_comboBox_8_currentIndexChanged ( int index );
    void on_comboBox_9_currentIndexChanged ( int index );
    void on_comboBox_10_currentIndexChanged ( int index );
    void on_comboBox_11_currentIndexChanged ( int index );
    void on_pushButton_92_clicked();


    // sert pour la page 7 // terminal
    void on_pushButton_82_clicked();
    void _on_comboBox_5_returnPressed(); 
    void on_comboBox_5_editTextChanged(const QString & text ); 


    // sert pour la page 8 // graph
    void on_pushButton_93_clicked();
    void on_pushButton_95_clicked();
    void on_checkBox_stateChanged ( int state ); 
    void on_checkBox_2_stateChanged ( int state ); 
    void on_checkBox_3_stateChanged ( int state ); 
    void on_checkBox_4_stateChanged ( int state ); 
    void on_checkBox_5_stateChanged ( int state ); 
    void on_checkBox_6_stateChanged ( int state ); 
    void on_checkBox_7_stateChanged ( int state ); 
    void on_checkBox_8_stateChanged ( int state ); 
    void on_checkBox_9_stateChanged ( int state ); 
    void on_checkBox_10_stateChanged ( int state ); 
    void on_checkBox_11_stateChanged ( int state ); 
    void on_checkBox_12_stateChanged ( int state ); 
    void on_checkBox_13_stateChanged ( int state ); 
    void on_checkBox_14_stateChanged ( int state ); 
    void on_checkBox_15_stateChanged ( int state ); 
    void on_checkBox_16_stateChanged ( int state ); 
    void on_checkBox_17_stateChanged ( int state ); 
    void on_checkBox_18_stateChanged ( int state ); 

    void on_pushButton_96_clicked();
    void on_pushButton_97_clicked();


};

#endif

