#include "plot.h"

Plot::Plot()
{
        valmin=-666;
        valmax=666;
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

// cas pour le graph des moteurs



///////////////////////////////////////
// Initialisation des valeurs dans le cas de moteurs
void Plot::Init_Motors()
{
     pointsAAfficher=300; // points a afficher

    // Disable polygon clipping
    QwtPainter::setDeviceClipping(false);

    // We don't need the cache here
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintCached, false);
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintPacked, false);

#ifdef Q_WS_X11
    canvas()->setAttribute(Qt::WA_PaintOnScreen, true);
#endif

    // Assign a title
    setTitle("Aibo Graph Motors");
    insertLegend(new QwtLegend(), QwtPlot::BottomLegend);

    alignScales();

    // tableau contenant les valeurs
    legLF1 = NULL;
    legLF2 = NULL;
    legLF3 = NULL;
    legLH1 = NULL;
    legLH2 = NULL;
    legLH3 = NULL;
    legRH1 = NULL;
    legRH2 = NULL;
    legRH3 = NULL;
    legRF1 = NULL;
    legRF2 = NULL;
    legRF3 = NULL;
    neck = NULL;
    headPan = NULL;
    headTilt = NULL;
    tailTilt = NULL;
    tailPan = NULL;
    mouth = NULL;
    xPoints = NULL;



    // Axis titles
    setAxisTitle(QwtPlot::xBottom, "Time/seconds"); // titre de l'axe des X
    setAxisScale(QwtPlot::xBottom, -2, 2);

    setAxisTitle(QwtPlot::yLeft, "Degrees"); // permet de mettre un titre a l'axe des Y
    setAxisScale(QwtPlot::yLeft, -2, 2);

}


void Plot::videPlot()
{
    // On libere la memoire des tableaux
    if (legLF1 != NULL)
    {
            delete legLF1; 
            delete legLF2;
            delete legLF3;
            delete legLH1;
            delete legLH2;
            delete legLH3;
            delete legRH1;
            delete legRH2;
            delete legRH3;
            delete legRF1;
            delete legRF2;
            delete legRF3;
            delete neck;
            delete headPan;
            delete headTilt;
            delete tailTilt;
            delete tailPan;
            delete mouth;

            delete xPoints;

            delete courbe1; 
            delete courbe2;
            delete courbe3;
            delete courbe4;
            delete courbe5;
            delete courbe6;
            delete courbe7;
            delete courbe8;
            delete courbe9;
            delete courbe10;
            delete courbe11;
            delete courbe12;
            delete courbe13;
            delete courbe14;
            delete courbe15;
            delete courbe16;
            delete courbe17;
            delete courbe18;

            legLF1 = NULL; 
            legLF2 = NULL;
            legLF3 = NULL;
            legLH1 = NULL;
            legLH2 = NULL;
            legLH3 = NULL;
            legRH1 = NULL;
            legRH2 = NULL;
            legRH3 = NULL;
            legRF1 = NULL;
            legRF2 = NULL;
            legRF3 = NULL;
            neck = NULL;
            headPan = NULL;
            headTilt = NULL;
            tailTilt = NULL;
            tailPan = NULL;
            mouth = NULL;

            xPoints = NULL;

            courbe1 = NULL; 
            courbe2 = NULL; 
            courbe3 = NULL; 
            courbe4 = NULL; 
            courbe5 = NULL; 
            courbe6 = NULL; 
            courbe7 = NULL; 
            courbe8 = NULL; 
            courbe9 = NULL; 
            courbe10 = NULL; 
            courbe11 = NULL; 
            courbe12 = NULL; 
            courbe13 = NULL; 
            courbe14 = NULL; 
            courbe15 = NULL; 
            courbe16 = NULL; 
      }

}


//////////////////////////////////////////////////
// On ajoute des valeurs a la liste
void Plot::addValues(double value1,double value2,double value3,double value4,double value5,double value6,double value7,double value8,double value9,double value10,double value11,double value12,double value13,double value14,double value15,double value16,double value17,double value18, double heure)
{

    if (legLF1 == NULL)
    {
            // Creation des tableaux qui vont stocker les valeurs
            legLF1 = new double[pointsAAfficher];
            legLF2 = new double[pointsAAfficher];
            legLF3 = new double[pointsAAfficher];
            legLH1 = new double[pointsAAfficher];
            legLH2 = new double[pointsAAfficher];
            legLH3 = new double[pointsAAfficher];
            legRH1 = new double[pointsAAfficher];
            legRH2 = new double[pointsAAfficher];
            legRH3 = new double[pointsAAfficher];
            legRF1 = new double[pointsAAfficher];
            legRF2 = new double[pointsAAfficher];
            legRF3 = new double[pointsAAfficher];
            neck = new double[pointsAAfficher];
            headPan = new double[pointsAAfficher];
            headTilt = new double[pointsAAfficher];
            tailTilt = new double[pointsAAfficher];
            tailPan = new double[pointsAAfficher];
            mouth = new double[pointsAAfficher];

            xPoints = new double[pointsAAfficher];


        // on vide les tableaux
         for( int i=0; i<pointsAAfficher; i++ )
         {
            xPoints[i] = heure;
            headPan[i] = value1;
            headTilt[i] = value2;
            neck[i] = value3;
            mouth[i] = value4;
            tailPan[i] = value5;
            tailTilt[i] = value6;
            legLF1[i] = value7;
            legLF2[i] =value8;
            legLF3[i] = value9;
            legLH1[i] = value10;
            legLH2[i] = value11;
            legLH3[i] = value12;
            legRF1[i] = value13;
            legRF2[i] = value14;
            legRF3[i] = value15;
            legRH1[i] = value16;
            legRH2[i] = value17;
            legRH3[i] = value18;
         }

        // Insert new curves
        courbe1 = new QwtPlotCurve("headPan.val");
        courbe2 = new QwtPlotCurve("headTilt.val");
        courbe3 = new QwtPlotCurve("neck.val");
        courbe4 = new QwtPlotCurve("mouth.val");
        courbe5 = new QwtPlotCurve("tailPan.val");
        courbe6 = new QwtPlotCurve("tailTilt.val");
        courbe7 = new QwtPlotCurve("legLF1.val");
        courbe8 = new QwtPlotCurve("legLF2.val");
        courbe9 = new QwtPlotCurve("legLF3.val");
        courbe10 = new QwtPlotCurve("legLH1.val");
        courbe11 = new QwtPlotCurve("legLH2.val");
        courbe12 = new QwtPlotCurve("legLH3.val");
        courbe13 = new QwtPlotCurve("legRF1.val");
        courbe14 = new QwtPlotCurve("legRF2.val");
        courbe15 = new QwtPlotCurve("legRF3.val");
        courbe16 = new QwtPlotCurve("legRH1.val");
        courbe17 = new QwtPlotCurve("legRH2.val");
        courbe18 = new QwtPlotCurve("legRH3.val");

        courbe1->attach(this);
        courbe2->attach(this);
        courbe3->attach(this);
        courbe4->attach(this);
        courbe5->attach(this);
        courbe6->attach(this);
        courbe7->attach(this);
        courbe8->attach(this);
        courbe9->attach(this);
        courbe10->attach(this);
        courbe11->attach(this);
        courbe12->attach(this);
        courbe13->attach(this);
        courbe14->attach(this);
        courbe15->attach(this);
        courbe16->attach(this);
        courbe17->attach(this);
        courbe18->attach(this);


        // Set curve styles
        courbe1->setPen(QPen(Qt::red));
        courbe2->setPen(QPen(Qt::green));
        courbe3->setPen(QPen(Qt::blue));
        courbe4->setPen(QPen(Qt::yellow));
        courbe5->setPen(QPen(Qt::black));
        courbe6->setPen(QPen(Qt::gray));
        courbe7->setPen(QPen(Qt::magenta));
        courbe8->setPen(QPen(Qt::magenta));
        courbe9->setPen(QPen(Qt::magenta));
        courbe10->setPen(QPen(Qt::magenta));
        courbe11->setPen(QPen(Qt::magenta));
        courbe12->setPen(QPen(Qt::magenta));
        courbe13->setPen(QPen(Qt::magenta));
        courbe14->setPen(QPen(Qt::magenta));
        courbe15->setPen(QPen(Qt::magenta));
        courbe16->setPen(QPen(Qt::magenta));
        courbe17->setPen(QPen(Qt::magenta));
        courbe18->setPen(QPen(Qt::magenta));


        // on demande a ce que la courbe ne s'affiche pas
        courbe1->setVisible(false);
        courbe2->setVisible(false);
        courbe3->setVisible(false);
        courbe4->setVisible(false);
        courbe5->setVisible(false);
        courbe6->setVisible(false);     
        courbe7->setVisible(false);
        courbe8->setVisible(false);
        courbe9->setVisible(false);
        courbe10->setVisible(false);
        courbe11->setVisible(false);
        courbe12->setVisible(false);
        courbe13->setVisible(false);
        courbe14->setVisible(false);
        courbe15->setVisible(false);
        courbe16->setVisible(false);
        courbe17->setVisible(false);
        courbe18->setVisible(false);


        // Attach (don't copy) data. Both curves use the same x array.
        courbe1->setRawData(xPoints, headPan, pointsAAfficher);
        courbe2->setRawData(xPoints, headTilt, pointsAAfficher);
        courbe3->setRawData(xPoints, neck, pointsAAfficher);
        courbe4->setRawData(xPoints, mouth, pointsAAfficher);
        courbe5->setRawData(xPoints, tailPan, pointsAAfficher);
        courbe6->setRawData(xPoints, tailTilt, pointsAAfficher);
        courbe7->setRawData(xPoints, legLF1, pointsAAfficher);
        courbe8->setRawData(xPoints, legLF2, pointsAAfficher);
        courbe9->setRawData(xPoints, legLF3, pointsAAfficher);
        courbe10->setRawData(xPoints, legLH1, pointsAAfficher);
        courbe11->setRawData(xPoints, legLH2, pointsAAfficher);
        courbe12->setRawData(xPoints, legLH3, pointsAAfficher);
        courbe13->setRawData(xPoints, legRF1, pointsAAfficher);
        courbe14->setRawData(xPoints, legRF2, pointsAAfficher);
        courbe15->setRawData(xPoints, legRF3, pointsAAfficher);
        courbe16->setRawData(xPoints, legRH1, pointsAAfficher);
        courbe17->setRawData(xPoints, legRH2, pointsAAfficher);
        courbe18->setRawData(xPoints, legRH3, pointsAAfficher);

        // on met le cadre aux bonnes dimensions 
        setAxisScale(QwtPlot::yLeft, -134, 120);

    }

	if(xPoints[0] == 0)
		for( int i=0; i<pointsAAfficher; i++ )
			xPoints[i] = heure;

       // on fait un dcalage a gauche des donnees
      int nbOctets = (pointsAAfficher-1)*sizeof(double);
       memmove ( xPoints, xPoints+1, nbOctets ); 
       memmove ( headPan, headPan+1, nbOctets ); 
       memmove ( headTilt, headTilt+1, nbOctets ); 
       memmove ( neck, neck+1, nbOctets ); 
       memmove ( mouth, mouth+1, nbOctets ); 
       memmove ( tailPan, tailPan+1, nbOctets ); 
       memmove ( tailTilt, tailTilt+1, nbOctets ); 
       memmove ( legLF1, legLF1+1, nbOctets ); 
       memmove ( legLF2, legLF2+1, nbOctets ); 
       memmove ( legLF3, legLF3+1, nbOctets ); 
       memmove ( legLH1, legLH1+1, nbOctets ); 
       memmove ( legLH2, legLH2+1, nbOctets ); 
       memmove ( legLH3, legLH3+1, nbOctets ); 
       memmove ( legRF1, legRF1+1, nbOctets ); 
       memmove ( legRF2, legRF2+1, nbOctets ); 
       memmove ( legRF3, legRF3+1, nbOctets ); 
       memmove ( legRH1, legRH1+1, nbOctets ); 
       memmove ( legRH2, legRH2+1, nbOctets ); 
       memmove ( legRH3, legRH3+1, nbOctets ); 


    // on remplit les tableaux
      xPoints[pointsAAfficher-1] = heure;
      headPan[pointsAAfficher-1] = value1;
      headTilt[pointsAAfficher-1] = value2;
      neck[pointsAAfficher-1] = value3;
      mouth[pointsAAfficher-1] = value4;
      tailPan[pointsAAfficher-1] = value5;
      tailTilt[pointsAAfficher-1] = value6;
      legLF1[pointsAAfficher-1] = value7;
      legLF2[pointsAAfficher-1] = value8;
      legLF3[pointsAAfficher-1] = value9;
      legLH1[pointsAAfficher-1] = value10;
      legLH2[pointsAAfficher-1] = value11;
      legLH3[pointsAAfficher-1] = value12;
      legRF1[pointsAAfficher-1] = value13;
      legRF2[pointsAAfficher-1] = value14;
      legRF3[pointsAAfficher-1] = value15;
      legRH1[pointsAAfficher-1] = value16;
      legRH2[pointsAAfficher-1] = value17;
      legRH3[pointsAAfficher-1] = value18;

    setAxisScale  (QwtPlot::xBottom, (int)( xPoints[0] - 1) , (int)( xPoints[pointsAAfficher - 1] + 1) ); // on indique le min et le max de l'axe des temps

    // update the display
    this->replot();
}





/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

// cas pour une variable



//////////////////////////////////////////////////
// On ajoute des valeurs a la liste
void Plot::addValuesVariable(double value, double heure)
{

    if (stockVariable == NULL)
    {
            // Creation des tableaux qui vont stocker les valeurs
            stockVariable = new double[pointsAAfficher];
            xPoints = new double[pointsAAfficher];

        // on vide les tableaux
         for( int i=0; i<pointsAAfficher; i++ )
         {
            xPoints[i] = heure;
            stockVariable[i] = value;
         }

        // Insert new curves
        cLeft = new QwtPlotCurve("Data Global Variable");
        cLeft->attach(this);

        // Set curve styles
        cLeft->setPen(QPen(Qt::blue));

        // Attach (don't copy) data. Both curves use the same x array.
        cLeft->setRawData(xPoints, stockVariable, pointsAAfficher);
    }

    if(valmax == 666 && valmin == -666)
    {
        valmin=value;
        valmax=value;
        setAxisScale(QwtPlot::yLeft, (int)valmin-1, (int)valmax+1);
    }

	if(xPoints[0] == 0)
		for( int i=0; i<pointsAAfficher; i++ )
			xPoints[i] = heure;

       // on fait un dcalage a gauche des donnees
      int nbOctets = (pointsAAfficher-1)*sizeof(double);
       memmove ( xPoints, xPoints+1, nbOctets ); 
       memmove ( stockVariable, stockVariable+1, nbOctets ); 

    // on remplit les tableaux
      xPoints[pointsAAfficher-1] = heure;
      stockVariable[pointsAAfficher-1] = value;

    setAxisScale  (QwtPlot::xBottom, (int)( xPoints[0] - 1) , (int)( xPoints[pointsAAfficher - 1] + 1) ); // on indique le min et le max de l'axe des temps

    if(valmax < value)
    {
              valmax = value;
              setAxisScale(QwtPlot::yLeft, (int)valmin-1, (int)valmax+1);
    }
    else if(valmin > value)
    {
              valmin = value;
              setAxisScale(QwtPlot::yLeft, (int)valmin-1, (int)valmax+1);
    }


    // update the display
    this->replot();
}



void Plot::videPlotVariable()
{
    // On libere la memoire des tableaux
    if (stockVariable != NULL)
    {
            delete cLeft;
            delete stockVariable; 
            delete xPoints;
            stockVariable = NULL;
            xPoints = NULL;
            cLeft = NULL;
      }

}


///////////////////////////////////////
// Initialisation des valeurs dans le cas d'une variable
void Plot::Init_Variable()
{
     pointsAAfficher=300; // points a afficher

    // Disable polygon clipping
    QwtPainter::setDeviceClipping(false);

    // We don't need the cache here
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintCached, false);
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintPacked, false);

#ifdef Q_WS_X11
    canvas()->setAttribute(Qt::WA_PaintOnScreen, true);
#endif

    // Assign a title
    setTitle("Aibo Graph Variable");
    insertLegend(new QwtLegend(), QwtPlot::BottomLegend);

    alignScales();

    // tableau contenant les valeurs
    stockVariable = NULL;
    xPoints = NULL;

    // Axis titles
    setAxisTitle(QwtPlot::xBottom, "Time/seconds"); // titre de l'axe des X
    setAxisScale(QwtPlot::xBottom, -2, 2);

    setAxisTitle(QwtPlot::yLeft, "Values");
    setAxisScale(QwtPlot::yLeft, -2, 2);
    
}


//////////////////////
//  Mise en forme de la fenetre avec bon repositionnement des elements
void Plot::alignScales()
{
    // The code below shows how to align the scales to
    // the canvas frame, but is also a good example demonstrating
    // why the spreaded API needs polishing.

    canvas()->setFrameStyle(QFrame::Box | QFrame::Plain );
    canvas()->setLineWidth(1);

    for ( int i = 0; i < QwtPlot::axisCnt; i++ )
    {
        QwtScaleWidget *scaleWidget = (QwtScaleWidget *)axisWidget(i);
        if ( scaleWidget )
            scaleWidget->setMargin(0);

        QwtScaleDraw *scaleDraw = (QwtScaleDraw *)axisScaleDraw(i);
        if ( scaleDraw )
            scaleDraw->enableComponent(QwtAbstractScaleDraw::Backbone, false);
    }
}

