#include "urbi.h"
#include "tele.h"


#include "urbi_page3.cpp"
#include "urbi_page4.cpp"
#include "urbi_page6.cpp"
#include "urbi_page8.cpp"

ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotC = NULL;                           

     lignes = NULL;

     // page 3
     devCount=18;
     devices=devices2;
     compteurvalue=0;
     value1  = 0;
     value2  = 0;  
     value3  = 0;
     value4  = 0;    
     value5  = 0;
     value6  = 0;    
     value7  = 0;
     value8  = 0;  
     value9  = 0;
     value10 = 0;  
     value11 = 0;
     value12 = 0;    
     value13 = 0;
     value14 = 0;    
     value15 = 0;
     value16 = 0;    
     value17 = 0;
     value18 = 0;   


     // page 4
     devCountLed=25;
     devicesLeds=devicesLeds2;
     compteurvalueled=0;

     // page 6
     robotI = NULL; 
     traitementEnCours=0;
     buffer = NULL;
     bufferRGB=NULL;
     captureImage=0;

     // page 7
     compteurligne=0;

     musiqueEnCours=0;

     imageEnCours=0;
     buffer2 = NULL;
     buffer2RGB=NULL;


     // page 8
     robotG = NULL;    
     devCountGraph=18;
     devicesGraph=devices2Graph;
     compteurvalueGraph=0;

     value1Graph=0;
     value2Graph=0;  
     value3Graph=0;
     value4Graph=0;    
     value5Graph=0;
     value6Graph=0;    
     value7Graph=0;
     value8Graph=0;  
     value9Graph=0;
     value10Graph=0;  
     value11Graph=0;
     value12Graph=0;    
     value13Graph=0;
     value14Graph=0;    
     value15Graph=0;
     value16Graph=0;    
     value17Graph=0;
     value18Graph=0;    

     robotG2 = NULL;    
}



/////////////////////////////////////////////////
// Tout Recuperer
//////////////////////////////////////////////////
UCallbackAction ConnectAibo::allrecup(const UMessage &msg) 
{ 

     QString texteServeur2;


	  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_BINARY) 
	  {

		  if (msg.value->binary->type == urbi::BINARY_IMAGE)
		  {

		      urbi::UImage& img = msg.value->binary->image;


     		    if( img.imageFormat == urbi::IMAGE_JPEG )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image JPEG " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
    		    else if ( img.imageFormat == urbi::IMAGE_YCbCr )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image YCbCr " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
    		    else if ( img.imageFormat == urbi::IMAGE_RGB )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image RGB " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
      		    else if ( img.imageFormat == urbi::IMAGE_PPM )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image PPM " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
      		    else
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image UNKNOWN " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }



    		    if (buffer2 == NULL && buffer2RGB == NULL)
    		    {
    		       buffer2 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
     		       buffer2RGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
     		   }

    		    int width = img.width;
    		    int height = img.height;

    		    // on place l'image dans un objet QImage
    		    QImage image;
    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		    {
    		        image.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
    		    }
     		   else // autres cas
     		   {
     		       if ( img.imageFormat == urbi::IMAGE_YCbCr)
     		           convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer2 );
      		      else if ( img.imageFormat == urbi::IMAGE_RGB)
       		         memcpy(  buffer2, img.data, img.size );
       		     else
        		 memcpy( buffer2, img.data, img.size );
    
        		  // conversion de l'image RGB 24 en RGB 32
           		for(int i=0; i<=width; i++)
           		{
                 		for(int j=0; j<=height; j++)
                 		{
                      			buffer2RGB[(4*i) + (j*width*4) + 0] = buffer2[(3*i) + (j*width*3) + 2];  // bleu
                      			buffer2RGB[(4*i) + (j*width*4) + 1] = buffer2[(3*i) + (j*width*3) + 1];  //vert
                      			buffer2RGB[(4*i) + (j*width*4) + 2] = buffer2[(3*i) + (j*width*3) + 0];  // rouge
                      			buffer2RGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                 		}
           		}    
    
          		// constructs image and fills with data 
          		image=QImage( buffer2RGB, img.width, img.height, QImage::Format_RGB32); // on stocke l'image
        	}

      		// enregistrement de l'image
      		imageEnCours++;
      		image_textbrowser = image.copy();

      		// envoi du signal pour dire que c'est une image
      		e3 = new QEvent((QEvent::Type)(1600));
      		QCoreApplication::postEvent(this,e3);

      		// liberation de la memoire
      		delete buffer2;
      		delete buffer2RGB;
      		buffer2=NULL;
      		buffer2RGB=NULL;

        
	  } // fin de BINARY_IMAGE


  else if (msg.value->binary->type == urbi::BINARY_SOUND)
  {
       urbi::USound& snd = msg.value->binary->sound;

        if( snd.soundFormat == urbi::SOUND_WAV )
        {
            texteServeur2 = "[" + QString::number(msg.timestamp) ;
            if(QString::fromLatin1(msg.tag.c_str()) != "")
              texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
            texteServeur2 = texteServeur2 + "] " + "Binary Sound " + QString::number(snd.size) + " wav" + "\n" ;
        }
        else if ( snd.soundFormat == urbi::SOUND_RAW)       
        {
            texteServeur2 = "[" + QString::number(msg.timestamp) ;
            if(QString::fromLatin1(msg.tag.c_str()) != "")
              texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
             texteServeur2 = texteServeur2 + "] " + "Binary Sound " + QString::number(snd.size) + " raw" + " " + QString::number(snd.channels) + " " + QString::number(snd.rate)  + " "  + QString::number(snd.sampleSize) + " " + QString::number(snd.sampleFormat) + "\n" ;
        }


  } // fin de BINARY_SOUND


	} // fin du DATA_BINARY


  QString tag;
  tag = QString::fromLatin1(msg.tag.c_str() );


  if ( tag == "totoledF1.val" || tag == "totoledF2.val" || tag == "totoledF3.val" || tag == "totoledF4.val" || tag == "totoledF5.val" || tag == "totoledF6.val" || tag == "totoledF7.val" )
    return URBI_CONTINUE;
  if ( tag == "totoledF8.val" || tag == "totoledF9.val" || tag == "totoledF10.val" || tag == "totoledF11.val" || tag == "totoledF12.val" || tag == "totoledF13.val" || tag == "totoledF14.val" )
    return URBI_CONTINUE;
  if ( tag == "totoledBFC.val" || tag == "totoledBFW.val" || tag == "totoledBMC.val" || tag == "totoledBMW.val" || tag == "totoledBRC.val" || tag == "totoledBRW.val" || tag == "totoledHC.val" )
    return URBI_CONTINUE;
  if ( tag == "totoledWIFI.val" || tag == "totomodeR.val" || tag == "totomodeG.val" || tag == "totomodeB.val" )
    return URBI_CONTINUE; 

  if ( tag == "totolegLF1.val" || tag == "totolegLF2.val" || tag == "totolegLF3.val" || tag == "totolegLH1.val" || tag == "totolegLH2.val" || tag == "totolegLH3.val" || tag == "totolegRH1.val" )
    return URBI_CONTINUE; 
  if ( tag == "totolegRH2.val" || tag == "totolegRH3.val" || tag == "totolegRF1.val" || tag == "totolegRF2.val" || tag == "totolegRF3.val" || tag == "totoneck.val" || tag == "totoheadPan.val" )
    return URBI_CONTINUE;  
  if ( tag == "totoheadTilt.val"  || tag == "tototailTilt.val" || tag == "tototailPan.val" || tag == "totomouth.val" )
    return URBI_CONTINUE; 


    if(lignes == NULL)
              lignes = new QString [500];



// Message non parse
	if(texteServeur2 == "")
	{
     texteServeur2 = "[" + QString::number(msg.timestamp) ;
     if(QString::fromLatin1(msg.tag.c_str()) != "")
       texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
     texteServeur2 = texteServeur2 + "] " + QString::fromLatin1(msg.rawMessage.c_str()) + "\n";
	}


    if (compteurligne >= 0 && compteurligne <= 498)
    {
       lignes[compteurligne] = texteServeur2;
       int valueEvent= 1100 + compteurligne;
       e3 = new QEvent((QEvent::Type)(valueEvent));
       QCoreApplication::postEvent(this,e3);
       compteurligne++;
    }
    else if (compteurligne >= 499 )
    {
       lignes[compteurligne] = texteServeur2;
       int valueEvent= 1100 + compteurligne;
       e3 = new QEvent((QEvent::Type)(valueEvent));
       QCoreApplication::postEvent(this,e3);
       compteurligne=0;
    }


  return URBI_CONTINUE;    

}










///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{
     
 if( ev->type() == (QEvent::Type)(1001))
 {
      if(valueled1 == 1)
         pere->ui.label_24->setText("<font color=\"green\">ledF1.val</font>");
      else
         pere->ui.label_24->setText("<font color=\"red\">ledF1.val</font>");
      if(valueled2 == 1)
         pere->ui.label_25->setText("<font color=\"green\">ledF2.val</font>");
      else
         pere->ui.label_25->setText("<font color=\"red\">ledF2.val</font>");
      if(valueled3 == 1)
         pere->ui.label_26->setText("<font color=\"green\">ledF3.val</font>");
      else
         pere->ui.label_26->setText("<font color=\"red\">ledF3.val</font>");
      if(valueled4 == 1)
         pere->ui.label_27->setText("<font color=\"green\">ledF4.val</font>");
      else
         pere->ui.label_27->setText("<font color=\"red\">ledF4.val</font>");
      if(valueled5 == 1)
         pere->ui.label_28->setText("<font color=\"green\">ledF5.val</font>");
      else
         pere->ui.label_28->setText("<font color=\"red\">ledF5.val</font>");
      if(valueled6 == 1)
         pere->ui.label_29->setText("<font color=\"green\">ledF6.val</font>");
      else
         pere->ui.label_29->setText("<font color=\"red\">ledF6.val</font>");
      if(valueled7 == 1)
         pere->ui.label_30->setText("<font color=\"green\">ledF7.val</font>");
      else
         pere->ui.label_30->setText("<font color=\"red\">ledF7.val</font>");
      if(valueled8 == 1)
         pere->ui.label_31->setText("<font color=\"green\">ledF8.val</font>");
      else
         pere->ui.label_31->setText("<font color=\"red\">ledF8.val</font>");
      if(valueled9 == 1)
         pere->ui.label_32->setText("<font color=\"green\">ledF9.val</font>");
      else
         pere->ui.label_32->setText("<font color=\"red\">ledF9.val</font>");
      if(valueled10 == 1)
         pere->ui.label_33->setText("<font color=\"green\">ledF10.val</font>");
      else
         pere->ui.label_33->setText("<font color=\"red\">ledF10.val</font>");
      if(valueled11 == 1)
         pere->ui.label_34->setText("<font color=\"green\">ledF11.val</font>");
      else
         pere->ui.label_34->setText("<font color=\"red\">ledF11.val</font>");
      if(valueled12 == 1)
         pere->ui.label_35->setText("<font color=\"green\">ledF12.val</font>");
      else
         pere->ui.label_35->setText("<font color=\"red\">ledF12.val</font>");
      if(valueled13 == 1)
         pere->ui.label_36->setText("<font color=\"green\">ledF13.val</font>");
      else
         pere->ui.label_36->setText("<font color=\"red\">ledF13.val</font>");
      if(valueled14 == 1)
         pere->ui.label_37->setText("<font color=\"green\">ledF14.val</font>");
      else
         pere->ui.label_37->setText("<font color=\"red\">ledF14.val</font>");
      if(valueled15 == 1)
         pere->ui.label_38->setText("<font color=\"green\">ledBFC.val</font>");
      else
         pere->ui.label_38->setText("<font color=\"red\">ledBFC.val</font>");
      if(valueled16 == 1)
         pere->ui.label_39->setText("<font color=\"green\">ledBFW.val</font>");
      else
         pere->ui.label_39->setText("<font color=\"red\">ledBFW.val</font>");
      if(valueled17 == 1)
         pere->ui.label_40->setText("<font color=\"green\">ledBMC.val</font>");
      else
         pere->ui.label_40->setText("<font color=\"red\">ledBMC.val</font>");
      if(valueled18 == 1)
         pere->ui.label_41->setText("<font color=\"green\">ledBMW.val</font>");
      else
         pere->ui.label_41->setText("<font color=\"red\">ledBMW.val</font>");
      if(valueled19 == 1)
         pere->ui.label_42->setText("<font color=\"green\">ledBRC.val</font>");
      else
         pere->ui.label_42->setText("<font color=\"red\">ledBRC.val</font>");
      if(valueled20 == 1)
         pere->ui.label_43->setText("<font color=\"green\">ledBRW.val</font>");
      else
         pere->ui.label_43->setText("<font color=\"red\">ledBRW.val</font>");
      if(valueled21 == 1)
         pere->ui.label_44->setText("<font color=\"green\">ledHC.val</font>");
      else
         pere->ui.label_44->setText("<font color=\"red\">ledHC.val</font>");
      if(valueled22 == 1)
         pere->ui.label_45->setText("<font color=\"green\">ledWIFI.val</font>");
      else
         pere->ui.label_45->setText("<font color=\"red\">ledWIFI.val</font>");
      if(valueled23 == 1)
         pere->ui.label_46->setText("<font color=\"green\">modeR.val</font>");
      else
         pere->ui.label_46->setText("<font color=\"red\">modeR.val</font>");
      if(valueled24 == 1)
         pere->ui.label_47->setText("<font color=\"green\">modeG.val</font>");
      else
         pere->ui.label_47->setText("<font color=\"red\">modeG.val</font>");
      if(valueled25 == 1)
         pere->ui.label_48->setText("<font color=\"green\">modeB.val</font>");
      else
         pere->ui.label_48->setText("<font color=\"red\">modeB.val</font>");
 }

 else if( ev->type() == (QEvent::Type)(1002))
 {
       pere->neRienFaireAvecLesMoteurs = 1;

       pere->ui.spinBox_16->setValue(value1); 
       pere->ui.spinBox_17->setValue(value2); 
       pere->ui.spinBox_18->setValue(value3); 
       pere->ui.spinBox_19->setValue(value4); 
       pere->ui.spinBox_20->setValue(value5); 
       pere->ui.spinBox_21->setValue(value6); 
       pere->ui.spinBox_9->setValue(value7); 
       pere->ui.spinBox_10->setValue(value8); 
       pere->ui.spinBox_11->setValue(value9); 
       pere->ui.spinBox_12->setValue(value10); 
       pere->ui.spinBox_13->setValue(value11); 
       pere->ui.spinBox_14->setValue(value12); 
       pere->ui.spinBox_4->setValue(value13); 
       pere->ui.spinBox_3->setValue(value14); 
       pere->ui.spinBox_2->setValue(value15); 
       pere->ui.spinBox_7->setValue(value16); 
       pere->ui.spinBox_8->setValue(value17); 
       pere->ui.spinBox_5->setValue(value18); 

       pere->ui.horizontalSlider->setValue(value15);
       pere->ui.horizontalSlider_2->setValue(value14);
       pere->ui.horizontalSlider_3->setValue(value13);
       pere->ui.horizontalSlider_4->setValue(value18);
       pere->ui.horizontalSlider_6->setValue(value16);
       pere->ui.horizontalSlider_7->setValue(value17);
       pere->ui.horizontalSlider_8->setValue(value7);
       pere->ui.horizontalSlider_9->setValue(value8);
       pere->ui.horizontalSlider_10->setValue(value9);
       pere->ui.horizontalSlider_11->setValue(value10);
       pere->ui.horizontalSlider_12->setValue(value11);
       pere->ui.horizontalSlider_13->setValue(value12);
       pere->ui.horizontalSlider_15->setValue(value1);
       pere->ui.horizontalSlider_16->setValue(value2);
       pere->ui.horizontalSlider_17->setValue(value3);
       pere->ui.horizontalSlider_18->setValue(value4);
       pere->ui.horizontalSlider_19->setValue(value5);
       pere->ui.horizontalSlider_20->setValue(value6);

       pere->neRienFaireAvecLesMoteurs = 0;

 }

 else if( ev->type() == (QEvent::Type)(1003))
 {
        pere->visionCamera.ui.label->setPixmap(QPixmap::fromImage(imageQT2));     // on affiche   
 }
 else if( ev->type() == (QEvent::Type)(1004))
 {
        pere->arretDeLaCamera(); // on desactive la camera  
 }

 else if( ev->type() >= (QEvent::Type)(1100) && ev->type() <= (QEvent::Type)(1599))
 {
       // on positionne le curseur a la fin
       QTextCursor cursorEnd(pere->ui.textBrowser->textCursor());
       cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
       pere->ui.textBrowser->setTextCursor ( cursorEnd );

       // on definit la couleur rouge
       pere->ui.textBrowser->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 

       // on ajoute le texte
       int num = (int)ev->type();
       pere->ui.textBrowser->insertPlainText( lignes[num-1100] ) ; 

       // on positionne le scrolling a la fin
       int positionMax = pere->ui.textBrowser->verticalScrollBar()->maximum();
       pere->ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
 }



// affichage image
 else if( ev->type() == (QEvent::Type)(1600))
 {
       QTextCursor cursorEnd(pere->ui.textBrowser->textCursor());
       cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
       pere->ui.textBrowser->setTextCursor ( cursorEnd );
       pere->ui.textBrowser->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 
       QTextDocument *textdocument_image = pere->ui.textBrowser->document();
       int numeroimage = imageEnCours;
       textdocument_image->addResource(QTextDocument::ImageResource, QUrl("image"+QString::number(numeroimage)), image_textbrowser); 
       cursorEnd.insertImage("image"+QString::number(numeroimage));
       QString phrase = "<br>";
       pere->ui.textBrowser->insertHtml( phrase ) ; 
       int positionMax = pere->ui.textBrowser->verticalScrollBar()->maximum();
       pere->ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
 }

// affichage graph motors
 else if( ev->type() == (QEvent::Type)(1601))
 {
       pere->visionGraph.addValues(value1Graph,value2Graph,value3Graph,value4Graph,value5Graph,value6Graph,value7Graph,value8Graph,value9Graph,value10Graph,value11Graph,value12Graph,value13Graph,value14Graph,value15Graph,value16Graph,value17Graph,value18Graph,heure/1000);
 }
 else if( ev->type() == (QEvent::Type)(1602))
 {
        pere->arretDuGraph(); // on desactive la fenetre du graph  
 }

// affichage graph variable
 else if( ev->type() == (QEvent::Type)(1603))
 {
       pere->visionGraph2.addValuesVariable(valueVariableGraph,heure/1000);
 }
 else if( ev->type() == (QEvent::Type)(1604))
 {
        pere->arretDuGraphVariable(); // on desactive la fenetre du graph  
 }


 return 1;
}
