
///////////////////////////////////////////
// Lancement de la fenetre graph
void Telecommande::on_pushButton_93_clicked()
{
     if(urbiTele.robotC != NULL)
     {
         // on affiche la fenetre de graph
         visionGraph.resize(600,600);
         visionGraph.setTitle( "Aibo Graph Motors" );   
         visionGraph.show();

         // recuperation des donnes du nom et du port
         QSettings settings("Aibo Telecommande", "GOSTAI");
         QString robotName = settings.value("robotname").toString();
         int robotPort = settings.value("robotport").toInt();


         // connexion
         if( urbiTele.robotG != NULL)
         {
             urbiTele.robotG->send("stop graph;");
             urbiTele.robotG->send(";;;; quit;");
             urbiTele.robotG->send("noop;");
             urbiTele.robotG->send("noop;");
             delete urbiTele.robotG;
             visionGraph.videPlot( ); // on libere la memoire
         }

         urbiTele.robotG = NULL;
         urbiTele.robotG =new UClient( robotName.toLatin1() , robotPort );


        if (!urbiTele.robotG->error())
        {
           setlocale(LC_NUMERIC,"C");
           urbiTele.pereGraph=pointeur;

            // on indique combien de temps doit durer l'enregistrement.
            visionGraph.pointsAAfficher = ui.spinBox_25->value() ;
            
           // recuperation de la position des moteurs
            QString frequency = ui.lineEdit_6->text();
            QString command_send = "graph:every(" + frequency + "ms) { ";
      	    urbiTele.robotG->send("%s", (const char *) command_send.toLatin1());
    
            for (int i=0;i<urbiTele.devCountGraph-1;i++) 
            {
                urbiTele.robotG->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotorGraph),urbiTele.devicesGraph[i]);
        	    urbiTele.robotG->send("%s << %s &",urbiTele.devicesGraph[i], urbiTele.devicesGraph[i]);
            }
            urbiTele.robotG->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotorGraph),urbiTele.devicesGraph[urbiTele.devCountGraph-1]);
            urbiTele.robotG->send("%s << %s",urbiTele.devicesGraph[urbiTele.devCountGraph-1], urbiTele.devicesGraph[urbiTele.devCountGraph-1]);
    
      	    urbiTele.robotG->send(" },");
    
        }



     }
} 


///////////////////////////////////////////
// Arret du graph
void Telecommande::on_pushButton_95_clicked()
{
         visionGraph.hide();
 
         if( urbiTele.robotG != NULL)
         {
             urbiTele.robotG->send("stop graph;");
             urbiTele.robotG->send(";;;; quit;");
             urbiTele.robotG->send("noop;");
             urbiTele.robotG->send("noop;");
             delete urbiTele.robotG;
             urbiTele.robotG = NULL;
             visionGraph.videPlot( ); // on libere la memoire

             // on redimensionne la fenetre
             visionGraph.setAxisScale(QwtPlot::xBottom, -2, 2);
             visionGraph.setAxisScale(QwtPlot::yLeft, -2, 2);
             visionGraph.valmax = 666;
             visionGraph.valmin = -666;
         }

} 


///////////////////////////////////////////
// Arret du graph
void Telecommande::arretDuGraph()
{
         if( urbiTele.robotG != NULL)
         {
             urbiTele.robotG->send("stop graph;");
             urbiTele.robotG->send(";;;; quit;");
             urbiTele.robotG->send("noop;");
             urbiTele.robotG->send("noop;");
             delete urbiTele.robotG;
             urbiTele.robotG = NULL;
             visionGraph.videPlot( ); // on libere la memoire

             // on redimensionne la fenetre
             visionGraph.setAxisScale(QwtPlot::xBottom, -2, 2);
             visionGraph.setAxisScale(QwtPlot::yLeft, -2, 2);
             visionGraph.valmax = 666;
             visionGraph.valmin = -666;
         }

} 


///////////////////////////////////////////
// case headPan
void Telecommande::on_checkBox_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe1->setVisible(true);
    else
        visionGraph.courbe1->setVisible(false);
}

///////////////////////////////////////////
// case headTilt
void Telecommande::on_checkBox_2_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe2->setVisible(true);
    else
        visionGraph.courbe2->setVisible(false);
}

///////////////////////////////////////////
// case neck
void Telecommande::on_checkBox_3_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe3->setVisible(true);
    else
        visionGraph.courbe3->setVisible(false);
}

///////////////////////////////////////////
// case mouth
void Telecommande::on_checkBox_4_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe4->setVisible(true);
    else
        visionGraph.courbe4->setVisible(false);
}

///////////////////////////////////////////
// case tailPan
void Telecommande::on_checkBox_5_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe5->setVisible(true);
    else
        visionGraph.courbe5->setVisible(false);
}

///////////////////////////////////////////
// case tailTilt
void Telecommande::on_checkBox_6_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe6->setVisible(true);
    else
        visionGraph.courbe6->setVisible(false);
}

///////////////////////////////////////////
// case legLF1
void Telecommande::on_checkBox_7_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe7->setVisible(true);
    else
        visionGraph.courbe7->setVisible(false);
}

///////////////////////////////////////////
// case legLF2
void Telecommande::on_checkBox_8_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe8->setVisible(true);
    else
        visionGraph.courbe8->setVisible(false);
}

///////////////////////////////////////////
// case legLF3
void Telecommande::on_checkBox_9_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe9->setVisible(true);
    else
        visionGraph.courbe9->setVisible(false);
}

///////////////////////////////////////////
// case legRF1
void Telecommande::on_checkBox_10_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe10->setVisible(true);
    else
        visionGraph.courbe10->setVisible(false);
}

///////////////////////////////////////////
// case legRF2
void Telecommande::on_checkBox_11_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe11->setVisible(true);
    else
        visionGraph.courbe11->setVisible(false);
}

///////////////////////////////////////////
// case legRF3
void Telecommande::on_checkBox_12_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe12->setVisible(true);
    else
        visionGraph.courbe12->setVisible(false);
}

///////////////////////////////////////////
// case legLH1
void Telecommande::on_checkBox_13_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe13->setVisible(true);
    else
        visionGraph.courbe13->setVisible(false);
}

///////////////////////////////////////////
// case legLH2
void Telecommande::on_checkBox_14_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe14->setVisible(true);
    else
        visionGraph.courbe14->setVisible(false);
}

///////////////////////////////////////////
// case legLH3
void Telecommande::on_checkBox_15_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe15->setVisible(true);
    else
        visionGraph.courbe15->setVisible(false);
}

///////////////////////////////////////////
// case legRH1
void Telecommande::on_checkBox_16_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe16->setVisible(true);
    else
        visionGraph.courbe16->setVisible(false);
}

///////////////////////////////////////////
// case legRH2
void Telecommande::on_checkBox_17_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe17->setVisible(true);
    else
        visionGraph.courbe17->setVisible(false);
}

///////////////////////////////////////////
// case legRH3
void Telecommande::on_checkBox_18_stateChanged ( int state )
{
    if( state != 0)
        visionGraph.courbe18->setVisible(true);
    else
        visionGraph.courbe18->setVisible(false);
}



//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// Cas d'un graph pour une seule variable


///////////////////////////////////////////
// Lancement de la fenetre graph
void Telecommande::on_pushButton_96_clicked()
{
     if(urbiTele.robotC != NULL)
     {
         // On recupere le nom de la variable que l'on veut grapher
         QString variableName = ui.lineEdit_3->text();
	 if(variableName == "")
		return;

         // on affiche la fenetre de graph
         visionGraph2.resize(600,600);
         QString titleWindowsGraph = "Aibo Graph Variable \"" +  variableName + "\"";
         visionGraph2.setTitle( titleWindowsGraph );   
         visionGraph2.show();

         // recuperation des donnes du nom et du port
         QSettings settings("Aibo Telecommande", "GOSTAI");
         QString robotName = settings.value("robotname").toString();
         int robotPort = settings.value("robotport").toInt();


         // connexion
         if( urbiTele.robotG2 != NULL)
	{
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             visionGraph2.videPlotVariable( ); // on libere la memoire
	}
         urbiTele.robotG2 = NULL;
         urbiTele.robotG2 =new UClient( robotName.toLatin1() , robotPort );


        if (!urbiTele.robotG2->error())
        {
           setlocale(LC_NUMERIC,"C");
           urbiTele.pereGraph=pointeur;

            // on indique combien de temps doit durer l'enregistrement.
            visionGraph2.pointsAAfficher = ui.spinBox_26->value() ;

           // recuperation de la valeur de la variable
           if (variableName != "")
           {
                urbiTele.robotG2->setCallback(callback(urbiTele,&ConnectAibo::returnvaluevariable),"graphvar");
                QString frequency = ui.lineEdit_7->text();
                QString phrase_Variable = "graph:every(" + frequency + "ms) {  graphvar << " + variableName  + " },";
           	    urbiTele.robotG2->send("%s", (const char *) phrase_Variable.toLatin1());
            }
    
        }


     }
} 



///////////////////////////////////////////
// Arret du graph
void Telecommande::on_pushButton_97_clicked()
{
         visionGraph2.hide();

         if( urbiTele.robotG2 != NULL)
         {
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             urbiTele.robotG2 = NULL;
             visionGraph2.videPlotVariable( ); // on libere la memoire

             // on redimensionne la fenetre
             visionGraph2.setAxisScale(QwtPlot::xBottom, -2, 2);
             visionGraph2.setAxisScale(QwtPlot::yLeft, -2, 2);
             visionGraph2.valmax = 666;
             visionGraph2.valmin = -666;

         }

} 

///////////////////////////////////////////
// Arret du graph
void Telecommande::arretDuGraphVariable()
{
         if( urbiTele.robotG2 != NULL)
         {
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             urbiTele.robotG2 = NULL;
             visionGraph2.videPlotVariable( ); // on libere la memoire

             // on redimensionne la fenetre
             visionGraph2.setAxisScale(QwtPlot::xBottom, -2, 2);
             visionGraph2.setAxisScale(QwtPlot::yLeft, -2, 2);
             visionGraph2.valmax = 666;
             visionGraph2.valmin = -666;
         }

} 


