#include "urbi.h"
#include "captureimage.h"


ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotI = NULL;  
     buffer = NULL;
     bufferRGB = NULL;   

     traitementEnCours=0; 
     visible = 0;
     capture=0;
     captureImage=0;

     compteur=0;

}

UCallbackAction ConnectAibo::command(const UMessage &msg) 
{

  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
       return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;
	urbi::UImage& img = msg.value->binary->image;

    		    int width = img.width;
    		    int height = img.height;

      if (buffer == NULL && bufferRGB == NULL)
      {
    		       buffer = new unsigned char[img.width * img.height * 3 * 8]; // 24 bits
     		       bufferRGB = new unsigned char[img.width * img.height * 4 * 8];  // 32 bits
      }


    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		        imageQT.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
     		   else 
               {
                   if ( img.imageFormat == urbi::IMAGE_YCbCr)
         		           convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );
      		       else if ( img.imageFormat == urbi::IMAGE_RGB)
       		          memcpy(  buffer, img.data, img.size );
       		       else
        		       memcpy( buffer, img.data, img.size );
            
                      // conversion de l'image RGB 24 en RGB 32
                       for(int i=0; i<=width; i++)
                       {
                             for(int j=0; j<=height; j++)
                             {
                                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                             }
                       }    
                
                       // copie de l'image dans QImage
                      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image

                }

      // on recupere la largeur et la hauteur
      int widthLabel = pere->ui.label_2->width();
      int heightLabel  = pere->ui.label_2->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT2 = imageQT;
  
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);
      
      if(capture == 1)
      {
                 QString nameFile="image_000.jpg";
                 QFile test;
                 QString number;
                 int j=1000;
                 for(int i=1 ; i<j ; i++)
                 {    
                                  number.setNum(i);
                                  if(i < 10)
                                       nameFile = "image_00" + number + ".jpg"; 
                                  else if(i < 100)
                                       nameFile = "image_0" + number + ".jpg"; 
                                  else if(i < 1000)
                                       nameFile = "image_" + number + ".jpg";                                        
                                  test.setFileName(nameFile);
                                  if( !test.exists() )
                                      break;
                 }

                 imageQT.save(nameFile,"JPG",100);
                 capture=0;           
      }
      imageQT.save("webcam.jpg","JPG",100); // enregistrement de l'image


      traitementEnCours=0;
  }

  return URBI_CONTINUE;
  
  
}

///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001))
 {
      pere->ui.label_2->setPixmap(QPixmap::fromImage(imageQT2));     // on affiche
 }

 return 1;
}
