

UCallbackAction ConnectAibo::urbiimage(const UMessage &msg) 
{

  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;
	urbi::UImage& img = msg.value->binary->image;

    		    int width = img.width;
    		    int height = img.height;


      if (buffer == NULL && bufferRGB == NULL)
      {
    		       buffer = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
     		       bufferRGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
      }


    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		    {
    		        imageQT.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
    		    }
     		   else // autres cas
     		   {
     		       if ( img.imageFormat == urbi::IMAGE_YCbCr)
     		           convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );
      		      else if ( img.imageFormat == urbi::IMAGE_RGB)
       		         memcpy(  buffer, img.data, img.size );
       		     else
        		 memcpy( buffer, img.data, img.size );
        
              // conversion de l'image RGB 24 en RGB 32
               for(int i=0; i<=width; i++)
               {
                     for(int j=0; j<=height; j++)
                     {
                          bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                          bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                          bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                          bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                     }
               }    
        
               // copie de l'image dans QImage
              imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image
        }

      // on recupere la largeur et la hauteur
      int widthLabel = pere->visionCamera.ui.label->width();
      int heightLabel  = pere->visionCamera.ui.label->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT2 = imageQT;
  

      if(captureImage == 1)
      {
                 QString nameFile="image_000.jpg";
                 QFile test;
                 QString number;
                 int j=10000;
                 for(int i=1 ; i<j ; i++)
                 {    
                                  number.setNum(i);
                                  if(i < 10)
                                       nameFile = "image_000" + number + ".jpg"; 
                                  else if(i < 100)
                                       nameFile = "image_00" + number + ".jpg"; 
                                  else if(i < 1000)
                                       nameFile = "image_0" + number + ".jpg";                                        
                                  else if(i < 10000)
                                       nameFile = "image_" + number + ".jpg";    
                                  test.setFileName(nameFile);
                                  if( !test.exists() )
                                      break;
                 }

                 imageQT.save(nameFile,"JPG",100);
                 captureImage=0;           
      }



       // on verifie que la fenetre est bien visible
       if (pere->visionCamera.isHidden() == 1)
       {
           e4 = new QEvent((QEvent::Type)(1005));
           QCoreApplication::postEvent(this,e4);  // on affiche l'image           
           delete buffer; // on libere la memoire
           delete bufferRGB;
           buffer = NULL;
           bufferRGB=NULL;
       }
       else
       {
           e4 = new QEvent((QEvent::Type)(1004));
           QCoreApplication::postEvent(this,e4);  // on affiche l'image
       }

      
      traitementEnCours=0;
  }



  return URBI_CONTINUE;
}



