#ifndef URBI_H
#define URBI_H



#include <urbi/uclient.hh>
#include <QWidget>
#include <QtGui>

using namespace urbi;

class Telecommande;

class ConnectAibo : public QWidget
{
    Q_OBJECT

public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotC; // communication des commandes
      UClient *robotI; // transfert des images
      UClient *robotG2; // graph d'une variable

      // lien pour acceder aux objets de telecommande
      Telecommande *pere;
      Telecommande *pereGraph;

      // les evenements servent pour l'affichage a l'ecran
      virtual bool event(QEvent *ev);
      QEvent *e1; // bumpers et roues
      QEvent *e2; // sonars
      QEvent *e3; // lasers
      QEvent *e4; // affichage texte
      QEvent *e5; // plot

      // les lignes qui stockent le code a afficher
      QString *lignes;
      int compteurligne;

      // sert pour la page 2
      UCallbackAction returnvaluemotor(const UMessage &);
      UCallbackAction returnvaluemotor2(const UMessage &);
      double value1;
      double value2;  
      int compteurvalue;
      int compteurvalue2;

      // sert pour la page 3 // sonars
      UCallbackAction returnvaluesonars(const UMessage &);
      int valueps0;
      int valueps1;
      int valueps2;
      int valueps3;
      int valueps4;
      int valueps5;
      int valueps6;
      int valueps7;
      int compteurvaluesonars;

      UCallbackAction returnvaluesonars2(const UMessage &);
      int valuels0;
      int valuels1;
      int valuels2;
      int valuels3;
      int valuels4;
      int valuels5;
      int valuels6;
      int valuels7;
      int compteurvaluesonarsls;


      // sert pour la page 4
      int devCountLed;
      char ** devicesLeds;
      UCallbackAction returnvalueled(const UMessage &); 
      int valueled1;
      int valueled2;  
      int valueled3;
      int valueled4;    
      int valueled5;
      int valueled6;    
      int valueled7;
      int valueled8;  
      int valueled9;
      int valueled10;  
      int compteurvalueled;

      // sert pour la page 6
      UCallbackAction urbiimage(const UMessage &);
      unsigned char* buffer;
      unsigned char* bufferRGB; 
      int traitementEnCours;
      QImage imageQT;
      QImage imageQT2;
      int captureImage;

      // sert pour la page 7
      UCallbackAction allrecup(const UMessage &); 
      QString texteServeur;
      int musiqueEnCours; // sert pour le nom de stockage des musiques
      int imageEnCours; // sert pour le nom de stockage des images
      unsigned char* buffer2; // stockage image en 24 bits
      unsigned char* buffer2RGB; // stockage image en 32 bits
      QImage image_textbrowser;

      // sert pour la page 8
      UCallbackAction returnvaluevariable(const UMessage &);
      double valueVariableGraph;
      double heure;
};



#endif

