#include <stdio.h>
#include <string.h>
#include <readline/readline.h>
#include <readline/history.h>
#include <signal.h>
#include <stdlib.h>

FILE* f = NULL;
char* dport = NULL;
char* host = NULL;

void sigint(int signal)
{
  char name[1024];

  strcpy(name, getenv("HOME"));
  strcat(name, "/.bt_history");
  write_history(name);
  exit(0);
}

void sigpipe(int signal)
{
  char command[1024];

  fprintf(stderr, " nc terminated, restarting...\n");
  sprintf(command, "nc %s %s", host, dport);
  f = popen(command, "w");
}

int main(int argc, char* argv[])
{
  signal(SIGINT, sigint);
  signal(SIGPIPE, sigpipe);

  dport = "54000";
  host = argv[1];
  if (argc < 1)
  {
    fprintf(stderr, "usage: %s [server [port]]\n", *argv);
    return EXIT_FAILURE;
  }
  if (argc > 2)
    dport = argv[2];
  if (argc == 1)
    host = "localhost";
  else
    host = argv[1];

  char command[1024];
  sprintf(command, "nc %s %s", host, dport);
  f = popen(command, "w");
  using_history();

  char name[1024];
  strcpy(name, getenv("HOME"));
  strcat(name, "/.bt_history");
  read_history(name);
  rl_bind_key ('\t', rl_insert);
  char *l = NULL;
  while((l = readline("")))
  {
    add_history(l);
    fprintf(f, "%s\n", l);
    fflush(f);
    free(l);
  }
  return EXIT_SUCCESS;

}

