#ifndef URBI_H
#define URBI_H

#include <urbi/uclient.hh>
#include <QtGui>
#include <sys/types.h>
#include <math.h>

////////////////////
#include <klt.h>
#include <pnmio.h>
//////////////////////


class CaptureImage;

using namespace urbi;

class ConnectAibo : public QWidget
{
    Q_OBJECT

      public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotI;
      CaptureImage *pere;
      UCallbackAction command(const UMessage &);
      UCallbackAction command2(const UMessage &);

      unsigned char* buffer;
      unsigned char* bufferRGB; 
      int traitementEnCours;

      int compteur;

      QString fileName;

      QImage imageQT;
      QImage imageQT2;

      virtual bool event(QEvent *ev);
      QEvent *e1;

///////////////////////////////////////////////
// Traitement de stabilisation

   void stabilisation_init(int width, int height);
   void stabilisation_convertgris(int width, int height);
   void stabilisation_stockfeatures(int width, int height);
   void stabilisation_deplacement(int width, int height);
   float atan_limit(float, float);
   void stabilisation_convertgris_with_points(int width, int height);
   void stabilisation_recadrage(int width, int height);

   int cmd_nfeatures; // nb de points d'interet par image
   int compteur_images; // nb d'images recuperees
   float global_Tx, global_Ty, global_teta; // deplacement de l'image d'une image a l'autre
   float somme_global_Tx, somme_global_Ty, somme_global_teta; // deplacement de la premiere image a l'image actuelle
   int nFrames; // on travaille sur 5 images


   // stockage des images en niveau de gris
   unsigned char *bufferKLT1;
   unsigned char *bufferKLT2;
   unsigned char *bufferKLT3;
   unsigned char *bufferKLT4;
   unsigned char *bufferKLT5;
   unsigned char *bufferKLT_temp;

   // stockage des images sur 32 bits pour etre mis au format QImage
   unsigned char *bufferKLT1_32;
   QImage imageQT3; // image en niveaux de gris
   unsigned char *bufferKLT2_32;
   QImage imageQT4; // image en niveaux de gris avec les points d'interet
   unsigned char *bufferKLT3_32, *bufferKLT3_32bis;
   QImage imageQT5; // image recadree


   // tableaux pour enregistrer la position des points d'interet
   float *xa1_tab, *xa2_tab, *ya1_tab, *ya2_tab, *diff_tab, *variance_tab;

   // indispensable pour KLT
   KLT_TrackingContext tc;
   KLT_FeatureList fl;
   KLT_FeatureList fl_temp;
   KLT_FeatureTable ft;
   KLT_FeatureHistory fh;


//   bool discard_outliers(bool*, kp_selector*, unsigned, float, float, float);








// Traitement de stabilisation
///////////////////////////////////////////////


};

#endif
