


void ConnectAibo::stabilisation_init(int width, int height)
{
    // au premier demarrage, on initialise toutes les variables
    if(bufferKLT1 == NULL)
    {
     bufferKLT1 = new unsigned char[width * height * 8];
     bufferKLT2 = new unsigned char[width * height * 8];
     bufferKLT3 = new unsigned char[width * height * 8];
     bufferKLT4 = new unsigned char[width * height * 8];
     bufferKLT5 = new unsigned char[width * height * 8];
     bufferKLT_temp = new unsigned char[width * height * 8]; // image tampon

     bufferKLT1_32 = new unsigned char[width * height * 4 * 8]; // image pour convertir en QT_Image
     bufferKLT2_32 = new unsigned char[width * height * 4 * 8]; // image pour convertir en QT_Image
     bufferKLT3_32 = new unsigned char[width * height * 4 * 8]; // image pour convertir en QT_Image
     bufferKLT3_32bis = new unsigned char[width * height * 4 * 8]; // image pour convertir en QT_Image

     xa1_tab = new float[cmd_nfeatures]; // stockage des coordonnees des points d'interet
     ya1_tab = new float[cmd_nfeatures];
     xa2_tab = new float[cmd_nfeatures];
     ya2_tab = new float[cmd_nfeatures];
     diff_tab = new float[cmd_nfeatures];
     variance_tab = new float[cmd_nfeatures];
    }
}



void ConnectAibo::stabilisation_convertgris(int width, int height)
{
   // conversion de l'image RGB 32 en niveaux de gris
   for(int i=0; i<=width; i++)
     for(int j=0; j<=height; j++)
         bufferKLT_temp[i + j*width] = ( bufferRGB[(4*i) + (j*width*4) + 0] + bufferRGB[(4*i) + (j*width*4) + 1] + bufferRGB[(4*i) + (j*width*4) + 2] ) / 3 ;

   if(compteur_images == 0)
    	 memcpy( bufferKLT1, bufferKLT_temp, width * height );
   else if(compteur_images == 1)
    	 memcpy( bufferKLT2, bufferKLT_temp, width * height );
   else if(compteur_images == 2)
    	 memcpy( bufferKLT3, bufferKLT_temp, width * height );
   else if(compteur_images == 3)
    	 memcpy( bufferKLT4, bufferKLT_temp, width * height );
   else if(compteur_images == 4)
    	 memcpy( bufferKLT5, bufferKLT_temp, width * height );
   else if(compteur_images >= 5) // on va faire une rotation des tableaux
   {
    	 unsigned char *pt_buffer_temp;
    	 pt_buffer_temp = bufferKLT1;
    	 bufferKLT1 = bufferKLT2;
    	 bufferKLT2 = bufferKLT3;
    	 bufferKLT3 = bufferKLT4;
    	 bufferKLT4 = bufferKLT5;
    	 bufferKLT5 = pt_buffer_temp;
    	 memcpy( bufferKLT5, bufferKLT_temp, width * height );
   }

   // conversion de l'image en niveaux de gris en RGB 32 pour QT
   for(int i=0; i<=width; i++)
   {
     for(int j=0; j<=height; j++)
     {
                                  bufferKLT1_32[(4*i) + (j*width*4) + 0] = bufferKLT_temp[i + j*width];  // bleu
                                  bufferKLT1_32[(4*i) + (j*width*4) + 1] = bufferKLT_temp[i + j*width];  //vert
                                  bufferKLT1_32[(4*i) + (j*width*4) + 2] = bufferKLT_temp[i + j*width];  // rouge
                                  bufferKLT1_32[(4*i) + (j*width*4) + 3] = 0;        // vide
     }
   }    
   imageQT3=QImage( bufferKLT1_32, width, height, QImage::Format_RGB32 ); // on stocke l'image en niveau de gris
   imageQT3 = imageQT3.scaledToHeight ( imageQT2.height() );          // on met a la bonne taille
}


void ConnectAibo::stabilisation_stockfeatures(int width, int height)
{
   // stockage des features des images
   if(compteur_images == 0) // premiere image
   {
     KLTSelectGoodFeatures(tc, bufferKLT1, width, height, fl);
     // les features sont stockees de la maniere suivante : 
     // fl->feature[i]->x // position x dans l'image
     // fl->feature[i]->y // position y dans l'image
     // fl->feature[i]->val // valeur de la feature

     // fonction permettant de stocker l'image en niveaux de gris avec des carres rouges pour indiquer les points d'interet
     // KLTWriteFeatureListToPPM(fl, bufferKLT1,width, height, "feat1.ppm"); 
     
     // fonction permettant de stocker la position des points d'interet dans un fichier texte
     // KLTWriteFeatureList(fl, "feat1.txt", "%3d");
     // KLTWriteFeatureList(fl, "feat1.txt", "%5.1f");  // text file 
     // KLTWriteFeatureList(fl, "feat1.fl", NULL);  // binary file 
     
     // stockage des features a l'emplacement 0
     KLTStoreFeatureList(fl, ft, 0);
   }
   else if(compteur_images == 1) // seconde image
   {
     KLTTrackFeatures(tc, bufferKLT1, bufferKLT2, width, height, fl);
     // quand un point n'est pas trouve, on a :
     // ( -1, -1)=  4 

     // KLTWriteFeatureListToPPM(fl, bufferKLT2, width, height, "feat2.ppm"); 
     // KLTWriteFeatureList(fl, "feat2.txt", "%3d");

     KLTReplaceLostFeatures(tc, bufferKLT2, width, height, fl);

     // stockage des features a l'emplacement 1
     KLTStoreFeatureList(fl, ft, 1);

     // on copie les features de l'entree 1 de la table dans ft_temp
     // KLTExtractFeatureList(fl_temp, ft, 1);

   }
   else if(compteur_images == 2) // troisieme image
   {
     KLTTrackFeatures(tc, bufferKLT2, bufferKLT3, width, height, fl);
     KLTReplaceLostFeatures(tc, bufferKLT2, width, height, fl);
     KLTStoreFeatureList(fl, ft, 2);
   }
   else if(compteur_images == 3) // quatrieme image
   {
     KLTTrackFeatures(tc, bufferKLT3, bufferKLT4, width, height, fl);
     KLTReplaceLostFeatures(tc, bufferKLT3, width, height, fl);
     KLTStoreFeatureList(fl, ft, 3);
   }
   else if(compteur_images == 4) // cinquieme image
   {
     KLTTrackFeatures(tc, bufferKLT4, bufferKLT5, width, height, fl);
     KLTReplaceLostFeatures(tc, bufferKLT4, width, height, fl);
     KLTStoreFeatureList(fl, ft, 4);
   }
   else if(compteur_images >= 5) // cinquieme image
   {
     KLTTrackFeatures(tc, bufferKLT4, bufferKLT5, width, height, fl);
     KLTReplaceLostFeatures(tc, bufferKLT4, width, height, fl);

     // on fait un decalage pour le stockage des listes de features
     KLTExtractFeatureList(fl_temp, ft, 1);
     KLTStoreFeatureList(fl_temp, ft, 0);
     KLTExtractFeatureList(fl_temp, ft, 2);
     KLTStoreFeatureList(fl_temp, ft, 1);
     KLTExtractFeatureList(fl_temp, ft, 3);
     KLTStoreFeatureList(fl_temp, ft, 2);
     KLTExtractFeatureList(fl_temp, ft, 4);
     KLTStoreFeatureList(fl_temp, ft, 3);

     KLTStoreFeatureList(fl, ft, 4);
   }
}


void ConnectAibo::stabilisation_deplacement(int width, int height)
{
     // on cherche a trouver le deplacement entre 2 images

    int X_CENTER = width / 2;
    int Y_CENTER = height / 2;

    // le outliers va permettre de voir si les deplacements sont bons
    bool outliers[cmd_nfeatures];

    // les variables suivantes servent a determiner les deplacements de l'image
    float Sxxp , Syyp , Sxyp , Syxp ;
    float xa1m , ya1m , xa2m , ya2m ;
    float Tx , Ty , teta ;
    unsigned matched_kp ;


    if(compteur_images >= 6)
    {
            // le outliers va permettre de voir si les deplacements sont bons
        	for ( int i=0; i<cmd_nfeatures; ++i )
        	{
        	  outliers[i] = false; // 0
        	}
        
            Sxxp = 0. ; Syyp = 0. ; Sxyp = 0. ; Syxp = 0.;
            xa1m = 0. ; ya1m = 0. ; xa2m = 0. ; ya2m = 0.;
            Tx = 0.   ; Ty = 0.   ; teta = 0.;
            matched_kp = 0;

//        	matched_kp = 0;
//        	Sxxp = Syyp = Sxyp = Syxp = xa1m = ya1m = xa2m = ya2m = Tx = Ty = teta = 0.;

        	for ( int i=0; i<cmd_nfeatures; i++ )
        	{
            		if ( fl->feature[i]->val == 0 ) // si fl->feature[i]->val == 0 alors cela signifie que le point a ete tracke
            		{
            		    matched_kp++; // on ajoute 1 au nombre de points correspondants trouves
            		    xa1_tab[i] = (float)ft->feature[i][3]->x - (float)X_CENTER; // on positionne x au centre
            		    ya1_tab[i] = (float)Y_CENTER - (float)ft->feature[i][3]->y;
            		    xa2_tab[i] = (float)ft->feature[i][4]->x - (float)X_CENTER;
            		    ya2_tab[i] = (float)Y_CENTER - (float)ft->feature[i][4]->y;
            		    xa1m += xa1_tab[i];
            		    ya1m += ya1_tab[i];
            		    xa2m += xa2_tab[i];
            		    ya2m += ya2_tab[i];
            		}
        	}

    	    if ( matched_kp == 0 ) // aucun point correspondant n'a ete trouve
        	{
            		global_teta = 0;
            		global_Tx = 0;
            		global_Ty = 0;
        	}

        	else
        	{	    
            		xa1m /= ((float) matched_kp); // valeur moyenne de x1
            		ya1m /= ((float) matched_kp); // valeur moyenne de y1
            		xa2m /= ((float) matched_kp); // valeur moyenne de x2
            		ya2m /= ((float) matched_kp); // valeur moyenne de y2
    		
            		for ( int i=0; i<cmd_nfeatures; i++ )
            		{
            		   if ( fl->feature[i]->val == 0 )
            		   {		    
            		      Sxxp += (xa2_tab[i] - xa2m)*(xa1_tab[i] - xa1m);
            		      Syyp += (ya2_tab[i] - ya2m)*(ya1_tab[i] - ya1m);
            		      Sxyp += (xa2_tab[i] - xa2m)*(ya1_tab[i] - ya1m);
            		      Syxp += (ya2_tab[i] - ya2m)*(xa1_tab[i] - xa1m);
            		   }
            		}

            		teta = atan_limit((Sxyp-Syxp), (Sxxp+Syyp));
            		Tx = xa1m - (xa2m*cos(teta) - ya2m*sin(teta));
            		Ty = ya1m - (xa2m*sin(teta) + ya2m*cos(teta));

            		global_teta = teta;
            		global_Tx = Tx;
            		global_Ty = Ty;
        	}

            somme_global_Tx = somme_global_Tx + global_Tx;
            somme_global_Ty = somme_global_Ty + global_Ty;
//            somme_global_teta = somme_global_teta + global_teta; 
            somme_global_teta = global_teta; 

            if(abs((int)somme_global_Tx) >= (int)(width/4) )
              somme_global_Tx = 0;
            if(abs((int)somme_global_Ty) >= (int)(height/4) )
              somme_global_Ty = 0;

    }
}

float ConnectAibo::atan_limit(float a, float b)
{
  float teta = atan2(a, b);
  if ( a < 0 )
      teta += 2 * M_PI;

  return teta;
}


void ConnectAibo::stabilisation_convertgris_with_points(int width, int height)
{
    if(compteur_images >= 6)
    {

       // conversion de l'image en niveaux de gris en RGB 32 pour QT
       for(int i=0; i<=width; i++)
       {
         for(int j=0; j<=height; j++)
         {
                                      bufferKLT2_32[(4*i) + (j*width*4) + 0] = bufferKLT_temp[i + j*width];  // bleu
                                      bufferKLT2_32[(4*i) + (j*width*4) + 1] = bufferKLT_temp[i + j*width];  //vert
                                      bufferKLT2_32[(4*i) + (j*width*4) + 2] = bufferKLT_temp[i + j*width];  // rouge
                                      bufferKLT2_32[(4*i) + (j*width*4) + 3] = 0;        // vide
         }
       }    


       int x;
       int y;

       // on positionne les points d'interet
       for ( int i=0; i<cmd_nfeatures; i++ )
       {
                    x = (int) fl->feature[i]->x;
                    y = (int) fl->feature[i]->y;
                    
                    if(x != 0 && y != 0 && x != width-1 && y != height-1)
                    {
                        if(fl->feature[i]->val != 0)
                        {
                            // x-1 et y
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 3] = 0;        // vide

                            // x+1 et y
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 3] = 0;        // vide

                            // x et y
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 3] = 0;        // vide

                            // x-1 et y-1
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 3] = 0;        // vide

                            // x et y-1
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 3] = 0;        // vide

                            // x+1 et y-1
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 3] = 0;        // vide

                            // x-1 et y+1
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 3] = 0;        // vide

                            // x et y+1
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 3] = 0;        // vide

                            // x+1 et y+1
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 0] = 255;  // bleu
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 2] = 0;  // rouge
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 3] = 0;        // vide

                        }
                        else
                        {
                            // x-1 et y
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x-1) ) + ( y * width*4) + 3] = 0;        // vide

                            // x+1 et y
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x+1) ) + ( y * width*4) + 3] = 0;        // vide

                            // x et y
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * x ) + ( y * width*4) + 3] = 0;        // vide

                            // x-1 et y-1
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y-1) * width*4) + 3] = 0;        // vide

                            // x et y-1
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x) ) + ( (y-1) * width*4) + 3] = 0;        // vide

                            // x+1 et y-1
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y-1) * width*4) + 3] = 0;        // vide

                            // x-1 et y+1
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x-1) ) + ( (y+1) * width*4) + 3] = 0;        // vide

                            // x et y+1
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x) ) + ( (y+1) * width*4) + 3] = 0;        // vide

                            // x+1 et y+1
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 0] = 0;  // bleu
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 1] = 0;  //vert
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 2] = 255;  // rouge
                    		bufferKLT2_32[(4 * (x+1) ) + ( (y+1) * width*4) + 3] = 0;        // vide

                        }
                    }
        }





       imageQT4=QImage( bufferKLT2_32, width, height, QImage::Format_RGB32 ); // on stocke l'image en niveau de gris
       imageQT4 = imageQT4.scaledToHeight ( imageQT2.height() );          // on met a la bonne taille

    }
}


void ConnectAibo::stabilisation_recadrage(int width, int height)
{

    // on copie l'image prcdente dans bufferKLT3_32bis
    memcpy( bufferKLT3_32bis, bufferRGB, width * height * 4 );
    
    // on copie l'image initiale
    memcpy( bufferKLT3_32, bufferRGB, width * height * 4 );
            
    if(compteur_images >= 6)
    {
       int depl_x = (int) somme_global_Tx;
       int depl_y = (int) somme_global_Ty;


       if(depl_x <= -1)       // deplacement vers la gauche mauvais
       {
                for(int i=0; i<=width+depl_x-1; i++)
                {

                       if(depl_y <= -1) // deplacement vers le haut
                       {
                                 for(int j=0; j<=height+depl_y-1; j++)
                                 {
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 0] = bufferKLT3_32[(4*(i-depl_x)) + ((j-depl_y)*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 1] = bufferKLT3_32[(4*(i-depl_x)) + ((j-depl_y)*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 2] = bufferKLT3_32[(4*(i-depl_x)) + ((j-depl_y)*width*4) + 2];  // rouge
                                 }
                       }
                       else if(depl_y >= 1) // deplacement vers le bas
                       {
                                 for(int j=0; j<=height-depl_y; j++)
                                 {
                                      bufferKLT3_32bis[(4*(i)) + ((j+depl_y)*width*4) + 0] = bufferKLT3_32[(4*(i-depl_x)) + (j*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i)) + ((j+depl_y)*width*4) + 1] = bufferKLT3_32[(4*(i-depl_x)) + (j*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i)) + ((j+depl_y)*width*4) + 2] = bufferKLT3_32[(4*(i-depl_x)) + (j*width*4) + 2];  // rouge
                                 }
                       }
                       else // pas de deplacement vertical
                       {
                                 for(int j=0; j<=height; j++) 
                                 {
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 0] = bufferKLT3_32[(4*(i-depl_x)) + (j*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 1] = bufferKLT3_32[(4*(i-depl_x)) + (j*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 2] = bufferKLT3_32[(4*(i-depl_x)) + (j*width*4) + 2];  // rouge
                                 }
                       }

                }    
       }
       else if(depl_x >= 1)       // deplacement vers la droite
       {
                for(int i=0; i<=width-depl_x; i++)
                {

                       if(depl_y <= -1) // deplacement vers le haut
                       {
                                 for(int j=0; j<=height+depl_y-1; j++)
                                 {
                                      bufferKLT3_32bis[(4*(i+depl_x)) + (j*width*4) + 0] = bufferKLT3_32[(4*(i)) + ((j-depl_y)*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i+depl_x)) + (j*width*4) + 1] = bufferKLT3_32[(4*(i)) + ((j-depl_y)*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i+depl_x)) + (j*width*4) + 2] = bufferKLT3_32[(4*(i)) + ((j-depl_y)*width*4) + 2];  // rouge
                                 }
                       }
                       else if(depl_y >= 1) // deplacement vers le bas
                       {
                                 for(int j=0; j<=height-depl_y; j++)
                                 {
                                      bufferKLT3_32bis[(4*(i+depl_x)) + ((j+depl_y)*width*4) + 0] = bufferKLT3_32[(4*(i)) + (j*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i+depl_x)) + ((j+depl_y)*width*4) + 1] = bufferKLT3_32[(4*(i)) + (j*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i+depl_x)) + ((j+depl_y)*width*4) + 2] = bufferKLT3_32[(4*(i)) + (j*width*4) + 2];  // rouge
                                 }
                       }
                       else // pas de deplacement vertical
                       {
                                 for(int j=0; j<=height; j++)
                                 {
                                      bufferKLT3_32bis[(4*(i+depl_x)) + (j*width*4) + 0] = bufferKLT3_32[(4*(i)) + (j*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i+depl_x)) + (j*width*4) + 1] = bufferKLT3_32[(4*(i)) + (j*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i+depl_x)) + (j*width*4) + 2] = bufferKLT3_32[(4*(i)) + (j*width*4) + 2];  // rouge
                                 }
                       }

                }    
       }
       else    // pas de deplacement horizontal
       {
                for(int i=0; i<=width; i++)
                {

                       if(depl_y <= -1) // deplacement vers le haut
                       {
                                 for(int j=0; j<=height+depl_y-1; j++)
                                 {
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 0] = bufferKLT3_32[(4*(i)) + ((j-depl_y)*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 1] = bufferKLT3_32[(4*(i)) + ((j-depl_y)*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 2] = bufferKLT3_32[(4*(i)) + ((j-depl_y)*width*4) + 2];  // rouge
                                 }
                       }
                       else if(depl_y >= 1) // deplacement vers le bas
                       {
                                 for(int j=0; j<=height-depl_y; j++)
                                 {
                                      bufferKLT3_32bis[(4*(i)) + ((j+depl_y)*width*4) + 0] = bufferKLT3_32[(4*(i)) + (j*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i)) + ((j+depl_y)*width*4) + 1] = bufferKLT3_32[(4*(i)) + (j*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i)) + ((j+depl_y)*width*4) + 2] = bufferKLT3_32[(4*(i)) + (j*width*4) + 2];  // rouge
                                 }
                       }
                       else // pas de deplacement vertical
                       {
                                 for(int j=0; j<=height; j++) 
                                 {
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 0] = bufferKLT3_32[(4*(i)) + (j*width*4) + 0];  // bleu
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 1] = bufferKLT3_32[(4*(i)) + (j*width*4) + 1];  //vert
                                      bufferKLT3_32bis[(4*(i)) + (j*width*4) + 2] = bufferKLT3_32[(4*(i)) + (j*width*4) + 2];  // rouge
                                 }
                       }

                }    
       }


    }

    imageQT5 = QImage( bufferKLT3_32bis, width, height, QImage::Format_RGB32 ); // on stocke l'image en niveau de gris
    imageQT5 = imageQT5.scaledToHeight ( imageQT2.height() );          // on met a la bonne taille

}



