#include "convertkfm.h"


///////////////////////////////////////////////
// Creation de l'objet
ConvertKFM::ConvertKFM(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

        etatConversion=0;
}

///////////////////////////////////////////////
// Bouton parcourir
void ConvertKFM::on_pushButton_2_clicked()
{
    QString openFilesPath;
    QString openFilesPath2;
    int sizeFile;
    QChar *data;

    QStringList files = QFileDialog::getOpenFileNames(
                                this, tr("QFileDialog::getOpenFileNames()"),
                                openFilesPath,
                                tr("Motion Control (*.kfm);; Pose Control (*.pse)"));
    if (files.count()) 
    {
        openFilesPath = files[0];
        ui.label_2->setText(openFilesPath);        // affichage du fichier selectionne
        sizeFile=openFilesPath.count();            // recuperation de sa taille
        data=openFilesPath.data();
        *(data+sizeFile-3)='u';
        *(data+sizeFile-2)='\0';
        *(data+sizeFile-1)='\0';
        openFilesPath2 = QString(data,sizeFile-2);       
        ui.label->setText(openFilesPath2); // on affiche son nouveau nom en .U
    }

}


void ConvertKFM::on_pushButton_clicked()    // bouton conversion
{
     QString tab[20];
     QString openFilesPath=ui.label_2->text();  // nom du fichier KFM
     QString openFilesPath2=ui.label->text();   // nom du fichier U

     int sizeFile;
     QChar *data;
     sizeFile=openFilesPath.count();            // recuperation de sa taille
     data=openFilesPath.data();
     if (*(data+sizeFile-3)=='k')               // KFM
     {
        readFileKFM(tab,openFilesPath,openFilesPath2);
        concatenation(openFilesPath2);
     }
     else if (*(data+sizeFile-3)=='p')           // PSE
     {
        readFile(tab,openFilesPath);
        writeFile(tab,openFilesPath2);
     }

     if( etatConversion == 1)
         QMessageBox::information(this, "Information", "Conversion is finished ");
     etatConversion=0;

}



/////////////////////////////////////////////////////////////////////////////////
// Lecture du fichier KFM
void ConvertKFM::readFileKFM(QString *tab,QString openFilesPath,QString openFilesPath2)
{
    QFile file;
    QString line;
    QString delay;
    file.setFileName(openFilesPath);  // ouverture du fichier KFM
    int nbPSE=0;

    if( file.exists() )
    {
        etatConversion=1;

        file.open(QIODevice::ReadOnly | QIODevice::Text );
        QTextStream in(&file);

        line = in.readLine(); // lecture premiere ligne avec nb positions
        nbPSE=line.toInt();

        line = in.readLine(); // lecture du nom de la premiere position PSE
        readFilePSE(tab,line,openFilesPath2); // lecture du fichier PSE

        line = in.readLine(); // lecture d'une ligne inutile

        for(int i=0 ; i<=nbPSE-2 ; i++)
        {
           delay = in.readLine(); // lecture du delay
           line = in.readLine(); // lecture du nom de la position PSE                      
           readFilePSE2(tab,line,openFilesPath2,delay);
           line = in.readLine(); // lecture d'une ligne inutile
        }

    file.close();
    }

    else
    {
        etatConversion=0;
        QMessageBox::information(this, "Error", "Your file KFM has not been found");
    }

}


///////////////////////////////////////////////////////////////////
// lecture d'un fichier PSE
void ConvertKFM::readFilePSE(QString *tab,QString openFilesPath,QString openFilesPath2)
{
    QFile file;
    file.setFileName(openFilesPath);  // ouverture du fichier PSE

    if( file.exists() )
    {
        file.open(QIODevice::ReadOnly | QIODevice::Text );
        QTextStream in(&file);

        int i=0,j=0,compteur=0;
        while (!in.atEnd()) 
        {
            QString line = in.readLine();
            if(i >= 4 && j==0)
            {
                 tab[compteur]=line;
                 compteur++;
            }

            i++;
            j++;
            if(j>=2)
                 j=0;
        }
        file.close();
    }
    else
    {
        etatConversion=0;

        QFileInfo namee(openFilesPath);
        QString nameInfoe = namee.baseName();
        QString texteAAfficher = "Your file PSE \"" + nameInfoe + "\" has not been found";
        QMessageBox::information(this, "Error", texteAAfficher);
    }



    QFile file2;
    file2.setFileName(openFilesPath2);   // ouverture du fichier U

    QFileInfo name(openFilesPath);
    QString nameInfo = name.baseName();

    // on remplace tous les caracteres speciaux dans le nom du fichier
    QChar space (' ');
    QChar diez ('#');
    nameInfo.replace ( space, "_" );
    nameInfo.replace ( diez, "_" );

    file2.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out(&file2);

    out << "if (isdef(pos." << nameInfo <<"))" << endl;
    out << "       delete pos." << nameInfo <<";" << endl << endl;
    out << "function pos." << nameInfo <<"(delay)" << endl;
    out << "{" << endl;
    out << "     neck = " << tab[0] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     headPan = " << tab[1] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     headTilt = " << tab[2] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     mouth = " << tab[3] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     earL = " << tab[4] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     earR = " << tab[5] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLF1 = " << tab[6] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLF2 = " << tab[7] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legLF3 = " << tab[8] << " time:delay" << endl;    
    out << "     &" << endl;   
    out << "     legLH1 = " << tab[9] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLH2 = " << tab[10] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legLH3 = " << tab[11] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     legRF1 = " << tab[12] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legRF2 = " << tab[13] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legRF3 = " << tab[14] << " time:delay" << endl;    
    out << "     &" << endl;   
    out << "     legRH1 = " << tab[15] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legRH2 = " << tab[16] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legRH3 = " << tab[17] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     tailTilt = " << tab[18] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     tailPan = " << tab[19] << " time:delay" << endl;    
    out << "};" << endl;  
    out << endl;  

    file2.close();
    
          
    
    QFile file3;
    file3.setFileName("urbitemp.txt");
    file3.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out2(&file3);
    out2 << "posDelay = 16ms;" << endl;
    out2 << "pos." << nameInfo <<"(1s);" << endl;
    file3.close(); 
  
}



void ConvertKFM::readFilePSE2(QString *tab,QString openFilesPath,QString openFilesPath2,QString delay)
{
    QFile file;
    file.setFileName(openFilesPath);  // ouverture du fichier PSE

    if( file.exists() )
    {
        file.open(QIODevice::ReadOnly | QIODevice::Text );
        QTextStream in(&file);

        int i=0,j=0,compteur=0;
        while (!in.atEnd()) 
        {
            QString line = in.readLine();
            if(i >= 4 && j==0)
            {
                 tab[compteur]=line;
                 compteur++;
            }

            i++;
            j++;
            if(j>=2)
                 j=0;
        }
    file.close();
    }
    else
    {
        etatConversion=0;

        QFileInfo namee(openFilesPath);
        QString nameInfoe = namee.baseName();
        QString texteAAfficher = "Your file PSE \"" + nameInfoe + "\" has not been found";
        QMessageBox::information(this, "Error", texteAAfficher);
    }


    QFile file2;
    file2.setFileName(openFilesPath2);   // ouverture du fichier U

    QFileInfo name(openFilesPath);
    QString nameInfo = name.baseName();

    // on remplace tous les caracteres speciaux dans le nom du fichier
    QChar space (' ');
    QChar diez ('#');
    nameInfo.replace ( space, "_" );
    nameInfo.replace ( diez, "_" );

    file2.open(QIODevice::Append | QIODevice::Text );
    QTextStream out(&file2);

    out << "if (isdef(pos." << nameInfo <<"))" << endl;
    out << "       delete pos." << nameInfo <<";" << endl << endl;
    out << "function pos." << nameInfo <<"(delay)" << endl;
    out << "{" << endl;
    out << "     neck = " << tab[0] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     headPan = " << tab[1] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     headTilt = " << tab[2] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     mouth = " << tab[3] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     earL = " << tab[4] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     earR = " << tab[5] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLF1 = " << tab[6] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLF2 = " << tab[7] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legLF3 = " << tab[8] << " time:delay" << endl;    
    out << "     &" << endl;   
    out << "     legLH1 = " << tab[9] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLH2 = " << tab[10] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legLH3 = " << tab[11] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     legRF1 = " << tab[12] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legRF2 = " << tab[13] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legRF3 = " << tab[14] << " time:delay" << endl;    
    out << "     &" << endl;   
    out << "     legRH1 = " << tab[15] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legRH2 = " << tab[16] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legRH3 = " << tab[17] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     tailTilt = " << tab[18] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     tailPan = " << tab[19] << " time:delay" << endl;    
    out << "};" << endl;  
    out << endl;  

    file2.close();


    QFile file3;
    file3.setFileName("urbitemp.txt");
    file3.open(QIODevice::Append | QIODevice::Text );
    QTextStream out2(&file3);
    out2 << "pos." << nameInfo << "(" << delay << " * posDelay);" << endl;
    file3.close(); 

}


void ConvertKFM::concatenation(QString openFilesPath2)
{
    QFile file2;
    file2.setFileName(openFilesPath2);   // ouverture du fichier U
    file2.open(QIODevice::Append | QIODevice::Text );
    QTextStream out(&file2);

    QFile file3;
    file3.setFileName("urbitemp.txt");
    file3.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in(&file3);

    while (!in.atEnd()) 
       out << in.readLine() << endl;    

    file2.close();
    file3.remove();
    file3.close(); 

}


/////////////////////////////////////////////////////////////
// Lecture d'un fichier PSE
void ConvertKFM::readFile(QString *tab,QString openFilesPath)
{
    QFile file;
    file.setFileName(openFilesPath); // on donne l'adresse du fichier

    if( file.exists() )
    {
        file.open(QIODevice::ReadOnly | QIODevice::Text ); // on ouvre le fichier en mode texte
        QTextStream in(&file);

        int i=0,j=0,compteur=0;
        while (!in.atEnd()) 
        {
            QString line = in.readLine();
            if(i >= 4 && j==0)
            {
                 tab[compteur]=line;     // on enregistre dans le tableau tab les positions des joints
                 compteur++;
            }

            i++;
            j++;
            if(j>=2)
                 j=0;
        }
        file.close();
        etatConversion=1;
    }
    else
    {
        etatConversion=0;
        QMessageBox::information(this, "Error", "Your file PSE has not been found");
    }



}


////////////////////////////////////////////////////////////////////
// Ecriture du fichier .U
void ConvertKFM::writeFile(QString *tab,QString openFilesPath2)
{
    QFile file2;
    file2.setFileName(openFilesPath2);

    QFileInfo name(openFilesPath2);
    QString nameInfo = name.baseName(); // On recupere seulement le nom du fichier

    // on remplace tous les caracteres speciaux dans le nom du fichier
    QChar space (' ');
    QChar diez ('#');
    nameInfo.replace ( space, "_" );
    nameInfo.replace ( diez, "_" );



    file2.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out(&file2);
    out << "if (isdef(pos." << nameInfo <<"))" << endl;
    out << "       delete pos." << nameInfo <<";" << endl << endl;
    out << "function pos." << nameInfo <<"(delay)" << endl;
    out << "{" << endl;
    out << "     neck = " << tab[0] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     headPan = " << tab[1] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     headTilt = " << tab[2] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     mouth = " << tab[3] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     earL = " << tab[4] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     earR = " << tab[5] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLF1 = " << tab[6] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLF2 = " << tab[7] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legLF3 = " << tab[8] << " time:delay" << endl;    
    out << "     &" << endl;   
    out << "     legLH1 = " << tab[9] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legLH2 = " << tab[10] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legLH3 = " << tab[11] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     legRF1 = " << tab[12] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legRF2 = " << tab[13] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legRF3 = " << tab[14] << " time:delay" << endl;    
    out << "     &" << endl;   
    out << "     legRH1 = " << tab[15] << " time:delay" << endl;    
    out << "     &" << endl;        
    out << "     legRH2 = " << tab[16] << " time:delay" << endl;    
    out << "     &" << endl;            
    out << "     legRH3 = " << tab[17] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     tailTilt = " << tab[18] << " time:delay" << endl;    
    out << "     &" << endl;  
    out << "     tailPan = " << tab[19] << " time:delay" << endl;    
    out << "};" << endl;  
    out << endl;  
    out << "pos." << nameInfo <<"(1s);" << endl;  

    file2.close();
}

