#include "conversionrgb.h"

//////////////////////////////////////////
// Creation de l'objet
Conversion::Conversion(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);
}


//////////////////////////////////////////
// Modification de Rouge
void Conversion::on_spinBox_valueChanged ( int i )
{

     unsigned char buffer[3]; // stockage RGB
     unsigned char buffer2[3]; // stockage YCBCr

     // on remplit buffer
     buffer[0]=ui.spinBox_3->value();   // blue
     buffer[1]=ui.spinBox_2->value(); // green
     buffer[2]=ui.spinBox->value();  // red

     // conversion de la couleur en YCbCr
     convertRGBtoYCrCb((const byte *) buffer, 3, (byte*) buffer2);

     // affichage des valeurs YCbCr
     ui.lcdNumber->display( buffer2[0] ); 
     ui.lcdNumber_2->display( buffer2[1] ); 
     ui.lcdNumber_3->display( buffer2[2] ); 

     // creation de la couleur
     QColor couleur ( buffer[2], buffer[1], buffer[0] ); 

     // application de la couleur
     ui.pushButton->setPalette(couleur);
}

//////////////////////////////////////////
// Modification de Vert
void Conversion::on_spinBox_2_valueChanged ( int i )
{

     unsigned char buffer[3];
     unsigned char buffer2[3];

     // on remplit buffer
     buffer[0]=ui.spinBox_3->value();
     buffer[1]=ui.spinBox_2->value();
     buffer[2]=ui.spinBox->value();

     // conversion de la couleur en YCbCr
     convertRGBtoYCrCb((const byte *) buffer, 3, (byte*) buffer2);

     ui.lcdNumber->display( buffer2[0] ); 
     ui.lcdNumber_2->display( buffer2[1] ); 
     ui.lcdNumber_3->display( buffer2[2] ); 
     
     // creation de la couleur
     QColor couleur ( buffer[2], buffer[1], buffer[0] ); 

     // application de la couleur
     ui.pushButton->setPalette(couleur);
}


//////////////////////////////////////////
// Modification de Bleu
void Conversion::on_spinBox_3_valueChanged ( int i )
{

     unsigned char buffer[3];
     unsigned char buffer2[3];

     // on remplit buffer
     buffer[0]=ui.spinBox_3->value();
     buffer[1]=ui.spinBox_2->value();
     buffer[2]=ui.spinBox->value();

     // conversion de la couleur en YCbCr
     convertRGBtoYCrCb((const byte *) buffer, 3, (byte*) buffer2);

     ui.lcdNumber->display( buffer2[0] ); 
     ui.lcdNumber_2->display( buffer2[1] ); 
     ui.lcdNumber_3->display( buffer2[2] ); 
     
     // creation de la couleur
     QColor couleur ( buffer[2], buffer[1], buffer[0] ); 

     // application de la couleur
     ui.pushButton->setPalette(couleur);
}


//////////////////////////////////////////
// Modification de Y
void Conversion::on_spinBox_4_valueChanged ( int i )
{

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on remplit buffer
     buffer[0]=ui.spinBox_4->value();
     buffer[1]=ui.spinBox_5->value();
     buffer[2]=ui.spinBox_6->value();

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const byte *) buffer, 3, (byte*) buffer2 );

     ui.lcdNumber_4->display( buffer2[0] ); 
     ui.lcdNumber_5->display( buffer2[1] ); 
     ui.lcdNumber_6->display( buffer2[2] ); 
     
     // creation de la couleur
     QColor couleur ( buffer2[0], buffer2[1], buffer2[2] ); 

     // application de la couleur
     ui.pushButton_2->setPalette(couleur);
}


//////////////////////////////////////////
// Modification de Cb
void Conversion::on_spinBox_5_valueChanged ( int i )
{

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on remplit buffer
     buffer[0]=ui.spinBox_4->value();
     buffer[1]=ui.spinBox_5->value();
     buffer[2]=ui.spinBox_6->value();

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const byte *) buffer, 3, (byte*) buffer2 );

     ui.lcdNumber_4->display( buffer2[0] ); 
     ui.lcdNumber_5->display( buffer2[1] ); 
     ui.lcdNumber_6->display( buffer2[2] ); 
     
     // creation de la couleur
     QColor couleur ( buffer2[0], buffer2[1], buffer2[2] ); 

     // application de la couleur
     ui.pushButton_2->setPalette(couleur);
}


//////////////////////////////////////////
// Modification de Cr
void Conversion::on_spinBox_6_valueChanged ( int i )
{

     unsigned char buffer[3]; // couleur YCbCr
     unsigned char buffer2[3]; // destination RGB

     // on remplit buffer
     buffer[0]=ui.spinBox_4->value();
     buffer[1]=ui.spinBox_5->value();
     buffer[2]=ui.spinBox_6->value();

     // conversion de la couleur en RGB
     convertYCrCbtoRGB( (const byte *) buffer, 3, (byte*) buffer2 );

     ui.lcdNumber_4->display( buffer2[0] ); 
     ui.lcdNumber_5->display( buffer2[1] ); 
     ui.lcdNumber_6->display( buffer2[2] ); 
     
     // creation de la couleur
     QColor couleur ( buffer2[0], buffer2[1], buffer2[2] ); 

     // application de la couleur
     ui.pushButton_2->setPalette(couleur);
}



