#include "captureimage.h"

/////////////////////////////////////////////////
// Creation de l'objet
CaptureImage::CaptureImage(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

        // configuration de la couleur 1
        color1.configure(0, 255, 120, 190, 150, 230,"Pink"); // rose
        color2.configure(0, 255, 168, 238, 67, 137,"Blue"); // bleu
        color3.configure(0, 255, 90, 160, 40, 90,"Green"); // vert
        color5.configure(0, 255, 10, 80, 80, 150,"Yellow"); // jaune

        int Ymoy;
        int Cbmoy;
        int Crmoy;
        unsigned char buffercolor[3]; // couleur YCbCr
        unsigned char buffercolor2[3]; // destination RGB

         // on calcule la valeur moyenne de la couleur1
         Ymoy = (int) ( (0 + 255) / 2 );
         Cbmoy = (int) ( (120 + 190) / 2 );
         Crmoy = (int) ( (150 + 230) / 2 );
         // on remplit buffer
         buffercolor[0]=Ymoy;
         buffercolor[1]=Cbmoy;
         buffercolor[2]=Crmoy;
         // conversion de la couleur en RGB
         convertYCrCbtoRGB( (const unsigned char *) buffercolor, 3, (unsigned char*) buffercolor2 );
        colorColor1 = QColor(buffercolor2[0],buffercolor2[1],buffercolor2[2]);
        ui.pushButton_2->setPalette(QPalette(colorColor1));

         // on calcule la valeur moyenne de la couleur2
         Ymoy = (int) ( (0 + 255) / 2 );
         Cbmoy = (int) ( (168 + 238) / 2 );
         Crmoy = (int) ( (67 + 137) / 2 );
         // on remplit buffer
         buffercolor[0]=Ymoy;
         buffercolor[1]=Cbmoy;
         buffercolor[2]=Crmoy;
         // conversion de la couleur en RGB
         convertYCrCbtoRGB( (const unsigned char *) buffercolor, 3, (unsigned char*) buffercolor2 );
        colorColor2 = QColor(buffercolor2[0],buffercolor2[1],buffercolor2[2]);
        ui.pushButton_3->setPalette(QPalette(colorColor2));

         // on calcule la valeur moyenne de la couleur3
         Ymoy = (int) ( (0 + 255) / 2 );
         Cbmoy = (int) ( (90 + 160) / 2 );
         Crmoy = (int) ( (40 + 90) / 2 );
         // on remplit buffer
         buffercolor[0]=Ymoy;
         buffercolor[1]=Cbmoy;
         buffercolor[2]=Crmoy;
         // conversion de la couleur en RGB
         convertYCrCbtoRGB( (const unsigned char *) buffercolor, 3, (unsigned char*) buffercolor2 );
        colorColor3 = QColor(buffercolor2[0],buffercolor2[1],buffercolor2[2]);
        ui.pushButton_4->setPalette(QPalette(colorColor3));

         // on calcule la valeur moyenne de la couleur5
         Ymoy = (int) ( (0 + 255) / 2 );
         Cbmoy = (int) ( (10 + 80) / 2 );
         Crmoy = (int) ( (80 + 150) / 2 );
         // on remplit buffer
         buffercolor[0]=Ymoy;
         buffercolor[1]=Cbmoy;
         buffercolor[2]=Crmoy;
         // conversion de la couleur en RGB
         convertYCrCbtoRGB( (const unsigned char *) buffercolor, 3, (unsigned char*) buffercolor2 );
        colorColor5 = QColor(buffercolor2[0],buffercolor2[1],buffercolor2[2]);
        ui.pushButton_6->setPalette(QPalette(colorColor5));

}

/////////////////////////////////////////////////
// Connexion au robot
void CaptureImage::on_pushButton_clicked()
{
    QString robotName = ui.lineEdit->text();
// sauvegarde du nom du robot
   QSettings settings("Detector Colors", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg3;");
          urbiImage.robotI->send("stop uimg4;");
          urbiImage.robotI->send("noop;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0; 
    }

    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;
    color1.pere=pointeur;
    color2.pere=pointeur;
    color3.pere=pointeur;
    color5.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
           // creation de la couleur verte
           QColor couleur ( 0, 255, 0 ); 
          // application de la couleur sur le bouton connexion
          ui.pushButton->setPalette(couleur);
    
        urbiImage.robotI->send("noop;");
        urbiImage.robotI->send("stop uimg3;");
        urbiImage.robotI->send("stop uimg4;");

        urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg3");
    
        QString videoName = ui.lineEdit_2->text();
        QString delayName = ui.lineEdit_3->text();
        QString recupimage = "uimg4:every(" + delayName + "){ uimg3:" + videoName + " },";    
        urbiImage.robotI->send("%s", (const char *) recupimage.toLatin1());

    }
    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }

}

/////////////////////////////////////////////////
// Selection de la couleur 1
void CaptureImage::on_pushButton_2_clicked()
{
     color1.show();
}

/////////////////////////////////////////////////
// Selection de la couleur 2
void CaptureImage::on_pushButton_3_clicked()
{
     color2.show();
}

/////////////////////////////////////////////////
// Selection de la couleur 3
void CaptureImage::on_pushButton_4_clicked()
{
     color3.show();
}

/////////////////////////////////////////////////
// Selection de la couleur 5
void CaptureImage::on_pushButton_6_clicked()
{
     color5.show();
}
