#include "urbi.h"
#include "captureimage.h"


//////////////////////////////////////////
// Creation de l'objet
ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotI = NULL;  
     buffer = NULL;

     bufferRGB = NULL;   
     bufferRGBCouleur1=NULL; 
     bufferRGBCouleur2=NULL; 
     bufferRGBCouleur3=NULL; 
     bufferRGBCouleur5=NULL; 
     bufferRGBFinal=NULL; 

     bufferYCbCr = NULL;   
     bufferYCbCrCouleur1 = NULL;
     bufferYCbCrCouleur2 = NULL;
     bufferYCbCrCouleur3 = NULL;
     bufferYCbCrCouleur5 = NULL;
     bufferYCbCrFinal = NULL;

     traitementEnCours=0; 
}

UCallbackAction ConnectAibo::command(const UMessage &msg) 
{
  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;

	  urbi::UImage& img = msg.value->binary->image;

      int width = img.width;
      int height = img.height;
      int size3b = width*height*3;

      if (buffer == NULL && bufferYCbCr == NULL && bufferRGB == NULL)
      {
 	       buffer = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
           bufferRGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits

            bufferRGBCouleur1 = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
            bufferRGBCouleur2 = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
            bufferRGBCouleur3 = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
            bufferRGBCouleur5 = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
            bufferRGBFinal = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits

            bufferYCbCr = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            bufferYCbCrCouleur1 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            bufferYCbCrCouleur2 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            bufferYCbCrCouleur3 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            bufferYCbCrCouleur5 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            bufferYCbCrFinal = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
      }


//////////////////////////////////////////////////////////////////////////////
// Realisation de imageQT et imageQT2
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image en RGB
      if( img.imageFormat == urbi::IMAGE_JPEG )
          convertJPEGtoRGB( (const byte *) img.data, img.size, (byte *) buffer, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
          convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );

      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    

       // copie de l'image dans QImage
      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image

      // on recupere la largeur et la hauteur
      int widthLabel = pere->ui.label_2->width();
      int heightLabel  = pere->ui.label_2->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT2 = imageQT;
  
  
//////////////////////////////////////////////////////////////////////////////
// Realisation de imageCouleur1
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image en YCbCr
      if( img.imageFormat == urbi::IMAGE_JPEG )
           convertJPEGtoYCrCb( (const byte *) img.data, img.size, (byte*) bufferYCbCr, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
           memcpy(bufferYCbCr, img.data, size3b);


      int nbDePixels=0;
      double centerX=0;
      double centerY=0;


       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCr[(3*i) + (j*width*3) + 0] <= pere->color1.Ymax && bufferYCbCr[(3*i) + (j*width*3) + 0] >= pere->color1.Ymin )
                     {
                         if( bufferYCbCr[(3*i) + (j*width*3) + 1] <=pere->color1.Cbmax && bufferYCbCr[(3*i) + (j*width*3) + 1] >= pere->color1.Cbmin )
                         {
                             if( bufferYCbCr[(3*i) + (j*width*3) + 2] <= pere->color1.Crmax && bufferYCbCr[(3*i) + (j*width*3) + 2] >= pere->color1.Crmin )
                             {
                                  nbDePixels++;
                                  centerX = centerX + i;
                                  centerY = centerY + j;
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = pere->color1.Ymoy;  // Y
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = pere->color1.Cbmoy;  //Cb
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = pere->color1.Crmoy;  // Cr
                             }
                             else
                             {
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = 16;  // Y
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = 128;  //Cb
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                             }
                         }
                         else
                         {
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = 16;  // Y
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = 128;  //Cb
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                         }
                     }
                     else
                     {
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = 16;  // Y
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = 128;  //Cb
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                     }
             }
       }    

       // on indique le nb de pixels et la position du centre
       pere->color1.nbTotal= nbDePixels ;
       if( nbDePixels != 0)
       {
           pere->color1.posX = (int) (centerX / nbDePixels) ;
           pere->color1.posY = (int) (centerY / nbDePixels) ;
       }
       else
       {
           pere->color1.posX = 0;
           pere->color1.posY = 0;           
       }

       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrCouleur1, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    


       // copie de l'image dans imageCouleur1
      imageCouleur1=QImage( bufferRGBCouleur1, width, height, QImage::Format_RGB32 ); // on stocke l'image


//////////////////////////////////////////////////////////////////////////////
// Realisation de imageCouleur2
/////////////////////////////////////////////////////////////////////////////

      nbDePixels=0;
      centerX=0;
      centerY=0;

       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCr[(3*i) + (j*width*3) + 0] <= pere->color2.Ymax && bufferYCbCr[(3*i) + (j*width*3) + 0] >= pere->color2.Ymin )
                     {
                         if( bufferYCbCr[(3*i) + (j*width*3) + 1] <=pere->color2.Cbmax && bufferYCbCr[(3*i) + (j*width*3) + 1] >= pere->color2.Cbmin )
                         {
                             if( bufferYCbCr[(3*i) + (j*width*3) + 2] <= pere->color2.Crmax && bufferYCbCr[(3*i) + (j*width*3) + 2] >= pere->color2.Crmin )
                             {
                                  nbDePixels++;
                                  centerX = centerX + i;
                                  centerY = centerY + j;
                                  bufferYCbCrCouleur2[(3*i) + (j*width*3) + 0] = pere->color2.Ymoy;  // Y
                                  bufferYCbCrCouleur2[(3*i) + (j*width*3) + 1] = pere->color2.Cbmoy;  //Cb
                                  bufferYCbCrCouleur2[(3*i) + (j*width*3) + 2] = pere->color2.Crmoy;  // Cr
                             }
                             else
                             {
                                  bufferYCbCrCouleur2[(3*i) + (j*width*3) + 0] = 16;  // Y
                                  bufferYCbCrCouleur2[(3*i) + (j*width*3) + 1] = 128;  //Cb
                                  bufferYCbCrCouleur2[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                             }
                         }
                         else
                         {
                             bufferYCbCrCouleur2[(3*i) + (j*width*3) + 0] = 16;  // Y
                             bufferYCbCrCouleur2[(3*i) + (j*width*3) + 1] = 128;  //Cb
                             bufferYCbCrCouleur2[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                         }
                     }
                     else
                     {
                         bufferYCbCrCouleur2[(3*i) + (j*width*3) + 0] = 16;  // Y
                         bufferYCbCrCouleur2[(3*i) + (j*width*3) + 1] = 128;  //Cb
                         bufferYCbCrCouleur2[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                     }
             }
       }    

       // on indique le nb de pixels et la position du centre
       pere->color2.nbTotal = (int) nbDePixels ;
       if( nbDePixels != 0)
       {
           pere->color2.posX = (int) (centerX / nbDePixels) ;
           pere->color2.posY = (int) (centerY / nbDePixels) ;
       }
       else
       {
           pere->color2.posX = 0;
           pere->color2.posY = 0;           
       }


       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrCouleur2, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBCouleur2[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBCouleur2[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBCouleur2[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBCouleur2[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    



       // copie de l'image dans imageCouleur2
      imageCouleur2=QImage( bufferRGBCouleur2, width, height, QImage::Format_RGB32 ); // on stocke l'image




//////////////////////////////////////////////////////////////////////////////
// Realisation de imageCouleur3
/////////////////////////////////////////////////////////////////////////////

      nbDePixels=0;
      centerX=0;
      centerY=0;

       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCr[(3*i) + (j*width*3) + 0] <= pere->color3.Ymax && bufferYCbCr[(3*i) + (j*width*3) + 0] >= pere->color3.Ymin )
                     {
                         if( bufferYCbCr[(3*i) + (j*width*3) + 1] <=pere->color3.Cbmax && bufferYCbCr[(3*i) + (j*width*3) + 1] >= pere->color3.Cbmin )
                         {
                             if( bufferYCbCr[(3*i) + (j*width*3) + 2] <= pere->color3.Crmax && bufferYCbCr[(3*i) + (j*width*3) + 2] >= pere->color3.Crmin )
                             {
                                  nbDePixels++;
                                  centerX = centerX + i;
                                  centerY = centerY + j;
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = pere->color3.Ymoy;  // Y
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = pere->color3.Cbmoy;  //Cb
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = pere->color3.Crmoy;  // Cr
                             }
                             else
                             {
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = 16;  // Y
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = 128;  //Cb
                                  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                             }
                         }
                         else
                         {
                             bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = 16;  // Y
                             bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = 128;  //Cb
                             bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                         }
                     }
                     else
                     {
                         bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] = 16;  // Y
                         bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] = 128;  //Cb
                         bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                     }
             }
       }    

       // on indique le nb de pixels et la position du centre
       pere->color3.nbTotal= nbDePixels ;
       if( nbDePixels != 0)
       {
           pere->color3.posX = (int) (centerX / nbDePixels) ;
           pere->color3.posY = (int) (centerY / nbDePixels) ;
       }
       else
       {
           pere->color3.posX = 0;
           pere->color3.posY = 0;           
       }

       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrCouleur3, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBCouleur3[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    
       

       // copie de l'image dans imageCouleur3
      imageCouleur3=QImage( bufferRGBCouleur3, width, height, QImage::Format_RGB32 ); // on stocke l'image








//////////////////////////////////////////////////////////////////////////////
// Realisation de imageCouleur5
/////////////////////////////////////////////////////////////////////////////

      nbDePixels=0;
      centerX=0;
      centerY=0;

       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCr[(3*i) + (j*width*3) + 0] <= pere->color5.Ymax && bufferYCbCr[(3*i) + (j*width*3) + 0] >= pere->color5.Ymin )
                     {
                         if( bufferYCbCr[(3*i) + (j*width*3) + 1] <=pere->color5.Cbmax && bufferYCbCr[(3*i) + (j*width*3) + 1] >= pere->color5.Cbmin )
                         {
                             if( bufferYCbCr[(3*i) + (j*width*3) + 2] <= pere->color5.Crmax && bufferYCbCr[(3*i) + (j*width*3) + 2] >= pere->color5.Crmin )
                             {
                                  nbDePixels++;
                                  centerX = centerX + i;
                                  centerY = centerY + j;
                                  bufferYCbCrCouleur5[(3*i) + (j*width*3) + 0] = pere->color5.Ymoy;  // Y
                                  bufferYCbCrCouleur5[(3*i) + (j*width*3) + 1] = pere->color5.Cbmoy;  //Cb
                                  bufferYCbCrCouleur5[(3*i) + (j*width*3) + 2] = pere->color5.Crmoy;  // Cr
                             }
                             else
                             {
                                  bufferYCbCrCouleur5[(3*i) + (j*width*3) + 0] = 16;  // Y
                                  bufferYCbCrCouleur5[(3*i) + (j*width*3) + 1] = 128;  //Cb
                                  bufferYCbCrCouleur5[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                             }
                         }
                         else
                         {
                             bufferYCbCrCouleur5[(3*i) + (j*width*3) + 0] = 16;  // Y
                             bufferYCbCrCouleur5[(3*i) + (j*width*3) + 1] = 128;  //Cb
                             bufferYCbCrCouleur5[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                         }
                     }
                     else
                     {
                         bufferYCbCrCouleur5[(3*i) + (j*width*3) + 0] = 16;  // Y
                         bufferYCbCrCouleur5[(3*i) + (j*width*3) + 1] = 128;  //Cb
                         bufferYCbCrCouleur5[(3*i) + (j*width*3) + 2] = 128;  // Cr                                 
                     }
             }
       }    

       // on affiche le nombre de pixels presents a l'ecran
       pere->color5.nbTotal= nbDePixels ;
       if( nbDePixels != 0)
       {
           pere->color5.posX = (int) (centerX / nbDePixels) ;
           pere->color5.posY = (int) (centerY / nbDePixels) ;
       }
       else
       {
           pere->color5.posX = 0;
           pere->color5.posY = 0;           
       }


       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrCouleur5, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBCouleur5[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBCouleur5[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBCouleur5[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBCouleur5[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    


       // copie de l'image dans imageCouleur5
      imageCouleur5=QImage( bufferRGBCouleur5, width, height, QImage::Format_RGB32 ); // on stocke l'image


//////////////////////////////////////////////////////////////////////////////
// Realisation de l'image finale
/////////////////////////////////////////////////////////////////////////////

       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] == pere->color1.Ymoy && bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] <=pere->color1.Cbmoy &&  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] <= pere->color1.Crmoy)
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->color1.Ymoy;  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->color1.Cbmoy;  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->color1.Crmoy;  // Cr
                     }
                     else if( bufferYCbCrCouleur2[(3*i) + (j*width*3) + 0] == pere->color2.Ymoy && bufferYCbCrCouleur2[(3*i) + (j*width*3) + 1] <=pere->color2.Cbmoy &&  bufferYCbCrCouleur2[(3*i) + (j*width*3) + 2] <= pere->color2.Crmoy)
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->color2.Ymoy;  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->color2.Cbmoy;  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->color2.Crmoy;  // Cr
                     }
                     else if( bufferYCbCrCouleur3[(3*i) + (j*width*3) + 0] == pere->color3.Ymoy && bufferYCbCrCouleur3[(3*i) + (j*width*3) + 1] <=pere->color3.Cbmoy &&  bufferYCbCrCouleur3[(3*i) + (j*width*3) + 2] <= pere->color3.Crmoy)
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->color3.Ymoy;  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->color3.Cbmoy;  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->color3.Crmoy;  // Cr
                     }
                     else if( bufferYCbCrCouleur5[(3*i) + (j*width*3) + 0] == pere->color5.Ymoy && bufferYCbCrCouleur5[(3*i) + (j*width*3) + 1] <=pere->color5.Cbmoy &&  bufferYCbCrCouleur5[(3*i) + (j*width*3) + 2] <= pere->color5.Crmoy)
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->color5.Ymoy;  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->color5.Cbmoy;  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->color5.Crmoy;  // Cr
                     }
                     else
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = bufferYCbCr[(3*i) + (j*width*3) + 0];  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = bufferYCbCr[(3*i) + (j*width*3) + 1];  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = bufferYCbCr[(3*i) + (j*width*3) + 2];  // Cr
                     }

             }
       }    


       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrFinal, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBFinal[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBFinal[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBFinal[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBFinal[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    


       // copie de l'image dans imageCouleur6
      imageFinal=QImage( bufferRGBFinal, width, height, QImage::Format_RGB32 ); // on stocke l'image

      imageFinal2 = imageFinal.scaledToHeight ( imageQT2.height() );          // on donne la meme taille que imageQT2


//////////////////////////////////////////////////////////////////////////////
// Affichage du resultat
/////////////////////////////////////////////////////////////////////////////
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);

      traitementEnCours=0;
 }

  return URBI_CONTINUE;
}


///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001))
 {
      pere->ui.label_2->setPixmap(QPixmap::fromImage(imageQT2));     // on affiche l'image normale

      pere->ui.label_3->setPixmap(QPixmap::fromImage(imageFinal2));     // on affiche l'image finale
      pere->ui.label_4->setPixmap(QPixmap::fromImage(imageCouleur1));     // on affiche l'image couleur 1
      pere->ui.label_5->setPixmap(QPixmap::fromImage(imageCouleur2));     // on affiche l'image couleur 2
      pere->ui.label_6->setPixmap(QPixmap::fromImage(imageCouleur3));     // on affiche l'image couleur 3
      pere->ui.label_8->setPixmap(QPixmap::fromImage(imageCouleur5));     // on affiche l'image couleur 5



      pere->color1.ui.lcdNumber->display(pere->color1.nbTotal);
      pere->color1.ui.lcdNumber_2->display(pere->color1.posX);
      pere->color1.ui.lcdNumber_3->display(pere->color1.posY);

      pere->color2.ui.lcdNumber->display(pere->color2.nbTotal);
      pere->color2.ui.lcdNumber_2->display(pere->color2.posX);
      pere->color2.ui.lcdNumber_3->display(pere->color2.posY);

      pere->color3.ui.lcdNumber->display(pere->color3.nbTotal);
      pere->color3.ui.lcdNumber_2->display(pere->color3.posX);
      pere->color3.ui.lcdNumber_3->display(pere->color3.posY);

      pere->color5.ui.lcdNumber->display(pere->color5.nbTotal);
      pere->color5.ui.lcdNumber_2->display(pere->color5.posX);
      pere->color5.ui.lcdNumber_3->display(pere->color5.posY);

 }

 return 1;
}
