#include "captureimage.h"

CaptureImage::CaptureImage(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

}

void CaptureImage::on_pushButton_clicked()
{
   QString robotName = ui.lineEdit->text();
   QString VideoDeviceName = ui.lineEdit_2->text();
   QString VideoDelay = ui.lineEdit_3->text();

   QSettings settings("Face Detection", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    // destruction d'une ancienne connexion
    if( urbiImage.robotI != NULL)
    {
             urbiImage.robotI->send(";;;;;quit;");
             urbiImage.robotI->send("stop uimg;");
             urbiImage.robotI->send("stop uimg2;");
             delete urbiImage.robotI;

             urbiImage.robotI = NULL;
             urbiImage.traitementEnCours=0; 
             urbiImage.visible = 0;
             urbiImage.capture=0;
             urbiImage.captureImage=0;
             urbiImage.compteur=0;
    }

    // connexion
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");

    QString phrase_send = "uimg2:every(" + VideoDelay +"){ uimg: " + VideoDeviceName + " },";
    urbiImage.robotI->send("%s", (const char *) phrase_send.toLatin1());
    }

    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }

}

void CaptureImage::on_lineEdit_returnPressed()
{
   QString robotName = ui.lineEdit->text();
   QString VideoDeviceName = ui.lineEdit_2->text();
   QString VideoDelay = ui.lineEdit_3->text();

   QSettings settings("Face Detection", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();

    // destruction d'une ancienne connexion
    if( urbiImage.robotI != NULL)
    {
             urbiImage.robotI->send(";;;;;quit;");
             urbiImage.robotI->send("stop uimg;");
             urbiImage.robotI->send("stop uimg2;");
             delete urbiImage.robotI;

             urbiImage.robotI = NULL;
             urbiImage.traitementEnCours=0; 
             urbiImage.visible = 0;
             urbiImage.capture=0;
             urbiImage.captureImage=0;
             urbiImage.compteur=0;
    }

    // connexion
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

    urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");

    QString phrase_send = "uimg2:every(" + VideoDelay +"){ uimg: " + VideoDeviceName + " },";
    urbiImage.robotI->send("%s", (const char *) phrase_send.toLatin1());
    }

    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }


}

void CaptureImage::on_pushButton_2_clicked()
{
    if( urbiImage.robotI != NULL)
          urbiImage.capture=1;
}



///////////////////////////////////////////
// changement de la base de reconnaissance des visages
void CaptureImage::on_comboBox_currentIndexChanged ( int index )
{
          QString base;
          if (index == 0)
             base = "haarcascade_frontalface_alt2.xml";
          else if (index == 1)
             base = "haarcascade_frontalface_alt.xml";
          else if (index == 2)
             base = "haarcascade_frontalface_alt_tree.xml";
          else if (index == 3)
             base = "haarcascade_frontalface_default.xml";
          else if (index == 4)
             base = "haarcascade_profileface.xml";
          else if (index == 5)
             base = "haarcascade_fullbody.xml";
          else if (index == 6)
             base = "haarcascade_upperbody.xml";
          else if (index == 7)
             base = "haarcascade_lowerbody.xml";

          urbiImage.cascade = (CvHaarClassifierCascade*)cvLoad( base.toLatin1(), 0, 0, 0 );
          if( !urbiImage.cascade )
              return ; // on sort car il y a une erreur

}
