#include "urbi.h"
#include "captureimage.h"


ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotI = NULL;  
     buffer = NULL;
     bufferRGB = NULL;   

     traitementEnCours=0; 
     visible = 0;
     captureimg=0;
     captureImage=0;

     compteur=0;

// code opencv
     storage = 0;

     MHI_DURATION = 1;
     MAX_TIME_DELTA = 0.5;
     MIN_TIME_DELTA = 0.05;
     N = 4;
     buf = NULL;
     last = 0;
     mhi = NULL; // MHI
     orient = NULL; // orientation
     mask = NULL; // valid orientation mask
     segmask = NULL; // motion segmentation map
     storage = NULL; // temporary storage

     storage = cvCreateMemStorage(0);

     motion = NULL;
     capture = NULL;

// code opencv

}

UCallbackAction ConnectAibo::command(const UMessage &msg) 
{

  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
       return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;
	urbi::UImage& img = msg.value->binary->image;

    		    int width = img.width;
    		    int height = img.height;

      if (buffer == NULL && bufferRGB == NULL)
      {
    		       buffer = new unsigned char[img.width * img.height * 3 * 8]; // 24 bits
     		       bufferRGB = new unsigned char[img.width * img.height * 4 * 8];  // 32 bits
      }


    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		        imageQT.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
     		   else 
               {
                   if ( img.imageFormat == urbi::IMAGE_YCbCr)
         		           convertYCrCbtoRGB( (const unsigned char *) img.data, img.size, (unsigned char*) buffer );
      		       else if ( img.imageFormat == urbi::IMAGE_RGB)
       		          memcpy(  buffer, img.data, img.size );
       		       else
        		       memcpy( buffer, img.data, img.size );
            
                      // conversion de l'image RGB 24 en RGB 32
                       for(int i=0; i<=width; i++)
                       {
                             for(int j=0; j<=height; j++)
                             {
                                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                             }
                       }    
                
                       // copie de l'image dans QImage
                      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image
                }

        imageQT3=imageQT; // on copie dans imageQT3, l'image capturee sans modification

// code opencv
     // on enregistre l'image sur le disque dur
     imageQT.save("image_clean.jpg","JPG",100);

      const char* filename = (char*)"image_clean.jpg";
      IplImage* image = cvLoadImage( filename, 1 );

       if( image )
       {
           if( !motion )
           {
                motion = cvCreateImage( cvSize(image->width,image->height), 8, 3 );
                cvZero( motion );
                motion->origin = image->origin;
            }
       }

       update_mhi( image, motion, 30 );
       cvReleaseImage( &image ); // on efface l'image

     // on charge le nouveau fichier image
     imageQT.load("image_cv.jpg");


// code opencv


      // on recupere la largeur et la hauteur
      int widthLabel = pere->ui.label_2->width();
      int heightLabel  = pere->ui.label_2->height();

      if( heightLabel < (widthLabel * height / width) )
      {
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
          imageQT4 = imageQT3.scaledToHeight ( heightLabel - 2 );          // on double la taille
      }
      else if( widthLabel < (heightLabel * width / height) )
      {
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
          imageQT4 = imageQT3.scaledToWidth ( widthLabel - 2 );          // on double la taille
      }
      else 
      {
          imageQT2 = imageQT;
          imageQT4 = imageQT3;
      }

  
/////////////////////////////////////////////////////////////  
// Creation de imageQT5 qui contient l'image normale + les modifications dues aux mouvements  
  
int widthimage = imageQT2.width();
int heightimage = imageQT2.height();
int a,b;
QRgb value; // va stocker la couleur du pixel
QRgb valueblack; // va stocker la couleur du pixel
valueblack = qRgb(0, 0, 0); // noir

imageQT5 = imageQT4; // imageQT5 prend la forme de l'image normale sans modification


// on parcourt toute l'image pour recuperer les valeurs
for(a = 0; a < widthimage; a++)
{
  for(b=0; b < heightimage; b++)
  {
     value = imageQT2.pixel( a , b );
     if(value != valueblack)
     {
        if(qBlue(value) > 30 || qGreen(value) > 30 || qRed(value) > 30) // pour supprimer le bruit qui est noir mais pas 100% noir
          imageQT5.setPixel(a, b, value);
     }

  }     
}

//////////////////////////////////////////////////////////////  
  
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);
      
      if(captureimg == 1)
      {
                 QString nameFile="image_000.jpg";
                 QFile test;
                 QString number;
                 int j=1000;
                 for(int i=1 ; i<j ; i++)
                 {    
                                  number.setNum(i);
                                  if(i < 10)
                                       nameFile = "image_00" + number + ".jpg"; 
                                  else if(i < 100)
                                       nameFile = "image_0" + number + ".jpg"; 
                                  else if(i < 1000)
                                       nameFile = "image_" + number + ".jpg";                                        
                                  test.setFileName(nameFile);
                                  if( !test.exists() )
                                      break;
                 }

                 imageQT5.save(nameFile,"JPG",100);
                 captureimg=0;           
      }


      traitementEnCours=0;
  }

  return URBI_CONTINUE;
    
}

///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001))
 {
      pere->ui.label_2->setPixmap(QPixmap::fromImage(imageQT4));     // on affiche l'image normale
      pere->ui.label_5->setPixmap(QPixmap::fromImage(imageQT2));     // on affiche les modifications dues aux mouvements
      pere->ui.label_6->setPixmap(QPixmap::fromImage(imageQT5));     // on affiche l'image normale + les modifications dues aux mouvements

 }


 return 1;
}



// parameters:
//  img - input video frame
//  dst - resultant motion picture
//  args - optional parameters
///////////////////////////////////////////
// detection des mouvements
void  ConnectAibo::update_mhi( IplImage* img, IplImage* dst, int diff_threshold )
{
    double timestamp = (double)clock()/CLOCKS_PER_SEC; // prend le temps courrant en secondes
    CvSize size = cvSize(img->width,img->height); // prend la taille de l'image courante
    int i, idx1 = last, idx2;
    IplImage* silh;
    CvSeq* seq;
    CvRect comp_rect;
    double count;
    double angle;
    CvPoint center;
    double magnitude;          
    CvScalar color;

    // allocate images at the beginning or
    // reallocate them if the frame size is changed
    if( !mhi || mhi->width != size.width || mhi->height != size.height ) 
    {
        if( buf == 0 ) 
        {
            buf = (IplImage**)malloc(N*sizeof(buf[0]));
            memset( buf, 0, N*sizeof(buf[0]));
        }
        
        for( i = 0; i < N; i++ ) 
        {
            cvReleaseImage( &buf[i] );
            buf[i] = cvCreateImage( size, IPL_DEPTH_8U, 1 );
            cvZero( buf[i] );
        }
        cvReleaseImage( &mhi );
        cvReleaseImage( &orient );
        cvReleaseImage( &segmask );
        cvReleaseImage( &mask );
        
        mhi = cvCreateImage( size, IPL_DEPTH_32F, 1 );
        cvZero( mhi ); // clear MHI at the beginning
        orient = cvCreateImage( size, IPL_DEPTH_32F, 1 );
        segmask = cvCreateImage( size, IPL_DEPTH_32F, 1 );
        mask = cvCreateImage( size, IPL_DEPTH_8U, 1 );
    }

    cvCvtColor( img, buf[last], CV_BGR2GRAY ); // convert frame to grayscale

    idx2 = (last + 1) % N; // index of (last - (N-1))th frame
    last = idx2;

    silh = buf[idx2];
    cvAbsDiff( buf[idx1], buf[idx2], silh ); // get difference between frames
    
    cvThreshold( silh, silh, diff_threshold, 1, CV_THRESH_BINARY ); // and threshold it
    cvUpdateMotionHistory( silh, mhi, timestamp, MHI_DURATION ); // update MHI

    // convert MHI to blue 8u image
    cvCvtScale( mhi, mask, 255./MHI_DURATION,(MHI_DURATION - timestamp)*255./MHI_DURATION );
    cvZero( dst );
    cvCvtPlaneToPix( mask, 0, 0, 0, dst );

    // calculate motion gradient orientation and valid orientation mask
    cvCalcMotionGradient( mhi, mask, orient, MAX_TIME_DELTA, MIN_TIME_DELTA, 3 );
    
    if( !storage )
        storage = cvCreateMemStorage(0);
    else
        cvClearMemStorage(storage);
    
    // segment motion: get sequence of motion components
    // segmask is marked motion components map. It is not used further
    seq = cvSegmentMotion( mhi, segmask, storage, timestamp, MAX_TIME_DELTA );

    // iterate through the motion components,
    // One more iteration (i == -1) corresponds to the whole image (global motion)
    for( i = -1; i < seq->total; i++ ) 
    {

        if( i < 0 ) // case of the whole image
        { 
            comp_rect = cvRect( 0, 0, size.width, size.height );
            color = CV_RGB(255,255,255);
            magnitude = 100;
        }
        else // i-th motion component
        { 
            comp_rect = ((CvConnectedComp*)cvGetSeqElem( seq, i ))->rect;
            if( comp_rect.width + comp_rect.height < 100 ) // reject very small components
                continue;
            color = CV_RGB(255,0,0);
            magnitude = 30;
        }

        // select component ROI
        cvSetImageROI( silh, comp_rect );
        cvSetImageROI( mhi, comp_rect );
        cvSetImageROI( orient, comp_rect );
        cvSetImageROI( mask, comp_rect );

        // calculate orientation
        angle = cvCalcGlobalOrientation( orient, mask, mhi, timestamp, MHI_DURATION);
        angle = 360.0 - angle;  // adjust for images with top-left origin

        count = cvNorm( silh, 0, CV_L1, 0 ); // calculate number of points within silhouette ROI

        cvResetImageROI( mhi );
        cvResetImageROI( orient );
        cvResetImageROI( mask );
        cvResetImageROI( silh );

        // check for the case of little motion
        if( count < comp_rect.width*comp_rect.height * 0.05 )
            continue;

        // draw a clock with arrow indicating the direction
        center = cvPoint( (comp_rect.x + comp_rect.width/2),(comp_rect.y + comp_rect.height/2) );

        cvCircle( dst, center, cvRound(magnitude*1.2), color, 3, CV_AA, 0 );
        cvLine( dst, center, cvPoint( cvRound( center.x + magnitude*cos(angle*CV_PI/180)), cvRound( center.y - magnitude*sin(angle*CV_PI/180))), color, 3, CV_AA, 0 );
    }

    cvSaveImage("image_cv.jpg", dst); // on enregistre l'image sur le disque dur
}

