#ifndef URBI_H
#define URBI_H

#include <urbi/uclient.hh>
#include <QtGui>
#include <sys/types.h>

// code opencv
#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <float.h>
#include <limits.h>
#include <time.h>
#include <ctype.h>
// code opencv

class CaptureImage;

using namespace urbi;

class ConnectAibo : public QWidget
{
    Q_OBJECT

      public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotI;
      CaptureImage *pere;
      UCallbackAction command(const UMessage &);
      UCallbackAction command2(const UMessage &);



/////////////////////////////////////////////////
// code opencv
void update_mhi( IplImage* img, IplImage* dst, int diff_threshold );

// various tracking parameters (in seconds)
double MHI_DURATION;
double MAX_TIME_DELTA;
double MIN_TIME_DELTA;
// number of cyclic frame buffer used for motion detection
// (should, probably, depend on FPS)
int N;

// ring image buffer
IplImage **buf;
int last;

// temporary images
IplImage *mhi ; // MHI
IplImage *orient ; // orientation
IplImage *mask ; // valid orientation mask
IplImage *segmask ; // motion segmentation map
CvMemStorage* storage ; // temporary storage

IplImage* motion;
CvCapture* capture;

// code opencv
/////////////////////////////////////////////////



      unsigned char* buffer;
      unsigned char* bufferRGB; 
      int captureimg;
      int traitementEnCours;

      int visible; // if someone is visible
      int captureImage;
      int compteur;
      double posx; // position in x of the face center
      double posy; // position in y of the face center

      int aa;
      int bb;   

      QString fileName;

      QImage imageQT;
      QImage imageQT2;
      QImage imageQT3;
      QImage imageQT4;
      QImage imageQT5;

      virtual bool event(QEvent *ev);
      QEvent *e1;

};

#endif
