#include "tele.h"


///////////////////////////////////////////
// Creation de l'objet
Telecommande::Telecommande(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

        // copie des pointeurs
       setlocale(LC_NUMERIC,"C");
       urbiTele.pere=pointeur;
}


///////////////////////////////////////////
// se connecter au robot pour sauver une variable
void Telecommande::on_pushButton_2_clicked()
{
    urbiTele.pere=pointeur;

    // recuperation des donnes du nom et du port
    QString robotName = ui.lineEdit->text();
    QSettings settings("save and export variables", "GOSTAI");
    settings.setValue("robotname", robotName);
    settings.sync ();

    if( urbiTele.robotC != NULL)
    {
        // fermeture de la session
          urbiTele.robotC->send(";;;; quit;");
          urbiTele.robotC->send("noop;");
          urbiTele.robotC->send("noop;");
          delete urbiTele.robotC;
    }
    urbiTele.robotC = NULL;
    urbiTele.robotC =new UClient( robotName.toLatin1() );

    if (!urbiTele.robotC->error())
    {
       // recuperation de la variable envoyee par le serveur
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::recuperation), "totosave");

       QString variableName = ui.lineEdit_2->text();
       QString phrase_send = "totosave:" + variableName +";";
       urbiTele.robotC->send("%s", (const char *) phrase_send.toLatin1());

       // creation de la couleur orange
       QColor couleur ( 255, 128, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);
    }
    else // pas de connexion
    {
         urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);         
    }

}

///////////////////////////////////////////
// se connecter au robot pour exporter une variable
void Telecommande::on_pushButton_3_clicked()
{
    urbiTele.pere=pointeur;

    // recuperation des donnes du nom et du port
    QString robotName = ui.lineEdit->text();
    QSettings settings("save and export variables", "GOSTAI");
    settings.setValue("robotname", robotName);
    settings.sync ();

    if( urbiTele.robotC != NULL)
    {
        // fermeture de la session
          urbiTele.robotC->send(";;;; quit;");
          urbiTele.robotC->send("noop;");
          urbiTele.robotC->send("noop;");
          delete urbiTele.robotC;
    }
    urbiTele.robotC = NULL;
    urbiTele.robotC =new UClient( robotName.toLatin1() );

    if (!urbiTele.robotC->error())
    {
       // creation de la couleur orange
       QColor couleur ( 255, 128, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_3->setPalette(couleur);
    }
    else // pas de connexion
    {
         urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_3->setPalette(couleur);         
      return;
    }

  etat_erreur = 0; // on part du principe que tout va bien se passer

  QString variablename=ui.lineEdit_5->text();  // on recupere le nom de la variable urbi
  QString openFilesPath=ui.lineEdit_4->text();  // on recupere le nom du fichier
  QFile file_data;
  QFile file_text;
  file_data.setFileName(openFilesPath+".dat");  // ouverture du fichier
  file_text.setFileName(openFilesPath+".txt");  // ouverture du fichier
  if( !file_text.exists() || !file_data.exists() ) // mauvais car fichiers absents
  {
       // fermeture de la session
       urbiTele.robotC->send(";;;; quit;");
       urbiTele.robotC->send("noop;");
       urbiTele.robotC->send("noop;");
       delete urbiTele.robotC;
       urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur2 ( 255, 0, 0 ); 
       // application de la couleur sur le bouton connexion
       ui.pushButton_3->setPalette(couleur2);         
       return;
  }

  file_text.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in_text(&file_text);
  QString line;

  // lecture de la premiere ligne
  line = in_text.readLine();

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  if(line == "MESSAGE_SYSTEM") // mauvais
  {
       // fermeture de la session
       urbiTele.robotC->send(";;;; quit;");
       urbiTele.robotC->send("noop;");
       urbiTele.robotC->send("noop;");
       delete urbiTele.robotC;
       urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur2 ( 255, 0, 0 ); 
       // application de la couleur sur le bouton connexion
       ui.pushButton_3->setPalette(couleur2);         
       etat_erreur = 1; // mauvais
       return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "MESSAGE_ERROR") // mauvais
  {
       // fermeture de la session
       urbiTele.robotC->send(";;;; quit;");
       urbiTele.robotC->send("noop;");
       urbiTele.robotC->send("noop;");
       delete urbiTele.robotC;
       urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur2 ( 255, 0, 0 ); 
       // application de la couleur sur le bouton connexion
       ui.pushButton_3->setPalette(couleur2);  
       etat_erreur = 1; // mauvais
       return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "MESSAGE_DATA") // bon
  {  }
////////////////////////////////////////////////////////////////////////////////
  else // mauvais
  {
       // fermeture de la session
       urbiTele.robotC->send(";;;; quit;");
       urbiTele.robotC->send("noop;");
       urbiTele.robotC->send("noop;");
       delete urbiTele.robotC;
       urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur2 ( 255, 0, 0 ); 
       // application de la couleur sur le bouton connexion
       ui.pushButton_3->setPalette(couleur2);         
       etat_erreur = 1; // mauvais
       return;
  }

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  // lecture de la seconde ligne
  line = in_text.readLine();
  int etatbinaire = 0;
  int etatlist = 0;
//  QString nameURBIServeur = "U40343440";

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  if(line == "DATA_DOUBLE") // type DOUBLE
  {
    // lecture de la valeur
    file_data.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in_data(&file_data);
    line = in_data.readLine();

    QString cmd; // commande
    QString cmd2; // commande
    QString cmd3; // commande
    QString cmd4; // commande

//    cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//    urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());

    cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
    urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());

//    cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = " + line + "; " + variablename + "; \"); ";
//    urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());

    cmd3 = variablename + " = " + line + ";"; 
    urbiTele.robotC->send("%s", (const char *) cmd3.toLatin1());
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_OBJECT") // type UObject
  {
       // fermeture de la session
       urbiTele.robotC->send(";;;; quit;");
       urbiTele.robotC->send("noop;");
       urbiTele.robotC->send("noop;");
       delete urbiTele.robotC;
       urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur2 ( 255, 0, 0 ); 
       // application de la couleur sur le bouton connexion
       ui.pushButton_3->setPalette(couleur2);         
       return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_STRING") // type UString
  {
    // lecture de la valeur
    file_data.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in_data(&file_data);
    line = in_data.readLine();

    QString cmd; // commande
    QString cmd2; // commande
    QString cmd3; // commande
    QString cmd4; // commande

//    cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//    urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());

    cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
    urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());

//    cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = \\\"" + line + "\\\" ; " + variablename + "; \"); ";
//    urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());

    cmd3 = variablename + " = \"" + line + "\";"; 
    urbiTele.robotC->send("%s", (const char *) cmd3.toLatin1());
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_VOID") // type vide
  {
       // fermeture de la session
       urbiTele.robotC->send(";;;; quit;");
       urbiTele.robotC->send("noop;");
       urbiTele.robotC->send("noop;");
       delete urbiTele.robotC;
       urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur2 ( 255, 0, 0 ); 
       // application de la couleur sur le bouton connexion
       ui.pushButton_3->setPalette(couleur2);         
       etat_erreur = 1; // mauvais
       return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_BINARY") // type binaire
  {
       etatbinaire = 1;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_LIST") // type UList
  {
       etatlist = 1;
  }
////////////////////////////////////////////////////////////////////////////////
  else // mauvais
  {
       // fermeture de la session
       urbiTele.robotC->send(";;;; quit;");
       urbiTele.robotC->send("noop;");
       urbiTele.robotC->send("noop;");
       delete urbiTele.robotC;
       urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur2 ( 255, 0, 0 ); 
       // application de la couleur sur le bouton connexion
       ui.pushButton_3->setPalette(couleur2);         
       etat_erreur = 1; // mauvais
       return;
  }

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  if(etatbinaire == 1) // type binaire
  {
      // lecture de la troisieme ligne
      line = in_text.readLine();

      if(line == "BINARY_NONE") // type BINARY_NONE
      {
        QString sizebin = in_text.readLine();
        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande
    
//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_UNKNOWN") // type BINARY_UNKNOWN
      {
        QString sizebin = in_text.readLine();
        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande
    
//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_IMAGE") // type BINARY_IMAGE
      {
        QString imagewidth = in_text.readLine();
        QString imageheight = in_text.readLine();
        QString imagesize = in_text.readLine();
        QString imageformat = in_text.readLine();
        if( imageformat == QString::number(IMAGE_JPEG))
            imageformat = "jpeg";
        else if( imageformat == QString::number(IMAGE_YCbCr))
            imageformat = "YCbCr";
        else if( imageformat == QString::number(IMAGE_RGB))
            imageformat = "rgb";
        else if( imageformat == QString::number(IMAGE_PPM))
            imageformat = "ppm";
        else if( imageformat == QString::number(IMAGE_UNKNOWN))
            imageformat = "unknown";

        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande

//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + " " + imageformat + " " + imagewidth + " " + imageheight + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + " " + imageformat + " " + imagewidth + " " + imageheight + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_SOUND") // type BINARY_SOUND
      {
        QString soundchannels = in_text.readLine();
        QString soundrate = in_text.readLine();
        QString soundsamplesize = in_text.readLine();
        QString soundsize = in_text.readLine();
        QString soundsampleformat = in_text.readLine();
        QString soundformat = in_text.readLine();
        if( soundformat == QString::number(SOUND_WAV))
            soundformat = "wav";
        else if( soundformat == QString::number(SOUND_RAW))
            soundformat = "raw";
        else if( soundformat == QString::number(SOUND_MP3))
            soundformat = "mp3";
        else if( soundformat == QString::number(SOUND_OGG))
            soundformat = "ogg";
        else if( soundformat == QString::number(SOUND_UNKNOWN))
            soundformat = "unknown";

        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande

//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + " " + soundformat + " " + soundchannels + " " + soundrate + " " + soundsamplesize + " " + soundsampleformat + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + " " + soundformat + " " + soundchannels + " " + soundrate + " " + soundsamplesize + " " + soundsampleformat + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else // mauvais
      {
           // fermeture de la session
           urbiTele.robotC->send(";;;; quit;");
           urbiTele.robotC->send("noop;");
           urbiTele.robotC->send("noop;");
           delete urbiTele.robotC;
           urbiTele.robotC = NULL;
           // creation de la couleur rouge
           QColor couleur2 ( 255, 0, 0 ); 
           // application de la couleur sur le bouton connexion
           ui.pushButton_3->setPalette(couleur2);
           etat_erreur = 1; // mauvais
           return;
      }

  }

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  if(etatlist == 1) // type ulist
  {
      // lecture de la troisieme ligne
      line = in_text.readLine();
      
      int nbvalues = line.toInt ();

      QString cmd; // commande
      QString cmd2; // commande
      QString cmd3; // commande
      QString cmd4; // commande
      QString cmd5; // commande
      QString cmd6; // commande

//      cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//      urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
      cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
      urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//      cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = [" ;
      cmd3 = variablename + " = [" ;

      for(int i=0 ; i < nbvalues ; i++)
      {
           traitementUList("", i);        
           if(i == 0)
           {
                cmd4 = cmd4 + variablename + "_" + QString::number(i);
                cmd3 = cmd3 + variablename + "_" + QString::number(i);
           }
           else
           {
               cmd4 = cmd4 + " , " + variablename + "_" + QString::number(i);
               cmd3 = cmd3 + " , " + variablename + "_" + QString::number(i);
           }
      }

//      cmd4 = cmd4 + "]; " + variablename + "; \");" ;
//      urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());

      cmd3 = "wait(1s); " + cmd3 + "];" + variablename + "; };";
      urbiTele.robotC->send("%s", (const char *) cmd3.toLatin1());

      for(int i=0 ; i < nbvalues ; i++)
      {
//           cmd6 = "+connection(\"" + nameURBIServeur + "\"): echo(\"if(isdef(" + variablename + "_" + QString::number(i) + ")) delete " + variablename + "_" + QString::number(i) + ";\");";
//           urbiTele.robotC->send("%s", (const char *) cmd6.toLatin1());
           cmd5 = "if(isdef(" + variablename + "_" + QString::number(i) + ")) delete " + variablename + "_" + QString::number(i) + ";";
           urbiTele.robotC->send("%s", (const char *) cmd5.toLatin1());
      }

  }

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


  // fermeture des fichiers
  file_data.close();
  file_text.close();

  if(etat_erreur == 1)
  {
           // fermeture de la session
           urbiTele.robotC->send(";;;; quit;");
           urbiTele.robotC->send("noop;");
           urbiTele.robotC->send("noop;");
           delete urbiTele.robotC;
           urbiTele.robotC = NULL;
           // creation de la couleur rouge
           QColor couleur2 ( 255, 0, 0 ); 
           // application de la couleur sur le bouton connexion
           ui.pushButton_3->setPalette(couleur2);
           etat_erreur = 1; // mauvais
           return;
  }


  // si on arrive ici, c'est que tout est bon.
  // creation de la couleur verte
  QColor couleur3 ( 0, 255, 0 ); 
  // application de la couleur sur le bouton connexion
  ui.pushButton_3->setPalette(couleur3);         

}




























///////////////////////////////////////////
// sert a traiter les UList
void Telecommande::traitementUList(QString nom, int numero)
{

  QString openFilesPath=ui.lineEdit_4->text();  // on recupere le nom du fichier
  QString variablename=ui.lineEdit_5->text();  // on recupere le nom de la variable urbi

  QFile file_data;
  QFile file_text;
  file_data.setFileName(openFilesPath + nom + "_" + QString::number(numero) + ".dat");  // ouverture du fichier
  file_text.setFileName(openFilesPath + nom + "_" + QString::number(numero) + ".txt");  // ouverture du fichier

//  QString nameURBIServeur = "U40343440";

  if( !file_text.exists() || !file_data.exists() )
  { return; } // il y a un probleme
  file_text.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in_text(&file_text);
  QString line;

  // lecture de la premiere ligne
  line = in_text.readLine();

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  if ( line != "MESSAGE_DATA") // mauvais type
  { 
     etat_erreur = 1; // mauvais
     return;
  } 


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  // lecture de la seconde ligne
  line = in_text.readLine();
  int etatbinaire = 0;
  int etatlist = 0;

  if ( line == "DATA_DOUBLE") // on recoit une donnee de type double
  { 
    // lecture de la valeur
    file_data.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in_data(&file_data);
    line = in_data.readLine();

    QString cmd; // commande
    QString cmd2; // commande
    QString cmd3; // commande
    QString cmd4; // commande

    variablename = variablename + nom + "_" + QString::number(numero); // on donne le bon nom a la variable

//    cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//    urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());

    cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
    urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());

//    cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = " + line + "; " + variablename + "; \"); ";
//    urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());

    cmd3 = variablename + " = " + line + ";"; 
    urbiTele.robotC->send("%s", (const char *) cmd3.toLatin1());
  } 

////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_STRING") // type UString
  {
    // lecture de la valeur
    file_data.open(QIODevice::ReadOnly | QIODevice::Text );
    QTextStream in_data(&file_data);
    line = in_data.readLine();

    QString cmd; // commande
    QString cmd2; // commande
    QString cmd3; // commande
    QString cmd4; // commande

    variablename = variablename + nom + "_" + QString::number(numero); // on donne le bon nom a la variable

//    cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//    urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());

    cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
    urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());

//    cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = \\\"" + line + "\\\" ; " + variablename + "; \"); ";
//    urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());

    cmd3 = variablename + " = \"" + line + "\";"; 
    urbiTele.robotC->send("%s", (const char *) cmd3.toLatin1());
  }
  else if(line == "DATA_OBJECT") // type UObject
  {
     return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_BINARY") // type binaire
  {
       etatbinaire = 1;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_LIST") // type UList
  {
       etatlist = 1;
  }
  else // mauvais
  {
     etat_erreur = 1; // mauvais
     return;
  }


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  if(etatbinaire == 1) // type binaire
  {
      // lecture de la troisieme ligne
      line = in_text.readLine();

      if(line == "BINARY_NONE") // type BINARY_NONE
      {
        QString sizebin = in_text.readLine();
        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande

        variablename = variablename + nom + "_" + QString::number(numero); // on donne le bon nom a la variable

//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_UNKNOWN") // type BINARY_UNKNOWN
      {
        QString sizebin = in_text.readLine();
        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande

        variablename = variablename + nom + "_" + QString::number(numero); // on donne le bon nom a la variable

//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_IMAGE") // type BINARY_IMAGE
      {
        QString imagewidth = in_text.readLine();
        QString imageheight = in_text.readLine();
        QString imagesize = in_text.readLine();
        QString imageformat = in_text.readLine();
        if( imageformat == QString::number(IMAGE_JPEG))
            imageformat = "jpeg";
        else if( imageformat == QString::number(IMAGE_YCbCr))
            imageformat = "YCbCr";
        else if( imageformat == QString::number(IMAGE_RGB))
            imageformat = "rgb";
        else if( imageformat == QString::number(IMAGE_PPM))
            imageformat = "ppm";
        else if( imageformat == QString::number(IMAGE_UNKNOWN))
            imageformat = "unknown";

        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande

        variablename = variablename + nom + "_" + QString::number(numero); // on donne le bon nom a la variable

//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + " " + imageformat + " " + imagewidth + " " + imageheight + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + " " + imageformat + " " + imagewidth + " " + imageheight + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_SOUND") // type BINARY_SOUND
      {
        QString soundchannels = in_text.readLine();
        QString soundrate = in_text.readLine();
        QString soundsamplesize = in_text.readLine();
        QString soundsize = in_text.readLine();
        QString soundsampleformat = in_text.readLine();
        QString soundformat = in_text.readLine();
        if( soundformat == QString::number(SOUND_WAV))
            soundformat = "wav";
        else if( soundformat == QString::number(SOUND_RAW))
            soundformat = "raw";
        else if( soundformat == QString::number(SOUND_MP3))
            soundformat = "mp3";
        else if( soundformat == QString::number(SOUND_OGG))
            soundformat = "ogg";
        else if( soundformat == QString::number(SOUND_UNKNOWN))
            soundformat = "unknown";

        qint64 taillefile = file_data.size(); 

        // lecture de la valeur
        file_data.open(QIODevice::ReadOnly);
        QDataStream in_data(&file_data);
        char buffer[taillefile];
        in_data.readRawData ( buffer, taillefile );

        QString cmd; // commande
        QString cmd2; // commande
        QString cmd3; // commande
        QString cmd4; // commande

        variablename = variablename + nom + "_" + QString::number(numero); // on donne le bon nom a la variable

//        cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//        urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
        cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
        urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//        cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = BIN " + QString::number(taillefile) + " " + soundformat + " " + soundchannels + " " + soundrate + " " + soundsamplesize + " " + soundsampleformat + "; " + variablename + "; \"); ";
//        urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());
    
        cmd3 = variablename + " = BIN " + QString::number(taillefile) + " " + soundformat + " " + soundchannels + " " + soundrate + " " + soundsamplesize + " " + soundsampleformat + ";" ; // dit que c'est un binaire et donne la taille des donnees
        urbiTele.robotC->sendBin(buffer, taillefile, cmd3.toLatin1() );
      }
////////////////////////////////////////////////////////////////////////////////
      else // mauvais
      {
           etat_erreur = 1; // mauvais
           return;
      }

  }

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

  if(etatlist == 1) // type ulist
  {
      // lecture de la troisieme ligne
      line = in_text.readLine();
      
      int nbvalues = line.toInt ();

      QString cmd; // commande
      QString cmd2; // commande
      QString cmd3; // commande
      QString cmd4; // commande
      QString cmd5; // commande
      QString cmd6; // commande

      variablename = variablename + nom + "_" + QString::number(numero); // on donne le bon nom a la variable

//      cmd2 = "+connection(\"" + nameURBIServeur + "\"):echo(\"if(isdef(" + variablename + ")) delete " + variablename + ";\");";
//      urbiTele.robotC->send("%s", (const char *) cmd2.toLatin1());
    
      cmd = "if(isdef(" + variablename + ")) delete " + variablename + ";";
      urbiTele.robotC->send("%s", (const char *) cmd.toLatin1());
    
//      cmd4 = "+connection(\"" + nameURBIServeur + "\"):echo(\"" + variablename + " = [" ;
      cmd3 = variablename + " = [" ;

      for(int i=0 ; i < nbvalues ; i++)
      {
           traitementUList(nom + "_" + QString::number(numero), i);        
           if(i == 0)
           {
                cmd4 = cmd4 + variablename + "_" + QString::number(i);
                cmd3 = cmd3 + variablename + "_" + QString::number(i);
           }
           else
           {
               cmd4 = cmd4 + " , " + variablename + "_" + QString::number(i);
               cmd3 = cmd3 + " , " + variablename + "_" + QString::number(i);
           }
      }

//      cmd4 = cmd4 + "]; " + variablename + "; \");" ;
//      urbiTele.robotC->send("%s", (const char *) cmd4.toLatin1());

      cmd3 = "wait(1s); " + cmd3 + "];" + variablename + "; };";
      urbiTele.robotC->send("%s", (const char *) cmd3.toLatin1());

      for(int i=0 ; i < nbvalues ; i++)
      {
//           cmd6 = "+connection(\"" + nameURBIServeur + "\"): echo(\"if(isdef(" + variablename + "_" + QString::number(i) + ")) delete " + variablename + "_" + QString::number(i) + ";\");";
//           urbiTele.robotC->send("%s", (const char *) cmd6.toLatin1());
           cmd5 = "if(isdef(" + variablename + "_" + QString::number(i) + ")) delete " + variablename + "_" + QString::number(i) + ";";
           urbiTele.robotC->send("%s", (const char *) cmd5.toLatin1());
      }

  }

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////



  file_data.close();
  file_text.close();

}

