#include "urbi.h"
#include "tele.h"


ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotC = NULL;                           
}

///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{
     
 if( ev->type() == (QEvent::Type)(1001))
 {
    if(etat == 1) // ce n'est pas bon
    {
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      pere->ui.pushButton_2->setPalette(couleur);
    }
    else if(etat == 0) // c'est bon
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      pere->ui.pushButton_2->setPalette(couleur); 
    }

 }

 return 1;
}



UCallbackAction ConnectAibo::recuperation(const UMessage &msg) 
{

  etat = 0; // on part du principe que ca va etre bon

  QString openFilesPath=pere->ui.lineEdit_3->text();  // on recupere le nom du fichier
  QFile file_data;
  QFile file_text;
  file_data.setFileName(openFilesPath+".dat");  // ouverture du fichier
  file_text.setFileName(openFilesPath+".txt");  // ouverture du fichier
  if( file_text.exists() || file_data.exists() )
  {} // peut etre mettre un avertissement pour eviter de supprimer un fichier utile
  file_text.open(QIODevice::WriteOnly | QIODevice::Text );
  QTextStream out_text(&file_text);

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_SYSTEM ) // on recoit un message system
  { 
    out_text << "MESSAGE_SYSTEM\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << QString::fromLatin1(msg.rawMessage.c_str()) << "\n";
    etat = 1; // ce n'est pas bon
  } 

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_ERROR ) // on recoit un message d'erreur
  { 
    out_text << "MESSAGE_ERROR\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << QString::fromLatin1(msg.rawMessage.c_str()) << "\n";
    etat = 1; // ce n'est pas bon
  } 

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_DOUBLE) // on recoit une donnee de type double
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_DOUBLE\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << (double) msg.value->val << "\n";
  } 

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_STRING) // on recoit une donnee de type string
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_STRING\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << QString::fromLatin1( msg.value->stringValue->c_str() ) << "\n";
  } 

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_VOID) // on recoit une donnee de type vide
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_VOID\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << "" << "\n";
    etat = 1; // ce n'est pas bon
  } 

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_BINARY) // on recoit une donnee de type binaire
  { 
        out_text << "MESSAGE_DATA\n";
        out_text << "DATA_BINARY\n";
    
        if (msg.value->binary->type == urbi::BINARY_NONE)
        {
           out_text << "BINARY_NONE\n";
           out_text << msg.value->binary->common.size << "\n";
           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*)msg.value->binary->common.data, msg.value->binary->common.size); 
        }
    
        if (msg.value->binary->type == urbi::BINARY_UNKNOWN)
        {
           out_text << "BINARY_UNKNOWN\n";
           out_text << msg.value->binary->common.size << "\n";
           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*)msg.value->binary->common.data, msg.value->binary->common.size); 
        }
    
        if (msg.value->binary->type == urbi::BINARY_IMAGE) // type image
        {
           urbi::UImage& img = msg.value->binary->image; // pointeur vers l'image
           out_text << "BINARY_IMAGE\n"; // type
           out_text << img.width << "\n"; // largeur
           out_text << img.height << "\n"; // hauteur
           out_text << img.size << "\n"; // taille en octets de l'image
           if( img.imageFormat == urbi::IMAGE_JPEG )
               out_text << IMAGE_JPEG << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_YCbCr )
               out_text << IMAGE_YCbCr << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_RGB )
               out_text << IMAGE_RGB << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_PPM )
               out_text << IMAGE_PPM << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_UNKNOWN )
               out_text << IMAGE_UNKNOWN << "\n"; 
    
           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*)img.data, img.size); 
        }
    
    
        if (msg.value->binary->type == urbi::BINARY_SOUND) // type son
        {
           urbi::USound& snd = msg.value->binary->sound; // pointeur vers le son
           out_text << "BINARY_SOUND\n";
           out_text << snd.channels << "\n"; // number of audio channels
           out_text << snd.rate << "\n"; // rate in Hertz
           out_text << snd.sampleSize << "\n"; // sample size in bit
           out_text << snd.size << "\n"; // total size in byte
           out_text << snd.sampleFormat << "\n"; // sample format  - SAMPLE_SIGNED or SAMPLE_UNSIGNED
           if( snd.soundFormat == urbi::SOUND_WAV )
               out_text << SOUND_WAV << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_RAW )
               out_text << SOUND_RAW << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_MP3 )
               out_text << SOUND_MP3 << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_OGG )
               out_text << SOUND_OGG << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_UNKNOWN )
               out_text << SOUND_UNKNOWN << "\n"; 


           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*)snd.data, snd.size); 
        }

  } 

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_OBJECT) // on recoit une donnee de type UObject
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_OBJECT\n";
    out_text << QString::fromLatin1(msg.value->object->refName.c_str()) << "\n";

    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << QString::fromLatin1(msg.rawMessage.c_str()) << "\n";
    etat = 1; // ce n'est pas bon - on ne peut pas sauvegarder un UObject
  } 

////////////////////////////////////////////////////////////////////////////////

  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_LIST) // on recoit une donnee de type UList
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_LIST\n";
    int ulistsize = msg.value->list->array.size(); // renvoie le nombre d'elements contenus dans la liste
    out_text << ulistsize << "\n";

    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << QString::fromLatin1(msg.rawMessage.c_str()) << "\n";

    UValue *valeurUList;
    for(int i=0; i<ulistsize ; i++)
    {
        valeurUList = msg.value->list->array[i];
        traitementUList("", i, valeurUList);
    }


  } 

////////////////////////////////////////////////////////////////////////////////


  file_data.close();
  file_text.close();

  e1 = new QEvent((QEvent::Type)(1001));
  QCoreApplication::postEvent(this,e1);  // on affiche la bonne couleur sur le bouton

  return URBI_CONTINUE;
}



///////////////////////////////////////////
// sert a traiter les UList
void ConnectAibo::traitementUList(QString nom, int numero, UValue *ptuvalue)
{

  QString openFilesPath=pere->ui.lineEdit_3->text();  // on recupere le nom du fichier
  QFile file_data;
  QFile file_text;
  file_data.setFileName(openFilesPath + nom + "_" + QString::number(numero) + ".dat");  // ouverture du fichier
  file_text.setFileName(openFilesPath + nom + "_" + QString::number(numero) + ".txt");  // ouverture du fichier
  if( file_text.exists() || file_data.exists() )
  {} // peut etre mettre un avertissement pour eviter de supprimer un fichier utile
  file_text.open(QIODevice::WriteOnly | QIODevice::Text );
  QTextStream out_text(&file_text);

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_DOUBLE) // on recoit une donnee de type double
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_DOUBLE\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << (double) ptuvalue->val << "\n";
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_STRING) // on recoit une donnee de type string
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_STRING\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << QString::fromLatin1( ptuvalue->stringValue->c_str() ) << "\n";
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_VOID) // on recoit une donnee de type vide
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_VOID\n";
    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << "" << "\n";
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_BINARY) // on recoit une donnee de type binaire
  { 
        out_text << "MESSAGE_DATA\n";
        out_text << "DATA_BINARY\n";
    
        if ( ptuvalue->binary->type == urbi::BINARY_NONE)
        {
           out_text << "BINARY_NONE\n";
           out_text << ptuvalue->binary->common.size << "\n";
           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*)ptuvalue->binary->common.data, ptuvalue->binary->common.size); 
        }
    
        if ( ptuvalue->binary->type == urbi::BINARY_UNKNOWN)
        {
           out_text << "BINARY_UNKNOWN\n";
           out_text << ptuvalue->binary->common.size << "\n";
           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*) ptuvalue->binary->common.data, ptuvalue->binary->common.size); 
        }
    
        if ( ptuvalue->binary->type == urbi::BINARY_IMAGE) // type image
        {
           urbi::UImage& img = ptuvalue->binary->image; // pointeur vers l'image
           out_text << "BINARY_IMAGE\n"; // type
           out_text << img.width << "\n"; // largeur
           out_text << img.height << "\n"; // hauteur
           out_text << img.size << "\n"; // taille en octets de l'image
           if( img.imageFormat == urbi::IMAGE_JPEG )
               out_text << IMAGE_JPEG << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_YCbCr )
               out_text << IMAGE_YCbCr << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_RGB )
               out_text << IMAGE_RGB << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_PPM )
               out_text << IMAGE_PPM << "\n"; 
           else if( img.imageFormat == urbi::IMAGE_UNKNOWN )
               out_text << IMAGE_UNKNOWN << "\n"; 
    
           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*)img.data, img.size); 
        }
    
    
        if ( ptuvalue->binary->type == urbi::BINARY_SOUND) // type son
        {
           urbi::USound& snd = ptuvalue->binary->sound; // pointeur vers le son
           out_text << "BINARY_SOUND\n";
           out_text << snd.channels << "\n"; // number of audio channels
           out_text << snd.rate << "\n"; // rate in Hertz
           out_text << snd.sampleSize << "\n"; // sample size in bit
           out_text << snd.size << "\n"; // total size in byte
           out_text << snd.sampleFormat << "\n"; // sample format  - SAMPLE_SIGNED or SAMPLE_UNSIGNED
           if( snd.soundFormat == urbi::SOUND_WAV )
               out_text << SOUND_WAV << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_RAW )
               out_text << SOUND_RAW << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_MP3 )
               out_text << SOUND_MP3 << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_OGG )
               out_text << SOUND_OGG << "\n"; 
           else if( snd.soundFormat == urbi::SOUND_UNKNOWN )
               out_text << SOUND_UNKNOWN << "\n"; 


           file_data.open(QIODevice::WriteOnly);
           file_data.write((const char*)snd.data, snd.size); 
        }

  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_OBJECT) // on recoit une donnee de type UObject
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_OBJECT\n";

    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << "" << "\n";
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_LIST) // on recoit une donnee de type UList
  { 
    out_text << "MESSAGE_DATA\n";
    out_text << "DATA_LIST\n";
    int ulistsize = ptuvalue->list->array.size(); // renvoie le nombre d'elements contenus dans la liste
    out_text << ulistsize << "\n";

    file_data.open(QIODevice::WriteOnly | QIODevice::Text );
    QTextStream out_data(&file_data);
    out_data << "\n";

    UValue *valeurUList;
    for(int i=0; i<ulistsize ; i++)
    {
        valeurUList = ptuvalue->list->array[i];
        traitementUList(nom + "_" + QString::number(numero), i, valeurUList);
    }
  } 

////////////////////////////////////////////////////////////////////////////////

  file_data.close();
  file_text.close();

}



/*
  class UMessage
  {
    UMessageType	 type;
    urbi::UValue	 *value;
    std::string	 message;
    std::string	 rawMessage;
  };

  class UValue
  {
    UDataType       type;
    ufloat          val;  ///< value if of type DATA_DOUBLE
    union
    {
      std::string	*stringValue;	///< value if of type DATA_STRING
      UBinary		*binary;	///< value if of type DATA_BINARY
      UList		*list;		///< value if of type DATA_LIST
      UObjectStruct	*object;	///< value if of type DATA_OBJ
    };
  };

  class UBinary
  {
    UBinaryType             type;
    struct
    {
       	void* data;             ///< binary data
    	size_t size;
    } common;
    UImage image;
    USound sound;
    /// Extra bin headers(everything after BIN <size> and before ';'.
    std::string message;
  };

  class UImage
  {
    unsigned char         *data;            ///< pointer to image data
    size_t size;             ///< image size in byte
    size_t width, height;    ///< size of the image
    UImageFormat          imageFormat;
  };

  class USound
  {
    char                  *data;            ///< pointer to sound data
    size_t size;             ///< total size in byte
    int                   channels;         ///< number of audio channels
    int                   rate;             ///< rate in Hertz
    int                   sampleSize;       ///< sample size in bit
    USoundFormat          soundFormat;      ///< format of the sound data
    enum SampleFormat
    {
      SAMPLE_SIGNED=1,
      SAMPLE_UNSIGNED=2
    };
    USoundSampleFormat    sampleFormat;     ///< sample format
  };

  class UObjectStruct
  {
    std::string refName;
    std::vector<UNamedValue> array;
    UValue & operator [](const std::string& s);
    UNamedValue & operator [](int i) {return array[i];}
    int size() {return array.size();}
  };

  class UList
  {
    std::vector<UValue *> array;
    UValue & operator [](int i) {return *array[i+offset];}
    const UValue & operator [](int i) const {return *array[i+offset];}
  };

*/

