#include "captureimage.h"

/////////////////////////////////////////////////
// Creation de l'objet
CaptureImage::CaptureImage(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

        // configuration de la couleur 1
        color1.configure(0, 255, 120, 190, 150, 230,"Pink"); // rose
        unsigned char buffercolor1[3]; // couleur YCbCr
        unsigned char buffercolor12[3]; // destination RGB
         // on calcule la valeur moyenne
         int Ymoy = (int) ( (0 + 255) / 2 );
         int Cbmoy = (int) ( (120 + 190) / 2 );
         int Crmoy = (int) ( (150 + 230) / 2 );
         // on remplit buffer
         buffercolor1[0]=Ymoy;
         buffercolor1[1]=Cbmoy;
         buffercolor1[2]=Crmoy;
         // conversion de la couleur en RGB
         convertYCrCbtoRGB( (const unsigned char *) buffercolor1, 3, (unsigned char*) buffercolor12 );
        colorColor1 = QColor(buffercolor12[0],buffercolor12[1],buffercolor12[2]);
        ui.pushButton_2->setPalette(QPalette(colorColor1));


        colorPen = QColor(255,0,255);
        ui.pushButton_4->setPalette(QPalette(colorPen));
        redPen = colorPen.red(); 
        greenPen = colorPen.green(); 
        bluePen = colorPen.blue();
        unsigned char buffer[3]; // couleur RGB
        unsigned char buffer2[3]; // destination YCbCr
        // on remplit buffer
        buffer[0]=bluePen;
        buffer[1]=greenPen;
        buffer[2]=redPen;
        // conversion de la couleur en YCbCr
        convertRGBtoYCrCb( (const byte *) buffer, 3, (byte*) buffer2 );
        YPen= buffer2[0] ; 
        CbPen= buffer2[1] ; 
        CrPen= buffer2[2] ; 


        colorBackground = QColor(212,208,200);
        redBackground = colorBackground.red(); 
        greenBackground = colorBackground.green(); 
        blueBackground = colorBackground.blue();
        // on remplit buffer
        buffer[0]=blueBackground; 
        buffer[1]=greenBackground;
        buffer[2]=redBackground;       
        // conversion de la couleur en YCbCr
        convertRGBtoYCrCb( (const byte *) buffer, 3, (byte*) buffer2 );        
        YBackground= buffer2[0] ; 
        CbBackground= buffer2[1] ; 
        CrBackground= buffer2[2] ; 


        clear=1; // on efface l'ecran
}

/////////////////////////////////////////////////
// Connexion au robot
void CaptureImage::on_pushButton_clicked()
{
    QString robotName = ui.lineEdit->text();
// sauvegarde du nom du robot
   QSettings settings("URBI Paint", "GOSTAI");
   settings.setValue("robotname", robotName);
   settings.sync ();


    if( urbiImage.robotI != NULL)
    {
        // fermeture de la session
          urbiImage.robotI->send(";;;; quit;");
          urbiImage.robotI->send("stop uimg;");
          urbiImage.robotI->send("noop;");
          urbiImage.robotI->send("noop;");
          delete urbiImage.robotI;

          // reinitialisation des parametres
          urbiImage.traitementEnCours=0; 
    }

    urbiImage.robotI = NULL;
    urbiImage.robotI =new UClient(robotName.toLatin1());
    urbiImage.pere=pointeur;
    color1.pere=pointeur;

    if (!urbiImage.robotI->error())
    {
           // creation de la couleur verte
           QColor couleur ( 0, 255, 0 ); 
          // application de la couleur sur le bouton connexion
          ui.pushButton->setPalette(couleur);
    
        urbiImage.robotI->send("noop;");
        urbiImage.robotI->send("stop uimg;");

        urbiImage.robotI->setCallback(callback(urbiImage,&ConnectAibo::command), "uimg");
    
        QString videoName = ui.lineEdit_2->text();
        QString delayName = ui.lineEdit_3->text();
        QString recupimage = "uimg:every(" + delayName + "){ uimg:" + videoName + " },";    
        urbiImage.robotI->send("%s", (const char *)  recupimage.toLatin1());

    }
    else // pas de connexion
    {
         urbiImage.robotI = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         
    }

}

/////////////////////////////////////////////////
// Selection de la couleur 1
void CaptureImage::on_pushButton_2_clicked()
{
     color1.show();
}

/////////////////////////////////////////////////
// Selection de la couleur 2
void CaptureImage::on_pushButton_3_clicked()
{

    QColor color = QColorDialog::getColor(colorBackground,this);
    if (color.isValid()) 
    {
        colorBackground=color;
        ui.pushButton_3->setPalette(QPalette(color));

        redBackground = color.red(); 
        greenBackground = color.green(); 
        blueBackground = color.blue();

        unsigned char buffer[3]; // couleur RGB
        unsigned char buffer2[3]; // destination YCbCr
        
        // on remplit buffer
        buffer[0]=blueBackground;
        buffer[1]=greenBackground;
        buffer[2]=redBackground;
        
        // conversion de la couleur en YCbCr
        convertRGBtoYCrCb( (const byte *) buffer, 3, (byte*) buffer2 );
        
        YBackground= buffer2[0] ; 
        CbBackground= buffer2[1] ; 
        CrBackground= buffer2[2] ; 

        clear=1;
    }
    
}

/////////////////////////////////////////////////
// Selection de la couleur 3
void CaptureImage::on_pushButton_4_clicked()
{

    QColor color = QColorDialog::getColor(colorPen,this);
    if (color.isValid()) 
    {
        colorPen=color;
        ui.pushButton_4->setPalette(QPalette(color));

        redPen = color.red(); 
        greenPen = color.green(); 
        bluePen = color.blue();

        unsigned char buffer[3]; // couleur RGB
        unsigned char buffer2[3]; // destination YCbCr
        
        // on remplit buffer
        buffer[0]=bluePen;
        buffer[1]=greenPen;
        buffer[2]=redPen;
        
        // conversion de la couleur en YCbCr
        convertRGBtoYCrCb( (const byte *) buffer, 3, (byte*) buffer2 );
        
        YPen= buffer2[0] ; 
        CbPen= buffer2[1] ; 
        CrPen= buffer2[2] ; 
 
    }

}


