#include "urbi.h"
#include "captureimage.h"


//////////////////////////////////////////
// Creation de l'objet
ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotI = NULL;  
     buffer = NULL;
     buffer2 = NULL;

     bufferRGB = NULL;   
     bufferRGBCouleur1=NULL; 
     bufferRGBFinal=NULL; 

     bufferYCbCr = NULL;   
     bufferYCbCrCouleur1 = NULL;
     bufferYCbCrFinal = NULL;

     traitementEnCours=0; 
}

UCallbackAction ConnectAibo::command(const UMessage &msg) 
{

  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;

 if(traitementEnCours == 0)
 {
      traitementEnCours=1;

	  urbi::UImage& img = msg.value->binary->image;

      int width = img.width;
	  int height = img.height;
      int size3b = width*height*3;

      if (buffer == NULL && bufferYCbCr == NULL && bufferRGB == NULL)
      {
            buffer = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            buffer2 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits

            bufferRGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
            bufferRGBCouleur1 = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
            bufferRGBFinal = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits

            bufferYCbCr = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            bufferYCbCrCouleur1 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
            bufferYCbCrFinal = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
      }


//////////////////////////////////////////////////////////////////////////////
// Realisation de imageQT et imageQT2 - Partie 1
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image en RGB
      if( img.imageFormat == urbi::IMAGE_JPEG )
          convertJPEGtoRGB( (const byte *) img.data, img.size, (byte *) buffer, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
          convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer );
      else if ( img.imageFormat == urbi::IMAGE_RGB)
            memcpy(  buffer, img.data, img.size );
      else
            memcpy(  buffer, img.data, img.size );






  
  
//////////////////////////////////////////////////////////////////////////////
// Realisation de imageCouleur1
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image en YCbCr

      if( img.imageFormat == urbi::IMAGE_JPEG )
           convertJPEGtoYCrCb( (const byte *) img.data, img.size, (byte*) bufferYCbCr, size3b);
      else if ( img.imageFormat == urbi::IMAGE_YCbCr)
           memcpy(bufferYCbCr, img.data, size3b);
      else if ( img.imageFormat == urbi::IMAGE_RGB)
          convertRGBtoYCrCb( (const byte *) img.data, img.size, (byte*) bufferYCbCr );


      int nbDePixels=0;
      double centerX=0;
      double centerY=0;


       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCr[(3*i) + (j*width*3) + 0] <= pere->color1.Ymax && bufferYCbCr[(3*i) + (j*width*3) + 0] >= pere->color1.Ymin )
                     {
                         if( bufferYCbCr[(3*i) + (j*width*3) + 1] <=pere->color1.Cbmax && bufferYCbCr[(3*i) + (j*width*3) + 1] >= pere->color1.Cbmin )
                         {
                             if( bufferYCbCr[(3*i) + (j*width*3) + 2] <= pere->color1.Crmax && bufferYCbCr[(3*i) + (j*width*3) + 2] >= pere->color1.Crmin )
                             {
                                  nbDePixels++;
                                  centerX = centerX + i;
                                  centerY = centerY + j;
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = pere->YPen;  // Y
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = pere->CbPen;  //Cb
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = pere->CrPen;  // Cr

                                  buffer[(3*i) + (j*width*3) + 0] = pere->color1.R;  // R
                                  buffer[(3*i) + (j*width*3) + 1] = pere->color1.G;  // G
                                  buffer[(3*i) + (j*width*3) + 2] = pere->color1.B;  // B
                             }
                             else
                             {
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = pere->YBackground;  // Y
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = pere->CbBackground;  //Cb
                                  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = pere->CrBackground;  // Cr                                 
                             }
                         }
                         else
                         {
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = pere->YBackground;  // Y
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = pere->CbBackground;  //Cb
                             bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = pere->CrBackground;  // Cr                                 
                         }
                     }
                     else
                     {
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] = pere->YBackground;  // Y
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] = pere->CbBackground;  //Cb
                         bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] = pere->CrBackground;  // Cr                                 
                     }
             }
       }    

       // on indique le nb de pixels et la position du centre
       pere->color1.nbTotal= nbDePixels ;
       if( nbDePixels != 0)
       {
           pere->color1.posX = (int) (centerX / nbDePixels) ;
           pere->color1.posY = (int) (centerY / nbDePixels) ;
       }
       else
       {
           pere->color1.posX = 0;
           pere->color1.posY = 0;           
       }

       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrCouleur1, size3b, (byte*) buffer2 );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 0] = buffer2[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 1] = buffer2[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 2] = buffer2[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBCouleur1[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    


       // copie de l'image dans imageCouleur1
      imageCouleur1=QImage( bufferRGBCouleur1, width, height, QImage::Format_RGB32 ); // on stocke l'image

      // imageCouleur1 contient pour l'image en cours l'objet de la couleur voulu, ainsi que le fond de la couleur voulu



//////////////////////////////////////////////////////////////////////////////
// Realisation de imageQT et imageQT2 - Partie 2
/////////////////////////////////////////////////////////////////////////////
      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGB[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGB[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGB[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGB[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    

       // copie de l'image dans QImage
      imageQT=QImage( bufferRGB, width, height, QImage::Format_RGB32 ); // on stocke l'image

      // on recupere la largeur et la hauteur
      int widthLabel = pere->ui.label_2->width();
      int heightLabel  = pere->ui.label_2->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT2 = imageQT.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT2 = imageQT.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT2 = imageQT;


//////////////////////////////////////////////////////////////////////////////
// Realisation de l'image finale
/////////////////////////////////////////////////////////////////////////////

      if(pere->clear == 1)    // on efface tout
      {
           for(int i=0; i<=width; i++)
           {
                 for(int j=0; j<=height; j++)
                 {
                             bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->YBackground;  // Y
                             bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->CbBackground;  //Cb
                             bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->CrBackground;  // Cr
                 }
           }                         

           pere->clear = 0;
      }

       // on cherche les pixels de la bonne couleur
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                     if( bufferYCbCrCouleur1[(3*i) + (j*width*3) + 0] == pere->YPen && bufferYCbCrCouleur1[(3*i) + (j*width*3) + 1] <=pere->CbPen &&  bufferYCbCrCouleur1[(3*i) + (j*width*3) + 2] <= pere->CrPen)
                     {
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 0] = pere->YPen;  // Y
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 1] = pere->CbPen;  //Cb
                         bufferYCbCrFinal[(3*i) + (j*width*3) + 2] = pere->CrPen;  // Cr
                     }
             }
       }    


       // conversion de l'image en RGB
       convertYCrCbtoRGB( (const byte *) bufferYCbCrFinal, size3b, (byte*) buffer );


      // conversion de l'image RGB 24 en RGB 32
       for(int i=0; i<=width; i++)
       {
             for(int j=0; j<=height; j++)
             {
                  bufferRGBFinal[(4*i) + (j*width*4) + 0] = buffer[(3*i) + (j*width*3) + 2];  // bleu
                  bufferRGBFinal[(4*i) + (j*width*4) + 1] = buffer[(3*i) + (j*width*3) + 1];  //vert
                  bufferRGBFinal[(4*i) + (j*width*4) + 2] = buffer[(3*i) + (j*width*3) + 0];  // rouge
                  bufferRGBFinal[(4*i) + (j*width*4) + 3] = 0;        // vide
             }
       }    


       // copie de l'image dans imageFinal
      imageFinal=QImage( bufferRGBFinal, width, height, QImage::Format_RGB32 ); // on stocke l'image
      imageFinal2 = imageFinal.scaledToHeight ( imageQT2.height() );          // on donne la meme taille que imageQT2


//////////////////////////////////////////////////////////////////////////////
// Affichage du resultat
/////////////////////////////////////////////////////////////////////////////
       e1 = new QEvent((QEvent::Type)(1001));
       QCoreApplication::postEvent(this,e1);


      traitementEnCours=0;
 }

  return URBI_CONTINUE;
}





///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001))
 {
      pere->ui.label_2->setPixmap(QPixmap::fromImage(imageQT2));     // on affiche l'image normale
      pere->ui.label_3->setPixmap(QPixmap::fromImage(imageFinal2));     // on affiche l'image finale

      pere->color1.ui.lcdNumber->display(pere->color1.nbTotal);
      pere->color1.ui.lcdNumber_2->display(pere->color1.posX);
      pere->color1.ui.lcdNumber_3->display(pere->color1.posY);
 }

 return 1;
}
