#include "tele.h"

#ifdef WIN32
#define usleep(a) Sleep(a/1000)
#endif 


Telecommande::Telecommande(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

        pingCount=0; 
}


///////////////////////////////////////////
// se connecter au robot
void Telecommande::on_lineEdit_returnPressed()
{
     // recuperation des donnes du nom
    QString robotName2 = ui.lineEdit->text();
    QSettings settings("URBI Ping", "GOSTAI");
    settings.setValue("robotname", robotName2);
    settings.sync ();
    robotName = robotName2;


    if( urbiTele.robotC != NULL)
    {
        // fermeture de la session
          urbiTele.robotC->send(";;;; quit;");
          urbiTele.robotC->send("uping;");
          urbiTele.robotC->send("dureefixe;");
          urbiTele.robotC->send("dureefixeloop;");
          urbiTele.robotC->send("noop;");
          urbiTele.robotC->send("noop;");
          delete urbiTele.robotC;

    }
    urbiTele.robotC = NULL;
    urbiTele.robotC =new UClient( robotName2.toLatin1());

    if (!urbiTele.robotC->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);

       setlocale(LC_NUMERIC,"C");
       urbiTele.pere=pointeur;

       // reglage de l'ecran terminal
       ui.textBrowser->clear(); // on efface le terminal 

       received=true; // le robot peut recevoir des pings
       pingCount=0;  // on remet le compteur a 0

       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::pong),"uping");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::dureefixe),"dureefixe");

       urbiTele.robotC->send( "dureefixeloop:every(1s){ dureefixe:1 }," ); // on envoie la commande une fois par seconde

    }
    else // pas de connexion
    {
         urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);         
    }

}


///////////////////////////////////////////
// se connecter au robot
void Telecommande::on_pushButton_2_clicked()
{
     // recuperation des donnes du nom
    QString robotName2 = ui.lineEdit->text();
    QSettings settings("URBI Ping", "GOSTAI");
    settings.setValue("robotname", robotName2);
    settings.sync ();
    robotName = robotName2;


    if( urbiTele.robotC != NULL)
    {
        // fermeture de la session
          urbiTele.robotC->send(";;;; quit;");
          urbiTele.robotC->send("uping;");
          urbiTele.robotC->send("dureefixe;");
          urbiTele.robotC->send("dureefixeloop;");
          urbiTele.robotC->send("noop;");
          urbiTele.robotC->send("noop;");
          delete urbiTele.robotC;

    }
    urbiTele.robotC = NULL;
    urbiTele.robotC =new UClient( robotName2.toLatin1());

    if (!urbiTele.robotC->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);

       setlocale(LC_NUMERIC,"C");
       urbiTele.pere=pointeur;

       // reglage de l'ecran terminal
       ui.textBrowser->clear(); // on efface le terminal 

       received=true; // le robot peut recevoir des pings
       pingCount=0;  // on remet le compteur a 0

       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::pong),"uping");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::dureefixe),"dureefixe");

       urbiTele.robotC->send( "dureefixeloop:every(1s){ dureefixe:1 }," ); // on envoie la commande une fois par seconde

    }
    else // pas de connexion
    {
         urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);         
    }

}
