#include "plot.h"

Plot::Plot()
{
        valmin=-666;
        valmax=666;
}


//////////////////////////////////////////////////
// On ajoute des valeurs a la liste
void Plot::addValuesVariable(double value, double heure)
{

    if (stockVariable == NULL)
    {
            // Creation des tableaux qui vont stocker les valeurs
            stockVariable = new double[pointsAAfficher];
            xPoints = new double[pointsAAfficher];

        // on vide les tableaux
         for( int i=0; i<pointsAAfficher; i++ )
         {
            xPoints[i] = heure;
            stockVariable[i] = value;
         }

        // Insert new curves
        cLeft = new QwtPlotCurve("Data Global Variable");
        cLeft->attach(this);

        // Set curve styles
        cLeft->setPen(QPen(Qt::blue));

        // Attach (don't copy) data. Both curves use the same x array.
        cLeft->setRawData(xPoints, stockVariable, pointsAAfficher);
    }

    if(valmax == 666 && valmin == -666)
    {
        valmin=value;
        valmax=value;
        setAxisScale(QwtPlot::yLeft, (int)valmin-1, (int)valmax+1);
    }

	if(xPoints[0] == 0)
		for( int i=0; i<pointsAAfficher; i++ )
			xPoints[i] = heure;

       // on fait un dcalage a gauche des donnees
      int nbOctets = (pointsAAfficher-1)*sizeof(double);
       memmove ( xPoints, xPoints+1, nbOctets ); 
       memmove ( stockVariable, stockVariable+1, nbOctets ); 

    // on remplit les tableaux
      xPoints[pointsAAfficher-1] = heure;
      stockVariable[pointsAAfficher-1] = value;

    setAxisScale  (QwtPlot::xBottom, (int)( xPoints[0] - 1) , (int)( xPoints[pointsAAfficher - 1] + 1) ); // on indique le min et le max de l'axe des temps

    if(valmax < value)
    {
              valmax = value;
              setAxisScale(QwtPlot::yLeft, (int)valmin-1, (int)valmax+1);
    }
    else if(valmin > value)
    {
              valmin = value;
              setAxisScale(QwtPlot::yLeft, (int)valmin-1, (int)valmax+1);
    }


    // update the display
    this->replot();
}



void Plot::videPlotVariable()
{
    // On libere la memoire des tableaux
    if (stockVariable != NULL)
    {
            delete cLeft;
            delete stockVariable; 
            delete xPoints;
            stockVariable = NULL;
            xPoints = NULL;
            cLeft = NULL;
      }

}


///////////////////////////////////////
// Initialisation des valeurs dans le cas d'une variable
void Plot::Init_Variable()
{
     pointsAAfficher=300; // points a afficher

    // Disable polygon clipping
    QwtPainter::setDeviceClipping(false);

    // We don't need the cache here
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintCached, false);
    canvas()->setPaintAttribute(QwtPlotCanvas::PaintPacked, false);

#ifdef Q_WS_X11
    canvas()->setAttribute(Qt::WA_PaintOnScreen, true);
#endif

    // Assign a title
    setTitle("URBI Graph Variable");
    insertLegend(new QwtLegend(), QwtPlot::BottomLegend);

    alignScales();

    // tableau contenant les valeurs
    stockVariable = NULL;
    xPoints = NULL;

    // Axis titles
    setAxisTitle(QwtPlot::xBottom, "Time/seconds"); // titre de l'axe des X
    setAxisScale(QwtPlot::xBottom, -2, 2);

    setAxisTitle(QwtPlot::yLeft, "Values");
    setAxisScale(QwtPlot::yLeft, -2, 2);
    
}


//////////////////////
//  Mise en forme de la fenetre avec bon repositionnement des elements
void Plot::alignScales()
{
    // The code below shows how to align the scales to
    // the canvas frame, but is also a good example demonstrating
    // why the spreaded API needs polishing.

    canvas()->setFrameStyle(QFrame::Box | QFrame::Plain );
    canvas()->setLineWidth(1);

    for ( int i = 0; i < QwtPlot::axisCnt; i++ )
    {
        QwtScaleWidget *scaleWidget = (QwtScaleWidget *)axisWidget(i);
        if ( scaleWidget )
            scaleWidget->setMargin(0);

        QwtScaleDraw *scaleDraw = (QwtScaleDraw *)axisScaleDraw(i);
        if ( scaleDraw )
            scaleDraw->enableComponent(QwtAbstractScaleDraw::Backbone, false);
    }
}

