#ifndef TELE_H
#define TELE_H

#include "ui_telecommande.h"
#include "urbi.h"
#include "camera.h"
#include "plot.h"
#include <QWidget>
#include <QtGui>

#include <QMainWindow>

class Telecommande : public QMainWindow
{
    Q_OBJECT

public:
    ConnectAibo urbiTele; // connexion URBI
    Camera visionCamera; // fenetre pour afficher la camera
    Plot visionGraph; // fenetre pour afficher les graphs des moteurs
    Plot visionGraph2; // fenetre pour afficher les graphs d'une variable

    Telecommande(QWidget *parent = 0);
    Telecommande *pointeur;

    Ui::Telecommande ui;

    int neRienFaireAvecLesMoteurs; // sert pour la page 3
    int neRienFaireAvecLaCamera; // sert pour la page 6

    void arretDeLaCamera(); // sert pour la page 6
    void arretDuGraph(); // sert pour la page 8
    void arretDuGraphVariable(); // sert pour la page 8

private slots:

    // sert pour la page 1
    void on_lineEdit_returnPressed(); 
    void on_pushButton_clicked();
    void on_pushButton_2_clicked();
    void on_pushButton_3_clicked();
    void on_pushButton_4_clicked();
    void on_pushButton_5_clicked();
    void on_pushButton_6_clicked();
    void on_pushButton_13_clicked();
    void on_pushButton_20_clicked();
    void on_pushButton_21_clicked();
    void on_pushButton_22_clicked();
    void on_pushButton_23_clicked();
    void on_pushButton_24_clicked();
    void on_pushButton_25_clicked();
    void on_pushButton_26_clicked();
    void on_pushButton_27_clicked();    
    void on_pushButton_28_clicked();    
    void on_pushButton_94_clicked();   
    void on_pushButton_98_clicked();   //group
    void on_pushButton_99_clicked();   //strict
    void on_pushButton_100_clicked();   //unstrict

    // sert pour la page 5 // envois de fichiers
    void on_pushButton_86_clicked();
    void on_pushButton_87_clicked();
    void on_pushButton_88_clicked();
    void on_pushButton_89_clicked();
    void on_pushButton_90_clicked();
    void on_pushButton_91_clicked();


    // sert pour la page 6 // camera
    void on_pushButton_83_clicked();
    void on_pushButton_92_clicked();


    // sert pour la page 7 // terminal
    void on_pushButton_82_clicked();
    void _on_comboBox_5_returnPressed(); 
    void on_comboBox_5_editTextChanged(const QString & text ); 


    // sert pour la page 8 // graph
    void on_pushButton_96_clicked();
    void on_pushButton_97_clicked();
 

};

#endif

