/*! file main.cpp
*******************************************************************************

File: main.cppn
Main file.

This file is part of 
%URBI Lab, version __urbilabversion__n
(c) Jean-Christophe Baillie, 2004-2005.

Permission to use, copy, modify, and redistribute this software for
non-commercial use is hereby granted.

This software is provided "as is" without warranty of any kind,
either expressed or implied, including but not limited to the
implied warranties of fitness for a particular purpose.

For more information, comments, bug reports: http://urbi.sourceforge.net

**************************************************************************** */

#include <qapplication.h>
#include <qsettings.h>

#include "mainform.hh"
#include "ugraph.hh"

/* global variables */

const     QString APP_KEY = "/urbilab"; ///< application key
///< used by QSettings when storing user settings

QSettings settings( "www.urbiforge.com", "urbilab" ); ///< contains the user setting, 
///< values loaded in different classes as needed

UGraph    graph;    ///< receives graphing demands from robots      


//! Main function
/*! After setting up the main window we leave everything on Qt

param argc
param argv

*/

int main( int argc, char ** argv ) {

  QApplication app( argc, argv );
  MainForm form;

  form.show();

  app.connect( &app, SIGNAL( lastWindowClosed() ), &app, SLOT( quit() ) );

  return app.exec();

}
