/*! file ucmdline.cpp
*******************************************************************************

File: ucmdline.cppn
Implementation of the UCmdLine class.

This file is part of
%URBI Lab, version __urbilabversion__n
(c) Jean-Christophe Baillie, 2004-2005.

Permission to use, copy, modify, and redistribute this software for
non-commercial use is hereby granted.

This software is provided "as is" without warranty of any kind,
either expressed or implied, including but not limited to the
implied warranties of fitness for a particular purpose.

For more information, comments, bug reports: http://urbi.sourceforge.net

**************************************************************************** */

#include <qlineedit.h>
#include <qevent.h>

#include "ucmdline.hh"

   //! UCmdLine constructor.
   /*! Constructs the command line.

   param parent is this widget's parent in Qt hierarchy
   param name within Qt
   */
   UCmdLine::UCmdLine( QWidget* parent)
     : QComboBox(parent) {

      // setSizePolicy( QSizePolicy( (QSizePolicy::Policy)7, (QSizePolicy::SizeType)0, 0, 0, sizePolicy().hasHeightForWidth() ) );
       setAcceptDrops( TRUE );
       setEditable( TRUE );
       //setSizeLimit( 10 ); //qt3
       setInsertPolicy( QComboBox::InsertAtBottom );
       setAutoCompletion( FALSE );
       setDuplicatesEnabled( TRUE );
       setFont( QFont( "Courier", 11 ) ); //TODO: use user settings
       setFocus();

       // highlights the command upon selection from combobox list
       connect( this, SIGNAL(activated(int)), lineEdit(), SLOT(selectAll() ) );

     }

//! UCmdLine destructor.
UCmdLine::~UCmdLine() {
  // no need to delete anything, Qt does everything

  //TODO: save command history
}

