/*! \file udebugtab.hh
 *******************************************************************************

 File: udebugtab.hh\n
 Definition of the UDebugTab class.

 This file is part of 
 %URBI Lab, version __urbilabversion__\n
 (c) Jean-Christophe Baillie, 2004-2005.

 Permission to use, copy, modify, and redistribute this software for
 non-commercial use is hereby granted.

 This software is provided "as is" without warranty of any kind,
 either expressed or implied, including but not limited to the
 implied warranties of fitness for a particular purpose.

 For more information, comments, bug reports: http://urbi.sourceforge.net

 **************************************************************************** */

#ifndef UDEBUGTAB_H
#define UDEBUGTAB_H


#include <qwidget.h>
//Added by qt3to4:
#include <QVBoxLayout>

#include "urobot.hh"

class QVBoxLayout;
class QTextEdit;
class QTcpSocket;
class QString;


//! UDebugTab class presents to the user one single debug connection. 
/*! It containes a text field for incoming debug messages.

    Messages are displayed as are, no parsing is done.

*/
class UDebugTab : public QWidget {
  
  Q_OBJECT
  
 public:

  UDebugTab( QWidget* parent = NULL);
  ~UDebugTab();

  void setRobot( URobot* robot );

  void append         ( QString& data ); 
  void clientConnected( );  
  void clientError    ( URobot::DebugClientErrType type );
  void clientClosed   ( );
  
 private:

  QTextEdit*   debugTextEdit;  ///< text field where the messages are displayed
  QVBoxLayout* debugTabLayout; ///< layout

  URobot*      robot;          ///< robot we are connected to

};


#endif // #ifndef UDEBUGTAB_H
