/*! \file udebugwindow.hh
 *******************************************************************************

 File: udebugwindow.hh\n
 Definition of the UDebugWindow class.

 This file is part of 
 %URBI Lab, version __urbilabversion__\n
 (c) Jean-Christophe Baillie, 2004-2005.

 Permission to use, copy, modify, and redistribute this software for
 non-commercial use is hereby granted.

 This software is provided "as is" without warranty of any kind,
 either expressed or implied, including but not limited to the
 implied warranties of fitness for a particular purpose.

 For more information, comments, bug reports: http://urbi.sourceforge.net

 **************************************************************************** */

#ifndef UDEBUGWINDOW_H
#define UDEBUGWINDOW_H

#include <qtabwidget.h>

class QString;

class UDebugTab;
class URobot;

//! UDebugWindow class is a window that holds all the debug tabs (connections).
/*! It manages tab creating and deleting.

*/
class UDebugWindow : public QTabWidget {
  
  Q_OBJECT
  
 public:

  UDebugWindow( QWidget* parent = NULL);
  ~UDebugWindow();
  
  void toFront( const char* hostName );

 public slots:

  void setCurrentPageByPtr( UDebugTab* page );
  void addNewTab          ( URobot* robot );
  void closeCurrentTab    ( );
 
 private:

  int pageIndexByHostName( const char* hostName );
  QWidget* pageByHostName( const char* hostName );
  
  

};
#endif // #ifndef UDEBUGWINDOW_H


