/*
 *   ugraphwindows.hh 
 *
 *   Implementation of UGraph
 *   desc: class that implements window for presenting the values (double, image, sound)
 *         
 */

#ifndef UDOUBLEGRAPHWINDOW_H
#define UDOUBLEGRAPHWINDOW_H


#include <qmainwindow.h>
//Added by qt3to4:
#include <QPixmap>
#include <QLabel>
#include <QGridLayout>
#include <QEvent>
#include <QPushButton>
#include <QSpinBox>
#include <qwt_plot.h>
#include <qwt_plot_curve.h>
#include "scrollzoomer.h"
#include "ugraphwindow.hh"
class QWidget;
class QGridLayout;
class QSpacerItem;
class QLabel;
class QEvent;

class UMessage; //liburbi

class UGraph;

extern UGraph graph;

class UDoubleGraphWindow : public UGraphWindow {

  Q_OBJECT

 public:
  UDoubleGraphWindow( QWidget* parent = 0);
  virtual ~UDoubleGraphWindow();
  virtual bool updateGraph( const UMessage& msg );
  virtual void initialize(URobot * robot, QString & variable, const QString & uniquetag);
  
 protected:
  URobot * robot;
  QString variable;
  QString tag;
  QPushButton  *stopButton, *clearButton;
  QSpinBox *limitBox;
  QLabel* label;
  QwtPlot *plot;
  QwtPlotCurve * curve;
  QwtArray< double > x;
  QwtArray< double > y;
  int limit;
  bool stoped;
  QwtPlotZoomer *zoomer;
  
 public slots:
 virtual void stopStart ();
  virtual void clear(); 
  virtual void limitChanged(int nLimit);
 protected slots:
  virtual void languageChange();

 private:
  
};
#endif

