/*! file ufunctions.cpp
*******************************************************************************

File: ufunction.cppn
Implementation common functions.

This file is part of 
%URBI Lab, version __urbilabversion__n
(c) Jean-Christophe Baillie, 2004-2005.

Permission to use, copy, modify, and redistribute this software for
non-commercial use is hereby granted.

This software is provided "as is" without warranty of any kind,
either expressed or implied, including but not limited to the
implied warranties of fitness for a particular purpose.

For more information, comments, bug reports: http://urbi.sourceforge.net

**************************************************************************** */

#include <stdlib.h>

#ifdef WIN32
#include <windows.h>
#endif /* WIN32 */

   //#include <time.h>
   //#include <stdio.h>
   //#include <sys/devpoll.h>

   // /*
   //  * 'tempFile()' - Generate a temporary filename.
   //  */

   // char *                                  /* O - Filename */
   // tempFile(char *filename,            /* I - Pointer to buffer */
   //              int  len)                  /* I - Size of buffer */
   // {
   //   int           fd;                     /* File descriptor for temp file */
   // #ifdef WIN32
   //   char          tmpdir[1024];           /* Windows temporary directory */
   // #else
   //   char          *tmpdir;                /* TMPDIR environment var */
   // #endif /* WIN32 */
   //   struct timeval curtime;               /* Current time */
   //   static char   buf[1024] = "";               /* Buffer if you pass in NULL and 0 */

   //  /*
   //   * See if a filename was specified...
   //   */

   //   if (filename == 0)
   //   {
   //     filename = buf;
   //     len      = sizeof(buf);
   //   }

   //  /*
   //   * See if TMPDIR is defined...
   //   */

   // #ifdef WIN32
   //   GetTempPath(sizeof(tmpdir), tmpdir);
   // #else
   //   if ((tmpdir = getenv("TMPDIR")) == 0)
   //     tmpdir = "/tmp";
   // #endif /* WIN32 */

   //  /*
   //   * Make the temporary name using the specified directory...
   //   */

   //   do
   //   {
   //    /*
   //     * Get the current time of day...
   //     */

   //     gettimeofday(&curtime, 0);

   //    /*
   //     * Format a string using the hex time values...
   //     */

   //     snprintf(filename, len - 1, "%s/%08x%05x", tmpdir,
   //              curtime.tv_sec, curtime.tv_usec);

   //    /*
   //     * Open the file in "exclusive" mode, making sure that we don't
   //     * stomp on an existing file or someone's symlink crack...
   //     */

   // #ifdef O_NOFOLLOW
   //     fd = open(filename, O_WRONLY | O_CREAT | O_EXCL | O_NOFOLLOW, 0600);
   // #else
   //     fd = open(filename, O_WRONLY | O_CREAT | O_EXCL, 0600);
   // #endif /* O_NOFOLLOW */
   //   }
   //   while (fd < 0);

   //  /*
   //   * Close the temp file - it'll be reopened later as needed...
   //   */

   //   close(fd);

   //  /*
   //   * Return the temp filename...
   //   */

   //   return (filename);

   // } 

   char* getTempDir( ) {

#ifdef WIN32
     static    char          tmpdir[1024];           /* Windows temporary directory */
#else
     char          *tmpdir;                /* TMPDIR environment var */
#endif /* WIN32 */



#ifdef WIN32
     GetTempPath(sizeof(tmpdir), (WCHAR*)tmpdir);
#else
     if ((tmpdir = getenv("TMPDIR")) == 0)
       tmpdir = "/tmp/";
#endif /* WIN32 */

     return tmpdir;

   }
