/*
 *   ugraphwindows.hh 
 *
 *   Implementation of UGraph
 *   desc: class that implements window for presenting the values (double, image, sound)
 *         
 */

#ifndef UGRAPHWINDOW_H
#define UGRAPHWINDOW_H


#include <QMainWindow>
//Added by qt3to4:
#include <QPixmap>
#include <QLabel>
#include <QGridLayout>
#include <QEvent>

class QWidget;
class QGridLayout;
class QSpacerItem;
class QPixmap;
class QLabel;
class QEvent;

class UMessage; //liburbi

class UGraph;
class URobot;
extern UGraph graph;

class UGraphWindow : public QMainWindow {

  Q_OBJECT

 public:
  UGraphWindow( QWidget* parent = 0 );
  virtual ~UGraphWindow();
  virtual bool updateGraph( const UMessage& msg );
  virtual void initialize(URobot * robot, QString & variable, const QString & uniquetag);
  bool event( QEvent* e );
  
 protected:
  QGridLayout* layout;
  QSpacerItem* spacer1;
  QSpacerItem* spacer2;
  QSpacerItem* spacer3;
  QSpacerItem* spacer4;
  QLabel* label;
  QPixmap* image;
  uchar * buffer32; 
 protected slots:
  virtual void languageChange();

 private:
  
};

#endif // #ifndef UGRAPHWINDOW_H
