/*
 *   uhostnameform.cpp
 *
 *   Implementation of UHostNameForm
 *   desc: implements dialog for asking for the hostname
 *
 */

#include "uhostnameform.hh"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#
#include <qimage.h>
#include <qpixmap.h>
//Added by qt3to4:
#include <QVBoxLayout>
#include <QHBoxLayout>

//! UHostNameForm constructor.
/*!
  Constructs a UHostNameForm as a child of 'parent', with the
  name 'name' and widget flags set to 'fl'.

  The dialog will by default be modeless, unless you set 'modal' to
  TRUE to construct a modal dialog.

  It's used to ask the user for hostname.

  param parent is this windows's parent in Qt hierarchy
  param modal see QDialog in Qt
  param name within Qt
  param fl are Qt flags

*/
UHostNameForm::UHostNameForm( QWidget* parent)
  : QDialog( parent ) {

   

    hostNameFormLayout = new QVBoxLayout( this);

    layout1 = new QHBoxLayout();

    hostNameLabel = new QLabel( this);
    layout1->addWidget( hostNameLabel );
    QSpacerItem* spacer = new QSpacerItem( 31, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer );

    hostNameLineEdit = new QLineEdit( this );
    layout1->addWidget( hostNameLineEdit );
    hostNameFormLayout->addLayout( layout1 );
    QSpacerItem* spacer_2 = new QSpacerItem( 20, 41, QSizePolicy::Minimum, QSizePolicy::Expanding );
    hostNameFormLayout->addItem( spacer_2 );

    layout2 = new QHBoxLayout( );
    QSpacerItem* spacer_3 = new QSpacerItem( 61, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout2->addItem( spacer_3 );

    OKPushButton = new QPushButton( this );
    layout2->addWidget( OKPushButton );

    cancelPushButton = new QPushButton( this );
    layout2->addWidget( cancelPushButton );

    hostNameFormLayout->addLayout( layout2 );

    languageChange();
    resize( QSize(249, 97).expandedTo(minimumSizeHint()) );
    //clearWState( WState_Polished );

    // signals and slots connections
    connect( OKPushButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( cancelPushButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
  }

//! UHostNameForm constructor.
/*! Destroys the object and frees any allocated resources */
UHostNameForm::~UHostNameForm() {
  // no need to delete child widgets, Qt does it all for us
}

//! Sets the strings of the subwidgets using the current language.
void
UHostNameForm::languageChange() {

  setWindowTitle( tr( "Enter IP or Host name" ) );
  hostNameLabel->setText( tr( "Host Name or IP of the robot:" ) );
  OKPushButton->setText( tr( "OK" ) );
  cancelPushButton->setText( tr( "Cancel" ) );

}

