/*! \file uhostnameform.hh
 *******************************************************************************

 File: uhostnameform.hh\n
 Definition of the UHostNameForm class.

 This file is part of 
 %URBI Lab, version __urbilabversion__\n
 (c) Jean-Christophe Baillie, 2004-2005.

 Permission to use, copy, modify, and redistribute this software for
 non-commercial use is hereby granted.

 This software is provided "as is" without warranty of any kind,
 either expressed or implied, including but not limited to the
 implied warranties of fitness for a particular purpose.

 For more information, comments, bug reports: http://urbi.sourceforge.net

 **************************************************************************** */

#ifndef UHOSTNAMEFORM_H
#define UHOSTNAMEFORM_H

#include <qvariant.h>
#include <qdialog.h>
//Added by qt3to4:
#include <QLabel>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QLabel;
class QLineEdit;
class QPushButton;


//! UHostNameForm class is a dialog boc used to ask for a host name
/*! 

*/
class UHostNameForm : public QDialog {
    
  Q_OBJECT

 public:
  UHostNameForm( QWidget* parent = 0);
  ~UHostNameForm();
  
  QLabel*      hostNameLabel;    ///< label
  QLineEdit*   hostNameLineEdit; ///< input field
  QPushButton* OKPushButton;     ///< OK button
  QPushButton* cancelPushButton; ///< Cancel button
  
 protected:
  QVBoxLayout* hostNameFormLayout; ///< main layout
  QHBoxLayout* layout1;            ///< layout
  QHBoxLayout* layout2;            ///< layout

 protected slots:
  virtual void languageChange(); 

};

#endif // #ifndef UHOSTNAMEFORM_H
