/*! file umsginpane.cpp
*******************************************************************************

File: umsginpane.cppn
Implementation of the UMsgInPane class.

This file is part of 
%URBI Lab, version __urbilabversion__n
(c) Jean-Christophe Baillie, 2004-2005.

Permission to use, copy, modify, and redistribute this software for
non-commercial use is hereby granted.

This software is provided "as is" without warranty of any kind,
either expressed or implied, including but not limited to the
implied warranties of fitness for a particular purpose.

For more information, comments, bug reports: http://urbi.sourceforge.net

**************************************************************************** */

#include <qstring.h>
   //#include <q3textedit.h>
#include <QTextBrowser>
#include <qfont.h>

#include "umsginpane.hh"
#include "umsgtab.hh"
   //! UMsgInPane constructor.
   /*! Sets up a text field.

   param parent is this widget's parent in Qt hierarchy
   param name within Qt
   */
   UMsgInPane::UMsgInPane( QWidget* parent, QWidget * cmdLine)
     : QWidget( parent ) {
     QVBoxLayout *layout = new QVBoxLayout;
       // msgInTextEdit = new Q3TextEdit( this, "msgInTextEdit" );
//        msgInTextEdit->setTextFormat(Qt::AutoText);
//        msgInTextEdit->setReadOnly( TRUE );
//        msgInTextEdit->setUndoRedoEnabled( FALSE ); 
//        msgInTextEdit->setFamily("Courier");

     msgInTextEdit = new UCacheTextBrowser( this, cmdLine );
       msgInTextEdit->setFontFamily( "Courier" );
       msgInTextEdit->setFontPointSize(10);
       layout->addWidget(msgInTextEdit);
       setLayout(layout);
     }

//! UMsgInPane destructor
UMsgInPane::~UMsgInPane() {
  // no need to delete anything, Qt does everything
}



