/*! \file umsginpane.hh
 *******************************************************************************

 File: umsginpane.hh\n
 Implementation of the UMsgOutPane class.

 This file is part of 
 %URBI Lab, version __urbilabversion__\n
 (c) Jean-Christophe Baillie, 2004-2005.

 Permission to use, copy, modify, and redistribute this software for
 non-commercial use is hereby granted.

 This software is provided "as is" without warranty of any kind,
 either expressed or implied, including but not limited to the
 implied warranties of fitness for a particular purpose.

 For more information, comments, bug reports: http://urbi.sourceforge.net

 **************************************************************************** */

#ifndef UMSGINPANE_H
#define UMSGINPANE_H

#include <QWidget>
//class Q3TextEdit;
class UCacheTextBrowser;

//! UMsgInPane class presents (displays) data received from robot. 
/*! It contains a text field, where received data are displayed (image, text).

*/
class UMsgInPane : public QWidget {

  Q_OBJECT
  
 public:
 
  UMsgInPane( QWidget* parent, QWidget * focusdest);
  ~UMsgInPane();

  //Q3TextEdit* getTextEdit() const { return msgInTextEdit; };
  UCacheTextBrowser* getTextEdit() const { return msgInTextEdit; };
  

 private:

  //Q3TextEdit* msgInTextEdit; ///< text field where messages are displayed
  UCacheTextBrowser* msgInTextEdit; ///< text field where messages are displayed
};

#endif // #ifndef UMSGINPANE_H
