/*! \file umsgwindow.hh
 *******************************************************************************

 File: umsgwindow.hh\n
 Definition of the UMsgWindow class.

 This file is part of 
 %URBI Lab, version __urbilabversion__\n
 (c) Jean-Christophe Baillie, 2004-2005.

 Permission to use, copy, modify, and redistribute this software for
 non-commercial use is hereby granted.

 This software is provided "as is" without warranty of any kind,
 either expressed or implied, including but not limited to the
 implied warranties of fitness for a particular purpose.

 For more information, comments, bug reports: http://urbi.sourceforge.net

 **************************************************************************** */

#ifndef UMSGWINDOW_H
#define UMSGWINDOW_H

#include <qtabwidget.h>
#include <qmap.h>

class UMsgTab;
class URobot;

//! UDebugWindow class is a window that holds all the msg tabs (connections).
/*! It manages tab creating and deleting.

*/
class UMsgWindow : public QTabWidget {
  
  Q_OBJECT
  
 public:

  UMsgWindow( QWidget* parent = NULL);
  ~UMsgWindow();

 public slots:

  void addNewTab      ( URobot* robot );
  void closeCurrentTab( );

 private:
  
  QMap<const char *, int> msgTabIds;  ///< list of unique clients ids for particular robot hostname
    ///< used in order to distinguish within tabs connected to the same robot, eg. scooby:1, scooby:2, etc 

};


#endif // #ifndef UMSGWINDOW_H


