/*! \file urobotmng.hh
 *******************************************************************************

 File: urobotmng.hh\n
 Definition of the URobotMng class.

 This file is part of 
 %URBI Lab, version __urbilabversion__\n
 (c) Jean-Christophe Baillie, 2004-2005.

 Permission to use, copy, modify, and redistribute this software for
 non-commercial use is hereby granted.

 This software is provided "as is" without warranty of any kind,
 either expressed or implied, including but not limited to the
 implied warranties of fitness for a particular purpose.

 For more information, comments, bug reports: http://urbi.sourceforge.net

 **************************************************************************** */


#ifndef UROBOTMNG_H
#define UROBOTMNG_H

#include <qlinkedlist.h>

class URobot;


//! URobotMng is a class that manages URobot objects
/*! It constructs and deletes robots upon demand.
*/
class URobotMng {

 public:
  
  URobotMng( );
  ~URobotMng( );
  
  URobot* getRobot   ( QString hostName );    
  // bool    robotExists( const char *hostName ) const; 
  // void    deleteRobot( const char *hostName );

 
 private:

  QLinkedList<URobot*> robotList;  ///< list of URobot objects

};


#endif // #ifndef UROBOTMNG_H
