#include "tele.h"

///////////////////////////////////////////
// Creation de l'objet
Telecommande::Telecommande(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

        // copie des pointeurs
       setlocale(LC_NUMERIC,"C");
       urbiTele.pere=pointeur;

       // on initialise toutes les donnees du graph variable
       windowmain = new MainWindow();

       etatpausereprise = 0;
       etatzoom = 0;

}



///////////////////////////////////////////
// se connecter au robot
void Telecommande::on_pushButton_clicked()
{
    urbiTele.pere=pointeur;

         // On recupere le nom de la variable que l'on veut grapher
         QString variableName = ui.lineEdit_2->text();
	 if(variableName == "")
		return;

///////////////////

         // on affiche la fenetre de graph
         windowmain->resize(600,600);
         windowmain->plot->PLOT_SIZE = ui.spinBox->value();   
         windowmain->show();


///////////////////

    // recuperation des donnes du nom et du port
    QString robotName = ui.lineEdit->text();
    QSettings settings("Variable Graph", "GOSTAI");
    settings.setValue("robotname", robotName);
    settings.sync ();

         // connexion
         if( urbiTele.robotG2 != NULL)
	     {
             if(etatpausereprise == 1) // on demande une reprise
             {
                etatpausereprise = 0;
                ui.pushButton_4->setText("Pause");
                urbiTele.robotG2->send("unfreeze graph;");
             }

             if(etatzoom == 1) // on demande un arret du zoom
             {
                etatzoom = 0;
                ui.pushButton_5->setText("Zoom");
                enableZoomMode(false);
             }

             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             windowmain->plot->videPlotVariable( ); // on libere la memoire
	      }
         urbiTele.robotG2 = NULL;
         urbiTele.robotG2 =new UClient( robotName.toLatin1()  );

///////////////////

        if (!urbiTele.robotG2->error())
        {
           setlocale(LC_NUMERIC,"C");
           urbiTele.pereGraph=pointeur;

           // recuperation de la valeur de la variable
           if (variableName != "")
           {
                urbiTele.robotG2->setCallback(callback(urbiTele,&ConnectAibo::returnvaluevariable),"graphvar");
                QString frequency = ui.lineEdit_3->text();
                QString phrase_Variable = "graph: every(" + frequency + "ms) {  graphvar: " + variableName  + " },";
                urbiTele.robotG2->send("unfreeze graph;");
           	    urbiTele.robotG2->send("%s", (const char *) phrase_Variable.toLatin1());

            }
    
        }


/////////////////////////////////////////////////////

    if (!urbiTele.robotG2->error())
    {
       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);

             // creation de la couleur grise
             QColor couleur2 ( 232, 232, 232 ); 
             // application de la couleur sur tous les boutons 
             ui.pushButton_2->setPalette(couleur2);       
             ui.pushButton_3->setPalette(couleur2);       
             ui.pushButton_4->setPalette(couleur2);      
             ui.pushButton_5->setPalette(couleur2);     

    }
    else // pas de connexion
    {
         urbiTele.robotG2 = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton->setPalette(couleur);         

             // creation de la couleur grise
             QColor couleur2 ( 232, 232, 232 ); 
             // application de la couleur sur tous les boutons 
             ui.pushButton_2->setPalette(couleur2);       
             ui.pushButton_3->setPalette(couleur2);       
             ui.pushButton_4->setPalette(couleur2);      
             ui.pushButton_5->setPalette(couleur2);    
    }




}


///////////////////////////////////////////
// Arret du graph
void Telecommande::on_pushButton_2_clicked()
{
         windowmain->hide(); // on cache la fenetre

         if( urbiTele.robotG2 != NULL)
         {
             if(etatpausereprise == 1) // on demande une reprise
             {
                etatpausereprise = 0;
                ui.pushButton_4->setText("Pause");
                urbiTele.robotG2->send("unfreeze graph;");
             }

             if(etatzoom == 1) // on demande un arret du zoom
             {
                etatzoom = 0;
                ui.pushButton_5->setText("Zoom");
                enableZoomMode(false);
             }

             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             urbiTele.robotG2 = NULL;
             windowmain->plot->videPlotVariable( ); // on libere la memoire

             // creation de la couleur rouge
             QColor couleur ( 255, 0, 0 ); 
             // application de la couleur sur le bouton arret
             ui.pushButton_2->setPalette(couleur);       

             // creation de la couleur grise
             QColor couleur2 ( 232, 232, 232 ); 
             // application de la couleur sur tous les boutons 
             ui.pushButton->setPalette(couleur2);       
             ui.pushButton_3->setPalette(couleur2);       
             ui.pushButton_4->setPalette(couleur2);      
             ui.pushButton_5->setPalette(couleur2);     
         }
} 

///////////////////////////////////////////
// Remise en forme du graphe
void Telecommande::on_pushButton_3_clicked()
{
         if( urbiTele.robotG2 != NULL)
         {
             windowmain->plot->resize();
         }
} 


///////////////////////////////////////////
// Pause / Reprise
void Telecommande::on_pushButton_4_clicked()
{
         if( urbiTele.robotG2 != NULL)
         {

             if(etatpausereprise == 0) // on demande une pause
             {
                etatpausereprise = 1;
                ui.pushButton_4->setText("Recovery");
                urbiTele.robotG2->send("freeze graph;");

             // creation de la couleur orange
             QColor couleur ( 255, 128, 0 ); 
             // application de la couleur sur le bouton pause
             ui.pushButton_4->setPalette(couleur);  

             // creation de la couleur grise
             QColor couleur2 ( 232, 232, 232 ); 
             // application de la couleur sur tous les boutons 
             ui.pushButton_2->setPalette(couleur2);       
             ui.pushButton_3->setPalette(couleur2);       
             ui.pushButton->setPalette(couleur2);      
             ui.pushButton_5->setPalette(couleur2);    

             }
             else if(etatpausereprise == 1) // on demande une reprise
             {
                etatpausereprise = 0;
                ui.pushButton_4->setText("Pause");
                urbiTele.robotG2->send("unfreeze graph;");

                if(etatzoom == 1) // le mode zoom etait active
                {
                            etatzoom = 0;
                            ui.pushButton_5->setText("Zoom");

                            enableZoomMode(false);

                            // on remet le graph en forme
                            on_pushButton_3_clicked();
                }

             // creation de la couleur verte
             QColor couleur ( 0, 255, 0 ); 
             // application de la couleur sur le bouton start
             ui.pushButton->setPalette(couleur);  

             // creation de la couleur grise
             QColor couleur2 ( 232, 232, 232 ); 
             // application de la couleur sur tous les boutons 
             ui.pushButton_2->setPalette(couleur2);       
             ui.pushButton_3->setPalette(couleur2);       
             ui.pushButton_4->setPalette(couleur2);      
             ui.pushButton_5->setPalette(couleur2);    

             }
         }
} 


///////////////////////////////////////////
// Zoom / Fin du zoom
void Telecommande::on_pushButton_5_clicked()
{
         if( urbiTele.robotG2 != NULL)
         {

             if(etatzoom == 0) // on demande un zoom
             {
                etatzoom = 1;
                ui.pushButton_5->setText("End zoom");

                if(etatpausereprise == 0) // si le mode pause n'est pas active, on l'active
                   on_pushButton_4_clicked();

             enableZoomMode(true);

             // creation de la couleur orange
             QColor couleur ( 255, 128, 0 ); 
             // application de la couleur sur le bouton pause
             ui.pushButton_5->setPalette(couleur);  


             }
             else if(etatzoom == 1) // on demande une fin de zoom
             {
                etatzoom = 0;
                ui.pushButton_5->setText("Zoom");

               enableZoomMode(false);

              // on remet le graph en forme
              on_pushButton_3_clicked();

             // creation de la couleur grise
             QColor couleur2 ( 232, 232, 232 ); 
             // application de la couleur sur tous les boutons 
             ui.pushButton_5->setPalette(couleur2);       

             }
         }
} 


///////////////////////////////////////////
// Arret du graph
void Telecommande::arretDuGraphVariable()
{
         if( urbiTele.robotG2 != NULL)
         {
             if(etatpausereprise == 1) // on demande une reprise
             {
                etatpausereprise = 0;
                ui.pushButton_4->setText("Pause");
                urbiTele.robotG2->send("unfreeze graph;");
             }

                if(etatzoom == 1) // le mode zoom etait active
                {
                            etatzoom = 0;
                            ui.pushButton_5->setText("Zoom");
                            enableZoomMode(false);
                }

             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             urbiTele.robotG2 = NULL;
             windowmain->plot->videPlotVariable( ); // on libere la memoire

         }

} 

///////////////////////////////////////////
// Activation ou desactivation du mode zoom
void Telecommande::enableZoomMode(bool on)
{
     if(on == true)
     {
       // initialisation du zoom
      d_zoomer[0] = new Zoomer( QwtPlot::xBottom, QwtPlot::yLeft, windowmain->plot->canvas());
      d_zoomer[0]->setRubberBand(QwtPicker::RectRubberBand);
      d_zoomer[0]->setRubberBandPen(QColor(Qt::green));
      d_zoomer[0]->setTrackerMode(QwtPicker::ActiveOnly);
      d_zoomer[0]->setTrackerPen(QColor(Qt::white));
      d_zoomer[1] = new Zoomer(QwtPlot::xTop, QwtPlot::yRight, windowmain->plot->canvas());

      d_zoomer[0]->setEnabled(on);
      d_zoomer[0]->zoom(0);
      d_zoomer[1]->setEnabled(on);
      d_zoomer[1]->zoom(0);
     }
     else if(on == false)
     {
      d_zoomer[0]->setEnabled(on);
      d_zoomer[0]->zoom(0);
      d_zoomer[1]->setEnabled(on);
      d_zoomer[1]->zoom(0);

      delete d_zoomer[0];
      delete d_zoomer[1];
     }

}







