#ifndef _DATA_PLOT_H
#define _DATA_PLOT_H 1

#include <qmainwindow.h>
#include <qwt_counter.h>
#include <qtoolbar.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qwt_plot.h>
#include <stdlib.h>
#include <qwt_painter.h>
#include <qwt_plot_canvas.h>
#include <qwt_plot_marker.h>
#include <qwt_plot_curve.h>
#include <qwt_scale_widget.h>
#include <qwt_legend.h>
#include <qwt_scale_draw.h>
#include <qwt_math.h>
#include <qwt_plot_marker.h>
#include <qwt_data.h>
#include <qwt_text.h>
#include <qwt_plot_zoomer.h>




class DataPlot : public QwtPlot
{
    Q_OBJECT

public:
    DataPlot(QWidget* = NULL);

    void alignScales();

    double *d_x; 
    double *d_z; 

    int PLOT_SIZE; // for 0 to 200 ==>  201;  
    QwtPlotCurve *cLeft;

    // cas pour la variable
    void onPlotVariable(double tempsActuel);
    void addValuesVariable(double value,double heure);
    void videPlotVariable(void);
    void resize(void);

    double valmin;
    double valmax;


};


class Zoomer: public QwtPlotZoomer
{
public:
    Zoomer(int xAxis, int yAxis, QwtPlotCanvas *canvas): QwtPlotZoomer(xAxis, yAxis, canvas)
    {
        setSelectionFlags(QwtPicker::DragSelection | QwtPicker::CornerToCorner);
        setTrackerMode(QwtPicker::AlwaysOff);
        setRubberBand(QwtPicker::NoRubberBand);

        // RightButton: zoom out by 1
        // Ctrl+RightButton: zoom out to full size
        setMousePattern(QwtEventPattern::MouseSelect2, Qt::RightButton, Qt::ControlModifier);
        setMousePattern(QwtEventPattern::MouseSelect3, Qt::RightButton);
    }
};



#endif

