
///////////////////////////////////////////
// se connecter au robot
void Telecommande::on_pushButton_2_clicked()
{
    urbiTele.pere=pointeur;

    // recuperation des donnes du nom et du port
    QString robotName = ui.lineEdit->text();
    int port = ui.spinBox->value();
    QSettings settings("iRobot Telecommande", "GOSTAI");
    settings.setValue("robotname", robotName);
    settings.setValue("robotport", port);
    settings.sync ();

    if( urbiTele.robotC != NULL)
    {
        // fermeture de la session
          urbiTele.robotC->send(";;;; quit;");
          urbiTele.robotC->send("noop;");
          urbiTele.robotC->send("noop;");
          delete urbiTele.robotC;

          // reinitialisation des parametres
          urbiTele.compteurligne=0;
          urbiTele.musiqueEnCours=0;
          urbiTele.imageEnCours=0;
          urbiTele.compteurvalue=0;
          urbiTele.compteurvalue2=0;
          urbiTele.compteurvalueled=0;
          urbiTele.compteurbumpers=0;
          urbiTele.compteurbuttons=0;
          urbiTele.compteurwalls=0;
          urbiTele.compteurcliffs=0;
          urbiTele.compteurodometry=0;
          urbiTele.compteurbattery=0;
    }
    urbiTele.robotC = NULL;
    urbiTele.robotC =new UClient( robotName.toLatin1() , port );

    if (!urbiTele.robotC->error())
    {
       neRienFaireAvecLesMoteurs = 0;

       // recuperation de tout ce qui est envoye par le serveur
       urbiTele.robotC->setWildcardCallback( callback(urbiTele,&ConnectAibo::allrecup) );

       // recuperation de la position des moteurs
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor),"totowheelL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor),"totowheelR");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor2),"totowheelL2");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor2),"totowheelR2");

       // recuperation de la position des leds
        QString tagLeds;
       // recuperation des leds
        for (int i=0;i<urbiTele.devCountLed-1;i++) 
        {
            tagLeds = "toto" + QString::fromLatin1(urbiTele.devicesLeds[i]);
            urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueled),tagLeds.toLatin1());
        }
        tagLeds = "toto" + QString::fromLatin1(urbiTele.devicesLeds[urbiTele.devCountLed-1]) ;
        urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueled),tagLeds.toLatin1());

       // recuperation de la distance IR
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueir),"totoir");

       // recuperation de l'etat des bumpers
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebumper),"totobumperL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebumper),"totobumperR");

       // recuperation de l'etat des boutons
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebuttons),"totobuttonP");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebuttons),"totobuttonA");

       // recuperation de l'etat des walls
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluewalls),"totowall");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluewalls),"totovirtualwall");

       // recuperation de l'etat des cliffs
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffFL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffR");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffFR");

       // recuperation de l'etat de l'odometry
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryval");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryangle");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryvelocity");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryradius");

       // recuperation de l'etat de la batterie
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterystate");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatteryval");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatteryvoltage");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterycharge");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterycapacity");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterysource");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterytemperature");

       // reglage de l'ecran terminal
       ui.textBrowser->clear(); // on efface le terminal 

       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);
    }
    else // pas de connexion
    {
         urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);         
    }

}

///////////////////////////////////////////
// se connecter au robot
void Telecommande::on_lineEdit_returnPressed()
{
    urbiTele.pere=pointeur;

    // recuperation des donnes du nom et du port
    QString robotName = ui.lineEdit->text();
    int port = ui.spinBox->value();
    QSettings settings("iRobot Telecommande", "GOSTAI");
    settings.setValue("robotname", robotName);
    settings.setValue("robotport", port);
    settings.sync ();

    if( urbiTele.robotC != NULL)
    {
        // fermeture de la session
          urbiTele.robotC->send(";;;; quit;");
          urbiTele.robotC->send("noop;");
          urbiTele.robotC->send("noop;");
          delete urbiTele.robotC;

          // reinitialisation des parametres
          urbiTele.compteurligne=0;
          urbiTele.musiqueEnCours=0;
          urbiTele.imageEnCours=0;
          urbiTele.compteurvalue=0;
          urbiTele.compteurvalue2=0;
          urbiTele.compteurvalueled=0;
          urbiTele.compteurbumpers=0;
          urbiTele.compteurbuttons=0;
          urbiTele.compteurwalls=0;
          urbiTele.compteurcliffs=0;
          urbiTele.compteurodometry=0;
          urbiTele.compteurbattery=0;
    }
    urbiTele.robotC = NULL;
    urbiTele.robotC =new UClient( robotName.toLatin1() , port );

    if (!urbiTele.robotC->error())
    {
       neRienFaireAvecLesMoteurs = 0;

       // recuperation de tout ce qui est envoye par le serveur
       urbiTele.robotC->setWildcardCallback( callback(urbiTele,&ConnectAibo::allrecup) );

       // recuperation de la position des moteurs
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor),"totowheelL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor),"totowheelR");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor2),"totowheelL2");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluemotor2),"totowheelR2");

       // recuperation de la position des leds
        QString tagLeds;
       // recuperation des leds
        for (int i=0;i<urbiTele.devCountLed-1;i++) 
        {
            tagLeds = "toto" + QString::fromLatin1(urbiTele.devicesLeds[i]);
            urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueled),tagLeds.toLatin1());
        }
        tagLeds = "toto" + QString::fromLatin1(urbiTele.devicesLeds[urbiTele.devCountLed-1]) ;
        urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueled),tagLeds.toLatin1());

       // recuperation de la distance IR
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueir),"totoir");

       // recuperation de l'etat des bumpers
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebumper),"totobumperL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebumper),"totobumperR");

       // recuperation de l'etat des boutons
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebuttons),"totobuttonP");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebuttons),"totobuttonA");

       // recuperation de l'etat des walls
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluewalls),"totowall");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluewalls),"totovirtualwall");

       // recuperation de l'etat des cliffs
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffFL");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffR");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluecliffs),"totocliffFR");

       // recuperation de l'etat de l'odometry
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryval");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryangle");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryvelocity");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvalueodometry),"totoodometryradius");

       // recuperation de l'etat de la batterie
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterystate");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatteryval");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatteryvoltage");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterycharge");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterycapacity");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterysource");
       urbiTele.robotC->setCallback(callback(urbiTele,&ConnectAibo::returnvaluebattery),"totobatterytemperature");

       // reglage de l'ecran terminal
       ui.textBrowser->clear(); // on efface le terminal 

       // creation de la couleur verte
       QColor couleur ( 0, 255, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);
    }
    else // pas de connexion
    {
         urbiTele.robotC = NULL;
       // creation de la couleur rouge
       QColor couleur ( 255, 0, 0 ); 
      // application de la couleur sur le bouton connexion
      ui.pushButton_2->setPalette(couleur);         
    }
}


///////////////////////////////////////////
// Eteindre le robot
void Telecommande::on_pushButton_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("shutdown;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] shutdown;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     }
}


///////////////////////////////////////////
// quit
void Telecommande::on_pushButton_3_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("quit;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] quit;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 
}


///////////////////////////////////////////
// reset
void Telecommande::on_pushButton_6_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("reset;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] reset;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 
}


///////////////////////////////////////////
// reboot
void Telecommande::on_pushButton_13_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("reboot;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] reboot;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// vars
void Telecommande::on_pushButton_20_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("vars;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] vars;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// uservars
void Telecommande::on_pushButton_21_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("uservars;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] uservars;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// ping
void Telecommande::on_pushButton_28_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("ping;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] ping;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// time()
void Telecommande::on_pushButton_22_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("time();");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] time();\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// cpuload()
void Telecommande::on_pushButton_23_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("cpuload();");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] cpuload();\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// freemem()
void Telecommande::on_pushButton_26_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("freemem();");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] freemem();\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// motors on
void Telecommande::on_pushButton_24_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("motors on;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] motors on;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 
}


///////////////////////////////////////////
// motors off
void Telecommande::on_pushButton_25_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("motors off;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] motors off;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 
}


///////////////////////////////////////////
// motor switch
void Telecommande::on_pushButton_27_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("motors switch;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] motors switch;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// stopall
void Telecommande::on_pushButton_4_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("stopall;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] stopall;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// taglist
void Telecommande::on_pushButton_5_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("taglist;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] taglist;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// connections
void Telecommande::on_pushButton_94_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("connections;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] connections;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// group
void Telecommande::on_pushButton_98_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("group;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] group;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// strict
void Telecommande::on_pushButton_99_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("strict;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] strict;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}


///////////////////////////////////////////
// unstrict
void Telecommande::on_pushButton_100_clicked()
{
     if(urbiTele.robotC != NULL)
     {
          urbiTele.robotC->send("unstrict;");
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText( "[Send] unstrict;\n" ) ; 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     } 

}
