#ifndef URBI_H
#define URBI_H

#include <urbi/uclient.hh>
#include <QWidget>
#include <QtGui>

using namespace urbi;

class Telecommande;

class ConnectAibo : public QWidget
{
    Q_OBJECT

public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotC; // communication des commandes
      UClient *robotI; // transfert des images
      UClient *robotG2; // graph d'une variable

      // lien pour acceder aux objets de telecommande
      Telecommande *pere;
      Telecommande *pereGraph;

      // les evenements servent pour l'affichage a l'ecran
      virtual bool event(QEvent *ev);
      QEvent *e1; // bumpers et roues
      QEvent *e2; // sonars
      QEvent *e3; // lasers
      QEvent *e4; // affichage texte
      QEvent *e5; // plot

      // les lignes qui stockent le code a afficher
      QString *lignes;
      int compteurligne;

      // sert pour la page 2 // les deplacements
      UCallbackAction returnvaluemotor(const UMessage &);
      UCallbackAction returnvaluemotor2(const UMessage &);
      double value1;
      double value2;  
      int compteurvalue;
      int compteurvalue2;

      // sert pour la page 3 // les capteurs
      UCallbackAction returnvalueir(const UMessage &msg);
      double valueir;

      UCallbackAction returnvaluebumper(const UMessage &msg);
      double valuebumper1;
      double valuebumper2;
      int compteurbumpers;

      UCallbackAction returnvaluebuttons(const UMessage &msg);
      double valuebutton1;
      double valuebutton2;
      int compteurbuttons;

      UCallbackAction returnvaluewalls(const UMessage &msg);
      double valuewall1;
      double valuewall2;
      int compteurwalls;

      UCallbackAction returnvaluecliffs(const UMessage &msg);
      double valuecliff1;
      double valuecliff2;
      double valuecliff3;
      double valuecliff4;
      int compteurcliffs;

      UCallbackAction returnvalueodometry(const UMessage &msg);
      double valueodometry1;
      double valueodometry2;
      double valueodometry3;
      double valueodometry4;
      int compteurodometry;

      UCallbackAction returnvaluebattery(const UMessage &msg);
      QString valuebattery1;
      double valuebattery2;
      double valuebattery3;
      double valuebattery4;
      double valuebattery5;
      double valuebattery6;
      double valuebattery7;
      int compteurbattery;

      // sert pour la page 7 // le terminal de commandes
      UCallbackAction allrecup(const UMessage &); 
      QString texteServeur;
      int musiqueEnCours; // sert pour le nom de stockage des musiques
      int imageEnCours; // sert pour le nom de stockage des images
      unsigned char* buffer2; // stockage image en 24 bits
      unsigned char* buffer2RGB; // stockage image en 32 bits
      QImage image_textbrowser;

      // sert pour la page 8 // les graphes
      UCallbackAction returnvaluevariable(const UMessage &);
      double valueVariableGraph;
      double heure;

      // sert pour la page 9 // les leds
      int devCountLed;
      char ** devicesLeds;
      UCallbackAction returnvalueled(const UMessage &); 
      int valueled1;
      int valueled2;  
      int valueled3;
      int compteurvalueled;

};

#endif

