#include "urbi.h"
#include "tele.h"

#include "urbi_page2.cpp"
#include "urbi_page8.cpp"


ConnectAibo::ConnectAibo(QWidget *parent)
        : QWidget(parent)
{
     robotC = NULL;                           

     lignes = NULL;

     // page 2
     compteurvalue=0;
     compteurvalue2=0;
     compteurvalueeye=0;

     // page 7
     compteurligne=0;

     musiqueEnCours=0;

     imageEnCours=0;
     buffer2 = NULL;
     buffer2RGB=NULL;

     // page 8
     robotG2 = NULL;    

}



/////////////////////////////////////////////////
// Tout Recuperer
//////////////////////////////////////////////////
UCallbackAction ConnectAibo::allrecup(const UMessage &msg) 
{ 

     QString texteServeur2;


	  if (msg.type == MESSAGE_DATA && msg.value->type == urbi::DATA_BINARY) 
	  {

		  if (msg.value->binary->type == urbi::BINARY_IMAGE)
		  {

		      urbi::UImage& img = msg.value->binary->image;


     		    if( img.imageFormat == urbi::IMAGE_JPEG )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image JPEG " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
    		    else if ( img.imageFormat == urbi::IMAGE_YCbCr )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image YCbCr " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
    		    else if ( img.imageFormat == urbi::IMAGE_RGB )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image RGB " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
      		    else if ( img.imageFormat == urbi::IMAGE_PPM )
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image PPM " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }
      		    else
     		    {
     		      texteServeur2 = "[" + QString::number(msg.timestamp);
                  if(QString::fromLatin1(msg.tag.c_str()) != "")
     		        texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str());
     		      texteServeur2 = texteServeur2 + "] " + "Binary Image UNKNOWN " + QString::number(img.size) + " " + QString::number(img.width) + "x" + QString::number(img.height) + "\n" ;
     		    }


    		    if (buffer2 == NULL && buffer2RGB == NULL)
    		    {
    		       buffer2 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
     		       buffer2RGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
     		   }

    		    int width = img.width;
    		    int height = img.height;

    		    // on place l'image dans un objet QImage
    		    QImage image;
    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		    {
    		        image.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
    		    }
     		   else // autres cas
     		   {
     		       if ( img.imageFormat == urbi::IMAGE_YCbCr)
     		           convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer2 );
      		      else if ( img.imageFormat == urbi::IMAGE_RGB)
       		         memcpy(  buffer2, img.data, img.size );
       		     else
        		 memcpy( buffer2, img.data, img.size );
    
        		  // conversion de l'image RGB 24 en RGB 32
           		for(int i=0; i<=width; i++)
           		{
                 		for(int j=0; j<=height; j++)
                 		{
                      			buffer2RGB[(4*i) + (j*width*4) + 0] = buffer2[(3*i) + (j*width*3) + 2];  // bleu
                      			buffer2RGB[(4*i) + (j*width*4) + 1] = buffer2[(3*i) + (j*width*3) + 1];  //vert
                      			buffer2RGB[(4*i) + (j*width*4) + 2] = buffer2[(3*i) + (j*width*3) + 0];  // rouge
                      			buffer2RGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                 		}
           		}    
    
          		// constructs image and fills with data 
          		image=QImage( buffer2RGB, img.width, img.height, QImage::Format_RGB32); // on stocke l'image
        	}

      		// enregistrement de l'image
      		imageEnCours++;
      		image_textbrowser = image.copy();

      		// envoi du signal pour dire que c'est une image
      		e4 = new QEvent((QEvent::Type)(1600));
      		QCoreApplication::postEvent(this,e4);

      		// liberation de la memoire
      		delete buffer2;
      		delete buffer2RGB;
      		buffer2=NULL;
      		buffer2RGB=NULL;

        
	  } // fin de BINARY_IMAGE


  else if (msg.value->binary->type == urbi::BINARY_SOUND)
  {
       urbi::USound& snd = msg.value->binary->sound;

        if( snd.soundFormat == urbi::SOUND_WAV )
        {
            texteServeur2 = "[" + QString::number(msg.timestamp) ;
            if(QString::fromLatin1(msg.tag.c_str()) != "")
              texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
            texteServeur2 = texteServeur2 + "] " + "Binary Sound " + QString::number(snd.size) + " wav" + "\n" ;
        }
        else if ( snd.soundFormat == urbi::SOUND_RAW)       
        {
            texteServeur2 = "[" + QString::number(msg.timestamp) ;
            if(QString::fromLatin1(msg.tag.c_str()) != "")
              texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
             texteServeur2 = texteServeur2 + "] " + "Binary Sound " + QString::number(snd.size) + " raw" + " " + QString::number(snd.channels) + " " + QString::number(snd.rate)  + " "  + QString::number(snd.sampleSize) + " " + QString::number(snd.sampleFormat) + "\n" ;
        }


  } // fin de BINARY_SOUND


	} // fin du DATA_BINARY


  QString tag;
  tag = QString::fromLatin1(msg.tag.c_str() );

  if ( tag == "totowheelL" || tag == "totowheelR" )
     return URBI_CONTINUE;    

  if ( tag == "totowheelL2" || tag == "totowheelR2" )
     return URBI_CONTINUE;    

  if ( tag =="totoeyeL" || tag == "totoeyeR" )
     return URBI_CONTINUE;    


    if(lignes == NULL)
              lignes = new QString [500];

// Message non parse
	if(texteServeur2 == "")
	{
     texteServeur2 = "[" + QString::number(msg.timestamp) ;
     if(QString::fromLatin1(msg.tag.c_str()) != "")
       texteServeur2 = texteServeur2 + ":" + QString::fromLatin1(msg.tag.c_str()) ;
     texteServeur2 = texteServeur2 + "] " + QString::fromLatin1(msg.rawMessage.c_str()) + "\n";
	}


    if (compteurligne >= 0 && compteurligne <= 498)
    {
       lignes[compteurligne] = texteServeur2;
       int valueEvent= 1100 + compteurligne;
       e4 = new QEvent((QEvent::Type)(valueEvent));
       QCoreApplication::postEvent(this,e4);
       compteurligne++;
    }
    else if (compteurligne >= 499 )
    {
       lignes[compteurligne] = texteServeur2;
       int valueEvent= 1100 + compteurligne;
       e4 = new QEvent((QEvent::Type)(valueEvent));
       QCoreApplication::postEvent(this,e4);
       compteurligne=0;
    }


  return URBI_CONTINUE;    

}










///////////////////////////////////////////
// se declenche quand des evenements sont recus
bool ConnectAibo::event(QEvent *ev)
{

 if( ev->type() == (QEvent::Type)(1001)) // position des roues
 {
       pere->neRienFaireAvecLesMoteurs = 1;

       pere->ui.spinBox_2->setValue((int)value1); 
       pere->ui.spinBox_3->setValue((int)value2); 

       pere->ui.horizontalSlider->setValue((int)value1);
       pere->ui.horizontalSlider_2->setValue((int)value2);

       pere->ui.lineEdit_2->setText(QString::number ( value1 ) );
       pere->ui.lineEdit_5->setText(QString::number ( value2 ) );

       pere->neRienFaireAvecLesMoteurs = 0;

 }

 else if( ev->type() == (QEvent::Type)(1002)) // position des roues
 {
       pere->neRienFaireAvecLesMoteurs = 1;

       pere->ui.lineEdit_2->setText(QString::number ( value1 ) );
       pere->ui.lineEdit_5->setText(QString::number ( value2 ) );

       pere->neRienFaireAvecLesMoteurs = 0;
 }

 else if( ev->type() == (QEvent::Type)(1003)) // eyes
 {
       pere->ui.lcdNumber->display(valueeye1); 
       pere->ui.lcdNumber_2->display(valueeye2); 

       pere->ui.progressBar->setValue(valueeye1); 
       pere->ui.progressBar_2->setValue(valueeye2); 
 }

    
 else if( ev->type() >= (QEvent::Type)(1100) && ev->type() <= (QEvent::Type)(1599))
 {
       // on positionne le curseur a la fin
       QTextCursor cursorEnd(pere->ui.textBrowser->textCursor());
       cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
       pere->ui.textBrowser->setTextCursor ( cursorEnd );

       // on definit la couleur rouge
       pere->ui.textBrowser->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 

       // on ajoute le texte
       int num = (int)ev->type();
       pere->ui.textBrowser->insertPlainText( lignes[num-1100] ) ; 

       // on positionne le scrolling a la fin
       int positionMax = pere->ui.textBrowser->verticalScrollBar()->maximum();
       pere->ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
 }



// affichage image
 else if( ev->type() == (QEvent::Type)(1600))
 {
       QTextCursor cursorEnd(pere->ui.textBrowser->textCursor());
       cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
       pere->ui.textBrowser->setTextCursor ( cursorEnd );
       pere->ui.textBrowser->setTextColor(QColor::QColor ( 255, 0, 0 )); // on decide la couleur par defaut 
       QTextDocument *textdocument_image = pere->ui.textBrowser->document();
       int numeroimage = imageEnCours;
       textdocument_image->addResource(QTextDocument::ImageResource, QUrl("image"+QString::number(numeroimage)), image_textbrowser); 
       cursorEnd.insertImage("image"+QString::number(numeroimage));
       QString phrase = "<br>";
       pere->ui.textBrowser->insertHtml( phrase ) ; 
       int positionMax = pere->ui.textBrowser->verticalScrollBar()->maximum();
       pere->ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
 }

// affichage graph variable
 else if( ev->type() == (QEvent::Type)(1603))
 {
       pere->visionGraph2.addValuesVariable(valueVariableGraph,heure/1000);
 }
 else if( ev->type() == (QEvent::Type)(1604))
 {
        pere->arretDuGraphVariable(); // on desactive la fenetre du graph  
 }

 return 1;
}
