function urbiDemoSynchronous(name)


disp('Connecting to the aibo :');
disp([' - > aibo = urbiConnect(' name ');']);
aibo = urbiConnect(name);
urbiClearConnection(aibo);
disp(sprintf('please press return to go forward\n')) ;
pause

disp('');
disp('Getting headPan.val value :');
disp(' - > v = urbiGetDeviceField(aibo, ''headPan.val'')');
v = urbiGetDeviceField(aibo, 'headPan.val')
disp('Getting simultaneously headPan.val and headTilt.val values');
disp(' - > V = urbiGetDevicesFields(aibo, {''headPan.val'', ''headTilt.val''})');
V = urbiGetDevicesFields(aibo, {'headPan.val', 'headTilt.val'})
disp(sprintf('please press return to go forward\n')) ;
pause

disp('Setting a=4 on urbi server :');
disp(' -> setDeviceField(aibo, ''a'', 4);');
urbiSetDeviceField(aibo, 'a', 4); 
disp('Setting simultaneously b=1 and c=2 :');
disp(' - > setDevices(aibo, {''b'', ''c''}, [1, 2]);');
urbiSetDevicesFields(aibo, {'b', 'c'}, [1, 2]);
disp(sprintf('please press return to go forward\n')) ;
pause

disp('Getting simultaneously a,b and c values :');
disp(' - > urbiGetDevicesFields(aibo, {''a'', ''b'', ''c''})');
urbiGetDevicesFields(aibo, {'a', 'b', 'c'})
disp(sprintf('please press return to go forward\n')) ;
pause


disp('Getting an image :');
disp(' - > [matrix, width, height, time] = getAiboImage(aibo)');
[matrix, width, height, time] = urbiGetImage(aibo);
disp('Displaying it :');
disp(' - > imshow(matrix);');
imshow(matrix);
disp(sprintf('please press return to go forward\n')) ;
pause

disp ('Playing a sound from the aibo stick :');
disp (' - > urbiPlayWavLocal(aibo, ''test.wav'') ;');
urbiPlayWavLocal(aibo, 'test.wav') ; 
disp(sprintf('please press return to go forward\n')) ;
pause

disp ('Playing a sound sent from the current matlab dir :');
disp ('- > urbiPlayWavRemote(aibo, ''libUrbi.wav'') ;');
urbiPlayWavRemote(aibo, 'libUrbi.wav') ; 
disp(sprintf('please press return to go forward\n')) ;
pause

disp ('Sending balltrackinghead.u script. Move the pink ball in front of aibo !');
disp(' - > urbiSendFile(aibo,''balltrackinghead.u'');');
urbiSendFile(aibo,'balltrackinghead.u');
disp(sprintf('please press return to go forward\n')) ;
pause


urbiSend(aibo,'stopall;');
disp('End of the demo... Closing urbi connection :');
disp(' - > urbiDisconnect(aibo);');
urbiDisconnect(aibo);