function con = urbiConnect(name, port)
%Opens a connection to the URBI server and returns the ID of the connection
% e.g. con = urbiConnect('101.1.1.1', 54000);

if (nargin <1)
    error('urbiConnect(name, port)\n name : IP or name of the urbi server\n port : port of the urbi server (def : 54000)',1);
end

if (nargin == 1)
    port= 54000;
end

con = pnet('tcpconnect', name, port);

if ( con > -1) 
    urbiClearConnection(con); 
else
    error('Connection failed on port %d' , port);
end
