function urbiDeleteCallBack(con, callBackID)
%Remove the specified callback
% This function removes a callback from the list of the callbacks processed
% by the urbiProcessEvent function.

if (nargin ~= 2)
    error('urbiDeleteCallBack(con, callBackID)\n con : connection to urbi server\n callBackID : id of the callBack',1);
end

global Internal_Call_Back_Array Internal_Call_Back_connections

n = size(Internal_Call_Back_Array{con + 1}, 1);
for i=1:n
    Array = Internal_Call_Back_Array{con + 1};
    S = Array(i);
    if (S.id == callBackID)
        head = Array (1:i-1);
        tail = Array (i+1:n);
        Internal_Call_Back_Array{con + 1} = [ head ; tail ];
        % No callBack on this connection -> retrieve con
        if (size(Internal_Call_Back_Array{con + 1}, 1) == 0)
            n = size(Internal_Call_Back_connections, 2);
            for j=1:n
                if (Internal_Call_Back_connections(j) == con)
                    head = Internal_Call_Back_connections (1:j-1);
                    tail = Internal_Call_Back_connections (i+j:n);
                    Internal_Call_Back_connections = [head tail];
                    return;
                end;
            end;
        end;
        return;
    end;
end;

error('Callback %d is not defined', callBackID);
