function [v, time] = urbiGetDeviceField(con, deviceAndField)
% Read a device field or a variable value
% e.g. v = getDeviceField(con, 'headPan.val');

urbiClearConnection(con,1);
tag_base = 'gdftag';
% Uses tag to choose the right answer among results
% Note requested results outputed before are lost
urbiSend(con, [tag_base ':' deviceAndField ';']);

o_tag = '';
while ~strcmp (o_tag, tag_base)
    r = pnet(con, 'readline', 'noblock');
    while isempty(r)
        r = pnet(con, 'readline', 'noblock');
    end;
    ans_string = strread (r, '%s');
    [timeStamp, o_tag] = strread(ans_string{1}, '[%u:%s]', 'whitespace', ']');
end;
v = str2num(ans_string{2});
time = timeStamp;
