function [matrix, width, height, time] = urbiGetImage(con,deviceName)
% Gets the current image from the urbi server  (default device : camera)
% This function gets the image from the specified device, or from the
% device "camera" if it is not specified
% The parameters for the camera have to set by the user with urbiSend
%
% This function returns :
%   matrix = matrix of the image (display with imshow(matrix);)
%   width, height = size of the image
%   time = time at which the image was taken by the robot


if (nargin == 1)
  deviceName='camera';
end

io_buffer = 'imageB.jpg';
urbiSend(con, [ deviceName ';']);
type = 'nothing' ;
while ~strcmp(type, 'BIN')
    r = pnet(con, 'readline');
    if (~isempty(r))
        [timeStamp, tag, typeTmp, rnum, rstring] = urbiParse(r) ;
        type = typeTmp ;
    end;
end;
[timeStamp, tag, type, rnum, rstring] = urbiParse(r) ;
width = sscanf(rstring{5}, '%u');
height = sscanf(rstring{6}, '%u');
nbytes = sscanf(rstring{3}, '%u') ;
pnet(con, 'readtofile', io_buffer, nbytes) ;
matrix = imread(io_buffer) ;
time = timeStamp;
