function [timeStamp, tag, type, rnum, rstring] = urbiParse(message)
% Parse messages from the URBI server
% This function parses messages comming from the server, however binary
% strings are not read nor converted to the corresponding object and should
% therefore be processed by the user. 
% Use urbiFullParse if you need the full message processing.


 string = strread(message, '%s') ;

 %keyboard;
 [timeStamp, tag] = strread(string{1}, '[%u:%s]', 'whitespace', ']') ;

 f = sscanf(string{2}, '%f') ;
 s = sscanf(string{2}, '%s') ;

 if ~isempty(f)
     type =  'numeric';
     rnum = f;
     rstring = '';
 else
     if strcmp(s, 'BIN')
        type = 'BIN';
        rnum = 0 ;
        rstring = string ;
    else
        if strcmp(s, '***')
            type = 'system';
            rnum = 0 ;
            rstring = string ;
        else
            type = 'string';
            rnum = 0 ;
            rstring = s ;
        end
    end
end ;

