#ifndef TELE_H
#define TELE_H

#include "ui_telecommande.h"
#include "urbi.h"
#include "plot.h"
#include <QWidget>
#include <QtGui>

#include <QMainWindow>

class Telecommande : public QMainWindow
{
    Q_OBJECT

public:
    ConnectAibo urbiTele; // connexion URBI
    Plot visionGraph2; // fenetre pour afficher les graphs d'une variable

    Telecommande(QWidget *parent = 0);
    Telecommande *pointeur;

    int neRienFaireAvecLesMoteursA; // sert pour la page 3
    int neRienFaireAvecLesMoteursB; // sert pour la page 3
    int neRienFaireAvecLesMoteursC; // sert pour la page 3

    Ui::Telecommande ui;

    void arretDuGraph(); // sert pour la page 8
    void arretDuGraphVariable(); // sert pour la page 8

private slots:

    // sert pour la page 1 ==> connexion
    void on_lineEdit_returnPressed(); 
    void on_pushButton_clicked();
    void on_pushButton_2_clicked();
    void on_pushButton_3_clicked();
    void on_pushButton_4_clicked();
    void on_pushButton_5_clicked();
    void on_pushButton_6_clicked();
    void on_pushButton_13_clicked();
    void on_pushButton_20_clicked();
    void on_pushButton_21_clicked();
    void on_pushButton_22_clicked();
    void on_pushButton_23_clicked();
    void on_pushButton_24_clicked();
    void on_pushButton_25_clicked();
    void on_pushButton_26_clicked();
    void on_pushButton_27_clicked();    
    void on_pushButton_28_clicked();    
    void on_pushButton_94_clicked();   
    void on_pushButton_98_clicked();   //group
    void on_pushButton_99_clicked();   //strict
    void on_pushButton_100_clicked();   //unstrict




    // sert pour la page 2 ==> functions
    void on_pushButton_14_clicked(); // niveau d'energie
    void on_pushButton_15_clicked(); // beeper

    // sert pour la page 3 ==> motors
   // delplace du robot, indication des roues et des bumpers
    void on_pushButton_77_clicked(); // on avance
    void on_pushButton_78_clicked(); // on tourne a gauche
    void on_pushButton_79_clicked(); // on tourne a droite
    void on_pushButton_80_clicked(); // on recule
    void on_pushButton_81_clicked(); // on s'arrete
    void on_spinBox_4_valueChanged ( int i );  // motor A
    void on_spinBox_5_valueChanged ( int i );   // motor B
    void on_spinBox_6_valueChanged ( int i );   // motor C
    void on_horizontalSlider_3_valueChanged();  // motor A
    void on_horizontalSlider_4_valueChanged();  // motor B
    void on_horizontalSlider_5_valueChanged();  // motor C

    void on_pushButton_16_clicked(); // motor A
    void on_pushButton_17_clicked(); // motor B
    void on_pushButton_18_clicked(); // motor C


    // sert pour la page 4 ==> sensors
    void on_pushButton_7_clicked(); // sonar
    void on_pushButton_8_clicked(); // light
    void on_pushButton_9_clicked(); // decibel
    void on_pushButton_11_clicked(); // bumper

    // sert pour la page 5 ==> envois de fichiers
    void on_pushButton_86_clicked();
    void on_pushButton_87_clicked();
    void on_pushButton_88_clicked();
    void on_pushButton_89_clicked();
    void on_pushButton_90_clicked();
    void on_pushButton_91_clicked();

    // sert pour la page 7 ==> terminal
    void on_pushButton_82_clicked();
    void on_comboBox_5_returnPressed(); 
    void on_comboBox_5_editTextChanged(const QString & text ); 


    // sert pour la page 8 ==> graph
    void on_pushButton_96_clicked();
    void on_pushButton_97_clicked();
 

};

#endif

