#ifndef URBI_H
#define URBI_H

#include <urbi/uclient.hh>
#include <QWidget>
#include <QtGui>

using namespace urbi;

class Telecommande;

class ConnectAibo : public QWidget
{
    Q_OBJECT

public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotC; // communication des commandes
      UClient *robotI; // transfert des images
      UClient *robotG2; // graph d'une variable

      // lien pour acceder aux objets de telecommande
      Telecommande *pere;
      Telecommande *pereGraph;

      // les evenements servent pour l'affichage a l'ecran
      virtual bool event(QEvent *ev);
      QEvent *e1; // bumpers et roues
      QEvent *e2; // sonars
      QEvent *e3; // lasers
      QEvent *e4; // affichage texte
      QEvent *e5; // plot

      // les lignes qui stockent le code a afficher
      QString *lignes;
      int compteurligne;

      // sert pour la page 2 // function
      UCallbackAction returnvaluebattery(const UMessage &);
      int valuebattery;


      // sert pour la page 3 // motors
      UCallbackAction returnvaluemotorA(const UMessage &);
      UCallbackAction returnvaluemotorB(const UMessage &);
      UCallbackAction returnvaluemotorC(const UMessage &);
      UCallbackAction returnvaluemotorA2(const UMessage &);
      UCallbackAction returnvaluemotorB2(const UMessage &);
      UCallbackAction returnvaluemotorC2(const UMessage &);
      int valuemotorA;
      int valuemotorB;
      int valuemotorC;
      int valuemotorA2;
      int valuemotorB2;
      int valuemotorC2;


      // sert pour la page 4 // sensors
      UCallbackAction returnvaluesonar(const UMessage &);
      int valuesonar;

      UCallbackAction returnvaluelight(const UMessage &);
      int valuelight;

      UCallbackAction returnvaluedecibel(const UMessage &);
      int valuedecibel;

      UCallbackAction returnvaluebumper(const UMessage &);
      int valuebumper;

      // sert pour la page 7
      UCallbackAction allrecup(const UMessage &); 
      QString texteServeur;
      int musiqueEnCours; // sert pour le nom de stockage des musiques
      int imageEnCours; // sert pour le nom de stockage des images
      unsigned char* buffer2; // stockage image en 24 bits
      unsigned char* buffer2RGB; // stockage image en 32 bits
      QImage image_textbrowser;

      // sert pour la page 8
      UCallbackAction returnvaluevariable(const UMessage &);
      double valueVariableGraph;
      double heure;
};

#endif

