#ifndef URBI_H
#define URBI_H

#include <urbi/uclient.hh>
#include <QWidget>
#include <QtGui>

using namespace urbi;

class Telecommande;

class ConnectAibo : public QWidget
{
    Q_OBJECT

public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotC; // communication des commandes
      UClient *robotI; // transfert des images
      UClient *robotG2; // graph d'une variable

      // lien pour acceder aux objets de telecommande
      Telecommande *pere;
      Telecommande *pereGraph;

      // les evenements servent pour l'affichage a l'ecran
      virtual bool event(QEvent *ev);
      QEvent *e1; // bumpers et roues
      QEvent *e2; // sonars
      QEvent *e3; // lasers
      QEvent *e4; // affichage texte
      QEvent *e5; // plot

      // les lignes qui stockent le code a afficher
      QString *lignes;
      int compteurligne;


      // sert pour la page 2 // bumpers
      UCallbackAction returnvaluebumpers(const UMessage &);
      int valuebumper1;
      int valuebumper2;  
      int valuebumper3;  
      int compteurvaluebumper;

      UCallbackAction returnvaluemotor(const UMessage &);
      UCallbackAction returnvaluemotor2(const UMessage &);
      double value1;
      double value2;  
      double value3;
      double value4;  
      int compteurvalue;
      int compteurvalue2;


      // sert pour la page 3 // sonars
      unsigned char* buffer;
      unsigned char* bufferRGB; 
      int traitementEnCours;
      QImage imageQT;
      QImage imageQT2;
      int captureImage;
      UCallbackAction returnvaluesonars(const UMessage &);
      double *valuesonars;

      // sert pour la page 4 // lasers
      UCallbackAction returnvaluelasers(const UMessage &);
      UCallbackAction returnvaluelasers2(const UMessage &);
      double *valuelasers;
      double lasercount;
      double laseranglemin;
      double laseranglemax;
      QImage imagelaserclean;
      QImage imagelaserclean2;
      QPointF *pointslaser;

      // sert pour la page 7
      UCallbackAction allrecup(const UMessage &); 
      QString texteServeur;
      int musiqueEnCours; // sert pour le nom de stockage des musiques
      int imageEnCours; // sert pour le nom de stockage des images
      unsigned char* buffer2; // stockage image en 24 bits
      unsigned char* buffer2RGB; // stockage image en 32 bits
      QImage image_textbrowser;

      // sert pour la page 8
      UCallbackAction returnvaluevariable(const UMessage &);
      double valueVariableGraph;
      double heure;
};

#endif

