
///////////////////////////////////////////
// Lancement de la camera
void Telecommande::on_pushButton_83_clicked()
{
     if(urbiTele.robotC != NULL)
     {
         // on affiche la camera
         visionCamera.show();

         // recuperation des donnes du nom et du port
         QSettings settings("Pioneer2 Telecommande", "GOSTAI");
         QString robotName = settings.value("robotname").toString();
         int robotPort = settings.value("robotport").toInt();

         // connexion
         if( urbiTele.robotI != NULL)
         {
             urbiTele.robotI->send("stop uimg;");
             urbiTele.robotI->send(";;;; quit;");
             urbiTele.robotI->send("noop;");
             urbiTele.robotI->send("noop;");
             delete urbiTele.robotI;

             // reinitialisation des variables
             urbiTele.traitementEnCours2 = 0;
             urbiTele.captureImage2 = 0;
         }
         urbiTele.robotI = NULL;
         urbiTele.robotI =new UClient( robotName.toLatin1() , robotPort );

         if (!urbiTele.robotI->error())
         {
                 urbiTele.robotI->send("stop uimg;");
                 urbiTele.robotI->setCallback(callback(urbiTele,&ConnectAibo::urbiimage), "uimg");
                 QString frequency = ui.lineEdit_10->text();
                 QString Camera_Active = "uimg:every(" + frequency + "ms){ uimg << " + ui.lineEdit_9->text() + "},";
                 urbiTele.robotI->send("%s", (const char *) Camera_Active.toLatin1());
         }
     }
} 


///////////////////////////////////////////
// Arret de la camera
void Telecommande::on_pushButton_92_clicked()
{
         // on cache la camera
         visionCamera.hide();

         // connexion
         if( urbiTele.robotI != NULL)
         {
             urbiTele.robotI->send("stop uimg;");
             urbiTele.robotI->send(";;;; quit;");
             urbiTele.robotI->send("noop;");
             urbiTele.robotI->send("noop;");
             delete urbiTele.robotI;
             urbiTele.robotI = NULL;

             // reinitialisation des variables
             urbiTele.traitementEnCours2 = 0;
             urbiTele.captureImage2 = 0;
         }

} 

///////////////////////////////////////////
// Arret de la camera
void Telecommande::arretDeLaCamera()
{
         // connexion
         if( urbiTele.robotI != NULL)
         {
             urbiTele.robotI->send("stop uimg;");
             urbiTele.robotI->send(";;;; quit;");
             urbiTele.robotI->send("noop;");
             urbiTele.robotI->send("noop;");
             delete urbiTele.robotI;
             urbiTele.robotI = NULL;

             // reinitialisation des variables
             urbiTele.traitementEnCours2 = 0;
             urbiTele.captureImage2 = 0;
         }

} 



///////////////////////////////////////////
// Rcuperer les valeurs de la camera
void Telecommande::on_pushButton_11_clicked()
{
    if(urbiTele.robotC != NULL)
    {
    	    urbiTele.robotC->send("stop totovaluesdecamera;");
    	    urbiTele.robotC->send("totovaluesdecamera:loop { totoanglecameratilt2 << camera.tilt & totoanglecamerapan2 << camera.pan & totozoomcamera2 << camera.zoom },");

            // creation de la couleur verte
            QColor couleur ( 0, 255, 0 ); 
            // application de la couleur sur le bouton connexion
            ui.pushButton_11->setPalette(couleur);
    }

}




///////////////////////////////////////////
// Modif de la valeur de angle tilt camera
void Telecommande::on_spinBox_4_valueChanged ( int i )
{
    if(urbiTele.robotC != NULL && neRienFaireAvecLesMoteurs == 0)
    {
           neRienFaireAvecLesMoteurs = 1;

           ui.horizontalSlider_3->setValue(i);

           QString value = QString::number(i);
           value="camera.tilt=" +value +";";
           urbiTele.robotC->send("%s", (const char *) value.toLatin1());  
           value = "[Send] " + value + "\n";
           QTextCursor cursorEnd(ui.textBrowser->textCursor());
           cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
           ui.textBrowser->setTextCursor ( cursorEnd );
           ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
           ui.textBrowser->insertPlainText( value ); 
           
           neRienFaireAvecLesMoteurs = 0;
    }
    
}    

///////////////////////////////////////////
// Modif de la valeur de angle tilt camera
void Telecommande::on_horizontalSlider_3_valueChanged()
{
    if(urbiTele.robotC != NULL && neRienFaireAvecLesMoteurs == 0)
    {
           neRienFaireAvecLesMoteurs = 1;

           ui.spinBox_4->setValue( ui.horizontalSlider_3->value() );     

           int i = ui.horizontalSlider_3->value();
           QString value = QString::number(i);
           value="camera.tilt=" +value +";";
           urbiTele.robotC->send("%s", (const char *) value.toLatin1());  
           value = "[Send] " + value + "\n";
           QTextCursor cursorEnd(ui.textBrowser->textCursor());
           cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
           ui.textBrowser->setTextCursor ( cursorEnd );
           ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
           ui.textBrowser->insertPlainText( value ); 
           
           neRienFaireAvecLesMoteurs = 0;
    }

}    


///////////////////////////////////////////
// Modif de la valeur de angle pan camera
void Telecommande::on_spinBox_5_valueChanged ( int i )
{
    if(urbiTele.robotC != NULL && neRienFaireAvecLesMoteurs == 0)
    {
           neRienFaireAvecLesMoteurs = 1;

           ui.horizontalSlider_4->setValue(i);

           QString value = QString::number(i);
           value="camera.pan=" +value +";";
           urbiTele.robotC->send("%s", (const char *) value.toLatin1());  
           value = "[Send] " + value + "\n";
           QTextCursor cursorEnd(ui.textBrowser->textCursor());
           cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
           ui.textBrowser->setTextCursor ( cursorEnd );
           ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
           ui.textBrowser->insertPlainText( value ); 
           
           neRienFaireAvecLesMoteurs = 0;
    }
    
}    

///////////////////////////////////////////
// Modif de la valeur de angle pan camera
void Telecommande::on_horizontalSlider_4_valueChanged()
{
    if(urbiTele.robotC != NULL && neRienFaireAvecLesMoteurs == 0)
    {
           neRienFaireAvecLesMoteurs = 1;

           ui.spinBox_5->setValue( ui.horizontalSlider_4->value() );     

           int i = ui.horizontalSlider_4->value();
           QString value = QString::number(i);
           value="camera.pan=" +value +";";
           urbiTele.robotC->send("%s", (const char *) value.toLatin1());  
           value = "[Send] " + value + "\n";
           QTextCursor cursorEnd(ui.textBrowser->textCursor());
           cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
           ui.textBrowser->setTextCursor ( cursorEnd );
           ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
           ui.textBrowser->insertPlainText( value ); 
           
           neRienFaireAvecLesMoteurs = 0;
    }

}    

///////////////////////////////////////////
// Modif de la valeur de zoom camera
void Telecommande::on_spinBox_6_valueChanged ( int i )
{
    if(urbiTele.robotC != NULL && neRienFaireAvecLesMoteurs == 0)
    {
           neRienFaireAvecLesMoteurs = 1;

           ui.horizontalSlider_5->setValue(i);

           QString value = QString::number(i);
           value="camera.zoom=" +value +";";
           urbiTele.robotC->send("%s", (const char *) value.toLatin1());  
           value = "[Send] " + value + "\n";
           QTextCursor cursorEnd(ui.textBrowser->textCursor());
           cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
           ui.textBrowser->setTextCursor ( cursorEnd );
           ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
           ui.textBrowser->insertPlainText( value ); 
           
           neRienFaireAvecLesMoteurs = 0;
    }
    
}    

///////////////////////////////////////////
// Modif de la valeur de zoom camera
void Telecommande::on_horizontalSlider_5_valueChanged()
{
    if(urbiTele.robotC != NULL && neRienFaireAvecLesMoteurs == 0)
    {
           neRienFaireAvecLesMoteurs = 1;

           ui.spinBox_6->setValue( ui.horizontalSlider_5->value() );     

           int i = ui.horizontalSlider_4->value();
           QString value = QString::number(i);
           value="camera.zoom=" +value +";";
           urbiTele.robotC->send("%s", (const char *) value.toLatin1());  
           value = "[Send] " + value + "\n";
           QTextCursor cursorEnd(ui.textBrowser->textCursor());
           cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
           ui.textBrowser->setTextCursor ( cursorEnd );
           ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
           ui.textBrowser->insertPlainText( value ); 
           
           neRienFaireAvecLesMoteurs = 0;
    }

}    


