///////////////////////////////////////////
// Lancement de la fenetre graph
void Telecommande::on_pushButton_96_clicked()
{
     if(urbiTele.robotC != NULL)
     {
         // On recupere le nom de la variable que l'on veut grapher
         QString variableName = ui.lineEdit_3->text();
	 if(variableName == "")
		return;

         // on affiche la fenetre de graph
         visionGraph2.resize(600,600);
         QString titleWindowsGraph = "Pioneer2 Graph Variable \"" +  variableName + "\"";
         visionGraph2.setTitle( titleWindowsGraph );   
         visionGraph2.show();

         // recuperation des donnes du nom et du port
         QSettings settings("Pioneer2 Telecommande", "GOSTAI");
         QString robotName = settings.value("robotname").toString();
         int robotPort = settings.value("robotport").toInt();


         // connexion
         if( urbiTele.robotG2 != NULL)
	{
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             visionGraph2.videPlotVariable( ); // on libere la memoire
	}
         urbiTele.robotG2 = NULL;
         urbiTele.robotG2 =new UClient( robotName.toLatin1() , robotPort );


        if (!urbiTele.robotG2->error())
        {
           setlocale(LC_NUMERIC,"C");
           urbiTele.pereGraph=pointeur;

            // on indique combien de temps doit durer l'enregistrement.
            visionGraph2.pointsAAfficher = ui.spinBox_26->value() ;

           // recuperation de la valeur de la variable
           if (variableName != "")
           {
                urbiTele.robotG2->setCallback(callback(urbiTele,&ConnectAibo::returnvaluevariable),"graphvar");
                QString frequency = ui.lineEdit_7->text();
                QString phrase_Variable = "graph:every(" + frequency + "ms) {  graphvar << " + variableName  + " },";
           	    urbiTele.robotG2->send("%s", (const char *) phrase_Variable.toLatin1());
            }
    
        }


     }
} 



///////////////////////////////////////////
// Arret du graph
void Telecommande::on_pushButton_97_clicked()
{
         visionGraph2.hide();

         if( urbiTele.robotG2 != NULL)
         {
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             urbiTele.robotG2 = NULL;
             visionGraph2.videPlotVariable( ); // on libere la memoire

             // on redimensionne la fenetre
             visionGraph2.setAxisScale(QwtPlot::xBottom, -2, 2);
             visionGraph2.setAxisScale(QwtPlot::yLeft, -2, 2);
             visionGraph2.valmax = 666;
             visionGraph2.valmin = -666;
         }

} 

///////////////////////////////////////////
// Arret du graph
void Telecommande::arretDuGraphVariable()
{
         if( urbiTele.robotG2 != NULL)
         {
             urbiTele.robotG2->send("stop graph;");
             urbiTele.robotG2->send("stop graphvar;");
             urbiTele.robotG2->send(";;;; quit;");
             urbiTele.robotG2->send("noop;");
             urbiTele.robotG2->send("noop;");
             delete urbiTele.robotG2;
             urbiTele.robotG2 = NULL;
             visionGraph2.videPlotVariable( ); // on libere la memoire

             // on redimensionne la fenetre
             visionGraph2.setAxisScale(QwtPlot::xBottom, -2, 2);
             visionGraph2.setAxisScale(QwtPlot::yLeft, -2, 2);
             visionGraph2.valmax = 666;
             visionGraph2.valmin = -666;
         }

} 


