
UCallbackAction ConnectAibo::urbiimage(const UMessage &msg) 
{


  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_BINARY || msg.value->binary->type != urbi::BINARY_IMAGE)
    return URBI_CONTINUE;

 if(traitementEnCours2 == 0)
 {
      traitementEnCours2 = 1;
	urbi::UImage& img = msg.value->binary->image;

    		    int width = img.width;
    		    int height = img.height;


      if (buffer3 == NULL && buffer3RGB == NULL)
      {
    		       buffer3 = new unsigned char[img.width * img.height * 3 * 5]; // 24 bits
     		       buffer3RGB = new unsigned char[img.width * img.height * 4 * 5];  // 32 bits
      }


    		    if( img.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
    		    {
    		        imageQT3.loadFromData ( (const uchar *) img.data, img.size, "JPEG" );
    		    }
     		   else // autres cas
     		   {
     		       if ( img.imageFormat == urbi::IMAGE_YCbCr)
     		           convertYCrCbtoRGB( (const byte *) img.data, img.size, (byte*) buffer3 );
      		      else if ( img.imageFormat == urbi::IMAGE_RGB)
       		         memcpy(  buffer3, img.data, img.size );
       		     else
        		 memcpy( buffer3, img.data, img.size );
        
              // conversion de l'image RGB 24 en RGB 32
               for(int i=0; i<=width; i++)
               {
                     for(int j=0; j<=height; j++)
                     {
                          buffer3RGB[(4*i) + (j*width*4) + 0] = buffer3[(3*i) + (j*width*3) + 2];  // bleu
                          buffer3RGB[(4*i) + (j*width*4) + 1] = buffer3[(3*i) + (j*width*3) + 1];  //vert
                          buffer3RGB[(4*i) + (j*width*4) + 2] = buffer3[(3*i) + (j*width*3) + 0];  // rouge
                          buffer3RGB[(4*i) + (j*width*4) + 3] = 0;        // vide
                     }
               }    
        
               // copie de l'image dans QImage
              imageQT3=QImage( buffer3RGB, width, height, QImage::Format_RGB32 ); // on stocke l'image
        }

      // on recupere la largeur et la hauteur
      int widthLabel = pere->visionCamera.ui.label->width();
      int heightLabel  = pere->visionCamera.ui.label->height();

      if( heightLabel < (widthLabel * height / width) )
          imageQT4 = imageQT3.scaledToHeight ( heightLabel - 2 );          // on double la taille
      else if( widthLabel < (heightLabel * width / height) )
          imageQT4 = imageQT3.scaledToWidth ( widthLabel - 2 );          // on double la taille
      else 
          imageQT4 = imageQT3;
  

      if(captureImage2 == 1)
      {
                 QString nameFile="image_000.jpg";
                 QFile test;
                 QString number;
                 int j=10000;
                 for(int i=1 ; i<j ; i++)
                 {    
                                  number.setNum(i);
                                  if(i < 10)
                                       nameFile = "image_000" + number + ".jpg"; 
                                  else if(i < 100)
                                       nameFile = "image_00" + number + ".jpg"; 
                                  else if(i < 1000)
                                       nameFile = "image_0" + number + ".jpg";                                        
                                  else if(i < 10000)
                                       nameFile = "image_" + number + ".jpg";    
                                  test.setFileName(nameFile);
                                  if( !test.exists() )
                                      break;
                 }

                 imageQT3.save(nameFile,"JPG",100);
                 captureImage2 = 0;           
      }



       // on verifie que la fenetre est bien visible
       if (pere->visionCamera.isHidden() == 1)
       {
           e6 = new QEvent((QEvent::Type)(1007));
           QCoreApplication::postEvent(this,e6);  // on affiche l'image           
           delete buffer3; // on libere la memoire
           delete buffer3RGB;
           buffer3 = NULL;
           buffer3RGB=NULL;
       }
       else
       {
           e6 = new QEvent((QEvent::Type)(1006));
           QCoreApplication::postEvent(this,e6);  // on affiche l'image
       }

      
      traitementEnCours2 = 0;
  }



  return URBI_CONTINUE;
}



UCallbackAction ConnectAibo::returnvaluedecamera(const UMessage &msg) 
{

  if (msg.type != MESSAGE_DATA || msg.value->type != urbi::DATA_DOUBLE)
    return URBI_CONTINUE;

  QString tag = QString::fromLatin1(msg.tag.c_str());
  double value = (double) msg.value->val;

    if( tag == "totoanglecameratilt2")
        valueangletiltcamera=value;
    else if( tag == "totoanglecamerapan2")
        valueanglepancamera=value;
    else if( tag == "totozoomcamera2")
        valuezoomcamera=value;

    compteurvaluedecamera++;

  if( compteurvaluedecamera == 0)
  {

      e1 = new QEvent((QEvent::Type)(1008));
      QCoreApplication::postEvent(this,e1);

       compteurvaluedecamera = 0;
  }


  return URBI_CONTINUE;

}
