#ifndef URBI_H
#define URBI_H



#include <urbi/uclient.hh>
#include <QWidget>
#include <QtGui>

using namespace urbi;

class Telecommande;

class ConnectAibo : public QWidget
{
    Q_OBJECT

public:
      ConnectAibo(QWidget *parent = 0);
      UClient *robotC; // communication des commandes
      UClient *robotI; // transfert des images
      UClient *robotG2; // graph d'une variable

      // lien pour acceder aux objets de telecommande
      Telecommande *pere;
      Telecommande *pereGraph;

      // les evenements servent pour l'affichage a l'ecran
      virtual bool event(QEvent *ev);
      QEvent *e1; // bumpers et roues
      QEvent *e2; // sonars
      QEvent *e3; // lasers
      QEvent *e4; // affichage texte
      QEvent *e5; // plot

      // les lignes qui stockent le code a afficher
      QString *lignes;
      int compteurligne;

      // sert pour la page 2 // fonctions de deplacement
      UCallbackAction returnvaluemotor(const UMessage &);
      UCallbackAction returnvaluemotor2(const UMessage &);
      double value1;
      double value2;  
      int compteurvalue;
      int compteurvalue2;

      // sert pour la page 3 // autres fonctions
      UCallbackAction returnvalueirsensors(const UMessage &);
      int valueir1;
      int valueir2;
      int valueir3;
      int valueir4;
      int compteurvalueirsensors;

      UCallbackAction returnvaluebattery(const UMessage &);
      int valuebattery;

      // sert pour la page 6 // fonctions de vision
      UCallbackAction urbiimage(const UMessage &);
      unsigned char* buffer;
      unsigned char* bufferRGB; 
      int traitementEnCours;
      QImage imageQT;
      QImage imageQT2;
      int captureImage;

      UCallbackAction returnvalueanglecamera(const UMessage &);
      int valueanglecamera;


      // sert pour la page 7
      UCallbackAction allrecup(const UMessage &); 
      QString texteServeur;
      int musiqueEnCours; // sert pour le nom de stockage des musiques
      int imageEnCours; // sert pour le nom de stockage des images
      unsigned char* buffer2; // stockage image en 24 bits
      unsigned char* buffer2RGB; // stockage image en 32 bits
      QImage image_textbrowser;

      // sert pour la page 8
      UCallbackAction returnvaluevariable(const UMessage &);
      double valueVariableGraph;
      double heure;
};



#endif

