#include "tele.h"

#include "tele_page1.cpp"
#include "tele_page5.cpp"
#include "tele_page7.cpp"


///////////////////////////////////////////
// Creation de l'objet
Telecommande::Telecommande(QWidget *parent)
        : QMainWindow(parent)
{
        ui.setupUi(this);

        // copie des pointeurs
       setlocale(LC_NUMERIC,"C");
       urbiTele.pere=pointeur;

        // sert pour le terminal
        connect( ui.comboBox_5->lineEdit(), SIGNAL(returnPressed()), this, SLOT(_on_comboBox_5_returnPressed()) );

       // on supprime l'auto complementation quand on tape du texte
       QCompleter * completer = 0;
       ui.comboBox_5->setCompleter ( completer );
       ui.comboBox_5->lineEdit()->setCompleter ( completer );

       // on permet les doublons
       ui.comboBox_5->setDuplicatesEnabled(1);
}


///////////////////////////////////////////////////
// MENU
///////////////////////////////////////////////////

void Telecommande::on_actionConfiguration_triggered()
{
   // recuperation de l'IP
   QSettings settings("URBI Surveyor Console", "GOSTAI");
   QString robotName = settings.value("robotname").toString();
   if(robotName == "")
        robotName = "localhost";
 
    bool ok;
    QString text;
    text = QInputDialog::getText(this, tr("IP Configuration"),
                                         tr("Name or IP of the robot :"), QLineEdit::Normal,
                                         robotName, &ok);
    if (ok && !text.isEmpty())
    {
        settings.setValue("robotname", text);
        settings.sync ();
    }

}

void Telecommande::on_actionPort_Configuration_triggered()
{
   QSettings settings("URBI Surveyor Console", "GOSTAI");
   int robotPort = settings.value("robotport").toInt();
   QString robotName = settings.value("robotname").toString();
   if(robotName == "")
        robotPort = 54000;

    bool ok;
    int i;
    i = QInputDialog::getInteger(this, tr("Port Configuration"),
                                     tr("Port of Connection :"), robotPort, 0, 1000000, 1, &ok);

    if (ok)
    {
        settings.setValue("robotport", i);
        settings.sync ();
    }

}


void Telecommande::on_actionExit_triggered()
{
    this->close();
}

