

///////////////////////////////////////////
// Slection du fichier URBI
void Telecommande::on_pushButton_86_clicked()
{
    QString openFilesPath;

    QStringList files = QFileDialog::getOpenFileNames(
                                this, tr("QFileDialog::getOpenFileNames()"),
                                openFilesPath,
                                tr("URBI File (*.u);; Text File (*.txt)"));
    if (files.count()) 
    {
        openFilesPath = files[0];
        ui.label_53->setText(openFilesPath);        // affichage du fichier selectionne


    // affichage sur l'ecran en dessous
          ui.textBrowser_2->clear(); // on efface le terminal 

          // on se met en noir
          ui.textBrowser_2->setTextColor(QColor::QColor ( 0, 0, 0 )); // on decide la couleur par defaut 

          QFile file;
          QString line;
          file.setFileName(openFilesPath);  // ouverture du fichier
          if( file.exists() )
          {
              file.open(QIODevice::ReadOnly | QIODevice::Text );
              QTextStream in(&file);

              while (!in.atEnd()) 
              {
                    line = in.readLine();
                    ui.textBrowser_2->insertPlainText( line + "\n" ); 
              }
          }
          file.close();

     }

}


///////////////////////////////////////////
// Envoi du fichier URBI
void Telecommande::on_pushButton_87_clicked()
{
    if(urbiTele.robotC != NULL)
    {
          QString openFilesPath=ui.label_53->text();  // on recupere le nom du fichier

          // on se place a la fin du terminal et en se met en bleu
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 

          QFile file;
          QString line;
          file.setFileName(openFilesPath);  // ouverture du fichier
          if( file.exists() )
          {
              file.open(QIODevice::ReadOnly | QIODevice::Text );
              QTextStream in(&file);

              while (!in.atEnd()) 
              {
                    line = in.readLine();
                    ui.textBrowser->insertPlainText( "[Send] " + line + "\n" ); 
                    urbiTele.robotC->send("%s", (const char *) ( line.toLatin1() + "\n"));
              }
          }
          file.close();

          // on se place a la fin du terminal
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     }

}



///////////////////////////////////////////
// Slection du fichier Binaire
void Telecommande::on_pushButton_88_clicked()
{
    QString openFilesPath;

    QStringList files = QFileDialog::getOpenFileNames(
                                this, tr("QFileDialog::getOpenFileNames()"),
                                openFilesPath,
                                tr(" Binary File (*.*)"));
    if (files.count()) 
    {
        openFilesPath = files[0];
        ui.label_55->setText(openFilesPath);        // affichage du fichier selectionne
    }

}


///////////////////////////////////////////
// Envoi du fichier Binaire
void Telecommande::on_pushButton_89_clicked()
{
    if(urbiTele.robotC != NULL)
    {
          QString openFilesPath=ui.label_55->text();  // on recupere le nom du fichier
          QFile file;
          QString line;
          file.setFileName(openFilesPath);  // ouverture du fichier
          if( file.exists() )
          {
              file.open(QIODevice::ReadOnly );
              QDataStream in(&file);

              qint64 taillefile;
              taillefile = file.size(); // donne la taille en octets du fichier 


                    if (taillefile >= 1000000)
                    {
                    	taillefile = 1000000;
                    }

                    QString cmd; // commande
                    cmd = ui.lineEdit_4->text() + " = BIN " + QString::number(taillefile) + " " ; // dit que c'est un binaire et donne la taille des donnees

                    if (ui.comboBox_4->currentText().contains("no header", Qt::CaseInsensitive) )
                    {
                    	cmd = cmd;
                    }	

                    else if (ui.comboBox_4->currentText().contains("image jpeg header", Qt::CaseInsensitive) )
                    {
			QImage fileImage;
			fileImage.load( openFilesPath );
			if(fileImage.isNull () != 1)
			{
			   int widthImage = fileImage.width();
			   int heightImage = fileImage.height();
	                       cmd = cmd + "jpeg " + QString::number(widthImage) + " " + QString::number(heightImage);
			}

                    }	

                    else if (ui.comboBox_4->currentText().contains("wav header", Qt::CaseInsensitive) )
                    {
                       cmd = cmd + "wav" ;
                    }	

                    else if (ui.comboBox_4->currentText().contains("raw 2 16000 16 1", Qt::CaseInsensitive) )
                    {
                       cmd = cmd + ui.comboBox_4->currentText() ;
                    }	

                    else if (ui.comboBox_4->currentText().contains("raw 2 8000 16 1", Qt::CaseInsensitive) )
                    {
                       cmd = cmd + ui.comboBox_4->currentText() ;
                    }	

                       cmd = cmd + ";";

		// envoie des donnees au serveur
                    char buffer[taillefile];
                    in.readRawData ( buffer, taillefile );
                    urbiTele.robotC->sendBin(buffer, taillefile, cmd.toLatin1() );
                    file.close();


          }


     }





}



///////////////////////////////////////////
// Slection du fichier Binary Sound
void Telecommande::on_pushButton_90_clicked()
{
    QString openFilesPath;

    QStringList files = QFileDialog::getOpenFileNames(
                                this, tr("QFileDialog::getOpenFileNames()"),
                                openFilesPath,
                                tr(" Sound File (*.wav)"));
    if (files.count()) 
    {
        openFilesPath = files[0];
        ui.label_58->setText(openFilesPath);        // affichage du fichier selectionne
    }

}


///////////////////////////////////////////
// Envoi du fichier Binary Sound
void Telecommande::on_pushButton_91_clicked()
{

    if(urbiTele.robotC != NULL)
    {
          QString openFilesPath=ui.label_58->text();  // on recupere le nom du fichier
          QFile file;
          QString line;
          file.setFileName(openFilesPath);  // ouverture du fichier
          if( file.exists() )
          {
              file.open(QIODevice::ReadOnly );
              QDataStream in(&file);

              qint64 taillefile;
              taillefile = file.size(); // donne la taille en octets du fichier 

              urbi::USound s, snd; // creation du fichier son
              if (taillefile >= 1000000)
              {
                  taillefile = 1000000;
              }
                             
                    char buffer[taillefile];
                    in.readRawData ( buffer, taillefile );

                    s.data = buffer; 
                    s.soundFormat = urbi::SOUND_WAV;	 
                    s.size = taillefile;

                    snd.soundFormat = urbi::SOUND_RAW;
                    snd.rate = 16000;
                    snd.sampleSize = 16;
                    snd.sampleFormat = urbi::SAMPLE_SIGNED;
                    snd.channels = 2;
                    snd.data = 0;
                    snd.size = 0;

                    convert(s, snd);

                    urbiTele.robotC->sendSound("speaker", snd,"toto");
                    file.close();

          }


     }

}







