

///////////////////////////////////////////
// Lancement de la camera
void Telecommande::on_pushButton_83_clicked()
{
     if(urbiTele.robotC != NULL)
     {
         // on affiche la camera
         visionCamera.show();

         // recuperation des donnes du nom et du port
         QSettings settings("Surveyor Telecommande", "GOSTAI");
         QString robotName = settings.value("robotname").toString();
         int robotPort = settings.value("robotport").toInt();

         // connexion
         if( urbiTele.robotI != NULL)
         {
             urbiTele.robotI->send(";;;; quit;");
             urbiTele.robotI->send("stop uimg;");
             urbiTele.robotI->send("noop;");
             urbiTele.robotI->send("noop;");
             delete urbiTele.robotI;

             // reinitialisation des variables
             urbiTele.traitementEnCours=0;
             urbiTele.captureImage=0;
         }
         urbiTele.robotI = NULL;
         urbiTele.robotI =new UClient( robotName.toLatin1() , robotPort );

         if (!urbiTele.robotI->error())
         {
                 urbiTele.robotI->send("stop uimg;");
                 urbiTele.robotI->setCallback(callback(urbiTele,&ConnectAibo::urbiimage), "uimg");
                 QString frequency = ui.lineEdit_8->text();
                 QString Camera_Active = "uimg:every(" + frequency + "ms){ uimg:" + ui.lineEdit_6->text() + "},";
                 urbiTele.robotI->send("%s", (const char *) Camera_Active.toLatin1());
         }
     }
} 


///////////////////////////////////////////
// Arret de la camera
void Telecommande::on_pushButton_92_clicked()
{
         // on cache la camera
         visionCamera.hide();

         // connexion
         if( urbiTele.robotI != NULL)
         {
             urbiTele.robotI->send(";;;; quit;");
             urbiTele.robotI->send("stop uimg;");
             urbiTele.robotI->send("noop;");
             urbiTele.robotI->send("noop;");
             delete urbiTele.robotI;
             urbiTele.robotI = NULL;

             // reinitialisation des variables
             urbiTele.traitementEnCours=0;
             urbiTele.captureImage=0;
         }

} 

///////////////////////////////////////////
// Arret de la camera
void Telecommande::arretDeLaCamera()
{
         // connexion
         if( urbiTele.robotI != NULL)
         {
             urbiTele.robotI->send(";;;; quit;");
             urbiTele.robotI->send("stop uimg;");
             urbiTele.robotI->send("noop;");
             urbiTele.robotI->send("noop;");
             delete urbiTele.robotI;
             urbiTele.robotI = NULL;

             // reinitialisation des variables
             urbiTele.traitementEnCours=0;
             urbiTele.captureImage=0;
         }

} 



///////////////////////////////////////////
// parametres video
void Telecommande::on_comboBox_currentIndexChanged ( int index )
{

     if(urbiTele.robotC != NULL)
     {
          QString position;
          if (index == 0)
             position = "camera.resolution = 1;";
          else if (index == 1)
             position = "camera.resolution = 3;";
          else if (index == 2)
             position = "camera.resolution = 5;";
          urbiTele.robotC->send("%s", (const char *) position.toLatin1());
          position = "[Send] " + position + "\n";
          QTextCursor cursorEnd(ui.textBrowser->textCursor());
          cursorEnd.movePosition(QTextCursor::End , QTextCursor::MoveAnchor);
          ui.textBrowser->setTextCursor ( cursorEnd );
          ui.textBrowser->setTextColor(QColor::QColor ( 0, 0, 255 )); // on decide la couleur par defaut 
          ui.textBrowser->insertPlainText(  position ); 
          int positionMax = ui.textBrowser->verticalScrollBar()->maximum();
          ui.textBrowser->verticalScrollBar()->setSliderPosition(positionMax);
     }

}
