#include "addcadre.h"
UStart(addcadre);

addcadre::addcadre(std::string s) : UObject(s)
{
	UBindVar(addcadre,image);
	UBindFunction(addcadre,init);
 	UBindFunction(addcadre,load);
 	UBindFunction(addcadre,black);
}

addcadre::~addcadre()
{
}

int addcadre::init(void)
{
  return 1; // Singleton
}

UImage addcadre::load(UValue data)
{
//////////////////////////////////////////////////////
// On commence par charger l'image du cadre en memoire
//////////////////////////////////////////////////////

    // create a UImage
    UImage Imagesrc;
    Imagesrc.imageFormat = IMAGE_JPEG;
    Imagesrc.width = 233;
    Imagesrc.height = 228;

    std::string File = "cadre.jpg";
    FILE *f;
    f = fopen(File.c_str(),"rb");
    if (!f)
    {
        printf("fichier image non present\n");     
        return Imagesrc;
    }

    struct stat st;
    stat(File.c_str(),&st);

    Imagesrc.data = new unsigned char[st.st_size];
    Imagesrc.size = st.st_size;
    fread(Imagesrc.data, 1,st.st_size, f);

//////////////////////////////////////////////////////
// On convertit en RGB
//////////////////////////////////////////////////////

    UImage Imagesrc2;
    Imagesrc2.width = Imagesrc.width;
    Imagesrc2.height = Imagesrc.height;
    Imagesrc2.imageFormat = IMAGE_RGB;
    Imagesrc2.size = Imagesrc.width * Imagesrc.height * 3;
    Imagesrc2.data = new unsigned char[Imagesrc.width * Imagesrc.height * 3];
    int Imagesrc2size = Imagesrc2.size;
    convertJPEGtoRGB(Imagesrc.data, Imagesrc.size, Imagesrc2.data,Imagesrc2size);

//////////////////////////////////////////////////////
// On recupere ensuite l'image de la camera
//////////////////////////////////////////////////////

   UImage image2;
   if(data.type == DATA_BINARY)
    {
           UImage camera = data;
        
           if ( camera.imageFormat == IMAGE_RGB )
           {
               image2 = data;
           }
           else if ( camera.imageFormat == IMAGE_YCbCr )
           {
                image2.width = camera.width;
                image2.height = camera.height;
                image2.size = camera.width * camera.height * 3;
                image2.imageFormat = IMAGE_RGB;
		image2.data = new unsigned char[camera.width * camera.height * 3];
                convertYCrCbtoRGB(camera.data, camera.size, image2.data);
           }
           else if ( camera.imageFormat == IMAGE_JPEG )
           {
                image2.width = camera.width;
                image2.height = camera.height;
                image2.size = camera.width * camera.height * 3;
                image2.imageFormat = IMAGE_RGB;
	  	image2.data = new unsigned char[camera.width * camera.height * 3];
                int image2size = image2.size;
                convertJPEGtoRGB(camera.data, camera.size, image2.data,image2size);
           }
    }
    else 
         return Imagesrc;

//////////////////////////////////////////////////////
// On passe l'image en niveau de gris
//////////////////////////////////////////////////////

    int i,j,valeur;
    for(i=0; i<image2.width; i++)
    {
             for(j=0; j<image2.height; j++)
             {
                      valeur=0;
                      valeur  = valeur + image2.data[(i+j*image2.width)*3+0];
                      valeur  = valeur + image2.data[(i+j*image2.width)*3+1];
                      valeur  = valeur + image2.data[(i+j*image2.width)*3+2];

                      valeur = (int)(valeur / 3);
                      image2.data[(i+j*image2.width)*3+0] = valeur;
                      image2.data[(i+j*image2.width)*3+1] = valeur;
                      image2.data[(i+j*image2.width)*3+2] = valeur;
             }
    }
                      


//////////////////////////////////////////////////////
// On place l'image dans le cadre
//////////////////////////////////////////////////////

    for(i=0; i<image2.width; i++)
    {
             for(j=0; j<image2.height; j++)
             {
                      Imagesrc2.data[( (i+13) + (j+35) * (Imagesrc2.width) )*3+0] = image2.data[(i+j*image2.width)*3+0];
                      Imagesrc2.data[( (i+13) + (j+35) * (Imagesrc2.width) )*3+1] = image2.data[(i+j*image2.width)*3+1];
                      Imagesrc2.data[( (i+13) + (j+35) * (Imagesrc2.width) )*3+2] = image2.data[(i+j*image2.width)*3+2];
             }
    }

//////////////////////////////////////////////////////
// On convertit en jpeg
//////////////////////////////////////////////////////

    UImage image3;
    image3.width = Imagesrc2.width;
    image3.height = Imagesrc2.height;
    image3.imageFormat = IMAGE_JPEG;
    image3.size=0;
    image3.data = new unsigned char[Imagesrc2.width * Imagesrc2.height * 3];
    int image3size = image3.size;
    convertRGBtoJPEG((const byte*)Imagesrc2.data, Imagesrc2.width, Imagesrc2.height, image3.data, image3size, 100);
    image3.size = image3size;

    image = image3;

    return image3;
}






UImage addcadre::black(void)
{
//////////////////////////////////////////////////////
// On commence par charger l'image noire en memoire
//////////////////////////////////////////////////////

    // create a UImage
    UImage Imagesrc;
    Imagesrc.imageFormat = IMAGE_JPEG;
    Imagesrc.width = 208;
    Imagesrc.height = 160;


    std::string File = "black.jpg";
    FILE *f;
    f = fopen(File.c_str(),"rb");
    if (!f)
    {
        printf("fichier image non present\n");     
        return Imagesrc;
    }

    struct stat st;
    stat(File.c_str(),&st);

    Imagesrc.data = new unsigned char[st.st_size];
    Imagesrc.size = st.st_size;
    fread(Imagesrc.data, 1,st.st_size, f);


    return Imagesrc;
}


