#include "diffimages.h"
UStart(diffimages);

diffimages::diffimages(std::string s) : UObject(s)
{
	UBindVar(diffimages,Imagebackground);
	UBindVar(diffimages,Imageobject);
	UBindVar(diffimages,Colorycbcr);
	UBindVar(diffimages,Colorycbcr2);

	UBindFunction(diffimages,init);
	UBindFunction(diffimages,loadbackground);
 	UBindFunction(diffimages,loadobject);
 	UBindFunction(diffimages,diff);
}

diffimages::~diffimages()
{
}

int diffimages::init(void)
{
  return 1; // Singleton
}


// diffimages.loadbackground(camera.raw);
void diffimages::loadbackground(UValue data)
{
   if(data.type == DATA_BINARY)
   {
           // data = camera.raw
	   imagebackground = data;
	   imageBackground = imagebackground.image; 
   }

   Imagebackground = imageBackground;
   return;
}



void diffimages::loadobject(UValue data)
{
   if(data.type == DATA_BINARY)
   {
           // data = camera.raw
	   imageobject = data;
	   imageObject = imageobject.image; 
	   colorycbcr  = data;
	   colorYcbcr  = colorycbcr.image; 
   }

   Imageobject = imageObject;
   return;
}


UList diffimages::diff(void)
{
    int i=0,j=0;
    int y=0,cb=0,cr=0;

    int width = imageObject.width;
    int height = imageObject.height;

	// si les changements sont inexistants, alors on met en blanc
    for(i=0; i<width; i++)
    {
             for(j=0; j<height; j++)
             {
		      y  = imageObject.data[(i+j*width)*3+0] - imageBackground.data[(i+j*width)*3+0];
                      cb = imageObject.data[(i+j*width)*3+1] - imageBackground.data[(i+j*width)*3+1];
                      cr = imageObject.data[(i+j*width)*3+2] - imageBackground.data[(i+j*width)*3+2];

		      y = abs(y);
		      cb = abs(cb);		
		      cr = abs(cr);

		      if( y < 30 && cb < 30 && cr < 30) // peu de changement ==> couleur blanc
		      {
                      	colorYcbcr.data[(i+j*width)*3+0] = 255;
                      	colorYcbcr.data[(i+j*width)*3+1] = 130;
                      	colorYcbcr.data[(i+j*width)*3+2] = 130;

		      }
		      else // changement ==> couleur objet
		      {
                      	colorYcbcr.data[(i+j*width)*3+0] = imageObject.data[(i+j*width)*3+0];
                      	colorYcbcr.data[(i+j*width)*3+1] = imageObject.data[(i+j*width)*3+1];
                      	colorYcbcr.data[(i+j*width)*3+2] = imageObject.data[(i+j*width)*3+2];

		      }

             }
    }


    Colorycbcr2 = colorYcbcr;

	// on cherche le point central de l'objet
    double posx=0,posy=0;
    int nbcases=0;

    for(i=0; i<width; i++)
    {
             for(j=0; j<height; j++)
             {
		      y  = colorYcbcr.data[(i+j*width)*3+0];
                      cb = colorYcbcr.data[(i+j*width)*3+1];
                      cr = colorYcbcr.data[(i+j*width)*3+2];

		      if( y != 255 && cb != 130 && cr != 130) 
		      {
			nbcases++;
			posx=posx+i;
			posy=posy+j;
		      }
            }
    }

	int posxglobal, posyglobal;
	posxglobal = (int) (posx/nbcases);
        posyglobal = (int) (posy/nbcases);

	// on vire tout ce qui n'est pas au centre
    for(i=0; i<width; i++)
    {
             for(j=0; j<height; j++)
             {

		if( i < posxglobal-10 || i > posxglobal+10 || j < posyglobal-10 || j > posyglobal+10)
	      {
                      	colorYcbcr.data[(i+j*width)*3+0] = 255;
                      	colorYcbcr.data[(i+j*width)*3+1] = 130;
                      	colorYcbcr.data[(i+j*width)*3+2] = 130;

	      }
            }
    }

    nbcases=0;
    double Yglobal=0, Cbglobal=0, Crglobal=0;
	// on regarde la couleur moyenne de l'objet

    for(i=0; i<width; i++)
    {
             for(j=0; j<height; j++)
             {
		      y  = colorYcbcr.data[(i+j*width)*3+0];
                      cb = colorYcbcr.data[(i+j*width)*3+1];
                      cr = colorYcbcr.data[(i+j*width)*3+2];

		      if( y != 255 && cb != 130 && cr != 130) 
		      {
			nbcases++;
                      	Yglobal = Yglobal + y;
                      	Cbglobal = Cbglobal + cb;
                      	Crglobal = Crglobal + cr;
		      }
            }
    }


    y = (int) (Yglobal/nbcases);
    cb = (int) (Cbglobal/nbcases);
    cr = (int) (Crglobal/nbcases);

    UList colorobject;
    // chargement des valeurs
    colorobject.array.push_back( new UValue((int)  y ) );
    colorobject.array.push_back( new UValue((int)  cb) );
    colorobject.array.push_back( new UValue((int)  cr) );

    Colorycbcr = colorYcbcr;

    return colorobject;
}

