#include "urbirecord.h"

char * devices[]={
  "legLF1",
  "legLF2",
  "legLF3",
  "legLH1",
  "legLH2",
  "legLH3",
  "legRH1",
  "legRH2",
  "legRH3",
  "legRF1",
  "legRF2",
  "legRF3",
  "neck",
  "headPan",
  "headTilt",
  "tailTilt",
  "tailPan",
  "mouth"
};

UStart(urbirecord);

urbirecord::urbirecord(std::string s) : UObject(s) 
{
	UBindFunction(urbirecord,init);
	UBindFunction(urbirecord,endRecord);
	UBindFunction(urbirecord,buildHeader);
	UBindFunction(urbirecord,startRecord);
	UBindFunction(urbirecord,addValues);

    devCount=18;
    etat=1;
    
}

urbirecord::~urbirecord()
{
}

int urbirecord::init(void)
{
  return 1; // Singleton
}


void urbirecord::endRecord(void) 
{
    if(etat == 1) // si l'enregistrement est a l'arret, on ne peut pas l'arreter a nouveau
      return; 
     
    etat = 1;  // etat arret

	std::string message;
    message = "stop looptagRecord;";
    urbi::send(message.c_str());

    fclose(f);
    return;
}


void urbirecord::buildHeader(void)
{
  fwrite("URBI",4,1,f);
  fwrite(&devCount,4,1,f);
  for (int i=0;i<devCount;i++)
  {
	  fwrite(devices[i],strlen(devices[i])+1,1,f);
	  short s=i;
	  fwrite(&s,2,1,f);
	  char c=(char)TYPE_ANGLE;
	  fwrite(&c,1,1,f);
  }
}

void urbirecord::startRecord(std::string nameFile)
{

  etat = 0; // etat enregistrement

  f=fopen(nameFile.c_str(),"w");
  buildHeader();
  time = 0; // le temps est mis a 0

	std::string message;
    message = "looptagRecord:loop urbirecord.addValues([legLF1,legLF2,legLF3,legLH1,legLH2,legLH3,legRH1,legRH2,legRH3,legRF1,legRF2,legRF3,neck,headPan,headTilt,tailTilt,tailPan,mouth],time()),";
    urbi::send(message.c_str());
}



void urbirecord::addValues(UList listvalues,UValue temps)
{

    if(etat == 1) // etat arret
            return;

    int ulistsize = listvalues.array.size(); // renvoie le nombre d'elements contenus dans la liste - 18 - devCount
    time = (int) temps.val;
    UCommand uc;
    UValue *valeurUList;

    for(int i=0; i<devCount ; i++)
    {
	   uc.id=i;
       valeurUList = listvalues.array[i];
	   uc.value.angle=valeurUList->val;
	   uc.timestamp=time; 
	   fwrite(&uc,sizeof(UCommand),1,f);
    }
}








 
 
