#include <urbi/uobject.hh>

using namespace urbi;

class urbirecord : public UObject
{
	public:

	urbirecord(std::string);
	~urbirecord(); 

	int init(void);
	void endRecord(void);
	void buildHeader(void);
	void startRecord(std::string nameFile);
	void addValues(UList listvalues,UValue temps);


    /*
      file format
      URBI (4 bytes)
      numjoints (4 bytes)
      [numjoint times] namejoint (char * nullterminated) id (short)  type(char)
      [til end of file]
        timestamp [int, milisec] id (short) value (UValue)
     */
    
    enum UType 
    {
      TYPE_BOOL,
      TYPE_ANGLE,
      TYPE_NORM
    };
    
    union UJointValue 
    {
      float angle;
      float normalized;
      bool boolean;
    };
    
    struct UCommand 
    {
      int timestamp;
      short id;
      UJointValue value;
    };


    int devCount;
    UClient *c;
    FILE *f;
    int etat;
    int time;




};

