#include <urbi/uobject.hh>
#include <urbi/uconversion.hh>
#include <avcodec.h>
using namespace urbi;

class vidcap : public UObject
{
	public:
	vidcap(std::string);
	~vidcap(); 

	// functions
	int init(void); // se lance si on fait un new
	void start(void); // demarre l'enregistrement et s'arrete par la fonction stop
	void startdelay(int delay); // demarre l'enregistrement et indique la duree totale
	void stop(void);  // arret de l'enregistrement. a utiliser si on a fait avant un start
	void initrecord(void); // initialisation de l'enregistrement (nom du fichier, codecs, allocation memoire, etc.)
	void record(void);
	void endrecord(void); // ferme proprement le fichier video
	int initvalueChanged(UVar &camera); // permet de connaitre les parametres de la source video et de creer un tableau pour stocker les donnees
	int valueChanged(UVar &camera); // enregistrement des images dans le fichier video

	void SaveFrame(AVFrame *pFrame, int width, int height, int iFrame);


	// variables
	UVar initimage; // on copie une fois l'image de la source video dans cette variable
	UVar image; // on copie la source video dans cette varialbe
	char *tab; // tableau contenant les donnees de l'image source (largeur * hauteur * 3)
	UVar frequency; // frequence de capture d'images
	UVar deviceCapture; // source des images
	int widthimage; // largeur de l'image
	int heigthimage; // hauteur de l'images
	int frames; // compteur de frames captures
	UVar delay; // duree de l'enregistrement
	int state; // 0 = pas enregistrement et 1 = enregistrement


	// variables FFMPEG
	AVCodec *codec;
	AVCodecContext *c;
	AVFrame *picture; // image au format PIX_FMT_YUV420P
	AVFrame *pictureRGB24; // image au format RGB24
	FILE *f;
	int outbuf_size;
	uint8_t *outbuf;
	int size; // size for YUV420P 
	uint8_t *picture_buf,*picture_buf1,*picture_buf2,*picture_buf3; 
	int sizeRGB24; // size for RGB24 
	uint8_t *picture_bufRGB24; 
	int i, out_size, x, y;

};

