#include "visionblur.h"

UStart(visionblur);

visionblur::visionblur(std::string s) : UObject(s)
{
	UBindVar(visionblur,image);
	UBindVar(visionblur,val);
	UBindVar(visionblur,level);
	UBindFunction(visionblur,init);
 	UBindFunction(visionblur,blur);
	UNotifyChange(image,&visionblur::valueChanged);
	UNotifyChange(level,&visionblur::levelChanged);

	URBI((
          visionblur.image = camera.raw;
          visionblur.val   = camera.raw;
    ));
	level=1;
	levelInt=1;


}

visionblur::~visionblur()
{
}

int visionblur::init(void)
{
  return 1; // Singleton
}

void visionblur::blur(void)
{
	URBI((visionblur.image = camera.raw;));

 	return;
}

int visionblur::levelChanged(UVar &l)
{    
 	levelInt=(int)l;
 	return 0;
}

int visionblur::valueChanged(UVar &image)
{    
 	UImage imgsrc;
 	UImage imgdest;

 	imgsrc = (UImage) image;
 	imgdest = (UImage) image;

 	int width=imgsrc.width;
 	int height=imgsrc.height;

    unsigned char Y;
    unsigned char Cb;
    unsigned char Cr;

    int Yall;
    int Cball;
    int Crall;

    int i,j;
    int k,l;
    int diviseur = (levelInt*2 + 1) * (levelInt*2 + 1);
    for(i=0+levelInt; i<width-levelInt; i++)
    {
             for(j=0+levelInt; j<height-levelInt; j++)
             {
                      
                Yall=0;
                Cball=0;
                Crall=0;
                for(k=i-levelInt; k<i+levelInt+1; k++)
                {
                         for(l=j-levelInt; l<j+levelInt+1; l++)
                         {
                              Yall  = Yall  + imgsrc.data[(k+l*width)*3+0];
                              Cball = Cball + imgsrc.data[(k+l*width)*3+1];
                              Crall = Crall + imgsrc.data[(k+l*width)*3+2];    
                                  
                         }
                }
                      
                Y  = (unsigned char)(Yall/ diviseur);
                Cb = (unsigned char)(Cball/diviseur);
                Cr = (unsigned char)(Crall/diviseur);                      

                imgdest.data[(i+j*width)*3+0] = Y;
                imgdest.data[(i+j*width)*3+1] = Cb;
                imgdest.data[(i+j*width)*3+2] = Cr;     
             }
    }

 	val = imgdest;

 	URBI((wait(3s); +connection("all"):visionblur.val;));

 	return 0;
}
