#include "facedetection.h"
UStart(facedetection);

facedetection::facedetection(std::string s) : UObject(s)
{
	UBindFunction(facedetection,init);
 	UBindFunction(facedetection,load);

 	image = NULL;

    storage = 0;
    cascade = 0;

    char *cascade_name = "haarcascade_frontalface_alt2.xml";
    cascade = (CvHaarClassifierCascade*)cvLoad( cascade_name, 0, 0, 0 );
    //if( !cascade )
    //    return URBI_CONTINUE; // on sort car il y a une erreur
    storage = cvCreateMemStorage(0);


}

facedetection::~facedetection()
{
}

int facedetection::init(void)
{

  return 1; // Singleton
}



void facedetection::load(UValue data)
{
//////////////////////////////////////////////////////
// On recupere l'image de la camera
//////////////////////////////////////////////////////

   if(data.type == DATA_BINARY)
    {
           UImage camera = data;

           int imgsize = camera.width * camera.height * 3;

           if (image == NULL)
             image = new unsigned char[camera.width * camera.height * 3]; // 24 bits
        
        int sizejpegimage;        
        
      // conversion de l'image en JPG
      if( camera.imageFormat == urbi::IMAGE_JPEG )  // cas ou l'image est un jpeg
      {
            memcpy(  image, camera.data, camera.size );
            sizejpegimage = camera.size;
      }
      else if ( camera.imageFormat == urbi::IMAGE_YCbCr)
      {
          urbi::convertYCrCbtoJPEG( camera.data, camera.width, camera.height, image, sizejpegimage, 100 );
      }
      else if ( camera.imageFormat == urbi::IMAGE_RGB)
      {
          urbi::convertRGBtoJPEG( camera.data, camera.width, camera.height, image, sizejpegimage , 100 );
      }
      else
      {
            memcpy(  image, camera.data, camera.size );
            sizejpegimage = camera.size;
      }


        std::string File = "image.jpg";
        FILE *f;
        f = fopen(File.c_str(),"wb");
        if (!f)
           return ;
        fwrite (image, 1 , sizejpegimage, f);
        fclose(f);


// code opencv
    cvNamedWindow( "image", CV_WINDOW_AUTOSIZE );

        const char* filename = (char*)"image.jpg";
        IplImage* imagecv = cvLoadImage( filename, CV_LOAD_IMAGE_COLOR );

        if( imagecv )
        {
            detect_and_draw( imagecv );
            if (cvWaitKey(10)>=0) cvDestroyWindow("image");
            cvReleaseImage( &imagecv );
        }
// code opencv



    }
}



///////////////////////////////////////////
// detection des visages
void facedetection::detect_and_draw( IplImage* img )
{
    static CvScalar colors[] = 
    {
        {{0,0,255}},
        {{0,128,255}},
        {{0,255,255}},
        {{0,255,0}},
        {{255,128,0}},
        {{255,255,0}},
        {{255,0,0}},
        {{255,0,255}}
    };

    double scale = 1.3;
    IplImage* gray = cvCreateImage( cvSize(img->width,img->height), 8, 1 );
    IplImage* small_img = cvCreateImage( cvSize( cvRound (img->width/scale),
                         cvRound (img->height/scale)),
                     8, 1 );
    int i;

    cvCvtColor( img, gray, CV_BGR2GRAY );
    cvResize( gray, small_img, CV_INTER_LINEAR );
    cvEqualizeHist( small_img, small_img );
    cvClearMemStorage( storage );

    if( cascade )
    {
        double t = (double)cvGetTickCount();
        CvSeq* faces = cvHaarDetectObjects( small_img, cascade, storage,
                                            1.1, 2, 0/*CV_HAAR_DO_CANNY_PRUNING*/,
                                            cvSize(30, 30) );
        t = (double)cvGetTickCount() - t;
        for( i = 0; i < (faces ? faces->total : 0); i++ )
        {
            CvRect* r = (CvRect*)cvGetSeqElem( faces, i );
            CvPoint center;
            int radius;
            center.x = cvRound((r->x + r->width*0.5)*scale);
            center.y = cvRound((r->y + r->height*0.5)*scale);
            radius = cvRound((r->width + r->height)*0.25*scale);
            cvCircle( img, center, radius, colors[i%8], 3, 8, 0 );
        }
    }

    cvShowImage( "image", img );
    cvReleaseImage( &gray );
    cvReleaseImage( &small_img );
}





