#include "lifegame.h"


UStart(lifegame);

// Creation de l'objet lifegame 
lifegame::lifegame(std::string s) : UObject(s) 
{
	UBindFunction(lifegame,init);
	UBindFunction(lifegame,start);
	UBindFunction(lifegame,next);

    etape = -1;
}


// Destruction de l'objet lifegame 
lifegame::~lifegame(void)
{

}

// empecher que l'on puisse faire un new lifegame()
int lifegame::init(void)
{
  return 1; // Singleton
}


vector <vector <bool> > inittab (unsigned int li, unsigned int co)
{
  srand(time(NULL));
  vector <vector <bool> > tab (li, vector <bool> (co, false));
  for (int i=0;i<li;i++)
    for (int j=0;j<co;j++)
      if (rand()%2==1) tab[i][j]=true;
  return (tab);
}


// demarrer le jeu
void lifegame::start(int ligne, int colonne )
{
	int li,co;
	li = ligne;
	co = colonne;
    tab = inittab((unsigned int) li , (unsigned int) co); // initialisation du tableau 

	affiche_vect(tab);
	int n = 1;

    etape = 0;
    std::string message; 
    message = "+connection(\"all\"): \"Pour voir la suite, faire lifegame.next();\";";
    urbi::send(message.c_str());      

}

// lignes, colonnes, et un vecteur vers le tableau
int nbvie (unsigned int li, unsigned int co, vector <vector <bool> > &tab)
{
  int nb=0;
  int x=tab[0].size();
  int y=tab.size();
  for (int i=-1;i<=1;i++)
  {
    for (int j=-1;j<=1;j++)
    {
      if (tab[(li+i+y)%y][(co+j+x)%x])
       ++nb;
    }
	if (tab[li][co])
     --nb;
  }
  return (nb);
}

bool evo (unsigned int li, unsigned int co, vector <vector <bool> > &tab)
{
  bool etat = tab[li][co];
  int vie = nbvie(li,co,tab);
  if (!etat) {
    if (vie == 3) 
      etat = true;
  }
  else {
    if (!(vie == 3 || vie == 2)) 
      etat=false;
  }
  return(etat);
}


vector<int> compte(vector <vector <bool> > tab)
{
  vector<int> stock;
  for(int i = 0; i < tab.size(); ++i)
  {
    for(int j = 0; j < tab[0].size(); ++j) 
    {
      bool a = evo(i, j, tab);
      if(tab[i][j] != a) 
      {
	    stock.push_back(i);
	    stock.push_back(j);
      }
    }
  }
   return stock;
}	

// on passe a l'etape suivante
void lifegame::next(void)
{
  if( etape == -1)
  {
    std::string message; 
    message = "+connection(\"all\"): \"Pour demarrer une partie, faire lifegame.start(ligne,colonne);\";";
    urbi::send(message.c_str());      
    return;
  }

  vector<int> coord_modif;
  coord_modif = compte(tab);

  if( coord_modif.size() == 0)
  {
    std::string message; 
    message = "+connection(\"all\"): \"Pour demarrer une partie, faire lifegame.start(ligne,colonne);\";";
    urbi::send(message.c_str());      
    return;
  }

  for(int a = 0; a < coord_modif.size(); a+=2) // sur le nombre de cases = lignes * colonnes
  {
		  int i = coord_modif[a];
		  int j = coord_modif[a + 1];
		  tab[i][j] = ! tab[i][j];
  }

  affiche_vect(tab);

  etape++;
  std::string messagetmp;
  std::string message;
  std::ostringstream ostr; 
  ostr << etape; 
  messagetmp = ostr.str(); 
  message = "+connection(\"all\"): \"Etape du jeu de la vie : " + messagetmp + "\";";
  urbi::send(message.c_str());
}

// on affiche des cases vides ou avec * dans la grille
std::string vect (vector<bool> tab)
{
  std::string message; // va contenir le contenu d'une ligne
  message = "+connection(\"all\"): \"";

  for (int i=0;i<tab.size();i++) // boucle for sur le nombre de colonnes
  {
      if (i == tab.size()-1)
	  {
          if (tab[i]) 
          {
            message = message + "*";
//            cout << '*'<< endl; 
          }
          else 
          {
            message = message + " ";
//            cout << ' ' << endl;
          }
      }
      else 
      {
        if (tab[i]) 
        {
          message = message + "*";
//          cout << "*";
        }
        else 
        {
          message = message + " ";
//          cout << " ";
        }
      }
  }

  message = message + "\";";
  return message;
}

// on affiche la grille
void lifegame::affiche_vect(vector <vector <bool> > tab)
{
  std::string message; // va contenir le contenu d'une ligne

  for (int i=0;i<tab.size();i++) // boucle for sur le nombre de lignes
  {
    message = vect(tab[i]);
    urbi::send(message.c_str());
  }

}

