#include "joystick.h"


int thread(void *ptclass)
{

 // on recupere l'adresse de notre classe
 joystick *pt = static_cast<joystick *>(ptclass);

  int result=0; // permet de faire des tests pour voir si tout est ok

	// Initialisation de SDL 
	result = SDL_Init(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK);
    if ( result < 0 ) // mauvaise initialisation, donc on quitte
    {
		std::string message = "+connection(\"all\"):\"Error. Couldn't initialize SDL\";";
		urbi::send(message.c_str());
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(-1);
	}

     // Activation du support UNICODE 
     SDL_EnableUNICODE(1);

     // on note le nombre de composants des joysticks de l'ordi
     pt->nbjoysticks = SDL_NumJoysticks();
     pt->nbmaxjoyaxes = 0;
     pt->nbmaxjoyballs = 0;
     pt->nbmaxjoyhats = 0;
     pt->nbmaxjoybuttons = 0;
     for (int i = 0; i < pt->nbjoysticks; i++)
     {
    	  SDL_Joystick * joy = SDL_JoystickOpen(i);
          if( pt->nbmaxjoyaxes < SDL_JoystickNumAxes(joy) )
             pt->nbmaxjoyaxes = SDL_JoystickNumAxes(joy);
          if( pt->nbmaxjoyballs < SDL_JoystickNumBalls(joy) )
             pt->nbmaxjoyballs = SDL_JoystickNumBalls(joy);
          if( pt->nbmaxjoyhats < SDL_JoystickNumHats(joy) )
             pt->nbmaxjoyhats = SDL_JoystickNumHats(joy);
          if( pt->nbmaxjoybuttons < SDL_JoystickNumButtons(joy) )
             pt->nbmaxjoybuttons = SDL_JoystickNumButtons(joy);
     }

	pt->initjoy();

     while(pt->etat)
     {
    	  // Mise  jour de l'tat du jeu  partir des vnements 
    	  pt->process_events();
     }

     return 1;
}





/////////////////////////////////////////////

UStart(joystick);

// Creation de l'objet joystick
joystick::joystick(std::string s) : UObject(s) 
{
	UBindFunction(joystick,init);
	UBindFunction(joystick,info);
	UBindFunction(joystick,updatejoy);
	UBindFunction(joystick,getbutton);
	UBindFunction(joystick,getaxis);
	UBindFunction(joystick,gethat);
	UBindFunction(joystick,getballx);
	UBindFunction(joystick,getbally);

    etat = 1; // boucle while() infinie
    // creation du thread qui met a jour les valeurs
    t1 = SDL_CreateThread(thread, (void*) this);

	// initialisation de toutes les variables
	joystick_ = NULL;
	nb_buttons = 0;
	nb_axis = 0;
	nb_hats = 0;
	nb_balls = 0;

	joystick_ = NULL;
}

// Destruction de l'objet mouse 
joystick::~joystick(void)
{
    etat = 0; // fin de la boucle while() du thread
    if(joystick_ != NULL)
  	  SDL_JoystickClose(joystick_);
    SDL_KillThread (t1); // destruction du thread
	SDL_QuitSubSystem(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK); // arret de SDL
    atexit(SDL_Quit); // fin de SDL
    SDL_Quit();
}

// creation de new joystick()
int joystick::init(void)
{
    return 1; // pas possible de faire une creation de joystick
}



// Recuperation des evenements
void joystick::process_events(void)
{

     // Un evenement attend d'etre traite ? 
     while (SDL_PollEvent(&event))
     {
	  // Si oui, quel type? 
	  switch (event.type)
	  {

          // Dplacement axe joystick 
	  case SDL_JOYAXISMOTION:
//	       printf("Axe %d du joystick %d positionne a %d\n", event.jaxis.axis, event.jaxis.which, event.jaxis.value);
		    if(event.jaxis.axis == 0)
              joyaxe1 = event.jaxis.value;
		    else if(event.jaxis.axis == 1)
              joyaxe2 = event.jaxis.value;
		    else if(event.jaxis.axis == 2)
              joyaxe3 = event.jaxis.value;
		    else if(event.jaxis.axis == 3)
              joyaxe4 = event.jaxis.value;
		    else if(event.jaxis.axis == 4)
              joyaxe5 = event.jaxis.value;
		    else if(event.jaxis.axis == 5)
              joyaxe6 = event.jaxis.value;
		    else if(event.jaxis.axis == 6)
              joyaxe7 = event.jaxis.value;
		    else if(event.jaxis.axis == 7)
              joyaxe8 = event.jaxis.value;
		    else if(event.jaxis.axis == 8)
              joyaxe9 = event.jaxis.value;
		    else if(event.jaxis.axis == 9)
              joyaxe10 = event.jaxis.value;
	       break;


          // Dplacement chapeau joystick 
	  case SDL_JOYHATMOTION:
		    if(event.jhat.hat == 0)
              joyhat1 = event.jhat.value;
		    else if(event.jhat.hat == 1)
              joyhat2 = event.jhat.value;
		    else if(event.jhat.hat == 2)
              joyhat3 = event.jhat.value;
		    else if(event.jhat.hat == 3)
              joyhat4 = event.jhat.value;
		    else if(event.jhat.hat == 4)
              joyhat5 = event.jhat.value;
		    else if(event.jhat.hat == 5)
              joyhat6 = event.jhat.value;
		    else if(event.jhat.hat == 6)
              joyhat7 = event.jhat.value;
		    else if(event.jhat.hat == 7)
              joyhat8 = event.jhat.value;
		    else if(event.jhat.hat == 8)
              joyhat9 = event.jhat.value;
		    else if(event.jhat.hat == 9)
              joyhat10 = event.jhat.value;
	       printf("Chapeau %d du joystick %d en position ",  event.jhat.hat, event.jhat.which);
	       switch (event.jhat.value)
	       {
	       case SDL_HAT_CENTERED:
		    printf("centree\n");
		    break;
	       case SDL_HAT_UP:
		    printf("haute\n");
		    break;
	       case SDL_HAT_RIGHT:
		    printf("droite\n");
		    break;
	       case SDL_HAT_DOWN:
		    printf("basse\n");
		    break;
	       case SDL_HAT_LEFT:
		    printf("gauche\n");
		    break;
	       case SDL_HAT_RIGHTUP:
		    printf("haute/droite\n");
		    break;
	       case SDL_HAT_RIGHTDOWN:
		    printf("basse/droite\n");
		    break;
	       case SDL_HAT_LEFTUP:
		    printf("haute/gauche\n");
		    break;
	       case SDL_HAT_LEFTDOWN:
		    printf("basse/gauche\n");
		    break;
	       }
	       break;


          // Dplacement trackball joystick 
	  case SDL_JOYBALLMOTION:
	       printf("Trackball %d du joystick %d a bouge de (%d, %d)\n", event.jball.ball, event.jball.which, event.jball.xrel, event.jball.yrel);
		    if(event.jball.ball == 0)
		    {
              joyballxrel1 = event.jball.xrel;
              joyballyrel1 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 1)
		    {
              joyballxrel2 = event.jball.xrel;
              joyballyrel2 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 2)
		    {
              joyballxrel3 = event.jball.xrel;
              joyballyrel3 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 3)
		    {
              joyballxrel4 = event.jball.xrel;
              joyballyrel4 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 4)
		    {
              joyballxrel5 = event.jball.xrel;
              joyballyrel5 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 5)
		    {
              joyballxrel6 = event.jball.xrel;
              joyballyrel6 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 6)
		    {
              joyballxrel7 = event.jball.xrel;
              joyballyrel7 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 7)
		    {
              joyballxrel8 = event.jball.xrel;
              joyballyrel8 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 8)
		    {
              joyballxrel9 = event.jball.xrel;
              joyballyrel9 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 9)
		    {
              joyballxrel10 = event.jball.xrel;
              joyballyrel10 = event.jball.yrel;
		    }
	       break;


          // Appui bouton joystick 
	  case SDL_JOYBUTTONDOWN:
      printf("Bouton %d du joystick %d enfonce\n", event.jbutton.button, event.jbutton.which);
          if( event.jbutton.button == 0 )
               joybutton1=1;
          else if(event.jbutton.button == 1)
               joybutton2=1;
          else if(event.jbutton.button == 2)
               joybutton3=1;
          else if(event.jbutton.button == 3)
               joybutton4=1;
          else if(event.jbutton.button == 4)
               joybutton5=1;
          else if(event.jbutton.button == 5)
               joybutton6=1;
          else if(event.jbutton.button == 6)
               joybutton7=1;
          else if(event.jbutton.button == 7)
               joybutton8=1;
          else if(event.jbutton.button == 8)
               joybutton9=1;
          else if(event.jbutton.button == 9)
               joybutton10=1;
          else if(event.jbutton.button == 10)
               joybutton11=1;
          else if(event.jbutton.button == 11)
               joybutton12=1;
          else if(event.jbutton.button == 12)
               joybutton13=1;
          else if(event.jbutton.button == 13)
               joybutton14=1;
          else if(event.jbutton.button == 14)
               joybutton15=1;
          else if(event.jbutton.button == 15)
               joybutton16=1;
          else if(event.jbutton.button == 16)
               joybutton17=1;
          else if(event.jbutton.button == 17)
               joybutton18=1;
          else if(event.jbutton.button == 18)
               joybutton19=1;
          else if(event.jbutton.button == 19)
               joybutton20=1;
	       break;


          // Relachement bouton joystick 
	  case SDL_JOYBUTTONUP:
	       printf("Bouton %d du joystick %d relache\n", event.jbutton.button, event.jbutton.which);
          if( event.jbutton.button == 0 )
               joybutton1=0;
          else if(event.jbutton.button == 1)
               joybutton2=0;
          else if(event.jbutton.button == 2)
               joybutton3=0;
          else if(event.jbutton.button == 3)
               joybutton4=0;
          else if(event.jbutton.button == 4)
               joybutton5=0;
          else if(event.jbutton.button == 5)
               joybutton6=0;
          else if(event.jbutton.button == 6)
               joybutton7=0;
          else if(event.jbutton.button == 7)
               joybutton8=0;
          else if(event.jbutton.button == 8)
               joybutton9=0;
          else if(event.jbutton.button == 9)
               joybutton10=0;
          else if(event.jbutton.button == 10)
               joybutton11=0;
          else if(event.jbutton.button == 11)
               joybutton12=0;
          else if(event.jbutton.button == 12)
               joybutton13=0;
          else if(event.jbutton.button == 13)
               joybutton14=0;
          else if(event.jbutton.button == 14)
               joybutton15=0;
          else if(event.jbutton.button == 15)
               joybutton16=0;
          else if(event.jbutton.button == 16)
               joybutton17=0;
          else if(event.jbutton.button == 17)
               joybutton18=0;
          else if(event.jbutton.button == 18)
               joybutton19=0;
          else if(event.jbutton.button == 19)
               joybutton20=0;
	       break;


	  default:
	       break;


	  }
     }    
}


// creation des variables pour le joystick
void joystick::initjoy(void)
{

    if( nbjoysticks == 0)
      return;

    if( nbmaxjoyaxes > 0)
    {
        if(nbmaxjoyaxes >= 1)
        {
           UBindVar(joystick,joyaxe1);
           joyaxe1 = 0;
        }
        if(nbmaxjoyaxes >= 2)
        {
           UBindVar(joystick,joyaxe2);
           joyaxe2 = 0;
        }
        if(nbmaxjoyaxes >= 3)
        {
           UBindVar(joystick,joyaxe3);
           joyaxe3 = 0;
        }
        if(nbmaxjoyaxes >= 4)
        {
           UBindVar(joystick,joyaxe4);
           joyaxe4 = 0;
        }
        if(nbmaxjoyaxes >= 5)
        {
           UBindVar(joystick,joyaxe5);
           joyaxe5 = 0;
        }
        if(nbmaxjoyaxes >= 6)
        {
           UBindVar(joystick,joyaxe6);
           joyaxe6 = 0;
        }
        if(nbmaxjoyaxes >= 7)
        {
           UBindVar(joystick,joyaxe7);
           joyaxe7 = 0;
        }
        if(nbmaxjoyaxes >= 8)
        {
           UBindVar(joystick,joyaxe8);
           joyaxe8 = 0;
        }
        if(nbmaxjoyaxes >= 9)
        {
           UBindVar(joystick,joyaxe9);
           joyaxe9 = 0;
        }
        if(nbmaxjoyaxes >= 10)
        {
           UBindVar(joystick,joyaxe10);
           joyaxe10 = 0;
        }
    }

    if( nbmaxjoyballs > 0)
    {
        if(nbmaxjoyballs >= 1)
        {
           UBindVar(joystick,joyballxrel1);
           UBindVar(joystick,joyballyrel1);
           joyballxrel1 = 0;
           joyballyrel1 = 0;
        }
        if(nbmaxjoyballs >= 2)
        {
           UBindVar(joystick,joyballxrel2);
           UBindVar(joystick,joyballyrel2);
           joyballxrel2 = 0;
           joyballyrel2 = 0;
        }
        if(nbmaxjoyballs >= 3)
        {
           UBindVar(joystick,joyballxrel3);
           UBindVar(joystick,joyballyrel3);
           joyballxrel3 = 0;
           joyballyrel3 = 0;
        }
        if(nbmaxjoyballs >= 4)
        {
           UBindVar(joystick,joyballxrel4);
           UBindVar(joystick,joyballyrel4);
           joyballxrel4 = 0;
           joyballyrel4 = 0;
        }
        if(nbmaxjoyballs >= 5)
        {
           UBindVar(joystick,joyballxrel5);
           UBindVar(joystick,joyballyrel5);
           joyballxrel5 = 0;
           joyballyrel5 = 0;
        }
        if(nbmaxjoyballs >= 6)
        {
           UBindVar(joystick,joyballxrel6);
           UBindVar(joystick,joyballyrel6);
           joyballxrel6 = 0;
           joyballyrel6 = 0;
        }
        if(nbmaxjoyballs >= 7)
        {
           UBindVar(joystick,joyballxrel7);
           UBindVar(joystick,joyballyrel7);
           joyballxrel7 = 0;
           joyballyrel7 = 0;
        }
        if(nbmaxjoyballs >= 8)
        {
           UBindVar(joystick,joyballxrel8);
           UBindVar(joystick,joyballyrel8);
           joyballxrel8 = 0;
           joyballyrel8 = 0;
        }
        if(nbmaxjoyballs >= 9)
        {
           UBindVar(joystick,joyballxrel9);
           UBindVar(joystick,joyballyrel9);
           joyballxrel9 = 0;
           joyballyrel9 = 0;
        }
        if(nbmaxjoyballs >= 10)
        {
           UBindVar(joystick,joyballxrel10);
           UBindVar(joystick,joyballyrel10);
           joyballxrel10 = 0;
           joyballyrel10 = 0;
        }
    }


    if( nbmaxjoyhats > 0)
    {
        if(nbmaxjoyhats >= 1)
        {
           UBindVar(joystick,joyhat1);
           joyhat1 = 0;
        }
        if(nbmaxjoyhats >= 2)
        {
           UBindVar(joystick,joyhat2);
           joyhat2 = 0;
        }
        if(nbmaxjoyhats >= 3)
        {
           UBindVar(joystick,joyhat3);
           joyhat3 = 0;
        }
        if(nbmaxjoyhats >= 4)
        {
           UBindVar(joystick,joyhat4);
           joyhat4 = 0;
        }
        if(nbmaxjoyhats >= 5)
        {
           UBindVar(joystick,joyhat5);
           joyhat5 = 0;
        }
        if(nbmaxjoyhats >= 6)
        {
           UBindVar(joystick,joyhat6);
           joyhat6 = 0;
        }
        if(nbmaxjoyhats >= 7)
        {
           UBindVar(joystick,joyhat7);
           joyhat7 = 0;
        }
        if(nbmaxjoyhats >= 8)
        {
           UBindVar(joystick,joyhat8);
           joyhat8 = 0;
        }
        if(nbmaxjoyhats >= 9)
        {
           UBindVar(joystick,joyhat9);
           joyhat9 = 0;
        }
        if(nbmaxjoyhats >= 10)
        {
           UBindVar(joystick,joyhat10);
           joyhat10 = 0;
        }
    }


    if( nbmaxjoybuttons > 0)
    {
        if(nbmaxjoybuttons >= 1)
        {
           UBindVar(joystick,joybutton1);
           joybutton1 = 0;
        }
        if(nbmaxjoybuttons >= 2)
        {
           UBindVar(joystick,joybutton2);
           joybutton2 = 0;
        }
        if(nbmaxjoybuttons >= 3)
        {
           UBindVar(joystick,joybutton3);
           joybutton3 = 0;
        }
        if(nbmaxjoybuttons >= 4)
        {
           UBindVar(joystick,joybutton4);
           joybutton4 = 0;
        }
        if(nbmaxjoybuttons >= 5)
        {
           UBindVar(joystick,joybutton5);
           joybutton5 = 0;
        }
        if(nbmaxjoybuttons >= 6)
        {
           UBindVar(joystick,joybutton6);
           joybutton6 = 0;
        }
        if(nbmaxjoybuttons >= 7)
        {
           UBindVar(joystick,joybutton7);
           joybutton7 = 0;
        }
        if(nbmaxjoybuttons >= 8)
        {
           UBindVar(joystick,joybutton8);
           joybutton8 = 0;
        }
        if(nbmaxjoybuttons >= 9)
        {
           UBindVar(joystick,joybutton9);
           joybutton9 = 0;
        }
        if(nbmaxjoybuttons >= 10)
        {
           UBindVar(joystick,joybutton10);
           joybutton10 = 0;
        }
        if(nbmaxjoybuttons >= 11)
        {
           UBindVar(joystick,joybutton11);
           joybutton11 = 0;
        }
        if(nbmaxjoybuttons >= 12)
        {
           UBindVar(joystick,joybutton12);
           joybutton12 = 0;
        }
        if(nbmaxjoybuttons >= 13)
        {
           UBindVar(joystick,joybutton13);
           joybutton13 = 0;
        }
        if(nbmaxjoybuttons >= 14)
        {
           UBindVar(joystick,joybutton14);
           joybutton14 = 0;
        }
        if(nbmaxjoybuttons >= 15)
        {
           UBindVar(joystick,joybutton15);
           joybutton15 = 0;
        }
        if(nbmaxjoybuttons >= 16)
        {
           UBindVar(joystick,joybutton16);
           joybutton16 = 0;
        }
        if(nbmaxjoybuttons >= 17)
        {
           UBindVar(joystick,joybutton17);
           joybutton17 = 0;
        }
        if(nbmaxjoybuttons >= 18)
        {
           UBindVar(joystick,joybutton18);
           joybutton18 = 0;
        }
        if(nbmaxjoybuttons >= 19)
        {
           UBindVar(joystick,joybutton19);
           joybutton19 = 0;
        }
        if(nbmaxjoybuttons >= 20)
        {
           UBindVar(joystick,joybutton20);
           joybutton20 = 0;
        }

    }


}

void joystick::selectjoy(int choix)
{
    if(joystick_ != NULL) // on verifie que joystick n'est pas alloue et s'il l'est, on le desalloue
	  SDL_JoystickClose(joystick_);


    // on recupere le nombre de joysticks
	int nb_joy = SDL_NumJoysticks();
 	if(choix <0 || choix >= nb_joy || nb_joy <= 0)
	{
		std::string message = "+connection(\"all\"):\"Error. Joystick doesn't found\";";
		urbi::send(message.c_str());
//		SDL_QuitSubSystem(SDL_INIT_JOYSTICK);
//		atexit(SDL_Quit); // fin de SDL
	    return ; // error
	}

    // ouverture du joystick choisi
	joystick_ = SDL_JoystickOpen(choix);

    // si joystick_ est null, alors il y a une erreur et on quitte
	if ( joystick_ == NULL ) 
    {
			std::string message = "+connection(\"all\"):\"Error. Couldn't open joystick\";";
			urbi::send(message.c_str());
//			SDL_QuitSubSystem(SDL_INIT_JOYSTICK);
//			atexit(SDL_Quit); // fin de SDL
			return ; // error
	} 

    // on verifie que le joystick a bien ete ouvert
   if(SDL_JoystickOpened (choix) == 0)
   {
			std::string message = "+connection(\"all\"):\"Error. Couldn't open joystick\";";
			urbi::send(message.c_str());
//			SDL_QuitSubSystem(SDL_INIT_JOYSTICK);
//			atexit(SDL_Quit); // fin de SDL
			return ; // error
   }

   // on recupere le nom du joystick
	const char *name;
	name = SDL_JoystickName(SDL_JoystickIndex(joystick_));

    // on affiche des infos au sujet du joystick
	printf("Watching joystick %d: (%s)\n", SDL_JoystickIndex(joystick_), name ? name : "Unknown Joystick");
	nb_buttons = SDL_JoystickNumButtons(joystick_); 
	nb_axis = SDL_JoystickNumAxes(joystick_);
	nb_hats = SDL_JoystickNumHats(joystick_);
	nb_balls = SDL_JoystickNumBalls(joystick_);
	printf("Joystick has %d axes, %d hats, %d balls, and %d buttons\n", nb_axis , nb_hats , nb_balls , nb_buttons);

    // on demande qu'a chaque changement de la valeur du joystick, une mise a jour soit effectuee.
    SDL_JoystickEventState(SDL_ENABLE); 
	SDL_Event event; // pour gerer les evenements

	// on recupere le nom du UObject et on met a jour les valeurs du joystick
    _name = __name; // _name prend le nom du UObject
//    std::string message = "tagjoystick" + _name + " : " + _name + ".updatejoy(\"" + _name + "\") ,";
//	urbi::send(message.c_str());

	return;
}


// donne la valeur d'un bouton
int joystick::getbutton(int choix)
{
    if(joystick_ == NULL) // aucun joystick n'a t slectionn
      selectjoy(0); // on choisit le joystick 0
    if(joystick_ == NULL) // alors l'affectation a echouee
      return -1;

    if( choix >= SDL_JoystickNumButtons(joystick_) || choix < 0 )
    {
//	std::string message = "+connection(\"all\"):\"Error. No button\";";
//	urbi::send(message.c_str());
    return -1;
    }

    // mise a jour de toutes les valeurs du joystick ouvert
//    SDL_JoystickUpdate (); 

    int etat = SDL_JoystickGetButton(joystick_,choix); 
    return etat;   
}


// donne la valeur d'un axe
int joystick::getaxis(int choix)
{
    if(joystick_ == NULL) // aucun joystick n'a t slectionn
      selectjoy(0); // on choisit le joystick 0
    if(joystick_ == NULL) // alors l'affectation a echouee
      return -1;


    if( choix >= SDL_JoystickNumAxes(joystick_) || choix < 0 )
    {
//	std::string message = "+connection(\"all\"):\"Error. No axis\";";
//	urbi::send(message.c_str());
    return -1;
    }

    // mise a jour de toutes les valeurs du joystick ouvert
//    SDL_JoystickUpdate (); 

    int etat = SDL_JoystickGetAxis(joystick_,choix); 
    return etat;   
}


// donne la valeur d'un chapeau
int joystick::gethat(int choix)
{
    if(joystick_ == NULL) // aucun joystick n'a t slectionn
      selectjoy(0); // on choisit le joystick 0
    if(joystick_ == NULL) // alors l'affectation a echouee
      return -1;

    if( choix >= SDL_JoystickNumHats(joystick_) || choix < 0 )
    {
//	std::string message = "+connection(\"all\"):\"Error. No axis\";";
//	urbi::send(message.c_str());
    return -1;
    }

    // mise a jour de toutes les valeurs du joystick ouvert
//    SDL_JoystickUpdate (); 

    int etat = SDL_JoystickGetHat(joystick_,choix); 
    return etat;   
}

// donne la valeur x d'une balle
int joystick::getballx(int choix)
{
    if(joystick_ == NULL) // aucun joystick n'a t slectionn
      selectjoy(0); // on choisit le joystick 0
    if(joystick_ == NULL) // alors l'affectation a echouee
      return -1;

    if( choix >= SDL_JoystickNumBalls(joystick_) || choix < 0 )
    {
//	std::string message = "+connection(\"all\"):\"Error. No ball\";";
//	urbi::send(message.c_str());
    return -1;
    }

    // mise a jour de toutes les valeurs du joystick ouvert
//    SDL_JoystickUpdate (); 

    int dx; int dy;
    int etat = SDL_JoystickGetBall(joystick_,choix,&dx,&dy); 
    return dx;   
}

// donne la valeur y d'une balle
int joystick::getbally(int choix)
{
    if(joystick_ == NULL) // aucun joystick n'a t slectionn
      selectjoy(0); // on choisit le joystick 0
    if(joystick_ == NULL) // alors l'affectation a echouee
      return -1;

    if( choix >= SDL_JoystickNumBalls(joystick_) || choix < 0 )
    {
//	std::string message = "+connection(\"all\"):\"Error. No ball\";";
//	urbi::send(message.c_str());
    return -1;
    }

    // mise a jour de toutes les valeurs du joystick ouvert
//    SDL_JoystickUpdate (); 

    int dx; int dy;
    int etat = SDL_JoystickGetBall(joystick_,choix,&dx,&dy); 
    return dy;   
}


// donne des infos sur les joysticks presents sur l'ordi
void joystick::info(void)
{
	const char *name;
	int i;
	SDL_Joystick *joystick;

	// Print information about the joysticks 
	int nb_joy = SDL_NumJoysticks();
	std::string message = "+connection(\"all\"):\"There are ";
	std::string messagetmp;
    std::ostringstream ostr; 
    ostr << nb_joy; 
    messagetmp = ostr.str(); 
    message = message + messagetmp;
	message = message + " joysticks attached\";";
	urbi::send(message.c_str());
	for ( i=0; i<SDL_NumJoysticks(); ++i ) 
    {
		name = SDL_JoystickName(i);
	
		message = "+connection(\"all\"):\"Joystick ";
		std::ostringstream ostr2; 
		ostr2 << i; 
		messagetmp = ostr2.str(); 
		message = message + messagetmp;
		message = message + " : ";
		message = message + name;
		message = message + "\";";
		urbi::send(message.c_str());
		joystick = SDL_JoystickOpen(i);
		if (joystick == NULL) 
        {
			fprintf(stderr, "SDL_JoystickOpen(%d) failed: %s\n", i, SDL_GetError());
			message = "+connection(\"all\"):\"Error. SDL_JoystickOpen() failed\";";
			urbi::send(message.c_str());
		} 
        else 
        {
			message = "+connection(\"all\"):\"* axes : ";
			std::ostringstream ostr3; 
			ostr3 << SDL_JoystickNumAxes(joystick); 
			messagetmp = ostr3.str(); 
			message = message + messagetmp;
			message = message + "\";";
			urbi::send(message.c_str());

			message = "+connection(\"all\"):\"* balls : ";
			std::ostringstream ostr4; 
			ostr4 << SDL_JoystickNumBalls(joystick); 
			messagetmp = ostr4.str(); 
			message = message + messagetmp;
			message = message + "\";";
			urbi::send(message.c_str());

			message = "+connection(\"all\"):\"* hats : ";
			std::ostringstream ostr5; 
			ostr5 << SDL_JoystickNumHats(joystick); 
			messagetmp = ostr5.str(); 
			message = message + messagetmp;
			message = message + "\";";
			urbi::send(message.c_str());

			message = "+connection(\"all\"):\"* buttons : ";
			std::ostringstream ostr6; 
			ostr6 << SDL_JoystickNumButtons(joystick); 
			messagetmp = ostr6.str(); 
			message = message + messagetmp;
			message = message + "\";";
			urbi::send(message.c_str());
			SDL_JoystickClose(joystick);
		}
	}


}








// actualisation des valeurs du joystick
void joystick::updatejoy(std::string _name)
{

// SDL_WaitEvent(&event); ==> fige le programme jusqu'a ce qu'un evenement se produise

    // mise a jour de toutes les valeurs du joystick ouvert
    SDL_JoystickUpdate (); 

    int i=0;
    int value =0 ;
	std::string message = "";

    for(i=0; i<nb_buttons;i++)
    {
       std::ostringstream ostr; 
       value = SDL_JoystickGetButton(joystick_,i);
       ostr << value; 
       std::ostringstream ostr2; 
       ostr2 << i; 
       message = message + _name + ".button" + ostr2.str() + " = " + ostr.str() + " & ";
    }

    for(i=0; i<nb_axis;i++)
    {
       std::ostringstream ostr; 
       value = SDL_JoystickGetAxis(joystick_,i);
       ostr << value; 
       std::ostringstream ostr2; 
       ostr2 << i; 
       message = message + _name + ".axis" + ostr2.str() + " = " + ostr.str() + " & ";
    }

    for(i=0; i<nb_hats;i++)
    {
       std::ostringstream ostr; 
       value = SDL_JoystickGetHat(joystick_,i);
       ostr << value; 
       std::ostringstream ostr2; 
       ostr2 << i; 
       message = message + _name + ".hat" + ostr2.str() + " = " + ostr.str() + " & ";
    }

    for(i=0; i<nb_balls;i++)
    {
       int dx, dy;
       value = SDL_JoystickGetBall(joystick_,i,&dx,&dy); 
       std::ostringstream ostr; 
       value = SDL_JoystickGetHat(joystick_,i);
       ostr << dx; 
       std::ostringstream ostr3; 
       value = SDL_JoystickGetHat(joystick_,i);
       ostr3 << dy; 
       std::ostringstream ostr2; 
       ostr2 << i; 
       message = message + _name + ".hatx" + ostr2.str() + " = " + ostr.str() + " & " + _name + ".haty" + ostr2.str() + " = " + ostr3.str() + " & ";
    }

    message = message + "tagjoystick" + _name + " : " + _name + ".updatejoy(\"" + _name + "\")"  + ",";
//    urbi::send(message.c_str());             
}


