#include "mastermind.h"

UStart(mastermind);

// Creation de l'objet mastermind
mastermind::mastermind(std::string s) : UObject(s) 
{
	UBindFunction(mastermind,init);
	UBindFunction(mastermind,start);
	UBindFunction(mastermind,play);
	UBindFunction(mastermind,solution);

	cpt=-1;
}


// Destruction de l'objet mastermind 
mastermind::~mastermind(void)
{
}

// creation de new mastermind()
int mastermind::init(void)
{
    return 1; // interdiction de faire un new
}

// demarrage d'une partie
void mastermind::start(void)
{

  int t_alea[4];
  int i;

  std::string message;
  message = "+connection(\"all\"):\"Ceci est le jeu de MasterMind. Le but etant de trouver une combinaison de 4 chiffres sachant que les chiffres doivent etre compris entre 0 et 5\";";
  urbi::send(message.c_str());


  srand(time(NULL)); // initialisation du generateur aleatoire
  for(i=0;i<4;i++)
  {
    t_alea[i]= rand()%6;
  }

  cpt=0;
  val1 = t_alea[0];
  val2 = t_alea[1];
  val3 = t_alea[2];
  val4 = t_alea[3];

  message = "+connection(\"all\"):\"Pour faire une proposition, faire mastermind.play(a,b,c,d); avec a,b,c,d comrpis entre 0 et 5\";";
  urbi::amessage.c_str());

}


// tentative pour trouver une solution
void mastermind::play(int a, int b, int c, int d)
{

  std::string message;

  if(cpt == -1)
  {
    message = "+connection(\"all\"):\"Faire mastermind.start(); pour demarrer une partie.\";";
    urbi::send(message.c_str());
    return;
  }

  if(a < 0 || a > 5 || b < 0 || b > 5 || c < 0 || c > 5 || d < 0 || d > 5  )
  {
    message = "+connection(\"all\"):\"Erreur, les valeurs doivent etre comprises entre 0 et 5 !\";";
    urbi::send(message.c_str());
    return;       
  }

  int cpt_correct=0, cpt_place=0;
  cpt+=1; 
  std::string messagetmp;
  std::ostringstream ostr; 
  message = "+connection(\"all\"):\"Essai : ";
  ostr << cpt; 
  messagetmp = ostr.str(); 
  message = message + messagetmp + "\";";
  urbi::send(message.c_str());


  if(a == val1 && b == val2 && c == val3 && d == val4)
  {
    message = "+connection(\"all\"):\"BRAVO, Vous avez gagne !\";";
    urbi::send(message.c_str());
    solution();
    cpt = -1;
    return;       
  }



// Compteur bien place
  if(a == val1) 
  {
       cpt_correct++;
       a = -1;
  }
  if(b == val2) 
  {
       cpt_correct++;
       b = -1;
  }
  if(c == val3) 
  {
       cpt_correct++;
       c = -1;
  }
  if(d == val4) 
  {
       cpt_correct++;
       d = -1;
  }


  std::ostringstream ostr2; 
  message = "+connection(\"all\"):\"Vous avez ";
  ostr2 << cpt_correct; 
  messagetmp = ostr2.str(); 
  message = message + messagetmp + " numeros bien place(s)\";";
  urbi::send(message.c_str());

// Compteur des numeros corrects mais mal places
  if(a != -1) 
  {
     if(val1 == b)
     {
       cpt_place++;
       b = -1;
     }
     else if(val1 == c)
     {
       cpt_place++;
       c = -1;
     }
     else if(val1 == d)
     {
       cpt_place++;
       d = -1;
     }
  }

  if(b != -1) 
  {
     if(val2 == a)
     {
       cpt_place++;
       a = -1;
     }
     else if(val2 == c)
     {
       cpt_place++;
       c = -1;
     }
     else if(val2 == d)
     {
       cpt_place++;
       d = -1;
     }
  }

  if(c != -1) 
  {
     if(val3 == a)
     {
       cpt_place++;
       a = -1;
     }
     else if(val3 == b)
     {
       cpt_place++;
       b = -1;
     }
     else if(val3 == d)
     {
       cpt_place++;
       d = -1;
     }
  }

  if(d != -1) 
  {
     if(val4 == a)
     {
       cpt_place++;
       a = -1;
     }
     else if(val4 == b)
     {
       cpt_place++;
       b = -1;
     }
     else if(val4 == c)
     {
       cpt_place++;
       c = -1;
     }
  }


  std::ostringstream ostr3; 
  message = "+connection(\"all\"):\"Vous avez ";
  ostr3 << cpt_place; 
  messagetmp = ostr3.str(); 
  message = message + messagetmp + " numero(s) correct(s) mais mal place(s)\";";
  urbi::send(message.c_str());
}


// affichage de la solution
void mastermind::solution(void)
{

  std::string message;
  std::string messagetmp;
  std::ostringstream ostr; 

  if(cpt == -1)
  {
    message = "+connection(\"all\"):\"Faire mastermind.start(); pour demarrer une partie.\";";
    urbi::send(message.c_str());
    return;
  }

  message = "+connection(\"all\"):\"La solution du jeu est : ";
  ostr << val1 << " - " << val2 << " - " << val3 << " - "  << val4; 
  messagetmp = ostr.str(); 
  message = message + messagetmp + "\";";
  urbi::send(message.c_str());
}
