#include "demineur.h"


UStart(demineur);

// Creation de l'objet demineur 
demineur::demineur(std::string s) : UObject(s) 
{

	UBindFunction(demineur,init);
	UBindFunction(demineur,RepeteCar);
	UBindFunction(demineur,LigneInter);
	UBindFunction(demineur,AffichagePerdu);
	UBindFunction(demineur,start);
	UBindFunction(demineur,play);
	UBindFunction(demineur,solution);
	UBindFunction(demineur,playM);

	Jeu = NULL; // le pointeur vers la matrice pointe vers null
	btest = 0; // le jeu n'a pas demarre

}


// Destruction de l'objet demineur 
demineur::~demineur(void)
{

}

// empecher que l'on puisse faire un new demineur()
int demineur::init(void)
{
  return 1; // Singleton
}


// Procdure de rptition de caractres spciaux pour affichage 
void demineur::RepeteCar(int carac, int nb)
{
  int boucle;
  std::string message = "+connection(\"all\"):\"";
  std::string messagetmp;
  for(boucle=0;boucle<nb;boucle++)
  {
//    printf("%c",carac);
   	messagetmp = carac;
    message = message + messagetmp;
  }
  message = message + "\";";
  urbi::send(message.c_str());
}


// Procdure d'impression de la ligne horizontale sparatrice de la matrice de jeu 
void demineur::LigneInter(int longueur)
{
  std::string message = "+connection(\"all\"):\"";
  std::string messagetmp;

  for(longueur;longueur>0;longueur--)
  {
    switch(longueur%2)
    {
      case 1:
//        printf("%c",HORII);
//        messagetmp = HORII;
        message = message + messagetmp;
        break;
      
      case 0:
//        printf("%c",INTERS);
//        messagetmp = HORII;
        message = message + messagetmp;
        break;
    }
  }

  message = message + "\";";
  urbi::send(message.c_str());

}

void demineur::AffichagePerdu()
{
//  printf("\nVous avez perdu !!!!!!!\n");
  std::string message = "+connection(\"all\"):\"Vous avez perdu !!!!!!!!!\";";
  urbi::send(message.c_str());
}



// Partie principale du programme 
void demineur::start(int lignes,int colonnes, int bombes)
{
   if(lignes <1 && lignes > 20)
   {
     std::string message = "+connection(\"all\"):\"Erreur. Le nombre de lignes doit etre compris entre 1 et 20\";";
     urbi::send(message.c_str());
   }
   if(colonnes <1 && colonnes > 20)
   {
     std::string message = "+connection(\"all\"):\"Erreur. Le nombre de colonnes doit etre compris entre 1 et 20\";";
     urbi::send(message.c_str());
   }

   if(bombes <1 && bombes > lignes*colonnes-1)
   {
     std::string message = "+connection(\"all\"):\"Erreur. Le nombre de bombes est incorrect\";";
     urbi::send(message.c_str());
   }

   largeur = colonnes;
   hauteur = lignes;

        if(btest==1 || Jeu != NULL)
        {
          delete Jeu;
          Jeu = NULL;
        }
        Jeu = new Matrice("test");
 
 
        Jeu->InitMatrice(lignes,colonnes,bombes);
        Jeu->InitBombe();
        Jeu->InitChiffre();

        btest=1;

        int result = Jeu->AfficheMatrice();

        if(result==1) 
        {
          btest = 0;
          AffichagePerdu();
          solution();
        }
        else
        {
          if(result==2)
          {
            delete Jeu;
            Jeu = NULL;
            btest=0;
          }
        }




}  


// On selectionne une case 
void demineur::play(int x,int y)
{
     if(Jeu == NULL)
     {
       std::string message = "+connection(\"all\"):\"Vous devez faire demineur.start(lignes,colonnes,bombes); pour demarrer la partie\";";
       urbi::send(message.c_str());
       return;
     }

//     printf("hauteur = %d et largeur = %d et x = %d et y = %d\n",hauteur,largeur,x,y);
     
     if(x < 0  || x > largeur || y <0 || y > hauteur)
     {
       std::string message = "+connection(\"all\"):\"Votre selection est en dehors de la matrice\";";
       urbi::send(message.c_str());
       return;
     }

     int result=0;
     result = Jeu->play(x,y);
     if(result == 1) // le jeu est perdu
     {
       std::string message = "+connection(\"all\"):\"Faire demineur.start(lignes,colonnes,bombes); pour demarrer une partie\";";
       urbi::send(message.c_str());

     }
     else
        Jeu->AfficheMatrice();
}  


// On selectionne une case avec une bombe
void demineur::playM(int x,int y)
{
     if(Jeu == NULL)
     {
       std::string message = "+connection(\"all\"):\"Vous devez faire demineur.start(lignes,colonnes,bombes); pour demarrer la partie\";";
       urbi::send(message.c_str());
       return;
     }

//     printf("hauteur = %d et largeur = %d et x = %d et y = %d\n",hauteur,largeur,x,y);
     
     if(x < 0  || x > largeur || y <0 || y > hauteur)
     {
       std::string message = "+connection(\"all\"):\"Votre selection est en dehors de la matrice\";";
       urbi::send(message.c_str());
       return;
     }

     int result=0;
     result = Jeu->playM(x,y);
     if(result == 1) // le jeu est perdu
     {
       std::string message = "+connection(\"all\"):\"Faire demineur.start(lignes,colonnes,bombes); pour demarrer une partie\";";
       urbi::send(message.c_str());

     }
     else
        Jeu->AfficheMatrice();
}  


// On donne la solution 
void demineur::solution(void)
{
     if(Jeu == NULL)
     {
       std::string message = "+connection(\"all\"):\"Vous devez faire demineur.start(lignes,colonnes,bombes); pour demarrer la partie\";";
       urbi::send(message.c_str());
       return;
     }

     Jeu->AfficheMatricesolution();
}  
