#include "matrice.h"

UStart(Matrice);

// Constructeur Classe Matrice 
Matrice::Matrice(std::string s) : UObject(s) 
{

	UBindFunction(Matrice,InitBombe);
	UBindFunction(Matrice,RafraichirMatrice);
	UBindFunction(Matrice,AfficheZero);
	UBindFunction(Matrice,InitBombe);
	UBindFunction(Matrice,AfficheZero);
	UBindFunction(Matrice,InitChiffre);
	UBindFunction(Matrice,PartieGagnee);
	UBindFunction(Matrice,RechercheCase);
	UBindFunction(Matrice,CompteurFlag);
	UBindFunction(Matrice,AffichagePerdu);
	UBindFunction(Matrice,LigneInter);
	UBindFunction(Matrice,RepeteCar);
	UBindFunction(Matrice,play);
	UBindFunction(Matrice,AfficheMatricesolution);
	UBindFunction(Matrice,playM);

}


// Destructeur de Matrice 
Matrice::~Matrice()
{
  int i1, i2;
  struct CaseMat * Suppr;
  for(i2 = this->iNbLig; i2>0;i2--)
  {
    for(i1 = this->iNbCol; i1>0 ; i1--)
    {
      Suppr = RechercheCase(i1,i2);
      delete Suppr;
      Suppr = NULL;
    }
  }
}



// Mthode de rafraichissement de la matrice, notamment pour les cases vides 
void Matrice::RafraichirMatrice()
{
  int bTest,x,y;
  struct CaseMat * Case;
  bTest = 1;
  while(bTest!=0)
  {
    bTest = 0;
    for(y=1;y<=this->iNbLig;y++)
    {
      for(x=1;x<=this->iNbCol;x++)
      {
        Case = this->RechercheCase(x,y);
        if((Case->NbBombe==0)&&(Case->CaseVisible==1))
        {
          if(this->AfficheZero(x,y)==1)
            bTest=1;
        }
      }
    }
  }
}

// Mthode d'initialisation de la Matrice 
void Matrice::InitMatrice(int largeur,int hauteur, int bombes)
{ 


  int Ligne = 0;    // On dclare les variables qui nous seront utiles
  int Colonne = 0;
  int Bombe = 0;
  int iCptL = 0;
  int iCptC = 0;
  int iCptB = 0;
  char test[20];
  struct CaseMat * Courant;
  struct CaseMat * ColPrecedent = NULL;
  struct CaseMat * LigPrecedent = NULL;
  struct CaseMat * PremierLigne = NULL;
  
  Ligne = largeur;
  std::string message = "+connection(\"all\"):\"La matrice fait ";
  std::string messagetmp;
  std::ostringstream ostr; 
  ostr << largeur; 
  messagetmp = ostr.str(); 
  message = message + messagetmp;
  message = message + " cases en largeur\";";
  urbi::send(message.c_str());


  Colonne = hauteur;
  message = "+connection(\"all\"):\"La matrice fait ";
  std::ostringstream ostr2; 
  ostr2 << hauteur; 
  messagetmp = ostr2.str(); 
  message = message + messagetmp;
  message = message + " cases en hauteur\";";
  urbi::send(message.c_str());

  
  Bombe = bombes; 
  message = "+connection(\"all\"):\"La matrice a ";
  std::ostringstream ostr3; 
  ostr3 << bombes; 
  messagetmp = ostr3.str(); 
  message = message + messagetmp;
  message = message + " bombes\";";
  urbi::send(message.c_str());


  // Quand la saisie est bonne pour les trois valeurs, on affecte ses dernires aux donnes membres
  this->iNbLig = Ligne;
  this->iNbCol = Colonne;
  this->iNbBombe = Bombe;
  for(iCptL = 1;iCptL <= Ligne; iCptL++)
  {
    for(iCptC = 1; iCptC <= Colonne; iCptC++)
    {
      Courant = new CaseMat;
      Courant->NumLig = iCptL; // nombre de lignes
      Courant->NumCol = iCptC; // nombre de colonnes
      Courant->Bombe = 0; // case sans bombe
      Courant->NbBombe = 0; // pas de bombe
      Courant->CaseVisible = 0; // case non visible
      if(ColPrecedent != NULL) 
      {
        ColPrecedent->ColonneSuivante = Courant;
      }
      else
      {
        PremierLigne = Courant;
      }
      if(LigPrecedent != NULL)
      {
        LigPrecedent->LigneSuivante = Courant;
        LigPrecedent = LigPrecedent->ColonneSuivante;
      }
      if((LigPrecedent==NULL)&&(ColPrecedent==NULL)) this->PremiereCase = Courant;
      ColPrecedent = Courant;
    }
    Courant->ColonneSuivante = NULL;
    ColPrecedent = NULL;
    LigPrecedent = PremierLigne;
  }
  Courant->LigneSuivante = NULL; 



}


  // Mthode d'initialisation des bombes dans la matrice 
void Matrice::InitBombe()
{
  int cptBombe, Bx, By;
  struct CaseMat * Test;
  cptBombe = this->iNbBombe; // on recupere le nombre de bombes total
  while(cptBombe>0) // tant que toutes les bombes n'ont pas ete dispo
  {
    Bx = 1 + rand()%(this->iNbCol);
    By = 1 + rand()%(this->iNbLig);
    Test = RechercheCase(Bx, By); // recherche case donne le contenu de la case
    if(Test->Bombe == 0)
    {
      Test->Bombe = 1;
      cptBombe--;
    }
  }
}

  // Mthode affichant les cases adjacentes  une case proche de 0 bombes 
int Matrice::AfficheZero(int x, int y)
{
  struct CaseMat * Test;
  int booleen;
  booleen = 0;
  if((x!=1)&&(y!=1))
  {
    Test = this->RechercheCase(x-1, y-1);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  if(x != 1)
  {
    Test = this->RechercheCase(x-1, y);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  if(y != 1)
  {
    Test = this->RechercheCase(x, y-1);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  if((x != this->iNbCol)&&(y!=1))
  {
    Test = this->RechercheCase(x+1, y-1);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  if(x != this->iNbCol)
  {
    Test = this->RechercheCase(x+1, y);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  if((y != this->iNbLig)&&(x!=1))
  {
    Test = this->RechercheCase(x-1, y+1);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  if(y != this->iNbLig)
  {
    Test = this->RechercheCase(x,y+1);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  if((x != this->iNbCol) && (y != this->iNbLig))
  {
    Test = this->RechercheCase(x+1, y+1);
    if(Test->CaseVisible==0)
    {
      Test->CaseVisible=1;
      booleen = 1;
    }
  }
  return(booleen);
}

  // Mthode d'initialisation du compteur de bombes  proximits 
void Matrice::InitChiffre()
{
  struct CaseMat * Courant;
  struct CaseMat * PremierLigne;
  struct CaseMat * Test;

  int compteur=0; // on va compter le nombre de cases

  int cpt,x,y;
  int stop = 0;
  Courant = this->PremiereCase;
  PremierLigne = Courant;
  while(stop!=1)
  {
    compteur++; // on augmente le nombre de cases de 1
    if( compteur >= (iNbCol*iNbLig+1) ) // c'est un test pour verifier que l'on ne va pas n'importe ou
    {
      stop=1;
      return;
    }

    cpt=0;
    x = Courant->NumCol;
    y = Courant->NumLig;

    if( x > iNbCol || y > iNbLig || x < 1 || y < 1 ) // c'est un test pour verifier que l'on ne va pas n'importe ou
    {
      stop=1;
      return;
    }

    if((x!=1)&&(y!=1))
    {
      Test = this->RechercheCase(x-1, y-1);
      if(Test->Bombe==1) cpt++;
    }
    if(x != 1)
    {
      Test = this->RechercheCase(x-1, y);
      if(Test->Bombe==1) cpt++;
    }
    if(y != 1)
    {
      Test = this->RechercheCase(x, y-1);
      if(Test->Bombe==1) cpt++;
    }


    if((x != this->iNbCol)&&(y!=1))
    {
      Test = this->RechercheCase(x+1, y-1);
      if(Test->Bombe==1) cpt++;
    }
    
    if(x != this->iNbCol)
    {
      Test = this->RechercheCase(x+1, y);
      if(Test->Bombe==1) cpt++;
    }
    
    if((y != this->iNbLig)&&(x!=1))
    {
      Test = this->RechercheCase(x-1, y+1);
      if(Test->Bombe==1) cpt++;
    }
    if(y != this->iNbLig)
    {
      Test = this->RechercheCase(x,y+1);
      if(Test->Bombe==1) cpt++;
    }
    if((x != this->iNbCol) && (y != this->iNbLig))
    {
      Test = this->RechercheCase(x+1, y+1);
      if(Test->Bombe==1) cpt++;
    }

    
    Courant->NbBombe = cpt++;

    if(Courant->ColonneSuivante != NULL )
    {
      Courant = Courant->ColonneSuivante;
    }
    else
    {
      if(PremierLigne->LigneSuivante != NULL )
      {
       Courant = PremierLigne->LigneSuivante;
       PremierLigne = Courant;
      }
      else stop=1;
    }



  }


}

  // Mthode vrifiant que toutes les cases sans bombes ont t dcouvertes 
int Matrice::PartieGagnee()
{
  int a,b,cpt,NbCaseSSBombe;
  struct CaseMat * Test;
  cpt = 0;
  NbCaseSSBombe = ( (this->iNbLig) * (this->iNbCol) ) - (this->iNbBombe);
  for(a=1;a<=this->iNbLig;a++)
  {
    for(b=1;b<=this->iNbCol;b++)
    {
      Test = RechercheCase(b,a);
      if(Test->CaseVisible==1) cpt++;
    }
  }
  if(NbCaseSSBombe==cpt)
  {
    return(1);
  }
  else
  {
    return(0);
  }
}


  // Mthode de recherche d'une case par ses coordonnes 
struct CaseMat * Matrice::RechercheCase(int x, int y)
{
  struct CaseMat * Courant;
  Courant = this->PremiereCase;
  while(Courant->NumLig != y)
  {
    Courant = Courant->LigneSuivante;
  }
  
  while(Courant->NumCol != x)
  {
    Courant = Courant->ColonneSuivante;
  }
  return(Courant);
}

  // Mthode pour compter le nombre de flags poss 
int Matrice::CompteurFlag()
{
  int a, b, cpt;
  struct CaseMat * Test;
  cpt = 0;
  for(a=1;a<=this->iNbLig;a++)
  {
    for(b=1;b<=this->iNbCol;b++)
    {
      Test = RechercheCase(b,a);
      if(Test->CaseVisible == 2) cpt++; // si caseVisible == 2 alors, il y a un flag
    }
  }
  return(cpt);
}

  // Mthode d'affichage de la matrice 
int Matrice::AfficheMatrice()
{
  int posX, posY, lTab, hTab, x, y, perdu, restant;
  char key;
  struct CaseMat * Courant;
  lTab = this->iNbCol;
  hTab = this->iNbLig;
  posX = 1;
  posY = 1;
  perdu = 0;
 

// affichage de la matrice

   int LIGNE= hTab;
   int COLONNE = lTab;

	int i, j, k;
	i = 0;


	std::string message;
	std::string messagetmp;

    this->RafraichirMatrice();

	for(j = 1; j <= LIGNE; j++)
	{

        std::ostringstream ostr; 
        if(j < 10)
           ostr << 0; 
        ostr << j; 
        messagetmp = ostr.str(); 
        message = "+connection(\"all\"): \"" + messagetmp;

        // on recupere le contenu de la case
        for(k = 1; k <= COLONNE; k++)
        {
            Courant = RechercheCase(k,j); // courant a les infos de la case
            if(Courant->CaseVisible == 0)
        	  messagetmp = "??";


            else
            {
                if(Courant->NbBombe!=0)
                {
                    std::ostringstream ostr5; 
                    ostr5 << Courant->NbBombe; 
                    messagetmp = ostr5.str();
                    messagetmp = " " + messagetmp;
                }
                else
                {
                   messagetmp = "  ";
                }
                if(Courant->Bombe == 1)
                {
                    messagetmp = "XX";
                }


            }


            message = message + " | " + messagetmp;
            i++;
         }
         message = message + " | \";";
         urbi::send(message.c_str());

         message = "+connection(\"all\"): \"   ";
         for(k = 1; k <= COLONNE; k++)
         {
            message = message + "-----";
         }
         message = message + "- \";";
         urbi::send(message.c_str());
	}

    message = "+connection(\"all\"): \"   ";
    for(k = 1; k <= COLONNE; k++)
    {
        std::ostringstream ostr; 
        if(k < 10)
           ostr << 0; 
        ostr << k; 
        messagetmp = ostr.str(); 
        message = message + "| " + messagetmp + " ";
    }
    message = message + "| \";";
    urbi::send(message.c_str());

    if(PartieGagnee()==0)
    {
       std::string message = "+connection(\"all\"):\"Faire demineur.play(x,y); pour decouvrir une case\";";
       urbi::send(message.c_str());
    }
    else
    {
       std::string message = "+connection(\"all\"):\"FELICITATION ! VOUS AVEZ GAGNE !!\";";
       urbi::send(message.c_str());
       perdu=2;
    }
  



  return(perdu);
}


// Procdure de rptition de caractres spciaux pour affichage 
void Matrice::RepeteCar(int carac, int nb)
{
  int boucle;
  std::string message = "+connection(\"all\"):\"";
  std::string messagetmp;
  for(boucle=0;boucle<nb;boucle++)
  {
   	messagetmp = carac;
    message = message + messagetmp;
  }
  message = message + "\";";
  urbi::send(message.c_str());

}

// Procdure d'impression de la ligne horizontale sparatrice de la matrice de jeu 
void Matrice::LigneInter(int longueur)
{
  std::string message = "+connection(\"all\"):\"";
  std::string messagetmp;

  for(longueur;longueur>0;longueur--)
  {
    switch(longueur%2)
    {
      case 1:
//        messagetmp = HORII;
        message = message + messagetmp;
        break;
      
      case 0:
//        messagetmp = HORII;
        message = message + messagetmp;
        break;
    }
  }

  message = message + "\";";
  urbi::send(message.c_str());

}

void Matrice::AffichagePerdu()
{
  std::string message = "+connection(\"all\"):\"Vous avez perdu !!!!!!!!!\";";
  urbi::send(message.c_str());
}

  // Mthode pour decouvrir une case 
int Matrice::play(int choixx, int choixy)
{
  int posX, posY, lTab, hTab, x, y, perdu, restant;
  char key;
  struct CaseMat * Courant;
  lTab = this->iNbCol;
  hTab = this->iNbLig;
  posX = 1;
  posY = 1;
  perdu = 0;
 
  posX = choixx;
  posY = choixy;
 
          Courant = RechercheCase(posX, posY);
          if(Courant->Bombe==1) 
          {
            std::string message = "+connection(\"all\"):\"PERDU, IL Y AVAIT UNE BOMBE, PAS DE CHANCE !\";";
            urbi::send(message.c_str());

            perdu = 1;
          }
          else
          {
            Courant->CaseVisible = 1;
            if(Courant->NbBombe==0) AfficheZero(posX, posY);
          }

  return(perdu);
}

  // Mthode pour decouvrir une case  avec une mine
int Matrice::playM(int choixx, int choixy)
{
  int posX, posY, lTab, hTab, x, y, perdu, restant;
  char key;
  struct CaseMat * Courant;
  lTab = this->iNbCol;
  hTab = this->iNbLig;
  posX = 1;
  posY = 1;
  perdu = 0;
 
  posX = choixx;
  posY = choixy;
 
          Courant = RechercheCase(posX, posY);
          if(Courant->Bombe==0) 
          {
            std::string message = "+connection(\"all\"):\"PERDU, IL N'Y AVAIT PAS DE BOMBE !\";";
            urbi::send(message.c_str());
            perdu = 1;
          }
          else
          {
            Courant->CaseVisible = 1;
          }

  return(perdu);
}



void Matrice::AfficheMatricesolution()
{
  int posX, posY, lTab, hTab, x, y, perdu, restant;
  char key;
  struct CaseMat * Courant;
  lTab = this->iNbCol;
  hTab = this->iNbLig;
  posX = 1;
  posY = 1;
  perdu = 0;
 

// affichage de la matrice

   int LIGNE= hTab;
   int COLONNE = lTab;

	int i, j, k;
	i = 0;


	std::string message;
	std::string messagetmp;

    this->RafraichirMatrice();

	for(j = 1; j <= LIGNE; j++)
	{

        std::ostringstream ostr; 
        if(j < 10)
           ostr << 0; 
        ostr << j; 
        messagetmp = ostr.str(); 
        message = "+connection(\"all\"): \"" + messagetmp;

        // on recupere le contenu de la case
        for(k = 1; k <= COLONNE; k++)
        {
            Courant = RechercheCase(k,j); // courant a les infos de la case

                if(Courant->NbBombe!=0)
                {
                    std::ostringstream ostr5; 
                    ostr5 << Courant->NbBombe; 
                    messagetmp = ostr5.str();
                    messagetmp = " " + messagetmp;
                }
                else
                {
                   messagetmp = "  ";
                }

                if(Courant->Bombe == 1)
                {
                    messagetmp = "XX";
                }

            message = message + " | " + messagetmp;
            i++;
         }
         message = message + " | \";";
         urbi::send(message.c_str());

         message = "+connection(\"all\"): \"   ";
         for(k = 1; k <= COLONNE; k++)
         {
            message = message + "-----";
         }
         message = message + "- \";";
         urbi::send(message.c_str());
	}

    message = "+connection(\"all\"): \"   ";
    for(k = 1; k <= COLONNE; k++)
    {
        std::ostringstream ostr; 
        if(k < 10)
           ostr << 0; 
        ostr << k; 
        messagetmp = ostr.str(); 
        message = message + "| " + messagetmp + " ";
    }
    message = message + "| \";";
    urbi::send(message.c_str());


}

