#include "mouse.h"


int thread(void *ptclass)
{

 // on recupere l'adresse de notre classe
 mouse *pt = static_cast<mouse *>(ptclass);

  int result=0; // permet de faire des tests pour voir si tout est ok

	// Initialisation de SDL 
	result = SDL_Init(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK);
    if ( result < 0 ) // mauvaise initialisation, donc on quitte
    {
		std::string message = "+connection(\"all\"):\"Error. Couldn't initialize SDL\";";
		urbi::send(message.c_str());
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(-1);
	}


	// Set a video mode 
 	pt->screen = SDL_SetVideoMode( pt->widthscreen, pt->heightscreen, 24, SDL_VIDEO_FLAGS );
//    printf("Mode video: %dx%dx%d\n", pt->screen->w, pt->screen->h,  pt->screen->format->BitsPerPixel);
	if( pt->screen == NULL )
	{
            fprintf( stderr, "Could not set video mode: %s\n", SDL_GetError() );
            SDL_Quit();
            exit( -1 );
	}

     // Activation du support UNICODE 
     SDL_EnableUNICODE(1);


     pt->nbjoysticks = SDL_NumJoysticks();
     pt->nbmaxjoyaxes = 0;
     pt->nbmaxjoyballs = 0;
     pt->nbmaxjoyhats = 0;
     pt->nbmaxjoybuttons = 0;
//     printf("Nombres de joysticks attaches: %d\n\n", pt->nbjoysticks);
     for (int i = 0; i < pt->nbjoysticks; i++)
     {
    	  SDL_Joystick * joy = SDL_JoystickOpen(i);
    //	  printf("Joystick %d: %s\n", i, SDL_JoystickName(i));
    //	  printf("Axes: %d\n", SDL_JoystickNumAxes(joy));
    //	  printf("Boutons: %d\n", SDL_JoystickNumButtons(joy));
    //	  printf("Trackballs: %d\n", SDL_JoystickNumBalls(joy));
    //	  printf("Chapeaux: %d\n\n", SDL_JoystickNumHats(joy));
          if( pt->nbmaxjoyaxes < SDL_JoystickNumAxes(joy) )
             pt->nbmaxjoyaxes = SDL_JoystickNumAxes(joy);
          if( pt->nbmaxjoyballs < SDL_JoystickNumBalls(joy) )
             pt->nbmaxjoyballs = SDL_JoystickNumBalls(joy);
          if( pt->nbmaxjoyhats < SDL_JoystickNumHats(joy) )
             pt->nbmaxjoyhats = SDL_JoystickNumHats(joy);
          if( pt->nbmaxjoybuttons < SDL_JoystickNumButtons(joy) )
             pt->nbmaxjoybuttons = SDL_JoystickNumButtons(joy);
     }

	pt->initjoy();


     // Chargement du sprite 
     pt->tmp = SDL_LoadBMP("souris.bmp");
     pt->sprite = SDL_DisplayFormat(pt->tmp);
     SDL_FreeSurface(pt->tmp);
     SDL_SetColorKey(pt->sprite, SDL_SRCCOLORKEY, SDL_MapRGB(pt->sprite->format, 0xff, 0x00, 0xff));

     // Position initiale du sprite 
     pt->spritepos.x = (pt->screen->w - pt->sprite->w) / 2;
     pt->spritepos.y = (pt->screen->h - pt->sprite->h) / 2;
     pt->spritepos.w = 0;
     pt->spritepos.h = 0;


/* // Si necessaire, on peut desactiver des evenements
    SDL_EventState (SDL_ACTIVEEVENT, SDL_IGNORE);

    // on ignore les evenements venant de la souris
    SDL_EventState (SDL_MOUSEMOTION , SDL_IGNORE);
    SDL_EventState (SDL_MOUSEBUTTONDOWN , SDL_IGNORE);
    SDL_EventState (SDL_MOUSEBUTTONUP , SDL_IGNORE);

    // on ignore les evenements venant du clavier
    SDL_EventState (SDL_KEYDOWN, SDL_IGNORE);
    SDL_EventState (SDL_KEYUP, SDL_IGNORE);

    // on ignore les evenements venant du Joystick
    SDL_EventState (SDL_JOYAXISMOTION , SDL_IGNORE);
    SDL_EventState (SDL_JOYHATMOTION , SDL_IGNORE);
    SDL_EventState (SDL_JOYBALLMOTION , SDL_IGNORE);
    SDL_EventState (SDL_JOYBUTTONDOWN , SDL_IGNORE);
    SDL_EventState (SDL_JOYBUTTONUP , SDL_IGNORE);
*/

     while(1)
     {
    	  // Mise  jour de l'tat du jeu  partir des vnements 
    	  pt->process_events();
    
    	  // Mise  jour de la position du sprite  partir de sa vlocit 
    	  pt->spritepos.x += pt->xvel;
    	  pt->spritepos.y += pt->yvel;
    	  // Test de dbordement d'cran 
    	  if (pt->spritepos.x < 0) pt->spritepos.x = 0;
    	  if (pt->spritepos.x > pt->screen->w - pt->sprite->w) pt->spritepos.x = pt->screen->w - pt->sprite->w;
    	  if (pt->spritepos.y < 0) pt->spritepos.y = 0;
    	  if (pt->spritepos.y > pt->screen->h - pt->sprite->h) pt->spritepos.y = pt->screen->h - pt->sprite->h;
    
    	  // Mise  jour de l'cran 
    	  // Remplissage de l'cran en noir 
    	  SDL_FillRect(pt->screen, NULL, 0);
    	  // Affichage du sprite puis mise  jour du buffer d'affichage 
    	  SDL_BlitSurface(pt->sprite, NULL, pt->screen, &(pt->spritepos));
    	  SDL_Flip(pt->screen);

     }


     return 1;
}





/////////////////////////////////////////////

UStart(mouse);

// Creation de l'objet mouse
mouse::mouse(std::string s) : UObject(s) 
{
	UBindFunction(mouse,init);

	UBindVar(mouse,mousex);
	UBindVar(mouse,mousey);
	UBindVar(mouse,mousexrelatif);
	UBindVar(mouse,mouseyrelatif);
	UBindVar(mouse,mousebutton1);
	UBindVar(mouse,mousebutton2);
	UBindVar(mouse,mousebutton3);
	UBindVar(mouse,mousebutton4);

	UBindVar(mouse,keybcar);
	UBindVar(mouse,keybcarNum);


    // initialisation des variables
    screen = NULL;
    xvel = 0; yvel = 0;
    cpt_clavier = 0;
    charactere[1]='\0';

    // creation du thread qui met a jour les valeurs
    t1 = SDL_CreateThread(thread, (void*) this);

    widthscreen = 640;
    heightscreen = 480;

}

// Destruction de l'objet mouse 
mouse::~mouse(void)
{
    SDL_KillThread (t1);
	SDL_QuitSubSystem(SDL_INIT_VIDEO);
    atexit(SDL_Quit); // fin de SDL
    SDL_Quit();
}

// creation de new mouse()
int mouse::init(void)
{
    return 1; // pas possible de faire une creation de mouse
}



// Recuperation des evenements
void mouse::process_events(void)
{

     // Un evenement attend d'etre traite ? 
     while (SDL_PollEvent(&event))
     {
	  // Si oui, quel type? 
	  switch (event.type)
	  {

          // Appui sur une touche 
	  case SDL_KEYDOWN:
	       printf("Touche %d enfoncee (caractere produit: %c)\n", event.key.keysym.sym, event.key.keysym.unicode);

           charactere[0]=event.key.keysym.unicode;
           caractere.assign( charactere );
	       keybcar = caractere;
           keybcarNum = event.key.keysym.sym;
           cpt_clavier++; 
	       switch (event.key.keysym.sym) // evenement clavier
	       {
	       case SDLK_LEFT: // touche de deplacement a gauche
		    xvel = -1;
		    break;
	       case SDLK_RIGHT: // touche de deplacement a droite
		    xvel = 1;
		    break;
	       case SDLK_UP:// touche de deplacement en haut
		    yvel = -1;
		    break;
	       case SDLK_DOWN: // touche de deplacement en bas
		    yvel = 1;
		    break;
	       default:
		    break;
	       }
	       break;


          // Relachement d'une touche 
	  case SDL_KEYUP:
	       printf("Touche %d relachee\n", event.key.keysym.sym);
           cpt_clavier--; 
           if(cpt_clavier == 0)
           {
           	       keybcar = '\0';
           	       keybcarNum = 0;
           }
	       switch (event.key.keysym.sym)
	       {
	       case SDLK_LEFT:
	       case SDLK_RIGHT:
		    xvel =0;
		    break;
	       case SDLK_UP:
	       case SDLK_DOWN:
		    yvel = 0;
		    break;
	       default:
		    break;
	       }
	       break;


          // Deplacement souris 
	  case SDL_MOUSEMOTION:
	       spritepos.x += event.motion.xrel;
	       spritepos.y += event.motion.yrel;
	       double valmousex,valmousey;
	       valmousex = (double)event.motion.x / (double)widthscreen;
	       valmousey = (double)event.motion.y / (double)heightscreen;
	       printf("valx = %f et valy = %f\n",valmousex,valmousey);
           mousex = valmousex;
           mousey = valmousey;
           mousexrelatif=event.motion.xrel;
           mouseyrelatif=event.motion.yrel;
	       printf("Position souris: (%d, %d)\n", event.motion.x, event.motion.y);
	       break;


          // Enfoncement bouton souris 
	  case SDL_MOUSEBUTTONDOWN:
          if( event.button.button == 1 )
               mousebutton1=1;
          else if(event.button.button == 2)
               mousebutton2=1;
          else if(event.button.button == 3)
               mousebutton3=1;
          else if(event.button.button == 4)
               mousebutton4=1;
	       printf("Click bouton souris %d\n", event.button.button);
	       break;

          // Relachement bouton souris 
	  case SDL_MOUSEBUTTONUP:
          if( event.button.button == 1 )
               mousebutton1=0;
          else if(event.button.button == 2)
               mousebutton2=0;
          else if(event.button.button == 3)
               mousebutton3=0;
          else if(event.button.button == 4)
               mousebutton4=0;
	       printf("Relachement bouton souris %d\n", event.button.button);
	       break;


          // Dplacement axe joystick 
	  case SDL_JOYAXISMOTION:
//	       printf("Axe %d du joystick %d positionne a %d\n", event.jaxis.axis, event.jaxis.which, event.jaxis.value);
	       /* Les axes pairs sont verticaux, les impairs horizontaux.
		  Les valeurs de jaxis.value tant trs grandes, on compense
		  en faisant un dcalage  droite (division par 2^13) */
/*
	       if (event.jaxis.axis % 2)
		    yvel = event.jaxis.value >> 13;
	       else
		    xvel = event.jaxis.value >> 13;
*/
		    if(event.jaxis.axis == 0)
              joyaxe1 = event.jaxis.value;
		    else if(event.jaxis.axis == 1)
              joyaxe2 = event.jaxis.value;
		    else if(event.jaxis.axis == 2)
              joyaxe3 = event.jaxis.value;
		    else if(event.jaxis.axis == 3)
              joyaxe4 = event.jaxis.value;
		    else if(event.jaxis.axis == 4)
              joyaxe5 = event.jaxis.value;
		    else if(event.jaxis.axis == 5)
              joyaxe6 = event.jaxis.value;
		    else if(event.jaxis.axis == 6)
              joyaxe7 = event.jaxis.value;
		    else if(event.jaxis.axis == 7)
              joyaxe8 = event.jaxis.value;
		    else if(event.jaxis.axis == 8)
              joyaxe9 = event.jaxis.value;
		    else if(event.jaxis.axis == 9)
              joyaxe10 = event.jaxis.value;
	       break;


          // Dplacement chapeau joystick 
	  case SDL_JOYHATMOTION:
		    if(event.jhat.hat == 0)
              joyhat1 = event.jhat.value;
		    else if(event.jhat.hat == 1)
              joyhat2 = event.jhat.value;
		    else if(event.jhat.hat == 2)
              joyhat3 = event.jhat.value;
		    else if(event.jhat.hat == 3)
              joyhat4 = event.jhat.value;
		    else if(event.jhat.hat == 4)
              joyhat5 = event.jhat.value;
		    else if(event.jhat.hat == 5)
              joyhat6 = event.jhat.value;
		    else if(event.jhat.hat == 6)
              joyhat7 = event.jhat.value;
		    else if(event.jhat.hat == 7)
              joyhat8 = event.jhat.value;
		    else if(event.jhat.hat == 8)
              joyhat9 = event.jhat.value;
		    else if(event.jhat.hat == 9)
              joyhat10 = event.jhat.value;
	       printf("Chapeau %d du joystick %d en position ",  event.jhat.hat, event.jhat.which);
	       switch (event.jhat.value)
	       {
	       case SDL_HAT_CENTERED:
//		    xvel = 0; yvel = 0;
		    printf("centree\n");
		    break;
	       case SDL_HAT_UP:
//		    xvel = 0; yvel = -1;
		    printf("haute\n");
		    break;
	       case SDL_HAT_RIGHT:
//		    xvel = 1; yvel = 0;
		    printf("droite\n");
		    break;
	       case SDL_HAT_DOWN:
//		    xvel = 0; yvel = 1;
		    printf("basse\n");
		    break;
	       case SDL_HAT_LEFT:
//		    xvel = -1; yvel = 0;
		    printf("gauche\n");
		    break;
	       case SDL_HAT_RIGHTUP:
//		    xvel = 1; yvel = -1;
		    printf("haute/droite\n");
		    break;
	       case SDL_HAT_RIGHTDOWN:
//		    xvel = 1; yvel = 1;
		    printf("basse/droite\n");
		    break;
	       case SDL_HAT_LEFTUP:
//		    xvel = -1; yvel = -1;
		    printf("haute/gauche\n");
		    break;
	       case SDL_HAT_LEFTDOWN:
//		    xvel = -1; yvel = 1;
		    printf("basse/gauche\n");
		    break;
	       }

	       break;


          // Dplacement trackball joystick 
	  case SDL_JOYBALLMOTION:
//	       spritepos.x += event.jball.xrel;
//	       spritepos.y += event.jball.yrel;
	       printf("Trackball %d du joystick %d a bouge de (%d, %d)\n", event.jball.ball, event.jball.which, event.jball.xrel, event.jball.yrel);
		    if(event.jball.ball == 0)
		    {
              joyballxrel1 = event.jball.xrel;
              joyballyrel1 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 1)
		    {
              joyballxrel2 = event.jball.xrel;
              joyballyrel2 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 2)
		    {
              joyballxrel3 = event.jball.xrel;
              joyballyrel3 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 3)
		    {
              joyballxrel4 = event.jball.xrel;
              joyballyrel4 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 4)
		    {
              joyballxrel5 = event.jball.xrel;
              joyballyrel5 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 5)
		    {
              joyballxrel6 = event.jball.xrel;
              joyballyrel6 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 6)
		    {
              joyballxrel7 = event.jball.xrel;
              joyballyrel7 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 7)
		    {
              joyballxrel8 = event.jball.xrel;
              joyballyrel8 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 8)
		    {
              joyballxrel9 = event.jball.xrel;
              joyballyrel9 = event.jball.yrel;
		    }
		    else if(event.jball.ball == 9)
		    {
              joyballxrel10 = event.jball.xrel;
              joyballyrel10 = event.jball.yrel;
		    }


	       break;


          // Appui bouton joystick 
	  case SDL_JOYBUTTONDOWN:
      printf("Bouton %d du joystick %d enfonce\n", event.jbutton.button, event.jbutton.which);
          if( event.jbutton.button == 0 )
               joybutton1=1;
          else if(event.jbutton.button == 1)
               joybutton2=1;
          else if(event.jbutton.button == 2)
               joybutton3=1;
          else if(event.jbutton.button == 3)
               joybutton4=1;
          else if(event.jbutton.button == 4)
               joybutton5=1;
          else if(event.jbutton.button == 5)
               joybutton6=1;
          else if(event.jbutton.button == 6)
               joybutton7=1;
          else if(event.jbutton.button == 7)
               joybutton8=1;
          else if(event.jbutton.button == 8)
               joybutton9=1;
          else if(event.jbutton.button == 9)
               joybutton10=1;
          else if(event.jbutton.button == 10)
               joybutton11=1;
          else if(event.jbutton.button == 11)
               joybutton12=1;
          else if(event.jbutton.button == 12)
               joybutton13=1;
          else if(event.jbutton.button == 13)
               joybutton14=1;
          else if(event.jbutton.button == 14)
               joybutton15=1;
          else if(event.jbutton.button == 15)
               joybutton16=1;
          else if(event.jbutton.button == 16)
               joybutton17=1;
          else if(event.jbutton.button == 17)
               joybutton18=1;
          else if(event.jbutton.button == 18)
               joybutton19=1;
          else if(event.jbutton.button == 19)
               joybutton20=1;
	       break;


          // Relachement bouton joystick 
	  case SDL_JOYBUTTONUP:
	       printf("Bouton %d du joystick %d relache\n", event.jbutton.button, event.jbutton.which);
          if( event.jbutton.button == 0 )
               joybutton1=0;
          else if(event.jbutton.button == 1)
               joybutton2=0;
          else if(event.jbutton.button == 2)
               joybutton3=0;
          else if(event.jbutton.button == 3)
               joybutton4=0;
          else if(event.jbutton.button == 4)
               joybutton5=0;
          else if(event.jbutton.button == 5)
               joybutton6=0;
          else if(event.jbutton.button == 6)
               joybutton7=0;
          else if(event.jbutton.button == 7)
               joybutton8=0;
          else if(event.jbutton.button == 8)
               joybutton9=0;
          else if(event.jbutton.button == 9)
               joybutton10=0;
          else if(event.jbutton.button == 10)
               joybutton11=0;
          else if(event.jbutton.button == 11)
               joybutton12=0;
          else if(event.jbutton.button == 12)
               joybutton13=0;
          else if(event.jbutton.button == 13)
               joybutton14=0;
          else if(event.jbutton.button == 14)
               joybutton15=0;
          else if(event.jbutton.button == 15)
               joybutton16=0;
          else if(event.jbutton.button == 16)
               joybutton17=0;
          else if(event.jbutton.button == 17)
               joybutton18=0;
          else if(event.jbutton.button == 18)
               joybutton19=0;
          else if(event.jbutton.button == 19)
               joybutton20=0;
	       break;


	  default:
	       break;


	  }
     }    
}


// creation des variables pour le joystick
void mouse::initjoy(void)
{

    if( nbjoysticks == 0)
      return;

    if( nbmaxjoyaxes > 0)
    {
        if(nbmaxjoyaxes >= 1)
           UBindVar(mouse,joyaxe1);
        if(nbmaxjoyaxes >= 2)
           UBindVar(mouse,joyaxe2);
        if(nbmaxjoyaxes >= 3)
           UBindVar(mouse,joyaxe3);
        if(nbmaxjoyaxes >= 4)
           UBindVar(mouse,joyaxe4);
        if(nbmaxjoyaxes >= 5)
           UBindVar(mouse,joyaxe5);
        if(nbmaxjoyaxes >= 6)
           UBindVar(mouse,joyaxe6);
        if(nbmaxjoyaxes >= 7)
           UBindVar(mouse,joyaxe7);
        if(nbmaxjoyaxes >= 8)
           UBindVar(mouse,joyaxe8);
        if(nbmaxjoyaxes >= 9)
           UBindVar(mouse,joyaxe9);
        if(nbmaxjoyaxes >= 10)
           UBindVar(mouse,joyaxe10);
    }

    if( nbmaxjoyballs > 0)
    {
        if(nbmaxjoyballs >= 1)
        {
           UBindVar(mouse,joyballxrel1);
           UBindVar(mouse,joyballyrel1);
        }
        if(nbmaxjoyballs >= 2)
        {
           UBindVar(mouse,joyballxrel2);
           UBindVar(mouse,joyballyrel2);
        }
        if(nbmaxjoyballs >= 3)
        {
           UBindVar(mouse,joyballxrel3);
           UBindVar(mouse,joyballyrel3);
        }
        if(nbmaxjoyballs >= 4)
        {
           UBindVar(mouse,joyballxrel4);
           UBindVar(mouse,joyballyrel4);
        }
        if(nbmaxjoyballs >= 5)
        {
           UBindVar(mouse,joyballxrel5);
           UBindVar(mouse,joyballyrel5);
        }
        if(nbmaxjoyballs >= 6)
        {
           UBindVar(mouse,joyballxrel6);
           UBindVar(mouse,joyballyrel6);
        }
        if(nbmaxjoyballs >= 7)
        {
           UBindVar(mouse,joyballxrel7);
           UBindVar(mouse,joyballyrel7);
        }
        if(nbmaxjoyballs >= 8)
        {
           UBindVar(mouse,joyballxrel8);
           UBindVar(mouse,joyballyrel8);
        }
        if(nbmaxjoyballs >= 9)
        {
           UBindVar(mouse,joyballxrel9);
           UBindVar(mouse,joyballyrel9);
        }
        if(nbmaxjoyballs >= 10)
        {
           UBindVar(mouse,joyballxrel10);
           UBindVar(mouse,joyballyrel10);
        }
    }


    if( nbmaxjoyhats > 0)
    {
        if(nbmaxjoyhats >= 1)
           UBindVar(mouse,joyhat1);
        if(nbmaxjoyhats >= 2)
           UBindVar(mouse,joyhat2);
        if(nbmaxjoyhats >= 3)
           UBindVar(mouse,joyhat3);
        if(nbmaxjoyhats >= 4)
           UBindVar(mouse,joyhat4);
        if(nbmaxjoyhats >= 5)
           UBindVar(mouse,joyhat5);
        if(nbmaxjoyhats >= 6)
           UBindVar(mouse,joyhat6);
        if(nbmaxjoyhats >= 7)
           UBindVar(mouse,joyhat7);
        if(nbmaxjoyhats >= 8)
           UBindVar(mouse,joyhat8);
        if(nbmaxjoyhats >= 9)
           UBindVar(mouse,joyhat9);
        if(nbmaxjoyhats >= 10)
           UBindVar(mouse,joyhat10);
    }


    if( nbmaxjoybuttons > 0)
    {
        if(nbmaxjoybuttons >= 1)
           UBindVar(mouse,joybutton1);
        if(nbmaxjoybuttons >= 2)
           UBindVar(mouse,joybutton2);
        if(nbmaxjoybuttons >= 3)
           UBindVar(mouse,joybutton3);
        if(nbmaxjoybuttons >= 4)
           UBindVar(mouse,joybutton4);
        if(nbmaxjoybuttons >= 5)
           UBindVar(mouse,joybutton5);
        if(nbmaxjoybuttons >= 6)
           UBindVar(mouse,joybutton6);
        if(nbmaxjoybuttons >= 7)
           UBindVar(mouse,joybutton7);
        if(nbmaxjoybuttons >= 8)
           UBindVar(mouse,joybutton8);
        if(nbmaxjoybuttons >= 9)
           UBindVar(mouse,joybutton9);
        if(nbmaxjoybuttons >= 10)
           UBindVar(mouse,joybutton10);
        if(nbmaxjoybuttons >= 11)
           UBindVar(mouse,joybutton11);
        if(nbmaxjoybuttons >= 12)
           UBindVar(mouse,joybutton12);
        if(nbmaxjoybuttons >= 13)
           UBindVar(mouse,joybutton13);
        if(nbmaxjoybuttons >= 14)
           UBindVar(mouse,joybutton14);
        if(nbmaxjoybuttons >= 15)
           UBindVar(mouse,joybutton15);
        if(nbmaxjoybuttons >= 16)
           UBindVar(mouse,joybutton16);
        if(nbmaxjoybuttons >= 17)
           UBindVar(mouse,joybutton17);
        if(nbmaxjoybuttons >= 18)
           UBindVar(mouse,joybutton18);
        if(nbmaxjoybuttons >= 19)
           UBindVar(mouse,joybutton19);
        if(nbmaxjoybuttons >= 20)
           UBindVar(mouse,joybutton20);

    }


}



