#include "pcfiles.h"

UStart(pcfiles);

pcfiles::pcfiles(std::string s) : UObject(s)
{
	UBindFunction(pcfiles,init);
	UBindFunction(pcfiles,sendimage);
	UBindFunction(pcfiles,sendsound);
	UBindFunction(pcfiles,sendbinary);
	UBindFunction(pcfiles,receiveimage);
	UBindFunction(pcfiles,receivesound);
	UBindFunction(pcfiles,receivebinary);
}

pcfiles::~pcfiles()
{
}

int pcfiles::init(void)
{
  return 1; // Singleton
}

/////////////////////////////////////////////
// sendimage
/////////////////////////////////////////////
UImage pcfiles::sendimage(UValue nameFile)
{    
    // create a UImage
    UImage Imagesrc;
    Imagesrc.imageFormat = IMAGE_JPEG;
    Imagesrc.size = 0;
    Imagesrc.width = 0;
    Imagesrc.height = 0;


   if(nameFile.type == DATA_STRING)
    {
        std::string File = nameFile;

        FILE *f;
        f = fopen(File.c_str(),"r");
        if (!f)
           return Imagesrc;

      	struct stat st;
      	stat(File.c_str(),&st);

      	Imagesrc.data = new unsigned char[st.st_size];
      	Imagesrc.size = st.st_size;
      	fread(Imagesrc.data, 1,st.st_size, f);
    }

         return Imagesrc;
}
/////////////////////////////////////////////
// sendimage
/////////////////////////////////////////////


/////////////////////////////////////////////
// sendsound
/////////////////////////////////////////////
USound pcfiles::sendsound(UValue nameFile)
{    
    // create a USound
    USound tmpSnd;
    tmpSnd.soundFormat = SOUND_WAV;
    tmpSnd.data = 0;
    tmpSnd.size = 0;
    tmpSnd.rate = 16000;  // inutile
    tmpSnd.sampleSize = 16; // inutile
    tmpSnd.sampleFormat = SAMPLE_SIGNED; // inutile
    tmpSnd.channels = 1; // inutile



   if(nameFile.type == DATA_STRING)
    {
        std::string File = nameFile;



      	FILE *f;
        f = fopen(File.c_str(),"r");
      	if (!f)
           return tmpSnd;


      	struct stat st;
      	stat(File.c_str(),&st);

      	tmpSnd.data = new char[st.st_size];
      	tmpSnd.size = st.st_size;

      	fread(tmpSnd.data, 1,st.st_size, f);


    }


    return tmpSnd;

}
/////////////////////////////////////////////
// sendsound
/////////////////////////////////////////////



/////////////////////////////////////////////
// sendbinary
/////////////////////////////////////////////
UBinary pcfiles::sendbinary(UValue nameFile)
{    

    // create a UBinary
    UBinary binarysrc;
    binarysrc.type = BINARY_UNKNOWN;
    binarysrc.common.data = 0;
    binarysrc.common.size = 0;


   if(nameFile.type == DATA_STRING)
    {
        std::string File = nameFile;

      	FILE *f;
        f = fopen(File.c_str(),"r");
      	if (!f)
           return binarysrc;

      	struct stat st;
      	stat(File.c_str(),&st);

      	binarysrc.common.data = new char[st.st_size];
      	binarysrc.common.size = st.st_size;

      	fread(binarysrc.common.data, 1,st.st_size, f);

    }

    return binarysrc;

}
/////////////////////////////////////////////
// sendbinary
/////////////////////////////////////////////


/////////////////////////////////////////////
// receiveimage
/////////////////////////////////////////////
void pcfiles::receiveimage(UValue data, UValue nameFile)
{    
   if(data.type == DATA_BINARY && nameFile.type == DATA_STRING)
    {
           UImage image = data;
        
           if ( image.imageFormat == IMAGE_RGB )
           {
                UImage image2;
                image2.width = image.width;
                image2.height = image.height;
                image2.imageFormat = IMAGE_JPEG;
                image2.data = new unsigned char[image.width * image.height];
                int image2size = image2.size;
                convertRGBtoJPEG(image.data, image.width, image.height, image2.data, image2size, 100);

                std::string File = nameFile;
                FILE *f;
                f = fopen(File.c_str(), "wb" );
      	        if (!f)
                   return;
                fwrite (image2.data, 1 , image2.size, f);
                fclose(f);
           }
           else if ( image.imageFormat == IMAGE_YCbCr )
           {
                UImage image2;
                image2.width = image.width;
                image2.height = image.height;
                image2.imageFormat = IMAGE_JPEG;
                image2.data = new unsigned char[image.width * image.height];
                int image2size = image2.size;
                convertYCrCbtoJPEG(image.data, image.width, image.height, image2.data, image2size, 100);

                std::string File = nameFile;
                FILE *f;
                f = fopen(File.c_str(), "wb" );
      	        if (!f)
                   return;
                fwrite (image2.data, 1 , image2.size, f);
                fclose(f);
           }
           else if ( image.imageFormat == IMAGE_JPEG )
           {
                std::string File = nameFile;
                FILE *f;
                f = fopen(File.c_str(), "wb" );
      	        if (!f)
                   return;
               fwrite (image.data, 1 , image.size, f);
                fclose(f);
           }
    }
        return;

}
/////////////////////////////////////////////
// receiveimage
/////////////////////////////////////////////

/////////////////////////////////////////////
// receivesound
/////////////////////////////////////////////
void pcfiles::receivesound(UValue data, UValue nameFile)
{    

   if(data.type == DATA_BINARY && nameFile.type == DATA_STRING)
    {
           USound soundaudio = data;
        
           if ( soundaudio.soundFormat == SOUND_RAW )
           {
                USound tmpSnd;
                tmpSnd.soundFormat = SOUND_WAV;
                tmpSnd.rate = soundaudio.rate;
                tmpSnd.sampleSize = soundaudio.sampleSize;
                tmpSnd.sampleFormat = soundaudio.sampleFormat;
                tmpSnd.channels = soundaudio.channels;
                tmpSnd.data = 0;
                tmpSnd.size = 0;
                convert( soundaudio, tmpSnd ); 


                std::string File = nameFile;
                FILE *f;
                f = fopen(File.c_str(), "wb" );
      	        if (!f)
                   return;
                fwrite (tmpSnd.data, 1 , tmpSnd.size, f);
                fclose(f);
           }
           else if ( soundaudio.soundFormat == SOUND_WAV )
           {
                std::string File = nameFile;
                FILE *f;
                f = fopen(File.c_str(), "wb" );
      	        if (!f)
                   return;
               fwrite (soundaudio.data, 1 , soundaudio.size, f);
                fclose(f);
           }
    }
        return;

}
/////////////////////////////////////////////
// receivesound
/////////////////////////////////////////////


/////////////////////////////////////////////
// receivebinary
/////////////////////////////////////////////
void pcfiles::receivebinary(UValue data, UValue nameFile)
{    
   if(data.type == DATA_BINARY && nameFile.type == DATA_STRING)
    {
           UBinary binarydata = data;
       
           std::string File = nameFile;
           FILE *f;
           f = fopen(File.c_str(), "wb" );
           if (!f)
                   return;
           fwrite (binarydata.common.data, 1 , binarydata.common.size, f);
           fclose(f);
    }
        return;

}
/////////////////////////////////////////////
// receivebinary
/////////////////////////////////////////////

