#include <urbi/uobject.hh>
#include <urbi/uconversion.hh>

#include <fmod.h>
#include <fmod_errors.h>
#include <sys/stat.h>

using namespace urbi;

class pcmicro : public UObject
{
	public:

	pcmicro(std::string);
	~pcmicro(); 

	int init(void);

	USound record(UValue duree);
	int ERRCHECK(FMOD_RESULT result);
	int InitSoundSystem(void);
	int InitRecord(int duree_secondes);
	int StartRecord(int lengthrecord);
	void SaveToWav(FMOD_SOUND *sound);
	void quit(void);

    UVar val;

// FMOD variables
    FMOD_SYSTEM          *system;
    FMOD_SOUND           *sound;
    FMOD_CHANNEL          *channel;
    FMOD_RESULT            result;
    FMOD_CREATESOUNDEXINFO exinfo;
    int                    key, driver, numdrivers, count;
    unsigned int           version;    
    unsigned int           datalength, soundlength;

};
