#include "pcspeaker.h"

UStart(pcspeaker);

pcspeaker::pcspeaker(std::string s) : UObject(s)
{
	UBindVar(pcspeaker,val);
	UNotifyChange(val,&pcspeaker::valuechanged);
	UBindFunction(pcspeaker,init);
	UBindFunction(pcspeaker,play);

	URBI((alias pcspeaker pcspeaker.val;));
	URBI((+connection("all"):echo("To listen a sound file, makes pcspeaker.play(\"file.wav\");");));



	channel=0;

	result = FMOD_System_Create(&system);
	if ( ERRCHECK(result) == -1 )
          exit(-1);
        
	result = FMOD_System_GetVersion(system, &version);
	if ( ERRCHECK(result) == -1 )
          exit(-1);
        
	if (version < FMOD_VERSION)
	{
          printf("Error!  You are using an old version of FMOD %08x.  This program requires %08x\n", version, FMOD_VERSION);
          exit(-1);
	}
        
	result = FMOD_System_Init(system, 32, FMOD_INIT_NORMAL, NULL);
	if ( ERRCHECK(result) == -1 )
          exit(-1);


}



pcspeaker::~pcspeaker()
{
}

int pcspeaker::init(void)
{
  return 1; // Singleton
}


/////////////////////////////////////////////
// play
/////////////////////////////////////////////
void pcspeaker::play(UValue sound)
{    


   if(sound.type == DATA_STRING)
    {
        std::string soundName = sound;
        std::string fileName = "pcspeaker = loadwav(\"" + soundName + "\");";
        urbi::send(fileName.c_str() ); 
   		return ;
}

    else
    {
	    return ;
    }


}
/////////////////////////////////////////////
// play
/////////////////////////////////////////////




/////////////////////////////////////////////
// valuechanged
/////////////////////////////////////////////
int pcspeaker::valuechanged(UVar &sound)
{    
   UValue variableSound;
   variableSound = sound.val();

   if(variableSound.type == DATA_BINARY)
    {
           USound soundaudio;
           soundaudio = (USound) sound;
        
           if ( soundaudio.soundFormat == SOUND_RAW )
           {
                USound tmpSnd;
                tmpSnd.soundFormat = SOUND_WAV;
                tmpSnd.rate = soundaudio.rate;
                tmpSnd.sampleSize = soundaudio.sampleSize;
                tmpSnd.sampleFormat = soundaudio.sampleFormat;
                tmpSnd.channels = soundaudio.channels;
                tmpSnd.data = 0;
                tmpSnd.size = 0;
                convert( soundaudio, tmpSnd ); 
                FILE *f;
                f = fopen("soundFile" , "wb" );
      	        if (!f)
                   return 0;
                fwrite (tmpSnd.data, 1 , tmpSnd.size, f);
                fclose(f);
           }
           else if ( soundaudio.soundFormat == SOUND_WAV )
           {
               FILE *f;
               f = fopen("soundFile" , "wb" );
               fwrite (soundaudio.data, 1 , soundaudio.size, f);
               fclose(f);
           }
        
        
            result = FMOD_System_CreateSound(system, "soundFile", FMOD_LOOP_OFF | FMOD_2D | FMOD_SOFTWARE, 0, &sound1);
            if ( ERRCHECK(result) == -1 )
               return 0;
        
            result = FMOD_System_PlaySound(system, FMOD_CHANNEL_FREE, sound1, false, &channel); 
            if ( ERRCHECK(result) == -1 )
               return 0;
        
            FMOD_System_Update(system);
        
        
        //    result = FMOD_Sound_Release(sound1);
        //    ERRCHECK(result);
        //    result = FMOD_System_Close(system);
        //    ERRCHECK(result);
        //    result = FMOD_System_Release(system);
        //    ERRCHECK(result);
        
   		    return 0;
        	
    } 

    else
    {
	    return 0;
    }

}
/////////////////////////////////////////////
// valuechanged
/////////////////////////////////////////////



/////////////////////////////////////////////
// ERRCHECK
/////////////////////////////////////////////
int pcspeaker::ERRCHECK(FMOD_RESULT result)
{
    if (result != FMOD_OK)
    {
        printf("FMOD error! (%d) %s\n", result, FMOD_ErrorString(result));
        return -1;
    }
    return 0;
}
/////////////////////////////////////////////
// ERRCHECK
/////////////////////////////////////////////
