

#include "puis4.h"


UStart(puissance4);

// Creation de l'objet puissance4 
puissance4::puissance4(std::string s) : UObject(s) 
{
	UBindFunction(puissance4,init);
	UBindFunction(puissance4,titre);
	UBindFunction(puissance4,initialgrille);
	UBindFunction(puissance4,affiche);
	UBindFunction(puissance4,sature);
	UBindFunction(puissance4,initial);
	UBindFunction(puissance4,jouer);
	UBindFunction(puissance4,V_verif);
	UBindFunction(puissance4,H_verif);
	UBindFunction(puissance4,DG_verif);
	UBindFunction(puissance4,DD_verif);
	UBindFunction(puissance4,test);
	UBindFunction(puissance4,ligne);
	UBindFunction(puissance4,verifcoup);
	UBindFunction(puissance4,coup_ordi);
	UBindFunction(puissance4,lancer);
	UBindFunction(puissance4,play);
	UBindFunction(puissance4,start);

	grille = NULL;
	if (grille == NULL)
	   grille = new char [TAILLE];


    esp=0;
    mode = 0; // pas de selection du mode de jeu (humain vs humain, ou ordi vs humain)
    cptjoueur = 0; // permet de savoir si c'est ou joueur 1 ou au joueur 2 de jouer
    initial(2); // on initialise la partie

}


// Destruction de l'objet puissance4 
puissance4::~puissance4(void)
{

  delete grille;

}

// empecher que l'on puisse faire un new puissance4()
int puissance4::init(void)
{
  return 1; // Singleton
}


// Initiliasation de la grille - remise a 0
void puissance4::initialgrille(void)
{
	int i;
	for(i = 0; i< TAILLE; i++)
		grille[i] = ' ';
}


// Cette procedure affiche la grille courante 
void puissance4::affiche(void)
{
	std::string message;
	std::string messagetmp;

	int i, j, k;
	i = 0;

	for(j = 1; j <= LIGNE; j++)
	{

        std::ostringstream ostr; 
        ostr << j; 
        messagetmp = ostr.str(); 
        message = "+connection(\"all\"): \"" + messagetmp;

        for(k = 1; k <= COLONNE; k++)
        {
        	messagetmp = grille[i];
            message = message + " | " + messagetmp;
            i++;
         }
         message = message + " | \";";
         urbi::send(message.c_str());

         message = "+connection(\"all\"): \"  ";
         for(k = 1; k <= COLONNE; k++)
         {
            message = message + "----";
         }
         message = message + "--\";";
         urbi::send(message.c_str());
	}
    message = "+connection(\"all\"): \"  ";
    for(k = 1; k <= COLONNE; k++)
    {
        std::ostringstream ostr; 
        ostr << k; 
        messagetmp = ostr.str(); 
        message = message + "| " + messagetmp + " ";
    }
    message = message + "| \";";
    urbi::send(message.c_str());
}


// On verifie si la grille est saturee, (elle l'est s'il n'y a plus de case vide sur la 1ere ligne) 
int puissance4::sature()
{

	int i, sature = 0;
    for(i=0; i<COLONNE; i++)
    {
    	if(grille[i] != ' ')
    		sature++;
    }

    if(sature == COLONNE) // on a sature
      return 1;
    else
      return 0;

}



// Verification des verticales pour voir si le joueur a gagne
int puissance4::V_verif(int joueurnb)
{
	int i, j, indice, win = 0;
    joueur joueurx;
    if(joueurnb == 1)
      joueurx.pion = joueur1.pion;
    else
      joueurx.pion = joueur2.pion;

	char jpion = joueurx.pion;
    for(i=1; i<=LIGNE-3; i++)
    {
      for(j=1; j<=COLONNE; j++)
      {
       indice = (i - 1)*COLONNE + j - 1;
       if(jpion == grille[indice] && jpion == grille[indice + 7] && jpion == grille[indice + 14] && jpion == grille[indice + 21])
                win = 1;
      }
    }
	return win;
}




// Verification des horizontales pour voir si le joueur a gagne
int puissance4::H_verif(int joueurnb)
{
	int i, j, indice, win = 0;
    joueur joueurx;
    if(joueurnb == 1)
      joueurx.pion = joueur1.pion;
    else
      joueurx.pion = joueur2.pion;
	char jpion = joueurx.pion;
    for(i=1; i<=LIGNE; i++)
    {
      for(j=1; j<=COLONNE-3; j++)
      {
       indice = (i - 1)*COLONNE + j - 1;
       if(jpion == grille[indice] && jpion == grille[indice + 1] && jpion == grille[indice + 2] && jpion == grille[indice + 3])
                win = 1;
      }
    }
	return win;
}

// Verifications des diagonales a "gauche"  pour voir si le joueur a gagne ( a optimiser )
int puissance4::DG_verif(int joueurnb)
{
	int i, j, indice, win = 0;
    joueur joueurx;
    if(joueurnb == 1)
      joueurx.pion = joueur1.pion;
    else
      joueurx.pion = joueur2.pion;
	char jpion = joueurx.pion;
    for(i=1; i <= LIGNE-3; i++)
    {
      for(j=4; j <= COLONNE; j++)
      {
       indice = (i - 1)*COLONNE + j - 1;
       if(jpion == grille[indice] && jpion == grille[indice + 6] && jpion == grille[indice + 12] && jpion == grille[indice + 18])
                win = 1;
      }
    }
	return win;
}

// Verification des diagonales a "droite"  pour voir si le joueur a gagne ( a optimiser )
int puissance4::DD_verif(int joueurnb)
{
	int i, j, indice, win = 0;
    joueur joueurx;
    if(joueurnb == 1)
      joueurx.pion = joueur1.pion;
    else
      joueurx.pion = joueur2.pion;
	char jpion = joueurx.pion;
    for(i=1; i <= LIGNE-3; i++)
    {
      for(j=1; j <= COLONNE-3; j++)
      {
       indice = (i - 1)*COLONNE + j - 1;
       if(jpion == grille[indice] && jpion == grille[indice + 8] && jpion == grille[indice + 16] && jpion == grille[indice + 24])
                win = 1;
      }
    }
	return win;
}


// La fonction globale qui verifie si le joueur a gagne ou si la grille est saturee 
int puissance4::test(int joueurnb)
{
	if(H_verif(joueurnb ) || V_verif( joueurnb ) || DG_verif(joueurnb ) || DD_verif(joueurnb) )
    	return GAGNE; // 1
	else if(sature())
    	return STOP; // 0
	else
    	return VERT ; // 2
}


// affiche le titre puissance 4
void puissance4::titre(void)
{

	std::string message = "+connection(\"all\"):\"*******************************\";";
    urbi::send(message.c_str());

	message = "+connection(\"all\"):\"*         PUISSANCE 4         *\";";
    urbi::send(message.c_str());

	message = "+connection(\"all\"):\"*******************************\";";
    urbi::send(message.c_str());
}


// Cette procedure met a jour la grille en fonction du joueur et de la colonne jouee 
int puissance4::jouer(int col, int joueurnb)
{

     if( verifcoup(col) == -1) // on verifie que l'on peut jouer le coup
         return -1;

    joueur joueurx;
    if(joueurnb == 1)
      joueurx.pion = joueur1.pion;
    else
      joueurx.pion = joueur2.pion;
	int indice = col-1;
    while(grille[indice] == ' ')
    	indice += 7;
	grille[indice-7]  = joueurx.pion;

	titre(); // affichage du titre
	affiche(); // affichage de la grille
	
	int result = test(joueurnb);
	if(result == 1)
	{
       if(joueurnb == 1)
       {
         std::string message = "+connection(\"all\"):\"Le joueur 1 a gagne !\";";
         urbi::send(message.c_str());
         return -1;         
       }
       else
       {
         std::string message = "+connection(\"all\"):\"Le joueur 2 a gagne !\";";
         urbi::send(message.c_str());
         return -1;
       }
     
     
	}         
              

	return 0;
	
}


// On recupre le numero ligne o le joueur a joue, en indiquant une colonne 
int puissance4::ligne(int col)
{
	int indice = col-1;
	int espl = 1;
	while(grille[indice] == ' ')
    {
		indice += 7;
		espl++;
	}
	return espl;

}



// On valide ici le coup du joueur courant en recuperant la colonne choisie 
int puissance4::verifcoup( int col)
{

	int ret, r = 0;
	std::string message = "+connection(\"all\"):\"";

	if( col == 0)
	{
		r = 1;
	}
	else if(col<1 || col>COLONNE)
	{
		r = 1;
	}
	else if(grille[col-1] != ' ')
	{
		r = 2;
	}

	if(r == 1)
    {
        message = message + "Entree invalide! Rejouez\";";
        urbi::send(message.c_str());
        r = -1;
    }
	else if(r == 2)
    {
        message = message + "Colonne pleine! Rejouez\";";
        urbi::send(message.c_str());
        r = -1;
    }

	else if(r == 0) // tout est ok
    {
    }

	return r;

}


// A completer avec l'intelligence artificielle, analyse verticale est faite 
// esp = numero de colonne joue par l'autre joueur
// pour le joueur, il faut mettre 1 car 1 = joueur humain
int puissance4::coup_ordi(int esp, int joueurnb)
{

    joueur joueurx;
    if(joueurnb == 1)
      joueurx.pion = joueur1.pion;
    else
      joueurx.pion = joueur2.pion;

	int col, i, indice, espl, j = 0;
	char jpion = joueurx.pion;
	replay:

	col = rand()%7 + 1;
	for(i=2; i<=LIGNE-2; i++)
    {
       indice = (i - 1)*COLONNE + esp - 1;
       if(jpion == grille[indice] && jpion == grille[indice + 7] && jpion == grille[indice + 14]&& grille[esp-1] == ' ')
                col = esp;
    }

	espl = ligne(esp);
	for(j=1; j<=COLONNE-3; j++)
    {
       indice = (espl - 1)*COLONNE + j - 1;
       if(grille[indice] == ' ' && jpion == grille[indice + 1] && jpion == grille[indice + 2] && jpion == grille[indice + 3])
                col = j;
       if(grille[indice] == jpion && ' ' == grille[indice + 1] && jpion == grille[indice + 2] && jpion == grille[indice + 3])
                col = j + 1;
       if(grille[indice] == jpion && jpion == grille[indice + 1] && ' ' == grille[indice + 2] && jpion == grille[indice + 3])
                col = j + 2;
       if(grille[indice] == jpion && jpion == grille[indice + 1] && jpion == grille[indice + 2] && ' ' == grille[indice + 3])
                col = j + 3;
    }
	for(j=1; j<=COLONNE-3; j++)
    {
       indice = (espl - 1)*COLONNE + j - 1;
       if(grille[indice] == ' ' && ' ' == grille[indice + 1] && jpion == grille[indice + 2] && jpion == grille[indice + 3])
                col = j;
       if(grille[indice] == jpion && ' ' == grille[indice + 1] && ' ' == grille[indice + 2] && jpion == grille[indice + 3])
                col = j + 1;
       if(grille[indice] == jpion && jpion == grille[indice + 1] && ' ' == grille[indice + 2] && ' ' == grille[indice + 3])
                col = j + 2;
       if(grille[indice] == ' ' && jpion == grille[indice + 1] && jpion == grille[indice + 2] && ' ' == grille[indice + 3])
                col = j + 3;
    }


	if(grille[col-1] != ' ')
		goto replay;

	return col;

}



// On itialise le jeu, les noms et les pions. Remarquez que ce sont les adresses des joueurs qui sont passees en parametres 
void puissance4::initial(int choixmode)
{

	joueur1.pion = 'O';
	joueur2.pion = 'X';
    cptjoueur = 0;
    esp = 0; 
     
	initialgrille();

	if(choixmode == 1)
	{
       strncpy(joueur1.nom,"Joueur Humain 1",79);
       strncpy(joueur2.nom,"Joueur Humain 2",79);
	}
	else if(choixmode == 2)
	{
       strncpy(joueur1.nom,"Joueur Humain",79);
       strncpy(joueur2.nom,"Ordinateur",79);
	}
    else
      return;

	titre();
	affiche();

	lancer(choixmode);

}


// on lance le jeu
void puissance4::lancer(int choixmode)
{

  if(choixmode == 1)
  {
     mode = choixmode;
     cptjoueur = 0;
     std::string message = "+connection(\"all\"): \"Joueur humain contre joueur humain\"; ";
     urbi::send(message.c_str());
     message = "+connection(\"all\"): \"Le joueur 1 demarre le jeu\"; ";
     urbi::send(message.c_str());               
     message = "+connection(\"all\"): \"Taper puissance4.play(colonne); pour jouer\"; ";
     urbi::send(message.c_str());        
  }
  else if(choixmode == 2)
  {
     mode = choixmode;
     cptjoueur = 0;
     std::string message = "+connection(\"all\"): \"Joueur humain contre ordinateur\"; ";
     urbi::send(message.c_str());
     message = "+connection(\"all\"): \"Le joueur humain demarre le jeu\"; ";
     urbi::send(message.c_str());               
     message = "+connection(\"all\"): \"Taper puissance4.play(colonne); pour jouer\"; ";
     urbi::send(message.c_str());        
  }
  else 
  {
     std::string message = "+connection(\"all\"): \"Erreur. Taper puissance4.lancer(choix); pour demarrer une partie en mode 1 ou 2.\"; ";
     urbi::send(message.c_str());
  }

}


// on joue un pion
void puissance4::play(int colonne)
{

  std::string message;
  int result;

  if(mode == 2) // humain vs ordi
  {
     result = jouer(colonne,1);
     if(result == -1)
      return;


     esp = colonne;
     int colonneordi = coup_ordi(esp, 1);   // a corriger
     jouer(colonneordi,2);
     message = "+connection(\"all\"): \"Taper puissance4.play(colonne); pour jouer\"; ";
     urbi::send(message.c_str());        
  }

  else if(mode == 1) // humain vs humain
  {
     if(cptjoueur == 0) // joueur 1 de jouer
     {
       result=jouer(colonne,1);
       cptjoueur++;
     }
     else // joueur 2 de jouer
     {
       result=jouer(colonne,2);
       cptjoueur = 0;
     }

     if(result == -1)
      return;

     message = "+connection(\"all\"): \"Taper puissance4.play(colonne); pour jouer\"; ";
     urbi::send(message.c_str());        
  }
  else 
  {
     std::string message = "+connection(\"all\"): \"Erreur. Taper puissance4.lancer(choix); pour demarrer une partie en mode 1 ou 2.\"; ";
     urbi::send(message.c_str());
  }

}

// Demarrer la partie
void puissance4::start(void)
{
   initial(2); 
}
