#include "actionfile.h"

UStart(actionfile);

// Creation de l'objet actionfile
actionfile::actionfile(std::string s) : UObject(s) 
{
	UBindFunction(actionfile,init);
	UBindFunction(actionfile,save);
	UBindFunction(actionfile,load);

}

// Destruction de l'objet actionfile 
actionfile::~actionfile(void)
{
}

// creation de new actionfile()
int actionfile::init(void)
{
    return 1; // pas possible de faire une creation de mouse
}


void actionfile::save(UValue value, std::string nameFile) // sauvegarde la value dans le fichier nameFile
{
    FILE *file_data;
    FILE *file_text;

	std::string nom_fichier_data = nameFile + ".dat";
	std::string nom_fichier_text = nameFile + ".txt";

    file_text = fopen(nom_fichier_text.c_str(),"w");
    if (!file_text) 
       return;

////////////////////////////////////////////////////////////////////////////////

    if (value.type == urbi::DATA_DOUBLE) // on recoit une donnee de type double
    { 
        fprintf (file_text, "MESSAGE_DATA\n"); 
        fprintf (file_text, "DATA_DOUBLE\n"); 

        file_data = fopen(nom_fichier_data.c_str(),"w");
        if (!file_data) 
           return;

        fprintf (file_data, "%f", value.val); 
    } 

////////////////////////////////////////////////////////////////////////////////

  if (value.type == urbi::DATA_STRING) // on recoit une donnee de type string
  { 
        fprintf (file_text, "MESSAGE_DATA\n"); 
        fprintf (file_text, "DATA_STRING\n"); 

        file_data = fopen(nom_fichier_data.c_str(),"w");
        if (!file_data) 
           return;

        fprintf (file_data, "%s", value.stringValue->c_str()); 
  } 

////////////////////////////////////////////////////////////////////////////////

  if (value.type == urbi::DATA_VOID) // on recoit une donnee de type vide
  { 
        fprintf (file_text, "MESSAGE_DATA\n"); 
        fprintf (file_text, "DATA_VOID\n"); 

        file_data = fopen(nom_fichier_data.c_str(),"w");
        if (!file_data) 
           return;

        fprintf (file_data, ""); 
  } 

////////////////////////////////////////////////////////////////////////////////

  if (value.type == urbi::DATA_OBJECT) // on recoit une donnee de type UObject
  { 
        fprintf (file_text, "MESSAGE_DATA\n"); 
        fprintf (file_text, "DATA_OBJECT\n"); 
        fprintf (file_data, "%s", value.object->refName.c_str()); 

        file_data = fopen(nom_fichier_data.c_str(),"w");
        if (!file_data) 
           return;

        fprintf (file_data, ""); 
  } 

////////////////////////////////////////////////////////////////////////////////

  if (value.type == urbi::DATA_BINARY) // on recoit une donnee de type binaire
  { 
        fprintf (file_text, "MESSAGE_DATA\n"); 
        fprintf (file_text, "DATA_BINARY\n"); 

        if (value.binary->type == urbi::BINARY_NONE)
        {
           fprintf (file_text, "BINARY_NONE\n");
           fprintf (file_text, "%d",value.binary->common.size);

           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(value.binary->common.data, value.binary->common.size,1, file_data); 
        }
    
        if (value.binary->type == urbi::BINARY_UNKNOWN)
        {
           fprintf (file_text, "BINARY_UNKNOWN\n");
           fprintf (file_text, "%d",value.binary->common.size);

           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(value.binary->common.data, value.binary->common.size,1, file_data); 
        }
    
        if (value.binary->type == urbi::BINARY_IMAGE) // type image
        {
           urbi::UImage& img = value.binary->image; // pointeur vers l'image
           fprintf (file_text, "BINARY_IMAGE\n");
           fprintf (file_text, "%d\n", img.width); // largeur
           fprintf (file_text, "%d\n", img.height); // hauteur
           fprintf (file_text, "%d\n", img.size); // taille en octets de l'image
           if( img.imageFormat == urbi::IMAGE_JPEG )
               fprintf (file_text, "%d\n", IMAGE_JPEG);
           else if( img.imageFormat == urbi::IMAGE_YCbCr )
               fprintf (file_text, "%d\n" ,IMAGE_YCbCr);
           else if( img.imageFormat == urbi::IMAGE_RGB )
               fprintf (file_text, "%d\n" ,IMAGE_RGB);
           else if( img.imageFormat == urbi::IMAGE_PPM )
               fprintf (file_text, "%d\n" ,IMAGE_PPM);
           else if( img.imageFormat == urbi::IMAGE_UNKNOWN )
               fprintf (file_text, "%d\n" ,IMAGE_UNKNOWN);
    
           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(img.data, img.size,1, file_data); 
        }
    
        if (value.binary->type == urbi::BINARY_SOUND) // type son
        {
           urbi::USound& snd = value.binary->sound; // pointeur vers le son
           fprintf (file_text, "BINARY_SOUND\n");
           fprintf (file_text, "%d\n", snd.channels); // number of audio channels
           fprintf (file_text, "%d\n", snd.rate); // rate in Hertz
           fprintf (file_text, "%d\n", snd.sampleSize); // sample size in bit
           fprintf (file_text, "%d\n", snd.size); // total size in byte
           fprintf (file_text, "%d\n", snd.sampleFormat); // sample format  - SAMPLE_SIGNED or SAMPLE_UNSIGNED

           if( snd.soundFormat == urbi::SOUND_WAV )
               fprintf (file_text, "%d\n" ,SOUND_WAV);
           else if( snd.soundFormat == urbi::SOUND_RAW )
               fprintf (file_text, "%d\n" ,SOUND_RAW);
           else if( snd.soundFormat == urbi::SOUND_MP3 )
               fprintf (file_text, "%d\n" ,SOUND_MP3);
           else if( snd.soundFormat == urbi::SOUND_OGG )
               fprintf (file_text, "%d\n" ,SOUND_OGG);
           else if( snd.soundFormat == urbi::SOUND_UNKNOWN )
               fprintf (file_text, "%d\n" ,SOUND_UNKNOWN);

           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(snd.data, snd.size,1, file_data); 
        }

  } 

////////////////////////////////////////////////////////////////////////////////

  if (value.type == urbi::DATA_LIST) // on recoit une donnee de type UList
  { 
    fprintf (file_text, "MESSAGE_DATA\n"); 
    fprintf (file_text, "DATA_LIST\n"); 

    int ulistsize = value.list->array.size(); // renvoie le nombre d'elements contenus dans la liste
    fprintf (file_text, "%d\n" ,ulistsize);

    file_data = fopen(nom_fichier_data.c_str(),"w");
    if (!file_data) 
       return;

    fprintf (file_data, ""); 

    UValue *valeurUList;
    for(int i=0; i<ulistsize ; i++)
    {
        valeurUList = value.list->array[i];
        traitementUList(nameFile, "", i, valeurUList);
    }


  } 

////////////////////////////////////////////////////////////////////////////////


    fclose(file_text);
    fclose(file_data);
}





void actionfile::traitementUList(std::string openFilesPath,std::string nom, int numero, UValue *ptuvalue)
{
    FILE *file_data;
    FILE *file_text;

    std::ostringstream ostr; 
    ostr << numero; 
    std::string numerostring = ostr.str(); 

    std::string nom2 = nom + "_" + numerostring;

	std::string nom_fichier_data = openFilesPath + nom + "_" + numerostring + ".dat";
	std::string nom_fichier_text = openFilesPath + nom + "_" + numerostring + ".txt";

    file_text = fopen(nom_fichier_text.c_str(),"w");
    if (!file_text) 
       return;

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_DOUBLE) // on recoit une donnee de type double
  { 
    fprintf (file_text, "MESSAGE_DATA\n"); 
    fprintf (file_text, "DATA_DOUBLE\n"); 

    file_data = fopen(nom_fichier_data.c_str(),"w");
    if (!file_data) 
       return;

    fprintf (file_data, "%f", ptuvalue->val); 
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_STRING) // on recoit une donnee de type string
  { 
    fprintf (file_text, "MESSAGE_DATA\n"); 
    fprintf (file_text, "DATA_STRING\n"); 

    file_data = fopen(nom_fichier_data.c_str(),"w");
    if (!file_data) 
       return;

    fprintf (file_data, "%s", ptuvalue->stringValue->c_str()); 
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_VOID) // on recoit une donnee de type vide
  { 
    fprintf (file_text, "MESSAGE_DATA\n"); 
    fprintf (file_text, "DATA_VOID\n"); 

    file_data = fopen(nom_fichier_data.c_str(),"w");
    if (!file_data) 
       return;

    fprintf (file_data, ""); 
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_OBJECT) // on recoit une donnee de type UObject
  { 
    fprintf (file_text, "MESSAGE_DATA\n"); 
    fprintf (file_text, "DATA_OBJECT\n"); 

    file_data = fopen(nom_fichier_data.c_str(),"w");
    if (!file_data) 
       return;

    fprintf (file_data, ""); 
  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_BINARY) // on recoit une donnee de type binaire
  { 

        fprintf (file_text, "MESSAGE_DATA\n"); 
        fprintf (file_text, "DATA_BINARY\n"); 

        if (ptuvalue->binary->type == urbi::BINARY_NONE)
        {
           fprintf (file_text, "BINARY_NONE\n");
           fprintf (file_text, "%d",ptuvalue->binary->common.size);

           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(ptuvalue->binary->common.data, ptuvalue->binary->common.size,1, file_data); 
        }
    
        if (ptuvalue->binary->type == urbi::BINARY_UNKNOWN)
        {
           fprintf (file_text, "BINARY_UNKNOWN\n");
           fprintf (file_text, "%d",ptuvalue->binary->common.size);

           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(ptuvalue->binary->common.data, ptuvalue->binary->common.size,1, file_data); 
        }
    
        if (ptuvalue->binary->type == urbi::BINARY_IMAGE) // type image
        {
           urbi::UImage& img = ptuvalue->binary->image; // pointeur vers l'image
           fprintf (file_text, "BINARY_IMAGE\n");
           fprintf (file_text, "%d\n", img.width); // largeur
           fprintf (file_text, "%d\n", img.height); // hauteur
           fprintf (file_text, "%d\n", img.size); // taille en octets de l'image
           if( img.imageFormat == urbi::IMAGE_JPEG )
               fprintf (file_text, "%d\n", IMAGE_JPEG);
           else if( img.imageFormat == urbi::IMAGE_YCbCr )
               fprintf (file_text, "%d\n" ,IMAGE_YCbCr);
           else if( img.imageFormat == urbi::IMAGE_RGB )
               fprintf (file_text, "%d\n" ,IMAGE_RGB);
           else if( img.imageFormat == urbi::IMAGE_PPM )
               fprintf (file_text, "%d\n" ,IMAGE_PPM);
           else if( img.imageFormat == urbi::IMAGE_UNKNOWN )
               fprintf (file_text, "%d\n" ,IMAGE_UNKNOWN);
    
           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(img.data, img.size,1, file_data); 
        }
    
        if (ptuvalue->binary->type == urbi::BINARY_SOUND) // type son
        {
           urbi::USound& snd = ptuvalue->binary->sound; // pointeur vers le son
           fprintf (file_text, "BINARY_SOUND\n");
           fprintf (file_text, "%d\n", snd.channels); // number of audio channels
           fprintf (file_text, "%d\n", snd.rate); // rate in Hertz
           fprintf (file_text, "%d\n", snd.sampleSize); // sample size in bit
           fprintf (file_text, "%d\n", snd.size); // total size in byte
           fprintf (file_text, "%d\n", snd.sampleFormat); // sample format  - SAMPLE_SIGNED or SAMPLE_UNSIGNED

           if( snd.soundFormat == urbi::SOUND_WAV )
               fprintf (file_text, "%d\n" ,SOUND_WAV);
           else if( snd.soundFormat == urbi::SOUND_RAW )
               fprintf (file_text, "%d\n" ,SOUND_RAW);
           else if( snd.soundFormat == urbi::SOUND_MP3 )
               fprintf (file_text, "%d\n" ,SOUND_MP3);
           else if( snd.soundFormat == urbi::SOUND_OGG )
               fprintf (file_text, "%d\n" ,SOUND_OGG);
           else if( snd.soundFormat == urbi::SOUND_UNKNOWN )
               fprintf (file_text, "%d\n" ,SOUND_UNKNOWN);

           file_data = fopen(nom_fichier_data.c_str(),"wb");
           if (!file_data) 
             return;

           fwrite(snd.data, snd.size,1, file_data); 
        }

  } 

////////////////////////////////////////////////////////////////////////////////

  if ( ptuvalue->type == urbi::DATA_LIST) // on recoit une donnee de type UList
  { 
    fprintf (file_text, "MESSAGE_DATA\n"); 
    fprintf (file_text, "DATA_LIST\n"); 

    int ulistsize = ptuvalue->list->array.size(); // renvoie le nombre d'elements contenus dans la liste
    fprintf (file_text, "%d\n" ,ulistsize);

    file_data = fopen(nom_fichier_data.c_str(),"w");
    if (!file_data) 
       return;

    fprintf (file_data, ""); 

    UValue *valeurUList;
    for(int i=0; i<ulistsize ; i++)
    {
        valeurUList = ptuvalue->list->array[i];
        traitementUList(openFilesPath, nom2, i, valeurUList);
    }


  } 

////////////////////////////////////////////////////////////////////////////////


    fclose(file_text);
    fclose(file_data);
   
}


UValue actionfile::load(std::string nameFile) // charge le contenu du fichier nameFile et renvoie la UValue
{
    FILE *file_data;
    FILE *file_text;
    UValue value_return;

	std::string nom_fichier_data = nameFile + ".dat";
	std::string nom_fichier_text = nameFile + ".txt";

    file_text = fopen(nom_fichier_text.c_str(),"r");
    if (!file_text) 
    {
       value_return = urbi::UValue("Error - file_text not found");
       return value_return;
    }

    // lecture de la premiere ligne
    std::string line;
    char lignetxt[100];
    fgets (lignetxt, sizeof(lignetxt), file_text);
    line = lignetxt;



////////////////////////////////////////////////////////////////////////////////
  if(line == "MESSAGE_SYSTEM\n") // mauvais
  {
       value_return = urbi::UValue("Error - MESSAGE_SYSTEM");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "MESSAGE_ERROR\n") // mauvais
  {
       value_return = urbi::UValue("Error - MESSAGE_ERROR");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "MESSAGE_DATA\n") // bon
  {  }
////////////////////////////////////////////////////////////////////////////////
  else // mauvais
  {
       value_return = urbi::UValue("Error - invalid MESSAGE");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////


  // lecture de la seconde ligne
    fgets (lignetxt, sizeof(lignetxt), file_text);
    line = lignetxt;

    int etatbinaire = 0;
    int etatlist = 0;

////////////////////////////////////////////////////////////////////////////////
  if(line == "DATA_DOUBLE\n") // type DOUBLE
  {
    // lecture de la valeur
    file_data = fopen(nom_fichier_data.c_str(),"r");
    if (!file_data) 
    {
       value_return = urbi::UValue("Error - file_data not found");
       return value_return;
    }
    float datafloat;
    fscanf(file_data, "%f", &datafloat);
    value_return = urbi::UValue(datafloat);
    return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_OBJECT\n") // type UObject
  {
       value_return = urbi::UValue("Error - DATA_OBJECT");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_VOID\n") // type vide
  {
       value_return = urbi::UValue("Error - DATA_VOID");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_STRING\n") // type UString
  {
    // lecture de la valeur
    file_data = fopen(nom_fichier_data.c_str(),"r");
    if (!file_data) 
    {
       value_return = urbi::UValue("Error - file_data not found");
       return value_return;
    }
    fgets (lignetxt, sizeof(lignetxt), file_data);
    line = lignetxt;
    value_return = urbi::UValue(line);
    return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_BINARY\n") // type binaire
  {
       etatbinaire = 1;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_LIST\n") // type UList
  {
       etatlist = 1;
  }
////////////////////////////////////////////////////////////////////////////////
  else // mauvais
  {
       value_return = urbi::UValue("Error - invalid DATA");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////




////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
  if(etatbinaire == 1) // type binaire
  {
      // lecture de la troisieme ligne
      fgets (lignetxt, sizeof(lignetxt), file_text);
      line = lignetxt;


      if(line == "BINARY_NONE\n") // type BINARY_NONE
      {
        // lecture de la taille du fichier
        int sizebin;
        fscanf(file_text, "%d", &sizebin);
        struct stat st;
        stat(nom_fichier_text.c_str(),&st);
        size_t taillefile = st.st_size; 

        UBinary binarynone;

        // lecture de la valeur
        file_data = fopen(nom_fichier_data.c_str(),"rb");
        if (!file_data) 
        {
          value_return = urbi::UValue("Error - file_data not found");
          return value_return;
        }

        char buffer[taillefile];
        fread(buffer,taillefile,1,file_data) ;

        binarynone.common.size = taillefile;
        binarynone.type = BINARY_NONE;
        binarynone.common.data = buffer;
    
        value_return = urbi::UValue(binarynone);
        return value_return;


      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_IMAGE\n") // type BINARY_IMAGE
      {
        UImage binaryimage;

        // lecture des informations relatives au fichier
        int imagewidth;
        int imageheight;
        int imagesize;
        int imageformat;
        std::string imageformatstr;
        fscanf(file_text, "%d", &imagewidth);
        fscanf(file_text, "%d", &imageheight);
        fscanf(file_text, "%d", &imagesize);
        fscanf(file_text, "%d", &imageformat);
        if( imageformat == IMAGE_JPEG)
            binaryimage.imageFormat = IMAGE_JPEG;
        else if( imageformat == IMAGE_YCbCr)
            binaryimage.imageFormat = IMAGE_YCbCr;
        else if( imageformat == IMAGE_RGB)
            binaryimage.imageFormat = IMAGE_RGB;
        else if( imageformat == IMAGE_PPM)
            binaryimage.imageFormat = IMAGE_PPM;
        else if( imageformat == IMAGE_UNKNOWN)
            binaryimage.imageFormat = IMAGE_UNKNOWN;

        struct stat st;
        stat(nom_fichier_data.c_str(),&st);
        size_t taillefile = st.st_size; 

        // lecture de la valeur
        file_data = fopen(nom_fichier_data.c_str(),"rb");
        if (!file_data) 
        {
          value_return = urbi::UValue("Error - file_data not found");
          return value_return;
        }

        unsigned char buffer[taillefile];
        fread(buffer,taillefile,1,file_data) ;

        binaryimage.data = buffer;
        binaryimage.size = taillefile;
        binaryimage.width = imagewidth;
        binaryimage.height = imageheight;

        value_return = urbi::UValue(binaryimage);
        return value_return;
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_SOUND\n") // type BINARY_SOUND
      {
        USound binarysound;

        // lecture des informations relatives au fichier
        int soundchannels;
        int soundrate;
        int soundsamplesize;
        int soundsize;
        int soundsampleformat;
        int soundformat;
        std::string soundformatstr;

        fscanf(file_text, "%d", &soundchannels);
        fscanf(file_text, "%d", &soundrate);
        fscanf(file_text, "%d", &soundsamplesize);
        fscanf(file_text, "%d", &soundsize);
        fscanf(file_text, "%d", &soundsampleformat);
        fscanf(file_text, "%d", &soundformat);

        if( soundformat == SOUND_WAV)
            binarysound.soundFormat = SOUND_WAV;
        else if( soundformat == SOUND_RAW)
            binarysound.soundFormat = SOUND_RAW;
        else if( soundformat == SOUND_MP3)
            binarysound.soundFormat = SOUND_MP3;
        else if( soundformat == SOUND_OGG)
            binarysound.soundFormat = SOUND_OGG;
        else if( soundformat == SOUND_UNKNOWN)
            binarysound.soundFormat = SOUND_UNKNOWN;

        struct stat st;
        stat(nom_fichier_data.c_str(),&st);
        size_t taillefile = st.st_size; 

        // lecture de la valeur
        file_data = fopen(nom_fichier_data.c_str(),"rb");
        if (!file_data) 
        {
          value_return = urbi::UValue("Error - file_data not found");
          return value_return;
        }

        char buffer[taillefile];
        fread(buffer,taillefile,1,file_data) ;

        binarysound.data = buffer;
        binarysound.size = taillefile;
        binarysound.channels = soundchannels;
        binarysound.rate = soundrate;
        binarysound.sampleSize = soundsamplesize;

        value_return = urbi::UValue(binarysound);
        return value_return;
      }
////////////////////////////////////////////////////////////////////////////////
      else // mauvais
      {
        value_return = urbi::UValue("Error - invalid BINARY");
        return value_return;
      }


  }
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
  if(etatlist == 1) // type ulist
  {
      // lecture de la troisieme ligne
      int nbvalues;
      fscanf(file_text, "%d", &nbvalues);

      UList urbilist;
      UValue urbilistvalue;

      for(int i=0 ; i < nbvalues ; i++)
      {
           urbilistvalue = traitementUListload(nameFile,"", i);        
           urbilist.array.push_back( new UValue(urbilistvalue) );
      }

      value_return = urbi::UValue(urbilist);
      return value_return;

  }
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

    value_return = urbi::UValue("Error");
    return value_return;

}



UValue actionfile::traitementUListload(std::string openFilesPath, std::string nom, int numero)
{
    UValue value_return;

    FILE *file_data;
    FILE *file_text;

    std::ostringstream ostr; 
    ostr << numero; 
    std::string numerostring = ostr.str(); 

    std::string nom2 = nom + "_" + numerostring;

	std::string nom_fichier_data = openFilesPath + nom + "_" + numerostring + ".dat";
	std::string nom_fichier_text = openFilesPath + nom + "_" + numerostring + ".txt";

    file_text = fopen(nom_fichier_text.c_str(),"r");
    if (!file_text) 
    {
        value_return = urbi::UValue("Error - file_text not found");
        return value_return;
    }

    // lecture de la premiere ligne
    std::string line;
    char lignetxt[100];
    fgets (lignetxt, sizeof(lignetxt), file_text);
    line = lignetxt;



////////////////////////////////////////////////////////////////////////////////
  if(line == "MESSAGE_SYSTEM\n") // mauvais
  {
       value_return = urbi::UValue("Error - MESSAGE_SYSTEM");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "MESSAGE_ERROR\n") // mauvais
  {
       value_return = urbi::UValue("Error - MESSAGE_ERROR");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "MESSAGE_DATA\n") // bon
  {  }
////////////////////////////////////////////////////////////////////////////////
  else // mauvais
  {
       value_return = urbi::UValue("Error - invalid MESSAGE");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////


  // lecture de la seconde ligne
    fgets (lignetxt, sizeof(lignetxt), file_text);
    line = lignetxt;

    int etatbinaire = 0;
    int etatlist = 0;

////////////////////////////////////////////////////////////////////////////////
  if(line == "DATA_DOUBLE\n") // type DOUBLE
  {
    // lecture de la valeur
    file_data = fopen(nom_fichier_data.c_str(),"r");
    if (!file_data) 
    {
       value_return = urbi::UValue("Error - file_data not found");
       return value_return;
    }
    float datafloat;
    fscanf(file_data, "%f", &datafloat);
    value_return = urbi::UValue(datafloat);
    return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_OBJECT\n") // type UObject
  {
       value_return = urbi::UValue("Error - DATA_OBJECT");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_VOID\n") // type vide
  {
       value_return = urbi::UValue("Error - DATA_VOID");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_STRING\n") // type UString
  {
    // lecture de la valeur
    file_data = fopen(nom_fichier_data.c_str(),"r");
    if (!file_data) 
    {
       value_return = urbi::UValue("Error - file_data not found");
       return value_return;
    }
    fgets (lignetxt, sizeof(lignetxt), file_data);
    line = lignetxt;
    value_return = urbi::UValue(line);
    return value_return;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_BINARY\n") // type binaire
  {
       etatbinaire = 1;
  }
////////////////////////////////////////////////////////////////////////////////
  else if(line == "DATA_LIST\n") // type UList
  {
       etatlist = 1;
  }
////////////////////////////////////////////////////////////////////////////////
  else // mauvais
  {
       value_return = urbi::UValue("Error - invalid DATA");
       return value_return;
  }
////////////////////////////////////////////////////////////////////////////////




////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
  if(etatbinaire == 1) // type binaire
  {
      // lecture de la troisieme ligne
      fgets (lignetxt, sizeof(lignetxt), file_text);
      line = lignetxt;


      if(line == "BINARY_NONE\n") // type BINARY_NONE
      {
        // lecture de la taille du fichier
        int sizebin;
        fscanf(file_text, "%d", &sizebin);
        struct stat st;
        stat(nom_fichier_text.c_str(),&st);
        size_t taillefile = st.st_size; 

        UBinary binarynone;

        // lecture de la valeur
        file_data = fopen(nom_fichier_data.c_str(),"rb");
        if (!file_data) 
        {
          value_return = urbi::UValue("Error - file_data not found");
          return value_return;
        }

        char buffer[taillefile];
        fread(buffer,taillefile,1,file_data) ;

        binarynone.common.size = taillefile;
        binarynone.type = BINARY_NONE;
        binarynone.common.data = buffer;
    
        value_return = urbi::UValue(binarynone);
        return value_return;


      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_IMAGE\n") // type BINARY_IMAGE
      {
        UImage binaryimage;

        // lecture des informations relatives au fichier
        int imagewidth;
        int imageheight;
        int imagesize;
        int imageformat;
        std::string imageformatstr;
        fscanf(file_text, "%d", &imagewidth);
        fscanf(file_text, "%d", &imageheight);
        fscanf(file_text, "%d", &imagesize);
        fscanf(file_text, "%d", &imageformat);
        if( imageformat == IMAGE_JPEG)
            binaryimage.imageFormat = IMAGE_JPEG;
        else if( imageformat == IMAGE_YCbCr)
            binaryimage.imageFormat = IMAGE_YCbCr;
        else if( imageformat == IMAGE_RGB)
            binaryimage.imageFormat = IMAGE_RGB;
        else if( imageformat == IMAGE_PPM)
            binaryimage.imageFormat = IMAGE_PPM;
        else if( imageformat == IMAGE_UNKNOWN)
            binaryimage.imageFormat = IMAGE_UNKNOWN;

        struct stat st;
        stat(nom_fichier_data.c_str(),&st);
        size_t taillefile = st.st_size; 

        // lecture de la valeur
        file_data = fopen(nom_fichier_data.c_str(),"rb");
        if (!file_data) 
        {
          value_return = urbi::UValue("Error - file_data not found");
          return value_return;
        }

        unsigned char buffer[taillefile];
        fread(buffer,taillefile,1,file_data) ;

        binaryimage.data = buffer;
        binaryimage.size = taillefile;
        binaryimage.width = imagewidth;
        binaryimage.height = imageheight;

        value_return = urbi::UValue(binaryimage);
        return value_return;
      }
////////////////////////////////////////////////////////////////////////////////
      else if(line == "BINARY_SOUND\n") // type BINARY_SOUND
      {
        USound binarysound;

        // lecture des informations relatives au fichier
        int soundchannels;
        int soundrate;
        int soundsamplesize;
        int soundsize;
        int soundsampleformat;
        int soundformat;
        std::string soundformatstr;

        fscanf(file_text, "%d", &soundchannels);
        fscanf(file_text, "%d", &soundrate);
        fscanf(file_text, "%d", &soundsamplesize);
        fscanf(file_text, "%d", &soundsize);
        fscanf(file_text, "%d", &soundsampleformat);
        fscanf(file_text, "%d", &soundformat);

        if( soundformat == SOUND_WAV)
            binarysound.soundFormat = SOUND_WAV;
        else if( soundformat == SOUND_RAW)
            binarysound.soundFormat = SOUND_RAW;
        else if( soundformat == SOUND_MP3)
            binarysound.soundFormat = SOUND_MP3;
        else if( soundformat == SOUND_OGG)
            binarysound.soundFormat = SOUND_OGG;
        else if( soundformat == SOUND_UNKNOWN)
            binarysound.soundFormat = SOUND_UNKNOWN;

        struct stat st;
        stat(nom_fichier_data.c_str(),&st);
        size_t taillefile = st.st_size; 

        // lecture de la valeur
        file_data = fopen(nom_fichier_data.c_str(),"rb");
        if (!file_data) 
        {
          value_return = urbi::UValue("Error - file_data not found");
          return value_return;
        }

        char buffer[taillefile];
        fread(buffer,taillefile,1,file_data) ;

        binarysound.data = buffer;
        binarysound.size = taillefile;
        binarysound.channels = soundchannels;
        binarysound.rate = soundrate;
        binarysound.sampleSize = soundsamplesize;

        value_return = urbi::UValue(binarysound);
        return value_return;
      }
////////////////////////////////////////////////////////////////////////////////
      else // mauvais
      {
        value_return = urbi::UValue("Error - invalid BINARY");
        return value_return;
      }


  }
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
  if(etatlist == 1) // type ulist
  {
      // lecture de la troisieme ligne
      int nbvalues;
      fscanf(file_text, "%d", &nbvalues);

      UList urbilist;
      UValue urbilistvalue;

      for(int i=0 ; i < nbvalues ; i++)
      {
           urbilistvalue = traitementUListload(openFilesPath, nom2, i);        
           urbilist.array.push_back( new UValue(urbilistvalue) );
      }

      value_return = urbi::UValue(urbilist);
      return value_return;

  }
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

    value_return = urbi::UValue("Error");
    return value_return;
}
