#include "stdafx.h"
#include "tts.h"


int thread(void *ptclass)
{

		// on recupere l'adresse de notre classe
		tts *pt = static_cast<tts *>(ptclass);

		// permet de voir si les commandes s'excutent correctement
		HRESULT hr;

		// pointeur pour jouer du son
		ISpVoice *pVoice;
		pVoice = NULL;

		// Initialiser la librairie COM:
		if (FAILED(::CoInitialize(NULL)))
		{
			printf("error initialise librairie COM\n");
			return -1;
		}

		CComPtr<ISpObjectToken> cpAudioOutToken;
		CComPtr<ISpObjectToken> cpVoiceToken;
		CComPtr<IEnumSpObjectTokens> cpEnum;
		ULONG ulCount = 0;

		// creation de l'instance pour le son
		hr = CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&pVoice); 

		// boucle infinie
		while( pt->etat != -1)
		{

			// parler
			if(pt->etat == 1) 
			{
				pt->etat = 0;
				// hr = pVoice->Speak(L"How are you ?", 0, NULL);

				// Change pitch
				// hr = pVoice->Speak(L"I am glad to speak.", SPF_ASYNC, NULL );

				// Change pitch
				// hr = pVoice->Speak(L"This sounds normal <pitch middle = '-10'/> but the pitch drops half way through", SPF_IS_XML, NULL );


				int nInputStrLen = (int) strlen (pt->phrase.c_str());
				WCHAR *pszOut = new WCHAR[nInputStrLen+1];
				for(int i=0; i<nInputStrLen ; i++)
					pszOut[i]= pt->phrase.c_str()[i];
				pszOut[nInputStrLen]= '\0';
				hr = pVoice->Speak( pszOut, SPF_ASYNC, NULL);
				delete pszOut;				

				// WCHAR theString[30];
				// wcscpy( theString, L"petit test." );
				// hr = pVoice->Speak( theString, SPF_ASYNC, NULL);

				// lit le texte d'un fichier
				// hr = pVoice->Speak(L"e:/tts.txt", SPF_IS_FILENAME, NULL );
				printf("fin etat 1\n");
			}

			// changer le rate (-10 et 10)
			if(pt->etat == 2) 
			{
				pt->etat = 0;
				hr = pVoice->SetRate(pt->m_DefaultRate);
				hr = pVoice->GetRate( &(pt->m_DefaultRate) );
				printf("fin etat 2\n");
			}

			// changer la priorite
			if(pt->etat == 3) 
			{
				pt->etat = 0;
				hr = pVoice->SetPriority(pt->pePriority);
				hr = pVoice->GetPriority( &(pt->pePriority) );
				printf("fin etat 3\n");
			}

			// mise en pause
			if(pt->etat == 4) 
			{
				pt->etat = 0;
				hr = pVoice->Pause();
				printf("fin etat 4\n");
			}

			// reprise
			if(pt->etat == 5) 
			{
				pt->etat = 0;
				hr = pVoice->Resume();
				printf("fin etat 5\n");
			}

			// changer le volume (0 et 100)
			if(pt->etat == 6) 
			{
				pt->etat = 0;
				hr = pVoice->SetVolume(pt->m_DefaultVolume);
				hr = pVoice->GetVolume( &(pt->m_DefaultVolume) );
				printf("fin etat 6\n");
			}

			// on recupere les proprietes de pVoice
			if(pt->etat == 7) 
			{
				pt->etat = 0;
				hr = pVoice->GetStatus( &(pt->pStatus) , &(pt->ppszLastBookmark) );
				printf("fin etat 7\n");
			}

			// on copie le son dans un fichier wav
			if(pt->etat == 8) 
			{
				pt->etat = 0;
				ISpStreamFormat *cpOldStream = NULL;
				hr = pVoice->GetOutputStream( &cpOldStream );
				CComPtr<ISpStream> cpSpStream;
				// Create the stream object.
				hr = cpSpStream.CoCreateInstance(CLSID_SpStream);
				// Create a stream format helper for 22khzm 16-bit, mono wave stream.
				CSpStreamFormat Fmt(SPSF_22kHz16BitMono, &hr);
				// Create new stream and its corresponding file on hard
				// disk (specify the file format when creating the file).
				hr = cpSpStream->BindToFile( L"C:\\uobject_tts.wav" , SPFM_CREATE_ALWAYS , &Fmt.FormatId() , Fmt.WaveFormatExPtr() , NULL );
				hr = cpSpStream->BindToFile(L"C:\\uobject_tts.wav", SPFM_CREATE_ALWAYS, &Fmt.FormatId(), Fmt.WaveFormatExPtr(), NULL);

				// dirige vers la sortie file stream
				hr = pVoice->SetOutput(cpSpStream,TRUE);

				int nInputStrLen = (int) strlen (pt->phrase.c_str());
				WCHAR *pszOut = new WCHAR[nInputStrLen+1];
				for(int i=0; i<nInputStrLen ; i++)
					pszOut[i]= pt->phrase.c_str()[i];
				pszOut[nInputStrLen]= '\0';
				hr = pVoice->Speak( pszOut, 0, NULL);

				// fermeture du flux stream pour fermer le fichier
				hr = cpSpStream->Close();
				delete pszOut;		

				// dirige vers la sortie standard
				hr = pVoice->SetOutput(cpOldStream,TRUE);
				printf("fin etat 8\n");
			}

			// on impose une voix
			if(pt->etat == 9) 
			{
				pt->etat = 0;
				hr = pVoice->GetVoice(&(pt->cpVoiceToken));
				hr = pVoice->SetVoice(pt->cpVoiceToken);
				printf("fin etat 9\n");
			}

			// on change la sortie audio
			if(pt->etat == 10) 
			{
				pt->etat = 0;
			    // Enumerate the available audio output devices.
			    hr = SpEnumTokens( SPCAT_AUDIOOUT, NULL, NULL, &cpEnum );
				// Get the number of audio output devices.
				hr = cpEnum->GetCount( &ulCount );
				if(pt->nb_outaudio > (int)ulCount)
					pt->nb_outaudio = (int)ulCount;
				for(int i=0; i < pt->nb_voice;i++)
					hr = cpEnum->Next( 1, &cpAudioOutToken, NULL );
				hr = pVoice->SetOutput( cpAudioOutToken, TRUE );
				printf("fin etat 10\n");
			}


			// on change la voix
			if(pt->etat == 11) 
			{
				pt->etat = 0;
				// Enumerate the available voices.
				hr = SpEnumTokens(SPCAT_VOICES, NULL, NULL, &cpEnum);
				// Get the number of voices.
				hr = cpEnum->GetCount(&ulCount);
				if(pt->nb_voice > (int)ulCount)
					pt->nb_voice = (int)ulCount;
				cpVoiceToken.Release();
				for(int i=0; i < pt->nb_voice;i++)
					hr = cpEnum->Next(1, &cpVoiceToken, NULL);
				hr = pVoice->SetVoice(cpVoiceToken);
				printf("fin etat 11\n");
			}

			// on retourne un wav
			if(pt->etat == 12) 
			{
				pt->etat = 13; // ne fait rien
				ISpStreamFormat *cpOldStream = NULL;
				hr = pVoice->GetOutputStream( &cpOldStream );
				CComPtr<ISpStream> cpSpStream;
				// Create the stream object.
				hr = cpSpStream.CoCreateInstance(CLSID_SpStream);
				// Create a stream format helper for 22khzm 16-bit, mono wave stream.
				CSpStreamFormat Fmt(SPSF_22kHz16BitMono, &hr);
				// Create new stream and its corresponding file on hard
				// disk (specify the file format when creating the file).
				hr = cpSpStream->BindToFile( L"C:\\uobject_tts.wav" , SPFM_CREATE_ALWAYS , &Fmt.FormatId() , Fmt.WaveFormatExPtr() , NULL );
				hr = cpSpStream->BindToFile(L"C:\\uobject_tts.wav", SPFM_CREATE_ALWAYS, &Fmt.FormatId(), Fmt.WaveFormatExPtr(), NULL);

				// dirige vers la sortie file stream
				hr = pVoice->SetOutput(cpSpStream,TRUE);

				int nInputStrLen = (int) strlen (pt->phrase.c_str());
				WCHAR *pszOut = new WCHAR[nInputStrLen+1];
				for(int i=0; i<nInputStrLen ; i++)
					pszOut[i]= pt->phrase.c_str()[i];
				pszOut[nInputStrLen]= '\0';
				hr = pVoice->Speak( pszOut, 0, NULL);

				// fermeture du flux stream pour fermer le fichier
				hr = cpSpStream->Close();
				delete pszOut;		

				// dirige vers la sortie standard
				hr = pVoice->SetOutput(cpOldStream,TRUE);

				printf("fin etat 12\n");
				pt->etat = 14; // avertir la fonction returnwav
			}

		}

		pVoice->Release();
		pVoice = NULL;

		// desInitialiser la librairie COM:
		::CoUninitialize();
		pt->etat = -2;

		return 1;
}



// activation du UObject
UStart(tts);

// creation de tts
tts::tts(std::string s) : UObject(s) 
{
		UBindFunction(tts,init);
		UBindFunction(tts,play);
		UBindFunction(tts,setrate);
		UBindFunction(tts,setpriority);
		UBindFunction(tts,pause);
		UBindFunction(tts,resume);
		UBindFunction(tts,setvolume);
		UBindFunction(tts,getstatus);
		UBindFunction(tts,playwav);
		UBindFunction(tts,setvoice);
		UBindFunction(tts,changevoice);
		UBindFunction(tts,changeoutaudio);
		UBindFunction(tts,returnwav);

		etat = 0;
		t1 = NULL;
	    if(t1 == NULL)
	    {
	      t1 = SDL_CreateThread(thread, (void*) this);
	    }

		return;
};

// destruction de tts
tts::~tts(void) 
{
	etat = -1;
	while(etat != -2) // en attente de la fermeture du thread
	{
	}

    // arret du thread
    if(t1 != NULL)
    {
        SDL_KillThread (t1);
        t1 = NULL;
    }

	return;
};

int tts::init(void)
{
		return 1;
};	
		
int tts::play(std::string word)
{
		phrase = word;
		etat = 1;
		return 0;
};



int tts::setrate(int rate)
{
		m_DefaultRate = rate;
		etat = 2;
		return 0;
}

int tts::setpriority(int priority)
{
		pePriority = (SPVPRIORITY) priority;
		etat = 3;
		return 0;
}

int tts::pause(void)
{
		etat = 4;
		return 0;
}

int tts::resume(void)
{
		etat = 5;
		return 0;
}

int tts::setvolume(int volume)
{
		m_DefaultVolume = volume;
		etat = 6;
		return 0;
}

int tts::getstatus(void)
{
		etat = 7;
		return 0;
}

int tts::playwav(std::string word)
{
		phrase = word;
		etat = 8;
		return 0;
}


int tts::setvoice(void)
{
		etat = 9;
		return 0;
}

int tts::changeoutaudio(int choice)
{
		nb_outaudio = choice;
		etat = 10;
		return 0;
}

int tts::changevoice(int choice)
{
		nb_voice = choice;
		etat = 11;
		return 0;
}

USound tts::returnwav(std::string word)
{
		phrase = word;
		etat = 12;

//		printf("Boucle attente.");
		while(etat != 14) // en attente du traitement par le thread
		{
			Sleep(5); 
//			printf(".");
		}
		etat = 0;
//		printf("Creation du USound et lecture du fichier wav\n");
		// create a USound
		USound tmpSnd;
		tmpSnd.soundFormat = SOUND_WAV;
		tmpSnd.data = 0;
		tmpSnd.size = 0;
		tmpSnd.rate = 16000;  // inutile
		tmpSnd.sampleSize = 16; // inutile
		tmpSnd.sampleFormat = SAMPLE_SIGNED; // inutile
		tmpSnd.channels = 1; // inutile

		std::string File = "c:\\uobject_tts.wav";
      	FILE *f;
        f = fopen(File.c_str(),"rb");
		int cpt = 0;
		while (!f)
		{
			cpt++;
			printf("fichier non trouve\n");
			Sleep(50); 
	        f = fopen(File.c_str(),"rb");
			if(cpt >=5)
				return tmpSnd;
		}

      	struct stat st;
      	stat(File.c_str(),&st);
      	tmpSnd.data = new char[st.st_size];
      	tmpSnd.size = st.st_size;
      	fread(tmpSnd.data, 1,st.st_size, f);
		fclose(f);

     	return tmpSnd;
};