#include "morpion.h"

UStart(morpion);

// Creation de l'objet morpion
morpion::morpion(std::string s) : UObject(s) 
{
	UBindFunction(morpion,init);
	UBindFunction(morpion,initialiser);
	UBindFunction(morpion,tableau);
	UBindFunction(morpion,transfoi);
	UBindFunction(morpion,transfoj);
	UBindFunction(morpion,start);
	UBindFunction(morpion,croix);
	UBindFunction(morpion,coin);
	UBindFunction(morpion,Fin);
	UBindFunction(morpion,afficherXO);
	UBindFunction(morpion,ordi);	
	UBindFunction(morpion,saisir);	

    // initialisation du tableau morpion
	tabmorpion = new int*[3];
    for (int i=0;i<3;i++)
    {
        tabmorpion[i] = new int[3];
    }

}


// Destruction de l'objet morpion 
morpion::~morpion(void)
{

}


// empecher que l'on puisse faire un new morpion()
int morpion::init(void)
{
  return 1; // Singleton
}


// Initialise la grille du morpion 
void morpion::initialiser(void)
{
int i,j;
    for (i=0;i<3;i++)
    {
         for (j=0;j<3;j++)
             tabmorpion[i][j]=VIDE;
    }
}


int convert(int nb)
{
    if (nb == 1) return 7;
    if (nb == 2) return 8;
    if (nb == 3) return 9;
    if (nb == 4) return 4;
    if (nb == 5) return 5;
    if (nb == 6) return 6;
    if (nb == 7) return 1;
    if (nb == 8) return 2;
    if (nb == 9) return 3;
}

// Affiche la grille du Morpion, ainsi que les touches utiles au jeu
void morpion::tableau(void)
{
	std::string message;
	std::string messagetmp;

    int LIGNE = 3;
    int COLONNE = 3;

	int i, j, k;
	i = 0;

         // on met une ligne horizontale
         message = "+connection(\"all\"): \"  ";
         for(k = 1; k <= COLONNE; k++)
         {
            message = message + "----";
         }
         message = message + "-\";";
         urbi::send(message.c_str());


	for(j = 1; j <= LIGNE; j++)
	{
        message = "+connection(\"all\"): \" ";
        for(k = 1; k <= COLONNE; k++)
        {
            std::ostringstream ostr; 
            ostr << convert((j-1)*3+k); 
            messagetmp = ostr.str(); 
            message = message + " | " + messagetmp;
            i++;
         }
         message = message + " | \";";
         urbi::send(message.c_str());


         message = "+connection(\"all\"): \"  ";
         for(k = 1; k <= COLONNE; k++)
         {
            message = message + "----";
         }
         message = message + "-\";";
         urbi::send(message.c_str());
	}
}




// Convertit le chiffre tap par le joueur (1  9) en donnant la ligne du tableau (0  2)
int morpion::transfoi(int nb)
{
 switch (nb)
        {
         case 1:case 2:case 3:
         return 2;
         break;
         case 4:case 5:case 6:
         return 1;
         break;
         case 7:case 8:case 9:
         return 0;
         break;
        }
return 0;
}

// Convertit le chiffre tap par le joueur (1  9) en donnant la ligne du tableau (0  2)
int morpion::transfoj(int nb)
{
 switch (nb)
        {
         case 1:case 4:case 7:
         return 0;
         break;
         case 2:case 5:case 8:
         return 1;
         break;
         case 3:case 6:case 9:
         return 2;
         break;
        }
return 0;
}



// Main 
void morpion::start(int begin)
{
// begin = 1 ==> on commence le jeu
// begin = 2 ==> l'ordinateur commence le jeu

	std::string message = "+connection(\"all\"):\"Bienvenu dans le Jeu du Morpion.\";";
    urbi::send(message.c_str());

    initialiser(); // on initialise la grille
    tableau(); // on affiche le tableau


    if(begin == 1)
    {
      message = "+connection(\"all\"):\"Vous commencez a jouer en premier.\";";
      urbi::send(message.c_str());   
    }

    else
    {
      message = "+connection(\"all\"):\"L'ordinateur joue en premier.\";";
      urbi::send(message.c_str());   
      ordi();
      afficherXO();
    }

    message = "+connection(\"all\"):\"Pour jouer, faire morpion.saisir(num_case);\";";
    urbi::send(message.c_str());

}


// L'ordinateur joue dans les cts haut,bas,gauche et droite 
void morpion::croix(void)
{
  int alea;
  int fin=0;

  int i,j;

  do
  {
   srand((unsigned) time(NULL)); // initialisation du generateur aleatoire
   alea=2*((rand() % 4)+1);
   i= transfoi(alea);
   j= transfoj(alea);
   if (tabmorpion[i][j]==VIDE)
   {
       tabmorpion[i][j]=CROIX;
       fin=1;
   }
  }
  while(fin!=1);
}


// Fonction qui permet  l'ordinateur de voir si il peur gagner et si le joueur peut gagner 
int morpion::verifordi(int CHOIX) 
{
    if(((tabmorpion[1][0]==CHOIX && tabmorpion[0][0]==CHOIX) || (tabmorpion[2][1]==CHOIX && tabmorpion[2][2]==CHOIX) || (tabmorpion[1][1]==CHOIX && tabmorpion[0][2]==CHOIX))  && (tabmorpion[2][0]==VIDE))
        return 1;
    
    if(((tabmorpion[2][0]==CHOIX && tabmorpion[2][2]==CHOIX) ||
           (tabmorpion[1][1]==CHOIX && tabmorpion[0][1]==CHOIX)) && (tabmorpion[2][1]==VIDE))
           return 2;
    
    if(((tabmorpion[2][0]==CHOIX && tabmorpion[2][1]==CHOIX) ||
           (tabmorpion[1][1]==CHOIX && tabmorpion[0][0]==CHOIX) ||
           (tabmorpion[1][2]==CHOIX && tabmorpion[0][2]==CHOIX)) && (tabmorpion[2][2]==VIDE))
           return 3;
    
    if(((tabmorpion[2][0]==CHOIX && tabmorpion[0][0]==CHOIX) ||
           (tabmorpion[1][1]==CHOIX && tabmorpion[1][2]==CHOIX)) && (tabmorpion[1][0]==VIDE))
           return 4;
    
    if(((tabmorpion[2][0]==CHOIX && tabmorpion[0][2]==CHOIX) ||
           (tabmorpion[2][1]==CHOIX && tabmorpion[0][1]==CHOIX) ||
           (tabmorpion[2][2]==CHOIX && tabmorpion[0][0]==CHOIX) ||
           (tabmorpion[1][0]==CHOIX && tabmorpion[1][2]==CHOIX)) && (tabmorpion[1][1]==VIDE))
           return 5;
    
    if(((tabmorpion[1][0]==CHOIX && tabmorpion[1][1]==CHOIX) ||
            (tabmorpion[2][2]==CHOIX && tabmorpion[0][2]==CHOIX)) && (tabmorpion[1][2]==VIDE))
            return 6;
    
    if(((tabmorpion[2][0]==CHOIX && tabmorpion[1][0]==CHOIX) ||
            (tabmorpion[1][1]==CHOIX && tabmorpion[2][2]==CHOIX) ||
            (tabmorpion[0][1]==CHOIX && tabmorpion[0][2]==CHOIX)) && (tabmorpion[0][0]==VIDE))
            return 7;
    
    if(((tabmorpion[2][1]==CHOIX && tabmorpion[1][1]==CHOIX) ||
           (tabmorpion[0][0]==CHOIX && tabmorpion[0][2]==CHOIX)) && (tabmorpion[0][1]==VIDE))
           return 8;
    
    if(((tabmorpion[2][0]==CHOIX && tabmorpion[1][1]==CHOIX) ||
            (tabmorpion[2][2]==CHOIX && tabmorpion[1][2]==CHOIX) ||
            (tabmorpion[0][0]==CHOIX && tabmorpion[0][1]==CHOIX)) && (tabmorpion[0][2]==VIDE))
            return 9;
    
    return 0;
}


// L'ordinateur joue dans les coins 
int morpion::coin()
{
    int alea,f=0;
    int i,j;
    if (tabmorpion[0][0]==VIDE || tabmorpion[0][2]==VIDE || tabmorpion[2][0]==VIDE || tabmorpion[2][2]==VIDE)
       {
        do
          {
           srand((unsigned) time(NULL));
           alea=(2*((rand() % 5)+1))-1;
           i = transfoi(alea);
           j = transfoj(alea);
           if ((alea)%2!=0 && tabmorpion[i][j]==VIDE)
              {
               tabmorpion[i][j]=CROIX;
               f=1;
               return 1;
              }
      }
      while (f!=1);
      }
    else return 0;
    return 0;
}



// Teste si il y a un gagnant et si jeu est complet 
morpion::Test morpion::Fin (void) 
{
       int i,j,joueurGagnant=VIDE;
       Test estFini=FAUX;
       if (tabmorpion[1][1]!=VIDE)        // Si la case 5 est VIDE, cela signifie que les diagonales...
          {                            //la ligne 1 et la colonne 1 ne sont pas gagnantes 
           if (((tabmorpion[0][1]==tabmorpion[1][1]) && (tabmorpion[1][1]==tabmorpion[2][1])) ||// Colonne 1  
	          ((tabmorpion[1][0]==tabmorpion[1][1]) && (tabmorpion[1][1]==tabmorpion[1][2])) ||  // Ligne 1   
	          ((tabmorpion[0][0]==tabmorpion[1][1]) && (tabmorpion[1][1]==tabmorpion[2][2])) || // Diagonale1
	          ((tabmorpion[0][2]==tabmorpion[1][1]) && (tabmorpion[1][1]==tabmorpion[2][0]))) // Diagonale2
              {
               joueurGagnant=tabmorpion[1][1]; // ROND ou CROIX 
               estFini = VRAI;
              }
          }

       if ((!estFini) && (tabmorpion[0][0]!=VIDE))      // Si la case 7 est vide, cela signifie que...
          {                                          //...la ligne 0 et le colonne 0 ne sont pas gagnantes 
           if (((tabmorpion[0][0]==tabmorpion[0][1]) && (tabmorpion[0][1]==tabmorpion[0][2])) ||// Ligne 0  
	          ((tabmorpion[0][0]==tabmorpion[1][0]) && (tabmorpion[1][0]==tabmorpion[2][0]))) // Colonne0 
               {
                joueurGagnant=tabmorpion[0][0];
                estFini=VRAI;
               }
          }

       if ((!estFini) && (tabmorpion[2][2] != VIDE))   // Si la case 3 est vide, cela signifie...
          {                                        //...que la ligne 2 et la colonne 2 ne sont gagnantes 
          if (((tabmorpion[2][0]==tabmorpion[2][1]) && (tabmorpion[2][1]==tabmorpion[2][2])) ||// Ligne 2   
	         ((tabmorpion[0][2]==tabmorpion[1][2]) && (tabmorpion[1][2]==tabmorpion[2][2]))) // Colonne 2 
             {
              joueurGagnant=tabmorpion[2][2];
              estFini = VRAI;
             }
          }

    if (estFini) // il y a un gagnant
    {
          if (joueurGagnant==ROND)
            {
               std::string message = "+connection(\"all\"):\"Le joueur ayant les O a gagne\";";
               urbi::send(message.c_str());
            }
          else
              {
               std::string message = "+connection(\"all\"):\"L'ordinateur ayant les X a gagne\";";
               urbi::send(message.c_str());
               }
    
         return VRAI;
    }

     for (i=0;i<3;i++)
         {
         for (j=0;j<3;j++)
             {
             if (tabmorpion[i][j]==VIDE)// Si toutes les cases ne sont pas remplies, le jeu continue... 
	         return FAUX;
             }
         }

	std::string message = "+connection(\"all\"):\"Match nul...\";";
    urbi::send(message.c_str());
    return VRAI;
}


// Affiche les X et O sur la grille
void morpion::afficherXO(void)
{
	std::string message;
	std::string messagetmp;

    int LIGNE = 3;
    int COLONNE = 3;

	int i, j, k;
	i = 0;

         // on met une ligne horizontale
         message = "+connection(\"all\"): \"  ";
         for(k = 1; k <= COLONNE; k++)
         {
            message = message + "----";
         }
         message = message + "-\";";
         urbi::send(message.c_str());


	for(j = 1; j <= LIGNE; j++)
	{
        message = "+connection(\"all\"): \" ";
        for(k = 1; k <= COLONNE; k++)
        {
           messagetmp = " "; 
           switch (tabmorpion[j-1][k-1])
           {
                   case ROND:
                   messagetmp = "O"; 
                   break;
                   case CROIX:
                   messagetmp = "X"; 
                   break;
           }

            message = message + " | " + messagetmp;
            i++;
         }
         message = message + " | \";";
         urbi::send(message.c_str());


         message = "+connection(\"all\"): \"  ";
         for(k = 1; k <= COLONNE; k++)
         {
            message = message + "----";
         }
         message = message + "-\";";
         urbi::send(message.c_str());
	}
}



// L'ordinateur joue un coup 
void morpion::ordi(void) 
{
    int alea=0;
    int i,j;

	std::string message;
	message = "+connection(\"all\"):\"L'ordinateur reflechit...\";";
    urbi::send(message.c_str());

    if ((alea=verifordi(CROIX))!=0)   // L'ordinateur regarde si il peut gagner... 
       {
        i = transfoi(alea);
        j = transfoj(alea);
        tabmorpion[i][j]=CROIX;
       }
    else
        {
         if ((alea=verifordi(ROND))!=0)  //...sinon il regarde si le joueur peut gagner... 
            {
                i = transfoi(alea);
                j = transfoj(alea);
                tabmorpion[i][j]=CROIX;
            }
         else
             {
              if (tabmorpion[1][1]==VIDE)    // ...Si aucun des joueurs ne peut gagner...   
                 {
                  alea=5;
                  tabmorpion[1][1]=CROIX;        //...l'ordinateur joue le coup central... 
                 }
              else
                  {
                   if  ((tabmorpion[0][0]==ROND && tabmorpion[2][2]==ROND)
                       && ((tabmorpion[1][0]==VIDE && tabmorpion[2][1]==VIDE && tabmorpion[2][0]==VIDE)
                       ||  (tabmorpion[1][2]==VIDE && tabmorpion[0][1]==VIDE && tabmorpion[0][2]==VIDE)))
                       croix();
                   if  ((tabmorpion[2][0]==ROND && tabmorpion[0][2]==ROND)
                       && ((tabmorpion[1][0]==VIDE && tabmorpion[0][0]==VIDE && tabmorpion[0][1]==VIDE)
                       ||  (tabmorpion[2][1]==VIDE && tabmorpion[2][2]==VIDE && tabmorpion[1][2]==VIDE)))
                       croix();
                   else
                       {
                        if (coin()==0)     // Si tous les coins sont pris, l'ordinateur...
                           croix();        // joue un ct
                       }
                  }
             }
       }
}




// Le joueur saisit une case
void morpion::saisir(int nb) 
{
     Test SaisieCorrecte=FAUX;

     if (nb<1 || nb>9)
     {
       std::string message;
       message = "+connection(\"all\"):\"Nombre incorrect ! Mettre une valeur comprise entre 1 et 9\";";
       urbi::send(message.c_str());
       return;
     }

     int i,j;
     i = transfoi(nb);
     j = transfoj(nb);

     if (tabmorpion[i][j]!=VIDE)
     {
       std::string message;
       message = "+connection(\"all\"):\"Cette case est deja prise !\";";
       urbi::send(message.c_str());
       afficherXO();
       return;
     }
     else
     {
       SaisieCorrecte=VRAI;
       tabmorpion[i][j]=ROND;
       afficherXO();
     }


     // on regarde si quelqu'un a gagne
     int agagne;
     agagne = Fin();
     if(agagne == FAUX) // personne a gagne, donc on fait jouer l'ordi
     {
         ordi();
         afficherXO();
         agagne = Fin();
     }

}
