#include "urbichat.h"

UStart(urbichat);

urbichat::urbichat(std::string s) : UObject(s) 
{
	UBindFunction(urbichat,init);
	UBindFunction(urbichat,creat);
	UBindFunction(urbichat,nick2);                               
	UBindFunction(urbichat,checkname2);    
	UBindFunction(urbichat,leave2);    
	UBindFunction(urbichat,join2);    
	UBindFunction(urbichat,send2);    
	UBindFunction(urbichat,chat2);    
	UBindFunction(urbichat,display);    
	UBindFunction(urbichat,displayuserschannel2);    

    // creation des fonctions URBI
    creat();

    members = NULL;
	members = new urbichatmember[100]; // creation de 100 enregistrements

    nb_connexions=0; // au demarrage, il y a personne de connecter
                          
}

urbichat::~urbichat()
{
	delete members;
}

int urbichat::init(void)
{
  return 1; // Singleton
}

void urbichat::creat(void)
{

    // creation de la fonction nick();
	URBI((
          function urbichat.nick(name) 
          {
             urbichat.nick2(local.connectionID , name);
          };
    ));


    // creation de la fonction checkname();
	URBI((
          function urbichat.checkname() 
          {
             urbichat.checkname2(local.connectionID);
          };
    ));


    // creation de la fonction leave();
	URBI((
          function urbichat.leave() 
          {
             urbichat.leave2(local.connectionID);
          };
    ));


    // creation de la fonction join();
	URBI((
          function urbichat.join(channel) 
          {
             urbichat.join2(local.connectionID , channel);
          };
    ));


    // creation de la fonction send();
	URBI((
          function urbichat.send(channel,msg) 
          {
             urbichat.send2(local.connectionID , channel , msg);
          };
    ));


    // creation de la fonction chat();
	URBI((
          function urbichat.chat(msg) 
          {
             urbichat.chat2(local.connectionID , msg);
          };
    ));

    // creation de la fonction displayuserschannel();
	URBI((
          function urbichat.displayuserschannel() 
          {
             urbichatusers:urbichat.displayuserschannel2(local.connectionID);
          };
    ));


  return;
}


void urbichat::nick2(std::string cid , std::string name)
{
   if( nb_connexions == 0)
   {
       nb_connexions = 1;
       members[0].setname(name);
       members[0].setcid(cid);
       members[0].setid(nb_connexions);
   }
   else
   {
         int ref = nb_connexions;
         int i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string cid2 = members[i].getcid();   
            if( cid == cid2 ) // comparaison 
                ref = i;
         } 

         if(ref == nb_connexions) // il s'agit d'une nouvelle connexion
         {
           nb_connexions ++; 
           members[ref].setname(name);
           members[ref].setcid(cid);
           members[ref].setid(1);
                
         }
         else // la connexion existait dej
         {
                members[ref].setname(name);
         }
   }

  return;
}

void urbichat::checkname2(std::string cid)
{
   if( nb_connexions == 0)
   {
       nb_connexions = 1;
       members[0].setname("anonymous_" + cid);
       members[0].setcid(cid);
       members[0].setid(nb_connexions);
   }
   else
   {
         int ref = nb_connexions;
         int i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string cid2 = members[i].getcid();   
            if( cid == cid2 ) // comparaison 
                ref = i;
         } 

         if(ref == nb_connexions) // il s'agit d'une nouvelle connexion
         {
           nb_connexions ++; 
           members[ref].setname("anonymous_" + cid);
           members[ref].setcid(cid);
           members[ref].setid(nb_connexions);
                
         }
   }
  return;
}

void urbichat::leave2(std::string cid)
{
   if( nb_connexions == 0) // si aucune connexion, alors pas besoin de se deconnecter car pas connecter
   {
       return;
   }
   else
   {
         int ref = nb_connexions;
         int i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string cid2 = members[i].getcid();   
            if( cid == cid2 ) // comparaison 
                ref = i;
         } 

         if(ref != nb_connexions) // il y a deja une connexion
         {
           members[ref].setchannel("");
         }
   }

  return;
}

void urbichat::join2(std::string cid , std::string channel)
{
   if( nb_connexions == 0)
   {
       nb_connexions = 1;
       members[0].setname("anonymous_" + cid);
       members[0].setcid(cid);
       members[0].setid(nb_connexions);
       members[0].setchannel(channel);
   }
   else
   {
         int ref = nb_connexions;
         int i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string cid2 = members[i].getcid();   
            if( cid == cid2 ) // comparaison 
                ref = i;
         } 

         if(ref == nb_connexions) // il s'agit d'une nouvelle connexion
         {
           nb_connexions ++; 
           members[ref].setname("anonymous_" + cid);
           members[ref].setcid(cid);
           members[ref].setid(nb_connexions);
           members[ref].setchannel(channel);
                
         }
         else // la connexion existait dej
         {
           members[ref].setchannel(channel);
         }
   }

  return;
}

void urbichat::send2(std::string cid , std::string channel , std::string msg)
{
   std::string nickname;

   if( nb_connexions == 0)
   {
       return;
   }

   // on recherche notre pseudo
         int ref = nb_connexions;
         int i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string cid2 = members[i].getcid();   
            if( cid == cid2 ) // comparaison 
                ref = i;
         } 

         if(ref == nb_connexions) // nous ne somme pas encore enregistre
         {
           nickname = "anonymous_" + cid;
         }
         else // nous sommes deja enregistre
         {
           nickname = members[ref].getname();
         }
   
   // on envoie le message
         std::string message = ""; 
         ref = nb_connexions;
         i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string channel2 = members[i].getchannel();   
            if( channel == channel2 ) // comparaison 
            {
                message += "urbichat+connection(\"" + members[i].getcid() + "\") : \"<" + nickname + "> " + msg + "\" & ";

            }

         } 

            if( message != "" ) // comparaison 
            {
                message += " ; ";
                urbi::send(message.c_str());
            }
   
   

  return;
}

void urbichat::chat2(std::string cid , std::string msg)
{
   std::string nickname;
   std::string defaultchannel;

   // on recherche notre pseudo et notre channel
         int ref = nb_connexions;
         int i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string cid2 = members[i].getcid();   
            if( cid == cid2 ) // comparaison 
                ref = i;
         } 

         if(ref == nb_connexions) // nous ne somme pas encore enregistre et donc on s'enregistre
         {
           nb_connexions ++; 
           members[ref].setname("anonymous_" + cid);
           members[ref].setcid(cid);
           members[ref].setid(nb_connexions);
         }

           // on recupere les donnees
           nickname = members[ref].getname();
           defaultchannel = members[ref].getchannel();

   
   // on envoie le message
         std::string message = ""; 
         ref = nb_connexions;
         i=0;
         for (i = 0 ; i < nb_connexions ; i++)
         {
        	std::string channel2 = members[i].getchannel();   
            if( defaultchannel == channel2 ) // comparaison 
            {
                message += "urbichat+connection(\"" + members[i].getcid() + "\") : \"<" + nickname + "> " + msg + "\" & ";

            }
         } 
        if( message != "" ) // comparaison 
        {
             message += " ; ";
             urbi::send(message.c_str());
        }
   
  return;
}


std::string urbichat::display(void)
{
 int nb_fiches = nb_connexions;

 std::string texte = "";
 std::stringstream s;
 std::string nb;

    int id;
	std::string cid;   
    std::string name;
    std::string channel;

 int i=0;
 for (i = 0 ; i < nb_fiches ; i++)
 {
    id = members[i].getid();
	cid = members[i].getcid();   
    name = members[i].getname();
    channel = members[i].getchannel();

    s.str("");
    s << i+1;
    nb = s.str();

        if(i == 0)
             texte += "[" + nb + "] Name=" + name + ", cid=" + cid + ", channel=" + channel ;
        else
             texte += " *-* [" + nb + "] Name=" + name + ", cid=" + cid + ", channel=" + channel ;
 }

  return texte;
}

std::string urbichat::displayuserschannel2(std::string cid2)
{
 int nb_fiches = nb_connexions;

 std::string texte = "";
 std::stringstream s;
 std::string nb;

// on recherche le nom de notre channel
    std::string defaultchannel;
 int i=0;
 for (i = 0 ; i < nb_fiches ; i++)
 {
    if(members[i].getcid() == cid2)
           defaultchannel = members[i].getchannel();
  }


    int id;
	std::string cid;   
    std::string name;
    std::string channel;

 int indication = 0; 
 i=0;
 for (i = 0 ; i < nb_fiches ; i++)
 {
    id = members[i].getid();
	cid = members[i].getcid();   
    name = members[i].getname();
    channel = members[i].getchannel();

    if(defaultchannel == channel)
    {
        s.str("");
        s << i+1;
        nb = s.str();
        
        if(indication == 0)
             texte += "[" + nb + "] Name=" + name + ", cid=" + cid + ", channel=" + channel ;
        else
             texte += " *-* [" + nb + "] Name=" + name + ", cid=" + cid + ", channel=" + channel ;

        indication = 1;
    }

 }

  return texte;
}
