#include "urbiimage.h"


UStart(urbiimage);

urbiimage::urbiimage(std::string s) : UObject(s) 
{
	UBindFunction(urbiimage,init);
	UBindFunction(urbiimage,setPeriod);
	UBindFunction(urbiimage,display);
	UBindFunction(urbiimage,stopDisplay);
	UBindFunction(urbiimage,startDisplay);
	UBindFunction(urbiimage,save);

    mon=NULL;
    period = 0;
    etat = 1;
}

urbiimage::~urbiimage()
{
  etat = 1; // arrete affichage images;
  if (mon != NULL)
  {
//    delete mon;
//    mon = NULL;
  }

}

int urbiimage::init(void)
{
  return 1; // Singleton
}

void urbiimage::setPeriod(int delai_ms)
{
	period = delai_ms;
}


void urbiimage::display(UImage image)
{
  if(etat == 1)
    return;

  urbi::UImage im;
  im.size = 0;
  im.data = 0;
  im.imageFormat = urbi::IMAGE_RGB;
  im.width = image.width;
  im.height = image.height;
  convert((const urbi::UImage &)image, (urbi::UImage &)im);
  int size = 3*im.width*im.height;

  if (mon == NULL)
    mon = new Monitor(im.width, im.height, "image");

  if(etat == 0)
    mon->setImage((bits8 *) im.data, size);
}

void urbiimage::stopDisplay(void)
{
    etat = 1; // arrete affichage images;
	std::string message;
    message = "stop looptagDisplay;";
    urbi::send(message.c_str());

  if (mon != NULL)
  {
//    delete mon;
//    mon = NULL;
  }
}

void urbiimage::startDisplay(std::string device)
{
    etat = 0; // affiche images;
	std::string message;
    if(period == 0)
      message = "looptagDisplay:loop urbiimage.display(" + device + "),";
    else
    {
      std::string delay;
      std::ostringstream ostr; 
      ostr << period; 
      delay = ostr.str(); 
      message = "looptagDisplay:every(" + delay + ") urbiimage.display(" + device + "),";
    }
    urbi::send(message.c_str());

}

void urbiimage::save(std::string nameFile, UImage image, std::string formatimage)
{

      FILE *f = fopen(nameFile.c_str(), "wb");

      if(image.imageFormat == urbi::IMAGE_JPEG && formatimage == "jpeg")
      {
          fwrite(image.data, 1, image.size, f);
      }
      else
      {
          UImage imagedest;
          imagedest.width = image.width;
          imagedest.height = image.height;
          if(formatimage == "jpeg")
            imagedest.imageFormat = urbi::IMAGE_JPEG;
          else if(formatimage == "ppm")
            imagedest.imageFormat = urbi::IMAGE_PPM;
          else
            imagedest.imageFormat = urbi::IMAGE_JPEG;
          convert((const urbi::UImage &) image, (urbi::UImage &) imagedest);
          fwrite(imagedest.data, 1, imagedest.size, f);
      }
      fclose(f);
}








 
 
