/*
 * Copyright (C) Gostai S.A.S., 2007.  All rights reserved.
 *
 * This software is provided "as is" without warranty of any kind,
 * either expressed or implied, including but not limited to the
 * implied warranties of fitness for a particular purpose.
 *
 * See the LICENSE file for more information.
 * For comments, bug reports and feedback: http://www.urbiforge.com
 */
#ifndef HOUGHCIRCLES_HH_
#define HOUGHCIRCLES_HH_

#include <iostream>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>
#include <math.h>
#include "visionbehavior.hpp"

/** \brief VisionBehavior 's implementation of
 * the Hough's transform to get circles
 * in an image.
 */
class		HoughCircles : public VisionBehavior<CvSeq> {
private:
  CvSeq*		result;
  CvMemStorage*		storage;
public:
  HoughCircles();
  virtual		~HoughCircles();
  virtual void		writeOn(IplImage& img) const;
  virtual CvSeq&	getResult();
private:
  virtual void		compute(const IplImage& img);
  virtual void		emptyResult();
};

#endif /* !HOUGHCIRCLES_HH_ */
