/*
 * Copyright (C) Gostai S.A.S., 2007.  All rights reserved.
 *
 * This software is provided "as is" without warranty of any kind,
 * either expressed or implied, including but not limited to the
 * implied warranties of fitness for a particular purpose.
 *
 * See the LICENSE file for more information.
 * For comments, bug reports and feedback: http://www.urbiforge.com
 */
#ifndef SQUARES_HH_
#define SQUARES_HH_

#include <iostream>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>
#include <math.h>
#include <vector>
#include <boost/foreach.hpp>
#include "visionbehavior.hpp"

/** \brief VisionBehavior 's implementation of 
 * an heavy algorithm which finds squares in an image.
 */
class		Squares : public VisionBehavior<CvSeq> {
private:
  CvMemStorage*		storage;
  CvSeq*		result;
  int			thresh;
public:
			Squares();
  virtual		~Squares();
  virtual void		writeOn(IplImage& img) const;
  virtual void		actOnKeyPressed(char& key);
  virtual CvSeq&	getResult();
private:
  double		angle(CvPoint*, CvPoint*, CvPoint*);
  virtual void		emptyResult();
  virtual void		compute(const IplImage& img);
};

#endif /* !SQUARES_HH_ */
